<?php
require_once (REPORTS_FOLDER . "/reportUtils.php");
require_once (DATABASE_FOLDER . "/reportingQueries.php");
require_once (PHPExcelPath . '/Classes/PHPExcel.php');
require_once (mPDF_FOLDER . "/mpdf.php");
require_once (REPORTS_FOLDER . "/hizridate.php");

class CONSOLIDATED_Output_XLSX {
    public static function printXLSX($arrDis) {

        $summary = array ();
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );

        global $GDATABASE, $MYLANGUAGE;

        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );

        $aCount = count ( $arrDis [0] ['result'] );

        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();

        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();

        $objPHPExcel = new PHPExcel ();
        $sheetProperties = $objPHPExcel->getProperties ();
        $sheetProperties->setCreator ( "Find'n'Secure" );
        $sheetProperties->setTitle ( $MYLANGUAGE->getString ( 'CONSOLIDATED' ) );
        $sheetProperties->setDescription ( $MYLANGUAGE->getString ( 'CON_INFO' ) );

        $myWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, 'Report' );
        $objPHPExcel->addSheet ( $myWorkSheet, 0 );

        $summaryWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, 'Summary' );
        $objPHPExcel->addSheet ( $summaryWorkSheet, 1 );

        $objPHPExcel->setActiveSheetIndex ( 0 );

        // set font-family and size
        $objPHPExcel->getDefaultStyle ()->getFont ()->setName ( 'Arial' );
        $objPHPExcel->getDefaultStyle ()->getFont ()->setSize ( 10 );

        // set default column widths
        for($i = 'A'; $i <= 'F'; $i ++) {
            $myWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
            $summaryWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
        }

        // set margins
        $myWorkSheet->getPageMargins ()->setRight ( 0.125 );
        $myWorkSheet->getPageMargins ()->setLeft ( 0.125 );

        // set page orientation
        $myWorkSheet->getPageSetup ()->setPaperSize ( PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4 );
        $myWorkSheet->getPageSetup ()->setFitToWidth ( 1 );
        $myWorkSheet->getPageSetup ()->setFitToHeight ( 0 );

        $row = 2;

        // report heading
        $myWorkSheet->SetCellValue ( "A$row", $MYLANGUAGE->getString ( 'CONSOLIDATED' ) );
        $myWorkSheet->mergeCells ( "A$row:C" . ($row + 4) );
        $headingStyle = array (
            'font' => array (
                'bold' => true,
                'size' => 16
            ),
            'alignment' => array (
                'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP
            )
        );
        $myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
        $myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );

        // company logo
        $logo = new PHPExcel_Worksheet_Drawing ();
        $logo->setPath ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' );
        $logo->setWorksheet ( $myWorkSheet );
        $logo->setCoordinates ( 'D' . $row );
        $myWorkSheet->mergeCells ( "D$row:F" . ($row + 4) );
        $logo->setOffsetX ( 115 );

        $row = 9;

        // company details
        $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'COMPANY_NAME' ) );
        $myWorkSheet->SetCellValue ( 'B' . $row, $answer [0] ['company'] );
        $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'USERNAME' ) );
        $myWorkSheet->SetCellValue ( 'E' . $row, $answer [0] ['username'] );
        $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
        $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );

        $row ++;

        $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
        $myWorkSheet->SetCellValue ( 'B' . $row, $sdate );
        $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
        $myWorkSheet->SetCellValue ( 'E' . $row, $edate );
        $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
        $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );

        $row += 2;

        // report details
        $detailsStyle = array (
            'borders' => array (
                'inside' => array (
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array (
                        'argb' => 'FFFFFFFF'
                    )
                )
            ),

            'fill' => array (
                'type' => PHPExcel_Style_Fill::FILL_SOLID,
                'startcolor' => array (
                    'argb' => 'FFDDDDDD'
                )
            )
        );

        $tCount = count ( $arrDis );

        for($i = 0; $i < $tCount; $i ++) {
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

            $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TRACKER_NAME' ) );
            $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['tinfo'] [0] ['name'] );
            $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'APPLICATION' ) );
            $myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( $apptype ) );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            $myWorkSheet->getStyle ( "A$row:H$row" )->applyFromArray ( $detailsStyle );
            $myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
            $myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );

            $row ++;

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LICENSEPLATE' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['licensePlate'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'VTYPE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['vtype'] );
            }

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
            }

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REFNO' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['arefno'] );
            }

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
            }

            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            $myWorkSheet->getStyle ( "A$row:H$row" )->applyFromArray ( $detailsStyle );
            $myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
            $myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );

            $row += 3;

            $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
            $myWorkSheet->SetCellValue ( 'B' . $row, $MYLANGUAGE->getString ( 'FIRST_IGNITION' ) );
            $myWorkSheet->SetCellValue ( 'C' . $row, 'First Ignition Location' );
            $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'LAST_IGNITION' ) );
            $myWorkSheet->SetCellValue ( 'E' . $row, 'Last Ignition Location' );
            $myWorkSheet->SetCellValue ( 'F' . $row, $MYLANGUAGE->getString ( 'SDURATION' ) ); 
            $myWorkSheet->SetCellValue ( 'G' . $row, $MYLANGUAGE->getString ( 'MDURATION' ) );
            $myWorkSheet->SetCellValue ( 'H' . $row, $MYLANGUAGE->getString ( 'IDLING_DURATION' ) );
            $myWorkSheet->SetCellValue ( 'I' . $row, $MYLANGUAGE->getString ( 'AVG_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ")" );
            $myWorkSheet->SetCellValue ( 'J' . $row, $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ")" );
            $myWorkSheet->SetCellValue ( 'K' . $row, $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ")" );
            $myWorkSheet->SetCellValue ( 'L' . $row, $MYLANGUAGE->getString('DRIVER') );
            $rowHeadStyle = array (
                'font' => array (
                    'bold' => true,
                    'size' => 9
                ),

                'borders' => array (
                    'bottom' => array (
                        'style' => PHPExcel_Style_Border::BORDER_THIN,
                        'color' => array (
                            'argb' => 'FF000000'
                        )
                    )
                )
            );
            $myWorkSheet->getStyle ( 'A' . $row . ':H' . $row )->applyFromArray ( $rowHeadStyle );
            $myWorkSheet->getStyle ( "D$row:F$row" )->getAlignment ()->setHorizontal ( PHPExcel_Style_Alignment::HORIZONTAL_RIGHT );

            $row ++;

            $ecount = count ( $arrDis [$i] ['result'] );

            $netDistance = 0;
            $netDuration = 0;
            $fmaxSpeed = 0;
            $totalStop = 0;
            $totalMove = 0;
            $totalIdeal = 0;

            for($j = 0; $j < $ecount - 1; $j ++) {
                if ($j % 2 == 1)
                    $backgroundColor = "#FaFaFa";
                else
                    $backgroundColor = "#F2F2F2";

                if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getDateStruct ();

                    $myWorkSheet->SetCellValue ( 'A' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $sdate->year, $sdate->month, $sdate->day, $sdate->hour, $sdate->min, $sdate->sec ) );
                    $myWorkSheet->getStyle ( 'A' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy' );


                    $resultData = &$arrDis [$i] ['result'] [$j];

                    $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                    $firstIgnition = $fdate->getDateStruct();

                    $myWorkSheet->SetCellValue ( 'B' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $firstIgnition->year, $firstIgnition->month, $firstIgnition->day, $firstIgnition->hour, $firstIgnition->min, $firstIgnition->sec ) );
                    $myWorkSheet->getStyle ( 'B' . $row )->getNumberFormat ()->setFormatCode ( 'hh:mm:ss' );
                    $myWorkSheet->SetCellValue ( 'C' . $row, $resultData->firstIgnition['location']);


                    $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                    $lastIgnition = $fdate->getDateStruct();

                    $myWorkSheet->SetCellValue ( 'D' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $lastIgnition->year, $lastIgnition->month, $lastIgnition->day, $lastIgnition->hour, $lastIgnition->min, $lastIgnition->sec ) );
                    $myWorkSheet->getStyle ( 'D' . $row )->getNumberFormat ()->setFormatCode ( 'hh:mm:ss' );
                    $myWorkSheet->SetCellValue ( 'E' . $row, $resultData->lastIgnition['location']);


                    $moveDuration = reportUtils::getDurationTextMedium($resultData->mDuration, $MYLANGUAGE);
                    //$stopDuration = reportUtils::getDurationTextMedium(86400 - $resultData->mDuration, $MYLANGUAGE);
                    
                    //Ideal duration start
                    //echo '<pre>';print_r($resultData->trips);echo '</pre>';
                    $ideal_duration = 0;
                    $tripsCount = count($resultData->trips);
                    for ($k = 0; $k < $tripsCount; $k++)
                    {
                        //echo $resultData->trips[$k]->duration;
                        $ideal_duration+=$resultData->trips[$k]->duration;
                    }
                    $idealDuration = reportUtils::getDurationText($ideal_duration, $MYLANGUAGE);
                    $stopDuration = reportUtils::getDurationTextMedium(((86400 - $resultData->mDuration) - $ideal_duration), $MYLANGUAGE);
                    //Ideal duration end

                    $totalMove += $resultData->mDuration;
                    $totalIdeal += $ideal_duration;
                    $totalStop += ((86400 - $resultData->mDuration) - $ideal_duration);
                    //$totalStop += (86400 - $resultData->mDuration);

                    $netDuration += $arrDis [$i] ['result'] [$j]->mDuration;

                    if ($arrDis [$i] ['result'] [$j]->maxSpeed > $fmaxSpeed)
                        $fmaxSpeed = $arrDis [$i] ['result'] [$j]->maxSpeed;

                    $myWorkSheet->SetCellValue ( 'F' . $row, $stopDuration);
                    $myWorkSheet->SetCellValue ( 'G' . $row, $moveDuration);
                    $myWorkSheet->SetCellValue ( 'H' . $row, $idealDuration);
                    $myWorkSheet->SetCellValue ( 'I' . $row, sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->avgSpeed ) );
                    $myWorkSheet->SetCellValue ( 'J' . $row, sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->maxSpeed ) );
                    $myWorkSheet->SetCellValue ( 'K' . $row, sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->distance ) );
                    $myWorkSheet->SetCellValue ( 'L' . $row, $arrDis[$i]['result'][$j]->driver);
                    $myWorkSheet->getStyle ( "A$row:J$row" )->getFill ()->getStartColor ()->setARGB ( 'FF' . $backgroundColor );

                    $netDistance += $arrDis [$i] ['result'] [$j]->distance;
                    $row ++;
                }
            } // for J

            $row ++;

            // row1 footer
            $myWorkSheet->SetCellValue ( 'F' . $row, reportUtils::getDurationTextMedium($totalStop, $MYLANGUAGE) );
            $myWorkSheet->SetCellValue ( 'G' . $row, reportUtils::getDurationTextMedium($totalMove, $MYLANGUAGE) );
            $myWorkSheet->SetCellValue ( 'H' . $row, reportUtils::getDurationTextMedium($totalIdeal, $MYLANGUAGE) );
            $myWorkSheet->SetCellValue ( 'K' . $row, $netDistance );
            $myWorkSheet->getStyle ( 'A' . $row . ':H' . $row )->getFont ()->setBold ( true );

            $row += 3;

            $cs = new csSummaryObject ();
            $cs->name = $arrDis [$i] ['tinfo'] [0] ['name'];
            $cs->distance = $netDistance;
            $cs->duration = $netDuration;
            $cs->maxSpeed = $fmaxSpeed;

            array_push ( $summary, $cs );
        } // for I

        $sCount = count ( $summary );

        $row ++;

        $s2row = 1;

        // report Header
        $summaryWorkSheet->SetCellValue ( 'A' . $s2row, $MYLANGUAGE->getString ( 'RSUMM' ) );
        $summaryWorkSheet->getStyle ( 'A' . $s2row )->getFont ()->setBold ( true );
        $s2row += 2;

        //$idealDuration $stopDuration SDURATION IDLING_DURATION $totalStop $totalMove $totalIdeal
        
        $summaryWorkSheet->SetCellValue ( 'A' . $s2row, $MYLANGUAGE->getString ( 'NAME' ) );
        $summaryWorkSheet->mergeCells ( 'A' . $s2row . ':B' . $s2row );
        $summaryWorkSheet->SetCellValue ( 'C' . $s2row, $MYLANGUAGE->getString ( 'MDURATION' ) );
        $summaryWorkSheet->mergeCells ( 'C' . $s2row . ':D' . $s2row );
        $summaryWorkSheet->SetCellValue ( 'E' . $s2row, $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ")" );
        $summaryWorkSheet->SetCellValue ( 'F' . $s2row, $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ")" );
        $summaryWorkSheet->getStyle ( 'A' . $s2row . ':F' . $s2row )->applyFromArray ( $rowHeadStyle );
        $summaryWorkSheet->getStyle ( "D$s2row:F$s2row" )->getAlignment ()->setHorizontal ( PHPExcel_Style_Alignment::HORIZONTAL_RIGHT );
        $s2row ++;

        // report summary
        for($i = 0; $i < $sCount; $i ++) {
            $summaryWorkSheet->SetCellValue ( 'A' . $s2row, $summary [$i]->name );
            $summaryWorkSheet->mergeCells ( 'A' . $s2row . ':B' . $s2row );
            $summaryWorkSheet->SetCellValue ( 'C' . $s2row, reportUtils::getDurationText ( $summary [$i]->duration, $MYLANGUAGE ) );
            $summaryWorkSheet->mergeCells ( 'C' . $s2row . ':D' . $s2row );
            $summaryWorkSheet->SetCellValue ( 'E' . $s2row, floor ( $summary [$i]->maxSpeed ) );
            $summaryWorkSheet->SetCellValue ( 'F' . $s2row, sprintf ( "%0.2f", $summary [$i]->distance ) );
            $summaryWorkSheet->getStyle ( 'A' . $s2row . ':F' . $s2row )->getBorders ()->getBottom ()->setBorderStyle ( PHPExcel_Style_Border::BORDER_THIN );
            $summaryWorkSheet->getStyle ( 'A' . $s2row . ':F' . $s2row )->getBorders ()->getTop ()->setBorderStyle ( PHPExcel_Style_Border::BORDER_THIN );
            $s2row ++;
        }////////////////////////////////
        // redirect output to browser
        header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
        header ( 'Content-Disposition: attachment;filename="consolidated_report.xlsx"' );
        header ( 'Cache-Control: max-age=0' );
        $objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
        $objWriter->save ( 'php://output' );
    }
}
class CONSOLIDATED_Output_PDF {
    public $pdf;
    public static $txtDirection;
    public static $revDirection;
    public static $direction;
    private function initializePDF() {
        global $MYLANGUAGE;

        $this->pdf = new mPDF ( "utf-8", "LETTER" );

        $this->pdf->SetCreator ( "Find'n'Secure" );
        $this->pdf->SetAuthor ( 'EMBARC' );
        $this->pdf->SetTitle ( $MYLANGUAGE->getString ( 'CONSOLIDATED' ) );
        $this->pdf->SetSubject ( $MYLANGUAGE->getString ( 'CONSOLIDATED' ) );
        $this->pdf->SetKeywords ( "Consolidated, Report, Findnsecure" );

        // set default header data
        $header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . $MYLANGUAGE->getString ( 'CONSOLIDATED' ) . '</td><td align="' . self::$revDirection . '"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
        $this->pdf->SetHTMLHeader ( $header, "E" );
        $this->pdf->SetHTMLHeader ( $header, "O" );
        $this->pdf->SetTopMargin ( 30 );

        // $this->pdf->SetDirectionality("rtl");
        $this->pdf->SetAutoFont ( AUTOFONT_ALL );
        $this->pdf->SetDirectionality ( self::$direction );
    }
    public function printPDF($arrDis) {
        global $GDATABASE, $MYLANGUAGE, $languageMatrix;

        if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
            self::$direction = $direction = "ltr";
        } else {
            self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
        }

        switch ($direction) {
            case "ltr" :
                self::$txtDirection = "left";
                self::$revDirection = "right";
                break;
            case "rtl" :
                self::$txtDirection = "right";
                self::$revDirection = "left";
                break;
        }

        $left = self::$txtDirection;
        $right = self::$revDirection;

        ob_start ();
        print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
                <html xmlns="http://www.w3.org/1999/xhtml">
                <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
                <style>' . file_get_contents ( CSS_FOLDER . '/reports_pdf.css' ) . '*{direction:' . $direction . ';} </style>
                </head>
                <body class="mainbody">
              ';

        $summary = array ();

        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );

        $this->initializePDF ();

        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
        $aCount = count ( $arrDis [0] ['result'] );
        $caletype=$_SESSION['caltype'];


        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
          $startdate=($arrDis [0] ['result'] [0]->date);
                $sortstart=explode('-',$startdate);
                $syear=$sortstart[0];
                $smonth=$sortstart[1];
                $sdate=$sortstart[2];
  $convertdates=hizridate::Greg2Hijri($sdate,$smonth,$syear);
  $stringdates=hizridate::islammmonth( $convertdates);
     if($caletype=="hijri")
            {
                $fsd=$stringdates.' '.$dates;
            }
            else
            {
                $fsd=$startdate.' '.$dates;
            }

        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();
         $endtdate=($arrDis [0] ['result'] [$aCount - 1]->date);
                $sortend=explode('-',$endtdate);
                $eyear=$sortend[0];
                $emonth=$sortend[1];
                $edate=$sortend[2];
  $convertdatee=hizridate::Greg2Hijri($edate,$emonth,$eyear);
  $stringdatee=hizridate::islammmonth( $convertdatee);
    if($caletype=="hijri")
            {
         $fed=$stringdatee.' '.$datee;
            }
            else
            {
                $fed=$endtdate.' '.$datee;
            }

        print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
        <tr>
            <td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>

            <td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
        </tr>

        <tr>
            <td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $fsd . '</div></td>
            <td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $fed . '</div></td>
        </tr>
        </table>';

        $tCount = count ( $arrDis );

        for($i = 0; $i < $tCount; $i ++) {
            
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

            /*print '<br><table width="100%" class ="topBottom10pxPadding">
            <tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
            </tr>';

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            }

            print "</table>";*/

            print '<table width="100%" cellspacing=0 cellpadding=5 style="font-size:11px;font-family:Arial;border:1px solid black" >
            <tr align="' . $left . '">
            <th style="width:100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . '</th>
            <th style="width:100px">' . $MYLANGUAGE->getString ( 'DATE' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'FIRST_IGNITION' ) . '</th>
            <th>' . 'First Ignition Location' . '</th>
            <th>' . $MYLANGUAGE->getString ( 'LAST_IGNITION' ) . '</th>
            <th>' . 'Last Ignition Location' . '</th>
            <th>' . $MYLANGUAGE->getString ( 'SDURATION' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'MDURATION' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'IDLING_DURATION' ) . '</th>
            <th align="center">' . $MYLANGUAGE->getString ( 'AVG_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            <th align="center">' . $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            <th align="' . $right . '">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
            <th>' . $MYLANGUAGE->getString('DRIVER')  . '</th>    
            </tr>';

            $ecount = count ( $arrDis [$i] ['result'] );

            $netDistance = 0;
            $netDuration = 0;
            $fmaxSpeed = 0;
            $totalStop = 0;
            $totalMove = 0;
            $totalIdeal = 0;

            for($j = 0; $j < $ecount - 1; $j ++) {
                if ($j % 2 == 1)
                    $backgroundColor = "#FaFaFa";
                else
                    $backgroundColor = "#F2F2F2";

                if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
              $sdate = $fdate->getFormattedDateString ();
        $datee = $fdate->getFormattedTimeString ();
         $sortstart=explode(' ',$sdate);
                $syear=$sortstart[2];
                $smonth=$sortstart[1];
                $sdatee=$sortstart[0];
                 $convertdates=hizridate::Greg2Hijri($sdatee,$smonth,$syear);
                   $stringdatee=hizridate::islammmonth( $convertdates);

                    if($caletype=="hijri")
                    {
                          $fsd=$stringdatee;
                    }
                    else{

                          $fsd=$sdate;
                    }
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
           $edate = $fdate->getFormattedDateString ();
        $datee = $fdate->getFormattedTimeString ();
         $sortstart=explode(' ',$edate);
                $syear=$sortstart[2];
                $smonth=$sortstart[1];
                $sdatee=$sortstart[0];
                 $convertdates=hizridate::Greg2Hijri($sdatee,$smonth,$syear);
                   $stringdatee=hizridate::islammmonth( $convertdates);

                    if($caletype=="hijri")
                    {
                          $fed=$stringdatee;
                    }
                    else{

                          $fed=$edate;
                    }   
                    $resultData = &$arrDis [$i] ['result'] [$j];

                    $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                    $firstIgnition = $fdate->getFormattedTimeString();
                    $firstIgnitionLocation = $resultData->firstIgnition['location'];

                    $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                    $lastIgnition = $fdate->getFormattedTimeString ();
                    $lastIgnitionLocation = $resultData->lastIgnition['location'];

                    //$hours = floor ( $arrDis [$i] ['result'] [$j]->mDuration / 3600 );
                    //$mins = floor ( ($arrDis [$i] ['result'] [$j]->mDuration - $hours * 3600) / 60 );
                    //$seconds = ($arrDis [$i] ['result'] [$j]->mDuration - $hours * 3600 - $mins * 60);

                    $moveDuration = reportUtils::getDurationTextMedium($resultData->mDuration, $MYLANGUAGE);
                    //$stopDuration = reportUtils::getDurationTextMedium(86400 - $resultData->mDuration, $MYLANGUAGE);
                    
                    //Ideal duration start
                    //echo '<pre>';print_r($resultData->trips);echo '</pre>';
                    $ideal_duration = 0;
                    $tripsCount = count($resultData->trips);
                    for ($k = 0; $k < $tripsCount; $k++)
                    {
                        //echo $resultData->trips[$k]->duration;
                        $ideal_duration+=$resultData->trips[$k]->duration;
                    }
                    $idealDuration = reportUtils::getDurationText($ideal_duration, $MYLANGUAGE);
                    $stopDuration = reportUtils::getDurationTextMedium(((86400 - $resultData->mDuration) - $ideal_duration), $MYLANGUAGE);
                    
                    //Ideal duration end

                    $totalMove += $resultData->mDuration;
                    $totalIdeal += $ideal_duration;
                    $totalStop += ((86400 - $resultData->mDuration) - $ideal_duration);

                    $netDuration += $arrDis [$i] ['result'] [$j]->mDuration;
                    if ($arrDis [$i] ['result'] [$j]->maxSpeed > $fmaxSpeed)
                        $fmaxSpeed = $arrDis [$i] ['result'] [$j]->maxSpeed;

                    print '<tr align="' . $left . '" style="font-weight:normal;font-size:11px;background-color:' . $backgroundColor . ';">
                    <td>' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
                    <td>' . $fsd . '</td>
                    <td>' . $firstIgnition . '</td>
                    <td>' . $firstIgnitionLocation . '</td>
                    <td>' . $lastIgnition . '</td>
                    <td>' . $lastIgnitionLocation . '</td>
                    <td>' . $stopDuration . '</td>
                    <td>' . $moveDuration .'</td>
                    <td>' . $idealDuration .'</td>
                    <td align="center">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->avgSpeed ) . '</td>
                    <td align="center">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->maxSpeed ) . '</td>
                    <td align="' . $right . '">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->distance ) . '</td>
                    <td>'.$arrDis[$i]['result'][$j]->driver.'</td>
                    </tr>';
                    $netDistance += $arrDis [$i] ['result'] [$j]->distance;
                }
            } // for J

            print "<tr align = 'left' style='font-size:11px; font-weight:bold'> <td colspan='6'>&nbsp;</td><td>";
            print reportUtils::getDurationTextMedium($totalStop, $MYLANGUAGE)."</td><td>".reportUtils::getDurationTextMedium($totalMove, $MYLANGUAGE);
            print "<td>".reportUtils::getDurationTextMedium($totalIdeal, $MYLANGUAGE)."</td>";
            print "<td colspan='2'>&nbsp;</td>";
            print "<td align='right'>".sprintf("%0.2f", $netDistance)."</td></tr>";
            print "</table>";


            $cs = new csSummaryObject ();
            $cs->name = $arrDis [$i] ['tinfo'] [0] ['name'];
            $cs->distance = $netDistance;
            $cs->duration = $netDuration;
            $cs->maxSpeed = $fmaxSpeed;

            array_push ( $summary, $cs );
        } // for I

        $sCount = count ( $summary );

        print '<br/><br/>
            <div style="font-family:Arial; font-size:18px; font-weight:bold;">' . $MYLANGUAGE->getString ( 'RSUMM' ) . '</div><br/>

            <table class="topHeader" border=0 width="100%" cellpadding="0" cellspacing="3" style="font-size:13px; padding-top:5px; padding-bottom:5px;">
        ';

        for($i = 0; $i < $sCount; $i ++) {
            print '<tr>
                <td>' . $summary [$i]->name . '&nbsp;</td>
                <td>' . reportUtils::getDurationText ( $summary [$i]->duration, $MYLANGUAGE ) . '</td>
                <td align="right">' . floor ( $summary [$i]->maxSpeed ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ' </td>
                <td style="font-weight:bold" align="' . $right . '">' . sprintf ( "%0.2f", $summary [$i]->distance ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
            </tr>';
        }

        print '</table>
            ';

        $contents = ob_get_contents ();
        ob_end_clean ();

        $this->pdf->WriteHTML ( $contents );
        $this->pdf->Output ();
    }
}
class CONSOLIDATED_Output_HTML {
    

    public static $txtDirection;
    public static $revDirection;
    public static $direction;
    public static function printHeader() {
        global $MYLANGUAGE, $languageMatrix;

        if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
            self::$direction = $direction = "ltr";
        } else {
            self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
        }

        switch ($direction) {
            case "ltr" :
                self::$txtDirection = "left";
                self::$revDirection = "right";
                break;
            case "rtl" :
                self::$txtDirection = "right";
                self::$revDirection = "left";
                break;
        }

        print '
                <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
                <html xmlns="http://www.w3.org/1999/xhtml">
                <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
                <title>' . $MYLANGUAGE->getString ( 'CONSOLIDATED' ) . '</title>
                <style>' . file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:' . $direction . ';} table tr td { min-width:90px;padding:5px;} </style>
                </head>
                <body class="mainbody" style="background-color:#999; background-image:none">
                <div id="reportframe" style="width:1220px">
                <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
              ';
    }


    
    public static function printHTML($arrDis) {
    ob_start ();
        $summary = array ();
        $aCount = count ( $arrDis [0] ['result'] );
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
                $startdate=($arrDis [0] ['result'] [0]->date);
                $sortstart=explode('-',$startdate);
                $syear=$sortstart[0];
                $smonth=$sortstart[1];
                $sdate=$sortstart[2];
  $convertdates=hizridate::Greg2Hijri($sdate,$smonth,$syear);
  $stringdates=hizridate::islammmonth( $convertdates);
   
 $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );

        $dates = $fdate->getFormattedTimeString ();
            $caletype=$_SESSION['caltype'];
            if($caletype=="hijri")
            {
                $fsd=$stringdates.' '.$dates;
            }
            else
            {
                $fsd=$startdate.' '.$dates;
            }
         $endtdate=($arrDis [0] ['result'] [$aCount - 1]->date);
                $sortend=explode('-',$endtdate);
                $eyear=$sortend[0];
                $emonth=$sortend[1];
                $edate=$sortend[2];
  $convertdatee=hizridate::Greg2Hijri($edate,$emonth,$eyear);
  $stringdatee=hizridate::islammmonth( $convertdatee);
   
 $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );

        $datee = $fdate->getFormattedTimeString ();
               if($caletype=="hijri")
            {
         $fed=$stringdatee.' '.$datee;
            }
            else
            {
                $fed=$endtdate.' '.$datee;
            }

        global $GDATABASE, $MYLANGUAGE;
    
        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
          
        CONSOLIDATED_Output_HTML::printHeader ();
        $left = self::$txtDirection;
        $right = self::$revDirection;

        
//echo '<pre>';print_r($arrDis);echo '</pre>';


      $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );

$sdate = $fdate->getFormattedDateString ();
        $datee = $fdate->getFormattedTimeString ();
         $sortstart=explode(' ',$sdate);
                $syear=$sortstart[2];
                $smonth=$sortstart[1];
                $sdatee=$sortstart[0];
                 $convertdates=hizridate::Greg2Hijri($sdatee,$smonth,$syear);
                   $stringdatee=hizridate::islammmonth( $convertdates);

                    if($caletype=="hijri")
                    {
                          $fsd=$stringdatee;
                    }
                    else{

                          $fsd=$sdate;
                    }

      $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );

      $edate = $fdate->getFormattedDateString ();
        $datee = $fdate->getFormattedTimeString ();
         $sortstart=explode(' ',$edate);
                $syear=$sortstart[2];
                $smonth=$sortstart[1];
                $sdatee=$sortstart[0];
                 $convertdates=hizridate::Greg2Hijri($sdatee,$smonth,$syear);
                   $stringdatee=hizridate::islammmonth( $convertdates);

                    if($caletype=="hijri")
                    {
                          $fed=$stringdatee;
                    }
                    else{

                          $fed=$edate;
                    }   
              //print $MYLANGUAGE->getString ( 'CONSOLIDATED' );
        print '<table width="100%" class="topBottom10pxPadding"><tr><td>' . $MYLANGUAGE->getString ( 'CONSOLIDATED' ) . '</td><td align="' . $right . '"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';

        print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
        <tr>
            <td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>

            <td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
        </tr>

        <tr>
            <td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $fsd . '</div></td>
            <td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $fed . '</div></td>
        </tr>
        </table>';

        $tCount = count ( $arrDis );
        for($i = 0; $i < $tCount; $i ++) {

            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
            /*print '<br><table width="100%" class ="topBottom10pxPadding">
            <tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
            </tr>';

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            }

            print "</table>";*/

            print '<table width="100%" cellSpacing=5 border=1 frame="hsides" rules="rows" style="font-size:13px;font-family:Arial" >
            <tr align="' . $left . '">
            <th>' . 'Tracker' . '</th>
            <th>' . $MYLANGUAGE->getString ( 'DATE' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'FIRST_IGNITION' ) . '</th>
            <th>' . 'First Ignition Location' .'</th>
            <th>' . $MYLANGUAGE->getString ( 'LAST_IGNITION' ) . '</th>
            <th>' . 'Last Ignition Location' .'</th>
            <th>' . $MYLANGUAGE->getString ( 'SDURATION' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'MDURATION' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'IDLING_DURATION' ) . '</th>
            <th align="center">' . $MYLANGUAGE->getString ( 'AVG_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            <th align="center">' . $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            <th align="' . $right . '">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
            <th>' . $MYLANGUAGE->getString('DRIVER') . '</th>
            </tr>';

            
            
            
            $ecount = count ( $arrDis [$i] ['result'] );
        

            $netDistance = 0;
            $netDuration = 0;
            $fmaxSpeed = 0;
            $totalStop = 0;
            $totalMove = 0;
            $totalIdeal = 0;

            for($j = 0; $j < $ecount - 1; $j ++) {
                if ($j % 2 == 1)
                    $backgroundColor = "#FaFaFa";
                else
                    $backgroundColor = "#F2F2F2";

                if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedDateString ();
        $datee = $fdate->getFormattedTimeString ();
         $sortstart=explode(' ',$sdate);
                $syear=$sortstart[2];
                $smonth=$sortstart[1];
                $sdatee=$sortstart[0];
                 $convertdates=hizridate::Greg2Hijri($sdatee,$smonth,$syear);
                   $stringdatee=hizridate::islammmonth( $convertdates);

                    if($caletype=="hijri")
                    {
                          $fsd=$stringdatee;
                    }
                    else{

                          $fsd=$sdate;
                    }
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
$edate = $fdate->getFormattedDateString ();
        $datee = $fdate->getFormattedTimeString ();
         $sortstart=explode(' ',$edate);
                $syear=$sortstart[2];
                $smonth=$sortstart[1];
                $sdatee=$sortstart[0];
                 $convertdates=hizridate::Greg2Hijri($sdatee,$smonth,$syear);
                   $stringdatee=hizridate::islammmonth( $convertdates);

                    if($caletype=="hijri")
                    {
                          $fed=$stringdatee;
                    }
                    else{

                          $fed=$edate;
                    }  

                    $resultData = &$arrDis [$i] ['result'] [$j];

                    $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                    $firstIgnition = $fdate->getFormattedTimeString();
                    $firstIgnitionLocation = $resultData->firstIgnition['location'];

                    $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                    $lastIgnition = $fdate->getFormattedTimeString ();
                    $lastIgnitionLocation = $resultData->lastIgnition['location'];

                    //$hours = floor ( $arrDis [$i] ['result'] [$j]->mDuration / 3600 );
                    //$mins = floor ( ($arrDis [$i] ['result'] [$j]->mDuration - $hours * 3600) / 60 );
                    //$seconds = ($arrDis [$i] ['result'] [$j]->mDuration - $hours * 3600 - $mins * 60);

                    $moveDuration = reportUtils::getDurationTextMedium($resultData->mDuration, $MYLANGUAGE);
                    
                    //$idealDuration = reportUtils::getDurationTextMedium($resultData['trips']->duration, $MYLANGUAGE);
                    
                    //Ideal duration start
                    //echo '<pre>';print_r($resultData->trips);echo '</pre>';
                    $ideal_duration = 0;
                    $tripsCount = count($resultData->trips);
                    for ($k = 0; $k < $tripsCount; $k++)
                    {
                        //echo $resultData->trips[$k]->duration;
                        $ideal_duration+=$resultData->trips[$k]->duration;
                    }
                    $idealDuration = reportUtils::getDurationText($ideal_duration, $MYLANGUAGE);
                    $stopDuration = reportUtils::getDurationTextMedium(((86400 - $resultData->mDuration) - $ideal_duration), $MYLANGUAGE);
                    //Ideal duration end

                    $totalMove += $resultData->mDuration;
                    $totalIdeal += $ideal_duration;
                    $totalStop += ((86400 - $resultData->mDuration) - $ideal_duration);
                    //$totalStop += (86400 - $resultData->mDuration);

                    $netDuration += $arrDis [$i] ['result'] [$j]->mDuration;

                    if ($arrDis [$i] ['result'] [$j]->maxSpeed > $fmaxSpeed)
                        $fmaxSpeed = $arrDis [$i] ['result'] [$j]->maxSpeed;
                   
                    //echo $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                    //echo '<pre>';print_r($arrDis [$i] ['result'] [$j]);echo '</pre>';die('new die'); 
                    //$this->rDatabase->reports_getLocationsData($tid, $dateArray);
                    //$newTripsArray  = $this->computeTrips($arrDis [$i] ['tinfo'] [0] ['trackerid']);
                    //$tripsCount = count($tripsArray);
                    //$y=0;
                    //echo '<pre>';print_r($newTripsArray);echo '</pre>';die('new die'); 
                    
                    
                    print '<tr align="' . $left . '" style="font-weight:normal;font-size:11px;background-color:' . $backgroundColor . ';">
                    <td>' .$arrDis [$i] ['tinfo'] [0] ['name']. '</td>
                    <td>' .$fsd. '</td>
                    <td>' . $firstIgnition . '</td>
                    <td>' . $firstIgnitionLocation . '</td>
                    <td>' . $lastIgnition . '</td>
                    <td>' . $lastIgnitionLocation . '</td>
                    <td>' . $stopDuration . '</td>
                    <td>' . $moveDuration .'</td>
                    <td>' . $idealDuration .'</td>
                    <td align="center">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->avgSpeed ) . '</td>
                    <td align="center">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->maxSpeed ) . '</td>
                    <td align="' . $right . '">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->distance ) . '</td>
                    <td>'.$arrDis[$i]['result'][$j]->driver.'</td>
                    </tr>';
                    $netDistance += $arrDis [$i] ['result'] [$j]->distance;
                }
            } // for 

            print "<tr align = 'left' style='font-size:11px; font-weight:bold'> <td colspan='6'>&nbsp;</td><td>";
            print reportUtils::getDurationTextMedium($totalStop, $MYLANGUAGE)."</td><td>".reportUtils::getDurationTextMedium($totalMove, $MYLANGUAGE);
            print "<td>".reportUtils::getDurationTextMedium($totalIdeal, $MYLANGUAGE)."</td>";
            print "<td colspan='2'>&nbsp;</td>";
            print "<td align='right'>".sprintf("%0.2f", $netDistance)."</td></tr>";
            print "</table>";

            $cs = new csSummaryObject ();
            $cs->name = $arrDis [$i] ['tinfo'] [0] ['name'];
            $cs->distance = $netDistance;
            $cs->duration = $netDuration;
            $cs->maxSpeed = $fmaxSpeed;

            array_push ( $summary, $cs );
        } // for I

        $sCount = count ( $summary );

        print '<br/><br/>
            <div style="font-family:Arial; font-size:18px; font-weight:bold;">' . $MYLANGUAGE->getString ( 'RSUMM' ) . '</div><br/>

            <table class="topHeader" border=1 frame="hsides" rules="rows" width="100%" cellpadding="0" cellspacing="0" style="font-size:15px; padding-top:5px; padding-bottom:5px;">
        ';

        for($i = 0; $i < $sCount; $i ++) {
            print '<tr>
                <td>' . $summary [$i]->name . '&nbsp;</td>
                <td>' . reportUtils::getDurationText ( $summary [$i]->duration, $MYLANGUAGE ) . '</td>
                <td align="right">' . floor ( $summary [$i]->maxSpeed ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ' </td>
                <td style="font-weight:bold" align="' . $right . '">' . sprintf ( "%0.2f", $summary [$i]->distance ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
            </tr>';
        }

        print '</table>
            ';

        CONSOLIDATED_Output_HTML::printFooter ();

        $contents = ob_get_contents ();
        ob_end_clean ();
        print $contents;
    }


    public static function printFooter() {
        print '
        <br/>
        <div style="width:100%; border:1px black solid; background-color:#404040; height:10px"> </div>
        </div></div>
        </body></html>';
    }
}

class CONSOLIDATED_FNSv3_Report {
    private $mConverter;
    private $rDatabase;
    
    private function getStatus($data) {

		if ($data['latitude'] == NULL) return STATUS_NOGPS;
		if ($data['speed'] > 0 && strpos ( $data['IO'], "j" ) !== false)
			$currentStatus = STATUS_MOVING;
		else if (strpos ( $data['IO'], "j" ) !== false)
			$currentStatus = STATUS_IDLE;
		else
			$currentStatus = STATUS_STOPPED;
		
		return $currentStatus;
	}
		

	private function computeTrips($tid) {
		global $GDATABASE;
	
		if (isset($_GET['SOTV']) && $_GET['SOTV'] > 0) $TRIPS_STOP_BREAKING_TIME = $_GET['SOTV'];
		else $TRIPS_STOP_BREAKING_TIME = TRIPS_STOP_BREAKING_TIME;
	
		if (isset($_GET['IDTV']) && $_GET['IDTV'] > 0) $TRIPS_IDLE_BREAKING_TIME = $_GET['IDTV'];
		else $TRIPS_IDLE_BREAKING_TIME = TRIPS_IDLE_BREAKING_TIME;
	
		$trips = array ();
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
	
		// Starting state of this automata will be TRIP_START
		$currentState = TRIP_START;
	
		$data = true;
		$distance = 0;
	
		$tprofiles = $GDATABASE->getTrackerTemperatureProfiles ( $tid );
		$card = $GDATABASE->getTrackerCard ( $tid );
	
		$computeTemperature = false;
		$tpr = array ();
	
		for($v = 0; $v < count ( $tprofiles ); $v ++) {
			if ($tprofiles [$v] !== false) {
				$computeTemperature = true;
			}
		}
	
		$exit = false;
		$oldData = false;
		//$Odometer = new FNSOdometer($tid, $_SESSION['timezone']);
	
		while ( $exit == false ) {
			$data = $this->rDatabase->reports_nextLocation ();
			//print "<br/>\r\n".$data['date'].",".$data['time'].",".$data['latitude'].",".$data['longitude'].",".$data['speed'].",".$data['IO'];
			switch ($currentState) {
	
				case TRIP_START :
						
					if ($data == false) {
						$exit = true;
						break;
					}
						
					//Skip the NO GPS State in the beginning of the data block
					$checkState = $this->getStatus ( $data );
					if ($checkState == STATUS_NOGPS) break;
						
					// move the state into its determined state
					$currentState = $checkState;
						
					$fdate->setUTCDate ( $data ['date'], $data ['time'] );
					$stateTransTime = $fdate->dateTime->getTimestamp ();
						
					$lastLatitude = $data ['latitude'];
					$lastLongitude = $data ['longitude'];
					$maxSpeed = $data ['speed'];
						
					$maxTemp = array ();
					$minTemp = array ();
						
					if ($computeTemperature == true) {
						for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
							$minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
						}
					}
						
					$n = new tripRObject ();
					$n->status = TRIP_START;
					$n->distance = $distance;
					$n->maxSpeed = $maxSpeed;
					$n->latitude = $data ['latitude'];
					$n->longitude = $data ['longitude'];
					$n->duration = 0;
					$n->date = $data ['date'];
					$n->time = $data ['time'];
					$n->maxTemp = $maxTemp;
					$n->minTemp = $minTemp;
					array_push($trips,$n);
					break;
	
				case STATUS_MOVING :
					if ($data != false) {
						$newState = $this->getStatus ( $data );
					}
						
					if ($newState != STATUS_MOVING || $data == false) {
	
						if ($data == false) {
							$exit = true;
							$data = $oldData;
						}
	
						if ($newState == STATUS_NOGPS) {
							$data = $oldData;
						}
	
						$fdate->setUTCDate ( $data ['date'], $data ['time'] );
	
						// if last state was movement only - means last state
						// was skipped due to trip time
						// in this case add to the previous packet otherwise
						// emit new packet
						$lastTripIndex = count ( $trips ) - 1;
						if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == STATUS_MOVING) {
							$trips [$lastTripIndex]->date = $data ['date'];
							$trips [$lastTripIndex]->time = $data ['time'];
							$trips [$lastTripIndex]->latitude = $data ['latitude'];
							$trips [$lastTripIndex]->longitude = $data ['longitude'];
							$trips [$lastTripIndex]->distance = $distance;
							$trips [$lastTripIndex]->maxSpeed = $maxSpeed;
							$trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
						} else {
							$n = new tripRObject ();
							$n->status = $currentState;
							$n->distance = $distance;
							$n->maxSpeed = $maxSpeed;
							$n->latitude = $data ['latitude'];
							$n->longitude = $data ['longitude'];
							$n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
							$n->date = $data ['date'];
							$n->time = $data ['time'];
							$n->maxTemp = $maxTemp;
							$n->minTemp = $minTemp;
							array_push ( $trips, $n );
								
							$maxTemp = array ();
							$minTemp = array ();
						}
	
						$currentState = $newState;
						// Set State transition time
						$stateTransTime = $fdate->dateTime->getTimestamp ();
					}
						
					$distance += reportUtils::getDistance ( $data ['latitude'], $data ['longitude'], $lastLatitude, $lastLongitude );
						
					if ($computeTemperature == true) {
						for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
								
							$ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
								
							if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
								$maxTemp [$tp] = $ctemp;
							else
								$maxTemp [$tp] = $ctemp;
								
							if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
								$minTemp [$tp] = $ctemp;
							else
								$minTemp [$tp] = $ctemp;
						}
					}
						
					if ($data ['speed'] > $maxSpeed)
						$maxSpeed = $data ['speed'];
						
					$lastLatitude = $data ['latitude'];
					$lastLongitude = $data ['longitude'];
						
					break;
	
				case STATUS_NOGPS:
					if ($data != false) {
						$newState = $this->getStatus ( $data );
					}else {
						$exit = true;
						$data = $oldData;
					}
						
					if ($newState != $currentState || $data == false) {
	
						$fdate->setUTCDate ( $data ['date'], $data ['time'] );
						$cTime = $fdate->dateTime->getTimestamp ();
	
						$n = new tripRObject ();
						$n->status = $currentState;
						$n->latitude = $lastLatitude;
						$n->longitude = $lastLongitude;
						$n->duration = $cTime - $stateTransTime;
						$n->date = $data['date'];
						$n->time = $data['time'];
						array_push ( $trips, $n );
						$stateTransTime = $cTime;
	
						$currentState = $newState;
					}
					break;
						
				case STATUS_STOPPED :
					// Both STOPPED and IDLE follow the same logic and correspondingly emits out correct records
	
				case STATUS_IDLE :
					if ($data != false) {
						$newState = $this->getStatus ( $data );
	
						$fdate->setUTCDate ( $data ['date'], $data ['time'] );
						$cTime = $fdate->dateTime->getTimestamp ();
	
						if ($computeTemperature == true) {
							for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
	
								$ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
	
								if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
									$maxTemp [$tp] = $ctemp;
								else
									$maxTemp [$tp] = $ctemp;
	
								if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
									$minTemp [$tp] = $ctemp;
								else
									$minTemp [$tp] = $ctemp;
							}
						}
	
						// If the time difference is greater then trips breaking
						// time then emit out
						if ($newState == STATUS_NOGPS){
							$emitOut = true;
							$data = $oldData;
						}else if ($currentState == STATUS_STOPPED) {
								
							if (($cTime - $stateTransTime) > ($TRIPS_STOP_BREAKING_TIME * 60))
								$emitOut = true;
							else
								$emitOut = false;
								
						} else {
							if (($cTime - $stateTransTime) > ($TRIPS_IDLE_BREAKING_TIME * 60))
								$emitOut = true;
							else
								$emitOut = false;
						}
	
					}
						
					if ($newState != $currentState || $data == false) {
						// Emit Packet and Set new state
						if ($emitOut || $data == false) {
	
							if ($data == false) {
								$exit = true;
								$data = $oldData;
								if ($emitOut == false) break;
							}
								
							$fdate->setUTCDate ( $data ['date'], $data ['time'] );
							$lastTripIndex = count ( $trips ) - 1;
							if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == $currentState) {
								$trips [$lastTripIndex]->date = $data ['date'];
								$trips [$lastTripIndex]->time = $data ['time'];
								$trips [$lastTripIndex]->latitude = $data ['latitude'];
								$trips [$lastTripIndex]->longitude = $data ['longitude'];
								$trips [$lastTripIndex]->distance = 0;
								$trips [$lastTripIndex]->maxSpeed = 0;
								$trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
							} else {
								$n = new tripRObject ();
								$n->status = $currentState;
								$n->latitude = $lastLatitude; // $data['latitude'];
								$n->longitude = $lastLongitude; // $data['longitude'];
								$n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
								$n->date = $data ['date'];
								$n->time = $data ['time'];
								array_push ( $trips, $n );
							}
								
							$stateTransTime = $fdate->dateTime->getTimestamp ();
							$distance = 0;
								
							$lastLatitude = $data ['latitude'];
							$lastLongitude = $data ['longitude'];
								
							$maxSpeed = $data ['speed'];
								
								
							if ($computeTemperature == true) {
								$minTemp = array ();
								$maxTemp = array ();
	
								for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
									$minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
								}
							}
						}
						$currentState = $newState;
					}
					break;
			}
			$oldData = $data;
		}
		return $trips;
	}
    
    
    private function computeParameters($tid, $dateArray, $days) {
        $geo = new GEOCODER();
        $this->rDatabase->reports_getLocationsData ( $tid, $dateArray );
        $daysCount = count ( $days );
        
        $sdate = new FNSDateTime ( $_SESSION ['timezone'] );
        $edate = new FNSDateTime ( $_SESSION ['timezone'] );
        $pdate = new FNSDateTime ( $_SESSION ['timezone'] );
        $npdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        $lastData = $this->rDatabase->reports_nextLocation ();
        $data = $this->rDatabase->reports_nextLocation ();
        // $nextData = $this->rDatabase->reports_nextLocation ();
        //echo '<pre>';print_r($data);echo '</pre>';
        
        for($x = 0; $x < $daysCount - 1; $x ++) {
            $sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
            $edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
            
            $days [$x]->distance = 0;

            while ( 1 ) {
                $pdate->setUTCDate ( $data ['date'], $data ['time'] );

//*************             
                $data['Converted Time'] = $pdate->getFormattedString();
                
//*************
                
                if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
                    
                    //$checkState = $this->getStatus ( $data );
                    //if($checkState === 'STATUS_IDLE') {
                    //    $ts = $pdate->dateTime->getTimestamp();
                    //    $days[$x]->iduration = $pdate->setTimestamp($ts - $data['duration']);
                    //}
                    
                    // Speed computations
                    if (isset ( $data ['IO'] ) && strpos ( $data ['IO'], 'j' ) !== false && $data ['speed'] > 0 ) {
                        // ignition is on
                        $npdate->setUTCDate ( $lastData ['date'], $lastData ['time'] );
                        
                        $difference = $pdate->dateTime->getTimestamp () - $npdate->dateTime->getTimestamp ();
                        if ($difference <= IGNITION_DIFF_THRESHOLD_TIME) {
                            $days [$x]->mDuration += $difference;
                            $days [$x]->distance += reportUtils::getDistance($data ['latitude'], $data ['longitude'], $lastData ['latitude'], $lastData ['longitude']);
                        }
                        if (!isset($days[$x]->firstIgnition['latitude'])) {             //For latitude and longitude of first ignition, useful in which j packet is not received
                            $days[$x]->firstIgnition['latitude'] = $lastData ['latitude'];
                            $days[$x]->firstIgnition['longitude'] = $lastData ['longitude'];
                        }
                    }
                    
                    if ($data ['speed'] > $days [$x]->maxSpeed)
                        $days [$x]->maxSpeed = $data ['speed'];
                    
                    $lastData = $data;
                    $data = $this->rDatabase->reports_nextLocation ();
                    if ($data == false)
                        break;
                } else
                    break; // if
                
            } // While

            if ($days [$x]->distance != 0) {
                $distance = $days [$x]->distance * 0.621371;
                
                $days [$x]->distance = $this->mConverter->convert ( $distance, "D" );
                $days [$x]->maxSpeed = $this->mConverter->convert ( $days [$x]->maxSpeed, "S" );
                
                if ($days [$x]->mDuration != 0)
                    $days [$x]->avgSpeed = $this->mConverter->convert ( $distance / ($days [$x]->mDuration / 3600), "S" );
                else
                    $days [$x]->avgSpeed = 0;
                
                if ($days [$x]->avgSpeed >= $days [$x]->maxSpeed) {
                    $days [$x]->maxSpeed = ceil ( $days [$x]->avgSpeed );
                }
                
                $days [$x]->latitude = $data ['latitude'];
                $days [$x]->longitude = $data ['longitude'];
            }
            $days[$x]->lastIgnition['latitude'] = $lastData ['latitude'];   //For latitude and longitude of last ignition, useful in which j packet is not received
            $days[$x]->lastIgnition['longitude'] = $lastData ['longitude'];
            
            $driver=$this->rDatabase->getDriverName ( $tid, $days[$x]->date, $days[$x]->time );  
            if($driver=="") { $driver="Unknown"; }
            $days[$x]->driver=$driver;
            
        } // for daysCount
        
        
        for($x = 0; $x < $daysCount - 1; $x ++) {
            $sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
            $edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
            $ign_result = $this->rDatabase->reports_getEventsData($tid,array('sdate' => $days[$x]->date, 'stime' => $days[$x]->time, 'edate' => $days[$x+1]->date, 'etime'=>$days[$x+1]->time),array(EVENT_START_ENGINE), true);

            if ($days[$x]->distance != 0 && $ign_result != false) {
                $days[$x]->firstIgnition = $ign_result[0];
                $days[$x]->lastIgnition = $ign_result[count($ign_result)-1];
            }
            $loc = $geo -> search($days[$x]->firstIgnition['latitude'],$days[$x]->firstIgnition['longitude'],true);
            $days[$x]->firstIgnition['location'] = $loc['location'];
            $loc = $geo -> search($days[$x]->lastIgnition['latitude'],$days[$x]->lastIgnition['longitude'],true);
            $days[$x]->lastIgnition['location'] = $loc['location'];
        } // for daysCount
                    
        //Ideal Time calculation start
        $this->rDatabase->reports_getLocationsData($tid, $dateArray);
        $tripsArray  = $this->computeTrips($tid);

        $daysCount = count($days);

        $sdate = new FNSDateTime($_SESSION['timezone']);
        $edate = new FNSDateTime($_SESSION['timezone']);
        $pdate = new FNSDateTime($_SESSION['timezone']);


        $tripsCount = count($tripsArray);
        $y=0;

        for ($x=0 ; $x < $daysCount-1; $x++)
        {
            $sdate->setUTCDate($days[$x]->date, $days[$x]->time);
            $edate->setUTCDate($days[$x+1]->date, $days[$x+1]->time);

            $darray = array();

            for ( ;$y < $tripsCount; $y++)
            {
                    $pdate->setUTCDate($tripsArray[$y]->date, $tripsArray[$y]->time);

                    if ( $pdate->dateTime->getTimestamp() >= $sdate->dateTime->getTimestamp() && $pdate->dateTime->getTimestamp() < $edate->dateTime->getTimestamp() )
                    {

                            if ($tripsArray[$y]->status == STATUS_IDLE)
                            {
                                    $ts = $pdate->dateTime->getTimestamp();
                                    $pdate->setTimestamp($ts - $tripsArray[$y]->duration);

                                    $tripsArray[$y]->startDate = $pdate->UTCDateString;
                                    $tripsArray[$y]->startTime = $pdate->UTCTime;

                                    array_push($darray,$tripsArray[$y]);
                            }
                    }else break;

            }//for dcount

            $dc = count($darray);
            if ($dc > 0)
            {
                    $days[$x]->trips = $darray;
            }

        }
        
        //Ideal Time calculation end
        
        return $days;
    }
    private function getTrackersList() {
        global $GDATABASE;
        $trackers = $GDATABASE->getTrackersList ( "trackerid" );
        $a = array ();
        $tcount = count ( $trackers );
        for($i = 0; $i < $tcount; $i ++) {
            array_push ( $a, $trackers [$i] ['trackerid'] );
        }
        return $a;
    }
    private function getReportData() {
        global $GDATABASE;
        $arrdate = reportUtils::getUTCReportTime ( $_GET );
        
        if ($_GET ['ftype'] == "E") {
            $trackers = $this->getTrackersList ();
        } else {
            $trackers = explode ( ",", $_GET ['trackers'] );
        }
        
        $tcount = count ( $trackers );
        
        $display_array = array ();
        
        for($i = 0; $i < $tcount; $i ++) {
            $days = reportUtils::getDays ( $arrdate, $_SESSION ['timezone'] );
            $result = $this->computeParameters ( $trackers [$i], $arrdate, $days );

            $arr = array ();
            
            $arr ['tinfo'] = $GDATABASE->getTrackerCard ( $trackers [$i] );
            $arr ['details'] = $GDATABASE->rp_getTrackersDetails ( $trackers [$i] );
            $arr ['result'] = $result;

            //var_dump($result);
            array_push ( $display_array, $arr );
        }
        //echo '<pre>';print_r($display_array);echo '</pre>';
        switch ($_GET ['format']) {
            case "HTML" :
                CONSOLIDATED_Output_HTML::printHTML ( $display_array );
                break;
            case "PDF" :
                $pdf = new CONSOLIDATED_Output_PDF ();
                $pdf->printPDF ( $display_array );
                break;
            case "XLSX" :
                ob_clean();
                CONSOLIDATED_Output_XLSX::printXLSX ( $display_array );
                break;
        }
    }
    public static function  islammmonth($arr)
    {
        $day=$arr[2];
$month=$arr[1];
$year=$arr[0];
switch($month)
{
    case 1:
    $month="Muharram";
    break;
    case 2:
    $month="Ṣafar";
    break;
    case 3;
    $month="Rabī‘ al-awwal";
    break;
    case 4:
    $month="Rabī‘ ath-thānī";
    break;
    case 5:
    $month="Jumādá al-ūlá";
    break;
    case 6:
    $month="Jumādá al-ākhirah";
    break;
    case 7:
    $month="Rajab";
    break;
    case 8:
    $month="Sha‘bān";
    break;
    case 9:
    $month="Ramaḍān";
    break;
    case 10:
    $month="Shawwāl";
    break;
    case 11:
    $month="Dhū al-Qa‘dah";
    break;
    case 12:
    $month="Dhū al-Ḥijjah";
    break;
}
return $day.' '.$month.' '.$year;
    }
  public static function intPart($floatNum)
    {
      if ($floatNum< -0.0000001){
         return ceil($floatNum-0.0000001);
    }
    return floor($floatNum+0.0000001);
    }
    
    public static function Greg2Hijri($day, $month, $year)
    {



    $day   = (int) $day;
    $month = (int) $month;
    $year  = (int) $year;
    //var_dump($day,$month,$year);

    if (($year > 1582) or (($year == 1582) and ($month > 10)) or (($year == 1582) and ($month == 10) and ($day > 14)))
    {
        $jd = self::intPart((1461*($year+4800+self::intPart(($month-14)/12)))/4)+self::intPart((367*($month-2-12*(self::intPart(($month-14)/12))))/12)-
        self::intPart( (3* (self::intPart(  ($year+4900+    self::intPart( ($month-14)/12)     )/100)    )   ) /4)+$day-32075;
    }
    else
    {
        $jd = 367*$year-self::intPart((7*($year+5001+self::intPart(($month-9)/7)))/4)+self::intPart((275*$month)/9)+$day+1729777;
    }

    $l = $jd-1948440+10632;
    $n = self::intPart(($l-1)/10631);
    $l = $l-10631*$n+354;
    $j = (self::intPart((10985-$l)/5316))*(self::intPart((50*$l)/17719))+(self::intPart($l/5670))*(self::intPart((43*$l)/15238));
    $l = $l-(self::intPart((30-$j)/15))*(self::intPart((17719*$j)/50))-(self::intPart($j/16))*(self::intPart((15238*$j)/43))+29;
    
    $month = self::intPart((24*$l)/709);
    $day   = $l-self::intPart((709*$month)/24);
    $year  = 30*$n+$j-30;
    
    $date = array();
   
    array_push($date,$year,$month,$day);
     return $date;
}
    public function execute() {
        global $MYLANGUAGE;
        $MYLANGUAGE = new FNSLanguage ();
        
        $this->mConverter = new metricConverter ();
        $this->mConverter->setMetrics ( $_GET ['metric'] );
        $this->rDatabase = new reportingQueries ();
        
        $this->getReportData ();
    }
}
?>

