<?php

/**
 * @version: 5.1
 */

require_once (REPORTS_FOLDER."/reportUtils.php");
require_once (DATABASE_FOLDER."/reportingQueries.php");
require_once (GRAPH_LIB_FOLDER . '/src/jpgraph.php');
require_once (GRAPH_LIB_FOLDER . '/src/jpgraph_bar.php');
require_once (GEOCODER_FOLDER."/geo.php");
require_once (PHPExcelPath . '/Classes/PHPExcel.php');
require_once (mPDF_FOLDER . "/mpdf.php");

class CONSUMPTIONDFM_Output_XLSX {
	public static function printXLSX($arrDis) {
		$summary = array ();
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );

		global $GDATABASE, $MYLANGUAGE;

		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );

		$aCount = count ( $arrDis [0] ['result'] );

		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();

		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();

		$objPHPExcel = new PHPExcel ();
		$sheetProperties = $objPHPExcel->getProperties ();
		$sheetProperties->setCreator ( "Find'n'Secure" );
		$sheetProperties->setTitle ( $MYLANGUAGE->getString ( 'CONSOLIDATED' ) );
		$sheetProperties->setDescription ( $MYLANGUAGE->getString ( 'CON_INFO' ) );

		$myWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, 'Report' );
		$objPHPExcel->addSheet ( $myWorkSheet, 0 );

		$summaryWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, 'Summary' );
		$objPHPExcel->addSheet ( $summaryWorkSheet, 1 );

		$objPHPExcel->setActiveSheetIndex ( 0 );

		// set font-family and size
		$objPHPExcel->getDefaultStyle ()->getFont ()->setName ( 'Arial' );
		$objPHPExcel->getDefaultStyle ()->getFont ()->setSize ( 10 );

		// set default column widths
		for($i = 'A'; $i <= 'F'; $i ++) {
			$myWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
			$summaryWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
		}

		// set margins
		$myWorkSheet->getPageMargins ()->setRight ( 0.125 );
		$myWorkSheet->getPageMargins ()->setLeft ( 0.125 );

		// set page orientation
		$myWorkSheet->getPageSetup ()->setPaperSize ( PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4 );
		$myWorkSheet->getPageSetup ()->setFitToWidth ( 1 );
		$myWorkSheet->getPageSetup ()->setFitToHeight ( 0 );

		$row = 2;

		// report heading
		$myWorkSheet->SetCellValue ( "A$row", $MYLANGUAGE->getString ( 'CONSUMPTION' ) );
		$myWorkSheet->mergeCells ( "A$row:E" . ($row + 4) );
		$headingStyle = array (
			'font' => array (
				'bold' => true,
				'size' => 16
			),
			'alignment' => array (
				'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
				'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP
			)
		);
		$myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
		$myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );

		// company logo
		$logo = new PHPExcel_Worksheet_Drawing ();
		$logo->setPath ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' );
		$logo->setWorksheet ( $myWorkSheet );
		$logo->setCoordinates ( 'I' . $row );
		$myWorkSheet->mergeCells ( "F$row:L" . ($row + 4) );
		$myWorkSheet->getStyle('F'.$row)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
		//$logo->setOffsetX(125);
		$row = 9;

		// company details
		$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'COMPANY_NAME' ) );
		$myWorkSheet->SetCellValue ( 'B' . $row, $answer [0] ['company'] );
		$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'USERNAME' ) );
		$myWorkSheet->SetCellValue ( 'E' . $row, $answer [0] ['username'] );
		$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
		$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );

		$row ++;

		$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
		$myWorkSheet->SetCellValue ( 'B' . $row, $sdate );
		$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
		$myWorkSheet->SetCellValue ( 'E' . $row, $edate );
		$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
		$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );

		$row += 2;

		// report details
		$detailsStyle = array (
			'borders' => array (
				'inside' => array (
					'style' => PHPExcel_Style_Border::BORDER_THIN,
					'color' => array (
						'argb' => 'FFFFFFFF'
					)
				)
			),

			'fill' => array (
				'type' => PHPExcel_Style_Fill::FILL_SOLID,
				'startcolor' => array (
					'argb' => 'FFDDDDDD'
				)
			)
		);

		$tCount = count ( $arrDis );
		$sumtable = array();

		for($i = 0; $i < $tCount; $i ++) {
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

			$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TRACKER_NAME' ) );
			$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['tinfo'] [0] ['name'] );
			$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'APPLICATION' ) );
			$myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( $apptype ) );
			$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
			$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
			$myWorkSheet->getStyle ( "A$row:L$row" )->applyFromArray ( $detailsStyle );
			$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );

			$row ++;

			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LICENSEPLATE' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['licensePlate'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'VTYPE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['vtype'] );
			}

			if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
			}

			if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REFNO' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['arefno'] );
			}

			if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
			}

			$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
			$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
			$myWorkSheet->getStyle ( "A$row:L$row" )->applyFromArray ( $detailsStyle );
			$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );

			$row += 3;

			$ecount = count($arrDis[$i]['result']);
			$sumtable[$arrDis[$i]['tinfo'][0]['name']] = array();
			$sumtable[$arrDis[$i]['tinfo'][0]['name']]['data'] = array();

			$grandtotal = 0;
			$grandtotalDistance = 0;

			for ($j=0; $j < $ecount-1; $j++)
			{
				if ( isset($arrDis[$i]['result'][$j]->graph)) {
					if ($j % 2 == 1) $backgroundColor = "#FaFaFa";
					else $backgroundColor = "#F2F2F2";

					$fdate->setUTCDate($arrDis[$i]['result'][$j]->date, $arrDis[$i]['result'][$j]->time);
					$sdate = $fdate->getFormattedDateString();

					// Consumption Graph
					$graph = new PHPExcel_Worksheet_MemoryDrawing ();
					$graph->setName("Consumption Graph For $sdate");
					$graph->setDescription("Consumption Graph For $sdate");
					$gdimage = imagecreatefromstring($arrDis[$i]['result'][$j]->graph);
					$graph->setImageResource($gdimage);
					$graph->setRenderingFunction(PHPExcel_Worksheet_MemoryDrawing::RENDERING_PNG);
					$graph->setMimeType(PHPExcel_Worksheet_MemoryDrawing::MIMETYPE_DEFAULT);
					$graph->setWorksheet($myWorkSheet);
					$graph->setCoordinates('A' . $row);
					$myWorkSheet->mergeCells("A$row:L" . ($row + 16));

					$row += 18;

					$sumtable[$arrDis[$i]['tinfo'][0]['name']]['data'][$sdate] = $arrDis[$i]['result'][$j];
					$grandtotal += $arrDis[$i]['result'][$j]->net;
					$grandtotalDistance += $arrDis[$i]['result'][$j]->distance;
				}
			}// for J

			$sumtable[$arrDis[$i]['tinfo'][0]['name']]['gtotal'] = $grandtotal;
			$sumtable[$arrDis[$i]['tinfo'][0]['name']]['gdtotal'] = $grandtotalDistance;

		}//for I

		$row=1;
		$avgunit = $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" )." / ".$MYLANGUAGE->getString ( "LITRE" );

		foreach ($sumtable as $k=>$v) {
			$summaryWorkSheet->setCellValue('A'.$row, $k);
			$summaryWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$summaryWorkSheet->getStyle ( 'A' . $row )->getFont ()->setSize(16);
			$row++;

			$summaryWorkSheet->setCellValue('A'.$row, $MYLANGUAGE->getString ( 'DATE' ));
			$summaryWorkSheet->setCellValue('B'.$row, $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')');
			$summaryWorkSheet->setCellValue('C'.$row, $MYLANGUAGE->getString ( 'CONSUMPTION' ) . " (" . $MYLANGUAGE->getString ( "LITRE" ) . ')');
			$summaryWorkSheet->setCellValue('D'.$row, $avgunit);
			$summaryWorkSheet->getStyle ("A$row:D$row")->getFont ()->setSize(12)->setBold(true);

			$row++;
			foreach($v['data'] as $kk => $vv) {
				$summaryWorkSheet->setCellValue('A' . $row, $kk);
				$summaryWorkSheet->setCellValue('B' . $row, $vv->distance);
				$summaryWorkSheet->setCellValue('C' . $row, $vv->net);
				$avg = sprintf("%0.2f", $vv->distance / $vv->net);
				$summaryWorkSheet->setCellValue('D' . $row, $avg);
				$row++;
			}
			$row++;
			$summaryWorkSheet->setCellValue('B'.$row, $v['gdtotal']);
			$summaryWorkSheet->setCellValue('C'.$row, $v['gtotal']);
			$avg = sprintf("%0.2f",$v['gdtotal'] /$v['gtotal']);
			$summaryWorkSheet->setCellValue('D'.$row, $avg);

			$row+=2;
		}

		$objPHPExcel->setActiveSheetIndex ( 0 );

		// redirect output to browser
		header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
		header ( 'Content-Disposition: attachment;filename="report.xlsx"' );
		header ( 'Cache-Control: max-age=0' );
		$objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
		$objWriter->save ( 'php://output' );
	}
}

class CONSUMPTIONDFM_Output_PDF {
	public $pdf;
	public static $txtDirection;
	public static $revDirection;
	public static $direction;
	private function initializePDF() {
		global $MYLANGUAGE;

		$this->pdf = new mPDF ( "utf-8", "LETTER" );

		$this->pdf->SetCreator ( "Find'n'Secure" );
		$this->pdf->SetAuthor ( 'EMBARC' );
		$this->pdf->SetTitle ( $MYLANGUAGE->getString ( 'CONSUMPTION' ) );
		$this->pdf->SetSubject ( $MYLANGUAGE->getString ( 'CONSUMPTION' ) );
		$this->pdf->SetKeywords ( "Consumption, Report, Findnsecure" );

		// set default header data
		$header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . $MYLANGUAGE->getString ( 'CONSUMPTION' ) . '</td><td align="' . self::$revDirection . '"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
		$this->pdf->SetHTMLHeader ( $header, "E" );
		$this->pdf->SetHTMLHeader ( $header, "O" );
		$this->pdf->SetTopMargin ( 30 );

		// $this->pdf->SetDirectionality("rtl");
		$this->pdf->SetAutoFont ( AUTOFONT_ALL );
		$this->pdf->SetDirectionality ( self::$direction );
	}
	public function printPDF($arrDis) {
		global $GDATABASE, $MYLANGUAGE, $languageMatrix;

		if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
			self::$direction = $direction = "ltr";
		} else {
			self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
		}

		switch ($direction) {
			case "ltr" :
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl" :
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}

		$left = self::$txtDirection;
		$right = self::$revDirection;

		ob_start ();
		print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<style>' . file_get_contents ( CSS_FOLDER . '/reports_pdf.css' ) . '*{direction:' . $direction . ';} </style>
				</head>
				<body class="mainbody">
			  ';

		$summary = array ();

		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );

		$this->initializePDF ();

		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		$aCount = count ( $arrDis [0] ['result'] );

		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();

		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();

		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>

			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>

		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';

		$tCount = count ( $arrDis );
		$sumtable = '';

		for($i = 0; $i < $tCount; $i ++) {

			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

			print '<br><table width="100%" class ="topBottom10pxPadding">
			<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
			</tr>';

			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			}

			print "</table>";

			print '<table width="100%" cellSpacing=2 cellpadding="2" border=0 frame="hsides" bordercolor="#999999" rules="rows" style="font-size:14px;font-family:Arial" >';

			$ecount = count($arrDis[$i]['result']);
			$sumtable .= '<table width="100%" cellSpacing=2 cellpadding="2" border=0 frame="hsides" bordercolor="#999999" rules="rows" style="font-size:11px;font-family:Arial" >';
			$sumtable .= "<tr><td colspan='4' style='font-family:Arial; font-weight:bold; font-size:16px'>{$arrDis[$i]['tinfo'][0]['name']}</td></tr>";

			$avgunit = $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" )." / ".$MYLANGUAGE->getString ( "LITRE" );

			$sumtable .= '<tr align="' . $left . '">
			<th style="font-size:14px" align="' . $left . '">' . $MYLANGUAGE->getString ( 'DATE' ) . '</th>
			<th style="font-size:14px" align="' . $left . '">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
			<th style="font-size:14px" align="' . $left . '">' . $MYLANGUAGE->getString ( 'CONSUMPTION' ) . " (" . $MYLANGUAGE->getString ( "LITRE" ) . ')</th>
			<th style="font-size:14px" align="' . $left . '">' . $avgunit . '</th>
			</tr>';


			$grandtotal = 0;
			$grandtotalDistance = 0;

			for ($j=0; $j < $ecount-1; $j++)
			{
				if (isset($arrDis[$i]['result'][$j]->graph)){
					if ($j % 2 == 1) $backgroundColor = "#FaFaFa";
					else $backgroundColor = "#F2F2F2";
					$fdate->setUTCDate($arrDis[$i]['result'][$j]->date, $arrDis[$i]['result'][$j]->time);
					$sdate = $fdate->getFormattedDateString();
					$avg = sprintf("%0.2f",$arrDis[$i]['result'][$j]->distance /$arrDis[$i]['result'][$j]->net);
					print '<tr><td>&nbsp;</td></tr><tr style="background-color:#BBBBBB;height:20px; padding-top:10px;"><td colspan="5" style="font-family:Arial; font-weight:bold; font-size:12px"> <img src="data:image/png;base64,'.base64_encode($arrDis[$i]['result'][$j]->graph).'"></td></tr>';
					$sumtable .= "<tr><td style='font-size:14px'>$sdate</td><td style='font-size:14px'>{$arrDis[$i]['result'][$j]->distance}</td><td style='font-size:14px'>{$arrDis[$i]['result'][$j]->net}</td><td style='font-size:14px'>{$avg}</td></tr>";
					$grandtotal += $arrDis[$i]['result'][$j]->net;
					$grandtotalDistance += $arrDis[$i]['result'][$j]->distance;
				}
			}// for J
			$avg = sprintf("%0.2f",$grandtotalDistance /$grandtotal);
			$sumtable .= "<tr><td></td><td style='font-size:14px;font-weight:bold'>{$grandtotalDistance}</td><td style='font-size:14px;font-weight:bold'>{$grandtotal}</td><td style='font-size:14px;font-weight:bold'>{$avg}</td></tr></table>".'<br><div class="dashes"> </div><br/>';

			print "</table>";

			print '<br><div class="dashes"> </div><br/>';

		}//for I

		print $sumtable;

		$contents = ob_get_contents ();
		ob_end_clean ();

		$this->pdf->WriteHTML ( $contents );
		$this->pdf->Output ();
	}
}


class CONSUMPTIONDFM_Output_HTML
{
	public static $txtDirection;
	public static $revDirection;
	public static $direction;
	
	
	public static function printHeader() {
		global $MYLANGUAGE, $languageMatrix;
	
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
	
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}
	
		print '
				<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>' . $MYLANGUAGE->getString ( 'CONSUMPTION' ) . '</title>
				<style>'. file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:'.$direction.';} </style>
				</head>
				<body class="mainbody" style="background-color:#999; background-image:none">
			    <div id="reportframe">
			    <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
			  ';
	}
	
	public static function printHTML($arrDis)
	{

		ob_start();

		$summary = array();

		$fdate = new FNSDateTime($_SESSION['timezone']);

		global $GDATABASE,$MYLANGUAGE;

		$answer = $GDATABASE->getAccountCard($_SESSION['username']);

		CONSUMPTIONDFM_Output_HTML::printHeader();
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$aCount = count($arrDis[0]['result']);

		$fdate->setUTCDate($arrDis[0]['result'][0]->date, $arrDis[0]['result'][0]->time);
		$sdate = $fdate->getFormattedString();

		$fdate->setUTCDate($arrDis[0]['result'][$aCount-1]->date, $arrDis[0]['result'][$aCount-1]->time);
		$edate = $fdate->getFormattedString();

		
		print '<table width="100%" class="topBottom10pxPadding"><tr><td>'.$MYLANGUAGE->getString('CONSUMPTION').'</td><td align="'.$right.'"><img src="data:image/png;base64,'. base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) .'"/></td></tr></table>';

		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">'.$MYLANGUAGE->getString('COMPANY_NAME').'</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">'.$answer[0]['company'].'</div></td>
			
			<td width="120px"><div class="tableHeading">'.$MYLANGUAGE->getString('USERNAME').'</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">'.$answer[0]['username'].'</div></td>
		</tr>
		
		<tr>
			<td ><div class="tableHeading">'.$MYLANGUAGE->getString('START_DATE').'</div></td>
			<td style="font-weight:bold"><div class="tableHeading">'.$sdate.'</div></td>
			<td ><div class="tableHeading">'.$MYLANGUAGE->getString('END_DATE').'</div></td>
			<td style="font-weight:bold"><div class="tableHeading">'.$edate.'</div></td>
		</tr>
		</table>';

		$tCount = count($arrDis);
		$sumtable = '';
		for ($i = 0; $i < $tCount; $i++)
		{
			print '<br><table width="100%" class ="topBottom10pxPadding" >
			<tr style="background-color:#dddddd">
			<td class="subHeading" style="font-weight:bold" width="100px">'.$MYLANGUAGE->getString('TRACKER_NAME').':</td><td class="subHeading" width="250px">'.$arrDis[$i]['tinfo'][0]['name'].'</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> '.$MYLANGUAGE->getString('APPLICATION').':</td><td class="subHeading">'.$MYLANGUAGE->getString($arrDis[$i]['details'][0]['apptype']).'</td>
			</tr>';
				
			if ($arrDis[$i]['details'][0]['apptype'] == "VT")
			{
				print '<tr style="background-color:#dddddd">
			<td class="subHeading" style="font-weight:bold" width="100px">'.$MYLANGUAGE->getString('LICENSEPLATE').':</td><td class="subHeading" width="250px">'.$arrDis[$i]['details'][0]['licensePlate'].'</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> '.$MYLANGUAGE->getString('VTYPE').':</td><td class="subHeading">'.$arrDis[$i]['details'][0]['vtype'].'</td>
			</tr>';
			}
				
			if ($arrDis[$i]['details'][0]['apptype'] == "PT")
			{
				print '<tr style="background-color:#dddddd">
			<td class="subHeading" style="font-weight:bold" width="100px">'.$MYLANGUAGE->getString('PNAME').':</td><td class="subHeading" width="250px">'.$arrDis[$i]['details'][0]['pname'].'</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> '.$MYLANGUAGE->getString('MOBILE').':</td><td class="subHeading">'.$arrDis[$i]['details'][0]['pmobile'].'</td>
			</tr>';
			}
				
			if ($arrDis[$i]['details'][0]['apptype'] == "AT")
			{
				print '<tr style="background-color:#dddddd">
			<td class="subHeading" style="font-weight:bold" width="100px">'.$MYLANGUAGE->getString('REFNO').':</td><td class="subHeading" width="250px">'.$arrDis[$i]['details'][0]['arefno'].'</td>
			</tr>';
			}
			print "</table>";

			print '<table width="100%" cellSpacing=2 cellpadding="2" border=1 frame="hsides" bordercolor="#999999" rules="rows" style="font-size:14px;font-family:Arial" >';

			$ecount = count($arrDis[$i]['result']);
			$sumtable .= '<table width="100%" cellSpacing=2 cellpadding="2" border=1 frame="hsides" bordercolor="#999999" rules="rows" style="font-size:11px;font-family:Arial" >';
			$sumtable .= "<tr><td colspan='4' style='font-family:Arial; font-weight:bold; font-size:16px'>{$arrDis[$i]['tinfo'][0]['name']}</td></tr>";

			$avgunit = $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" )." / ".$MYLANGUAGE->getString ( "LITRE" );

			$sumtable .= '<tr align="' . $left . '">
			<th style="font-size:14px" align="' . $left . '">' . $MYLANGUAGE->getString ( 'DATE' ) . '</th>
			<th style="font-size:14px" align="' . $left . '">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
			<th style="font-size:14px" align="' . $left . '">' . $MYLANGUAGE->getString ( 'CONSUMPTION' ) . " (" . $MYLANGUAGE->getString ( "LITRE" ) . ')</th>
			<th style="font-size:14px" align="' . $left . '">' . $avgunit . '</th>
			<th style="font-size:14px" align="' . $left . '">Price</th>
			</tr>';


			$grandtotal = 0;
			$grandtotalDistance = 0;

			for ($j=0; $j < $ecount-1; $j++)
			{
				if (isset($arrDis[$i]['result'][$j]->graph)){
					if ($j % 2 == 1) $backgroundColor = "#FaFaFa";
					else $backgroundColor = "#F2F2F2";
					$fdate->setUTCDate($arrDis[$i]['result'][$j]->date, $arrDis[$i]['result'][$j]->time);
					$sdate = $fdate->getFormattedDateString();
					$avg = sprintf("%0.2f",$arrDis[$i]['result'][$j]->distance /$arrDis[$i]['result'][$j]->net);
					$price = sprintf("%0.2f",$arrDis[$i]['result'][$j]->net*$arrDis[$i]['result'][$j]->fuelPrice);
					print '<tr><td>&nbsp;</td></tr><tr style="background-color:#BBBBBB;height:20px; padding-top:10px;"><td colspan="5" style="font-family:Arial; font-weight:bold; font-size:12px"> <img src="data:image/png;base64,'.base64_encode($arrDis[$i]['result'][$j]->graph).'"></td></tr>';
					$sumtable .= "<tr><td style='font-size:14px'>$sdate</td><td style='font-size:14px'>{$arrDis[$i]['result'][$j]->distance}</td><td style='font-size:14px'>{$arrDis[$i]['result'][$j]->net}</td><td style='font-size:14px'>{$avg}</td><td style='font-size:14px'>{$price}</td></tr>";
					$grandtotal += $arrDis[$i]['result'][$j]->net;
					$grandtotalDistance += $arrDis[$i]['result'][$j]->distance;
					$grandtotalPrice += $price;
				}
			}// for J
			$avg = sprintf("%0.2f",$grandtotalDistance /$grandtotal);
			$sumtable .= "<tr><td></td><td style='font-size:14px;font-weight:bold'>{$grandtotalDistance}</td><td style='font-size:14px;font-weight:bold'>{$grandtotal}</td><td style='font-size:14px;font-weight:bold'>{$avg}</td><td style='font-size:14px;font-weight:bold'>{$grandtotalPrice}</td></tr></table>".'<br><div class="dashes"> </div><br/>';

			print "</table>";


			print '<br><div class="dashes"> </div><br/>';

		}//for I

		print $sumtable;

		CONSUMPTIONDFM_Output_HTML::printFooter();

		$contents = ob_get_contents();
		ob_end_clean();
		print $contents;
	}

	public static function printFooter()
	{
		print '
		<br/>
		<div style="width:100%; border:1px black solid; background-color:#404040; height:10px" />
		</div></div>
		</body></html>';
	}

}


class CONSUMPTIONDFM_FNSv3_Report
{
	private $mConverter;
	private $rDatabase;

	private function getImage($xLabels, $ytitle, $values){
		$graph = new Graph(880, 250);
		$graph->SetScale("textlin");
		$graph->SetMargin(60, 30, 35, 60);
		$graph->SetShadow ();
		$graph->xaxis->SetTickLabels($xLabels);
		$graph->xaxis->SetLabelAngle (- 90 );
		$graph->yaxis->SetTextTickInterval ( 3000, 0 );

		$graph->yaxis->title->Set ($ytitle);
		$graph->yaxis->SetTitleMargin( 40 );

		//plot bar on graph
		$barplot = new BarPlot($values);
		$graph->Add($barplot);
		$barplot->value->show();
		$barplot->value->HideZero(true);
		$barplot->value->SetAlign("center");
		ob_start ();
		$graph->Stroke ();
		$contents = ob_get_contents ();
		ob_end_clean ();
		return $contents;
	}


	private function computeParameters($tid, $dateArray, $days, $fuelPulses)
	{
		global $TRACKING_EVENTS, $MYLANGUAGE, $GDATABASE;
		
		if ($_GET['events'] > 0)
		{
			$eventsParam = array($_GET['events']);
		}else {
			$eventsParam = null;
		}

		$xarray = array();
		for ($i = 0; $i <24; $i++) {
			$xarray[$i] = sprintf("%02d:00", $i);
		}

		$dataSet = $this->rDatabase->reports_getLocationsData($tid, $dateArray);
		$daysCount = count($days);

		$sdate = new FNSDateTime($_SESSION['timezone']);
		$edate = new FNSDateTime($_SESSION['timezone']);
		$pdate = new FNSDateTime($_SESSION['timezone']);
		$npdate = new FNSDateTime ( $_SESSION ['timezone'] );


		$fc=array();
		$oldDate = null;


		$geo = new GEOCODER();

		$dc = 0;

		$accInitializer = array();

		for ($i = 0; $i < 24; $i++) {
			$accInitializer[$i] = 0;
		}

		$lastData = $this->rDatabase->reports_nextLocation ();
		$data = $this->rDatabase->reports_nextLocation();

		for ($x=0 ; $x < $daysCount-1; $x++) {
			if ($data == false) break;

			$sdate->setUTCDate($days[$x]->date, $days[$x]->time);
			$edate->setUTCDate($days[$x + 1]->date, $days[$x + 1]->time);

			$days[$x]->distance = 0;
			$acc = $accInitializer;

			while (1) {
				$pdate->setUTCDate ( $data ['date'], $data ['time'] );

//*************             
                $data['Converted Time'] = $pdate->getFormattedString();
                
//*************

                if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
                    // Speed computations   
                    if ( $data['speed'] > 0 || ( strpos ( $data ['IO'], 'j' ) !== false )) {
                        // ignition is on
                        $distanceDiff = reportUtils::getDistance($data ['latitude'], $data ['longitude'], $lastData ['latitude'], $lastData ['longitude']);
            $distanceDiff *= 10 ;
            if($distanceDiff > 0 )  {
                $npdate->setUTCDate ( $lastData ['date'], $lastData ['time'] );
                            $difference = $pdate->dateTime->getTimestamp () - $npdate->dateTime->getTimestamp ();
                if($difference <= IGNITION_DIFF_THRESHOLD_TIME)
                                $days [$x]->mDuration += $difference;
                            $distanceDiff /= 10 ;
                            $days [$x]->distance += $distanceDiff ;
                             }
				



					}

					$misc = json_decode($data['misc'], true);

					//if(isset($misc['fc'])) {
					//	sscanf($misc['fc'], "%x", $fc);
					if (isset($misc['trip'])) {
						sscanf($misc['trip'], "%x", $fc);
						//Accumulator for fuel consumption graph

						$chour = floor($pdate->Time / 3600);
						$acc[$chour] += $fc/$fuelPulses;
					}
				} else break;


				$lastData = $data;
				$data = $this->rDatabase->reports_nextLocation();
				if ($data == false) break;
			}
			$net = 0;
			foreach ($acc as $i => $a) {
				$net += $a;
			}
			$fuelPrice = $_GET['fuelPrice'];
			$distance = $days [$x]->distance * 0.621371;
			$days[$x]->distance = sprintf("%0.2f",$this->mConverter->convert ( $distance, "D" ));
			$days[$x]->graph = $this->getImage($xarray, $sdate->getFormattedDateString(), $acc);
			$days[$x]->net = sprintf("%0.3f",$net);
			$days[$x]->fuelPrice = $fuelPrice;
		}

		header("Content-type:text/html");
		return $days;
	}
	private function getTrackersList()
	{
		global $GDATABASE;
		$trackers = $GDATABASE->getTrackersList("trackerid");
		$a = array();
		$tcount = count($trackers);
		for ($i=0; $i < $tcount; $i++)
		{
			array_push($a, $trackers[$i]['trackerid']);
		}
		return $a;
	}

	private function getReportData()
	{
		global $GDATABASE;
		$arrdate = reportUtils::getUTCReportTime($_GET);

		if ($_GET['ftype'] == "E")
		{
			$trackers = $this->getTrackersList();
		}else {
			$trackers = explode(",",$_GET['trackers']);
		}

		$tcount = count($trackers);

		$display_array = array();



		for ($i = 0; $i < $tcount; $i++)
		{
			$arr = array();

			$arr['tinfo'] = $GDATABASE->getTrackerCard($trackers[$i]);
			$arr['details'] = $GDATABASE->rp_getTrackersDetails($trackers[$i]);
			
			$days = reportUtils::getDays($arrdate, $_SESSION['timezone']);
			$result = $this->computeParameters($trackers[$i], $arrdate, $days, $arr['details'][0]['fuelPulses']);

			$arr['result'] = $result;
				
			array_push($display_array, $arr);
		}

		switch ($_GET['format'])
		{
			case "HTML":
				CONSUMPTIONDFM_Output_HTML::printHTML($display_array);
				break;
			case "PDF":
				$pdf = new CONSUMPTIONDFM_Output_PDF();
				$pdf-> printPDF($display_array);
				break;
			case "XLSX":
				$xls = new CONSUMPTIONDFM_Output_XLSX();
				$xls-> printXLSX($display_array);
				break;

		}

	}


	public function execute()
	{
		global $MYLANGUAGE;
		set_time_limit(0);
		$MYLANGUAGE = new FNSLanguage();

		$this->mConverter = new metricConverter();
		$this->mConverter->setMetrics($_GET['metric']);
		$this->rDatabase = new reportingQueries();

		$this->getReportData();

	}
}
?>
