<?php

/**
 * @version: 5.1
 */

require_once (REPORTS_FOLDER . "/reportUtils.php");
require_once (DATABASE_FOLDER . "/reportingQueries.php");
require_once (GEOCODER_FOLDER . '/geo.php');
require_once (mPDF_FOLDER . "/mpdf.php");
require_once (PHPExcelPath . '/Classes/PHPExcel.php');
class DAYWISEVEHICLESUMMARY_Output_XLSX {
    public static function printXLSX($arrDis) {
        
        $rDatabase = new reportingQueries();
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        global $GDATABASE, $MYLANGUAGE;
        
        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
        
        $aCount = count ( $arrDis [0] ['result'] );
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();
        
        $objPHPExcel = new PHPExcel ();
        $sheetProperties = $objPHPExcel->getProperties ();
        $sheetProperties->setCreator ( "Find'n'Secure" );
        $sheetProperties->setTitle ( 'Day Wise Vehicle Summary' );
        $sheetProperties->setDescription ( 'Day Wise Vehicle Summary' );
        
        $myWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, 'Report' );
        $objPHPExcel->addSheet ( $myWorkSheet, 0 );
        $objPHPExcel->setActiveSheetIndex ( 0 );
        
        // set font-family and size
        $objPHPExcel->getDefaultStyle ()->getFont ()->setName ( 'Arial' );
        $objPHPExcel->getDefaultStyle ()->getFont ()->setSize ( 10 );
        
        // set default column widths
        for($i = 'A'; $i <= 'T'; $i ++) {
            $myWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
        }
        
        // set margins
        $myWorkSheet->getPageMargins ()->setRight ( 0.125 );
        $myWorkSheet->getPageMargins ()->setLeft ( 0.125 );
        
        // set page orientation
        $myWorkSheet->getPageSetup ()->setPaperSize ( PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4 );
        $myWorkSheet->getPageSetup ()->setFitToWidth ( 1 );
        $myWorkSheet->getPageSetup ()->setFitToHeight ( 0 );
        
        // set rtl
        // $myWorkSheet->setRightToLeft(true);
        
        $row = 2;
        
        // report heading
        $myWorkSheet->SetCellValue ( "A$row", 'Day Wise Vehicle Summary' );
        $myWorkSheet->mergeCells ( "A$row:C" . ($row + 4) );
        $headingStyle = array (
                'font' => array (
                        'bold' => true,
                        'size' => 16 
                ),
                'alignment' => array (
                        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                        'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP 
                ) 
        );
        $myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
        $myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );
        
        // company logo
        $logo = new PHPExcel_Worksheet_Drawing ();
        $logo->setPath ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' );
        $logo->setWorksheet ( $myWorkSheet );
        $logo->setCoordinates ( 'D' . $row );
        $myWorkSheet->mergeCells ( "D$row:F" . ($row + 4) );
        $logo->setOffsetX ( 50 );
        
        $row = 9;
        
        // company details
        $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'COMPANY_NAME' ) );
        $myWorkSheet->SetCellValue ( 'B' . $row, $answer [0] ['company'] );
        $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'USERNAME' ) );
        $myWorkSheet->SetCellValue ( 'E' . $row, $answer [0] ['username'] );
        $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
        $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
        
        $row ++;
        
        $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
        $myWorkSheet->SetCellValue ( 'B' . $row, $sdate );
        $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
        $myWorkSheet->SetCellValue ( 'E' . $row, $edate );
        $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
        $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
        
        $row += 2;
        
        $detailsStyle = array (
                'borders' => array (
                        'inside' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FFFFFFFF' 
                                ) 
                        ) 
                ),
                
                'fill' => array (
                        'type' => PHPExcel_Style_Fill::FILL_SOLID,
                        'startcolor' => array (
                                'argb' => 'FFDDDDDD' 
                        ) 
                ) 
        );
        
        $rowHeadStyle = array (
                'font' => array (
                        'bold' => true,
                        'size' => 9 
                ),
                
                'borders' => array (
                        'bottom' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FF000000' 
                                ) 
                        ),
                        'top' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FF000000' 
                                ) 
                        ) 
                ),
                
                'fill' => array (
                        'type' => PHPExcel_Style_Fill::FILL_SOLID,
                        'startcolor' => array (
                                'argb' => 'FFDDDDDD' 
                        ) 
                ) 
        );
        
        $subHeadStyle = array (
                'font' => array (
                        'bold' => true,
                        'size' => 9 
                ),
                
                'borders' => array (
                        'bottom' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FFcccccc' 
                                ) 
                        ),
                        'top' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FFcccccc' 
                                ) 
                        ) 
                ),
                
                'fill' => array (
                        'type' => PHPExcel_Style_Fill::FILL_SOLID,
                        'startcolor' => array (
                                'argb' => 'FFF2F2F2' 
                        ) 
                ) 
        );
        
        $tCount = count ( $arrDis );
        
        for($i = 0; $i < $tCount; $i ++) {
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

            $VEHICLEID = $arrDis [$i] ['tinfo'] [0]['vehicleid'];
            $VEHICLEGROUP = $arrDis [$i] ['tinfo'] [0]['type'];
            $REGISTRATIONNO = (!empty($arrDis [$i] ['tinfo'] [0]['licensePlate']))?$arrDis [$i] ['tinfo'] [0]['licensePlate']:$arrDis [$i] ['tinfo'] [0] ['name'];
            
            $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TRACKER_NAME' ) );
            $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['tinfo'] [0] ['name'] );
            $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'APPLICATION' ) );
            $myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( $apptype ) );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':T' . $row );
            $myWorkSheet->getStyle ( "A$row:T$row" )->applyFromArray ( $detailsStyle );
            $myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
            $myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
            
            $row ++;
            
            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LICENSEPLATE' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['licensePlate'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'VTYPE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['vtype'] );
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REFNO' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['arefno'] );
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
            }
            
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':T' . $row );
            $myWorkSheet->getStyle ( "A$row:F$row" )->applyFromArray ( $detailsStyle );
            $myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
            $myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
            
            $row += 3;
            
            $ecount = count ( $arrDis [$i] ['result'] );
            
            $data = $arrDis [$i] ['result'];
            $initialized = false;
            $sno=0; 


            $myWorkSheet->SetCellValue ( 'A' . $row, 'SLNO');
            $myWorkSheet->SetCellValue ( 'B' . $row, 'REGISTRATION NO');
            $myWorkSheet->SetCellValue ( 'C' . $row, 'VEHICLE ID');
            $myWorkSheet->SetCellValue ( 'D' . $row, 'VEHICLE GROUP');
            $myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString('DATE' ));
            $myWorkSheet->SetCellValue ( 'F' . $row, 'START LOCATION');
            $myWorkSheet->SetCellValue ( 'G' . $row, 'NO OF STOP');
            $myWorkSheet->SetCellValue ( 'H' . $row, 'STOP DURATION (HH.MM)');
            $myWorkSheet->SetCellValue ( 'I' . $row, 'NO OF IDLE');
            $myWorkSheet->SetCellValue ( 'J' . $row, $MYLANGUAGE->getString('IDLE_DUR'));
            $myWorkSheet->SetCellValue ( 'K' . $row, 'IDLE PERCENTAGE (%)');
            $myWorkSheet->SetCellValue ( 'L' . $row, $MYLANGUAGE->getString ( 'MAX_SPEED' ) . " " . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) );
            $myWorkSheet->SetCellValue ( 'M' . $row, $MYLANGUAGE->getString ( 'AVG_SPEED' ) . " " . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) );
            $myWorkSheet->SetCellValue ( 'N' . $row, 'NO OF OVER SPEED');
            $myWorkSheet->SetCellValue ( 'O' . $row, 'TRAVEL TIME (HH.MM)');
            $myWorkSheet->SetCellValue ( 'P' . $row, 'N/W LOSS OR  STOP DURATION (HH.MM)');
            $myWorkSheet->SetCellValue ( 'Q' . $row, 'ENGINE HRS (HH.MM)');
            $myWorkSheet->SetCellValue ( 'R' . $row, 'DISTANCE TRAVELLED');
            $myWorkSheet->SetCellValue ( 'S' . $row, 'END LOCATION');
            $myWorkSheet->SetCellValue ( 'T' . $row, 'DRIVER NAME');
            $myWorkSheet->SetCellValue ( 'U' . $row, 'START PACKET TIME');
            $myWorkSheet->SetCellValue ( 'V' . $row, 'END PACKET TIME');
            $myWorkSheet->SetCellValue ( 'W' . $row, 'FIRST RUNNING RECORD');
            $myWorkSheet->SetCellValue ( 'X' . $row, 'LAST RUNNING RECORD');
            $myWorkSheet->SetCellValue ( 'Y' . $row, 'IDLE VIOLATION COUNT');
            $myWorkSheet->SetCellValue ( 'Z' . $row, 'STOPPAGE VIOLATION COUNT');
            $myWorkSheet->SetCellValue ( 'AA' . $row, 'OWNER NAME');

            $myWorkSheet->getStyle ( 'A' . $row . ':AA' . $row )->applyFromArray ( $subHeadStyle );
            
            $row ++;


            for($j = 0; $j < $ecount - 1; $j ++) {
                
                $tripsCount = count ( $data [$j]->trips );
                
                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    
                    // $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate );
                    // $myWorkSheet->mergeCells ( "A$row:T$row" );
                    // $myWorkSheet->getStyle ( 'A' . $row . ':AA' . $row )->applyFromArray ( $rowHeadStyle );
                    // $row += 2;
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    $is_one_line_print = true;
                    $report_max_speed_array = array();
                    $report_avg_speed_array = array();
                    $no_of_stop = 0;
                    $no_of_ideal = 0;
                    $no_of_stop_violatio = 0;
                    $no_of_ideal_violatio = 0;

                    
                    
                    for($k = 0; $k < $tripsCount; $k ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$j]->trips [$k];
                            $initialized = true;
                            continue;
                        }
                        
                        if ($data [$j]->trips [$k]->status == STATUS_MOVING) {

                            $IdealTime_Limit = $_GET['IDTV'];
                            $stopTime_Limit = $_GET['SOTV'];
                            
                            $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                            $sdate = $fdate->getFormattedString ();
                            $splace = $oldRecord->place ['location'];
                            $start_odometer = $oldRecord->odometer;
                            
                            $fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            $edate = $fdate->getFormattedString ();
                            $eplace = $data [$j]->trips [$k]->place ['location'];
                            $end_odometer = $data [$j]->trips [$k]->odometer;
                            
                            $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            
                            $user = $_SESSION ['username'];
                            $rec = $GDATABASE->getUserRecord ( $user );
                            $password = $rec [0] ['password'];
                            
                            $hashData = $password . $oldRecord->date . $oldRecord->time . $data [$j]->trips [$k]->date . $data [$j]->trips [$k]->time . $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                            $hash = hash ( "sha256", $hashData );
                            
                            $dstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                            $idlestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                            $drivingstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration, $MYLANGUAGE );

                            $stoppagestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->stoppagetime, $MYLANGUAGE );


                            if($data [$j]->trips [$k]->stoppagetime > 0)$no_of_stop++;
                            if($data [$j]->trips [$k]->stoppagetime > $stopTime_Limit)$no_of_stop_violatio++;

                            if($data [$j]->trips [$k]->idletime > 0)$no_of_ideal++;
                            if($data [$j]->trips [$k]->idletime > $IdealTime_Limit)$no_of_ideal_violatio++;

                           
                            
                            $driver = $data [$j]->trips [$k]->driver;
                            if ($driver == false)
                                $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                            
                            $ttemp = array ();
                            if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
                                for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
                                    if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
                                        $n = new emptyClass ();
                                        $n->index = $tp;
                                        $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$j]->trips [$k]->maxTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "°F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$j]->trips [$k]->minTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "°F";
                                        array_push ( $ttemp, $n );
                                    }
                                }
                            }
                            
                            $backgroundColor = "none";
                            
                            $net_duration += ($data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime);
                            $net_idling_duration += $data [$j]->trips [$k]->idletime;
                            $net_stoppage_duration += $data [$j]->trips [$k]->stoppagetime;
                            
                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString . "<br/>";
                            }
                           
                            $net_distance += $data [$j]->trips [$k]->distance;
                            $net_private += $data [$j]->trips [$k]->pdistance;

                            if($is_one_line_print) {

                                $is_one_line_print = false;
                                $report_splace = $splace;
                                $report_sdate = $sdate;

                                $report_start_odometer = sprintf ( "%0.2f ", $start_odometer ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" );

                                $report_accel = $hCounts['accel'];

                            } else {

                                $report_eplace = $eplace;
                                $report_edate  = $edate;

                                $report_end_odometer = sprintf ( "%0.2f ", $end_odometer ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" );
                                $report_deaccel = $hCounts['deaccel'];
                            }
                            
                            $report_max_speed_array[] = $data [$j]->trips [$k]->maxSpeed;
                            $report_avg_speed_array[] = $data [$j]->trips [$k]->avgSpeed;

                        }
                        $oldRecord = $data [$j]->trips [$k];
                    }

                    $report_avg_speed = 0;
                    $report_avg_speed_array = array_filter($report_avg_speed_array);
                    $report_avg_speed = array_sum($report_avg_speed_array)/count($report_avg_speed_array);

                    $per_of_ideal = 0;
                    $per_of_ideal = ceil((($no_of_ideal * 100) / $tripsCount));


                    $firstIgnition =  0;
                    $lastIgnition = 0;

                    if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                        $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                        $sdate = $fdate->getFormattedDateString ();

                        $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                        $edate = $fdate->getFormattedDateString ();

                        $resultData = &$arrDis [$i] ['result'] [$j];

                        $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                        $firstIgnition = $fdate->getFormattedTimeString();

                        $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                        $lastIgnition = $fdate->getFormattedTimeString ();
                    }

                    if($report_splace!='') {

                        $sno=$sno + 1;

                        if($no_of_ideal_violatio < 15)$no_of_ideal_violatio=0;
                        if($no_of_stop_violatio < 9)$no_of_stop_violatio=0;
                    
                        // origin
                        
                        // $myWorkSheet->SetCellValue ( 'G' . $row, reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) );
                        // $myWorkSheet->SetCellValue ( 'H' . $row, reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) );
                        // $myWorkSheet->SetCellValue ( 'I' . $row, reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) );
                        // $myWorkSheet->SetCellValue ( 'K' . $row, sprintf ( "%0.2f ", $net_distance ) );
                        // $myWorkSheet->SetCellValue ( 'L' . $row, sprintf ( "%0.2f ", $net_private ) );
                        // $myWorkSheet->SetCellValue ( 'M' . $row, sprintf ( "%0.2f ", $net_distance - $net_private ) );
                        // $myWorkSheet->getStyle ( "A$row:T$row" )->getFont ()->setBold ( true );
                        // $myWorkSheet->getStyle ( "A$row:T$row" )->getFont ()->getColor ()->setARGB ( 'ff017fff' );

                        $myWorkSheet->SetCellValue ( 'A' . $row, $sno);                    
                        $myWorkSheet->SetCellValue ( 'B' . $row, $REGISTRATIONNO);
                        $myWorkSheet->SetCellValue ( 'C' . $row, $VEHICLEID);
                        $myWorkSheet->SetCellValue ( 'D' . $row, $VEHICLEGROUP);
                        $myWorkSheet->SetCellValue ( 'E' . $row, date('d/m/Y',strtotime($report_sdate)));
                        $myWorkSheet->SetCellValue ( 'F' . $row, $report_splace);
                        $myWorkSheet->SetCellValue ( 'G' . $row, $no_of_stop);
                        $myWorkSheet->SetCellValue ( 'H' . $row, reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ));
                        $myWorkSheet->SetCellValue ( 'I' . $row, $no_of_ideal);
                        $myWorkSheet->SetCellValue ( 'J' . $row, reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ));
                        $myWorkSheet->SetCellValue ( 'K' . $row, $per_of_ideal.'(%)');
                        $myWorkSheet->SetCellValue ( 'L' . $row, sprintf ( "%0.1f ", max($report_max_speed_array) ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" )); 
                        $myWorkSheet->SetCellValue ( 'M' . $row, sprintf ( "%0.1f ", $report_avg_speed ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ));
                        $myWorkSheet->SetCellValue ( 'N' . $row, 0);
                        $myWorkSheet->SetCellValue ( 'O' . $row, reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ));
                        $myWorkSheet->SetCellValue ( 'P' . $row, reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ));
                        $myWorkSheet->SetCellValue ( 'Q' . $row, reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) );
                        $myWorkSheet->SetCellValue ( 'R' . $row, sprintf ( "%0.2f ", $net_distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ));
                        $myWorkSheet->SetCellValue ( 'S' . $row, $report_eplace);
                        $myWorkSheet->SetCellValue ( 'T' . $row, $driver);
                        $myWorkSheet->SetCellValue ( 'U' . $row, $report_sdate);
                        $myWorkSheet->SetCellValue ( 'V' . $row, $report_edate);
                        $myWorkSheet->SetCellValue ( 'W' . $row, $firstIgnition);
                        $myWorkSheet->SetCellValue ( 'X' . $row, $lastIgnition);
                        $myWorkSheet->SetCellValue ( 'Y' . $row, $no_of_ideal_violatio);
                        $myWorkSheet->SetCellValue ( 'Z' . $row, $no_of_stop_violatio);
                        $myWorkSheet->SetCellValue ( 'AA' . $row, '');

                        $myWorkSheet->getStyle ( "A$row:AA$row" )->getFont ()->setBold ( true );
                        $myWorkSheet->getStyle ( "A$row:AA$row" )->getFont ()->getColor ()->setARGB ( 'ff017fff' );
                        
                        $row ++;
                    }
                }
            } // for J
            $row ++;
        } // for I
          
        // redirect output to browser
        header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
        header ( 'Content-Disposition: attachment;filename="DayWiseVehicleSummary.xlsx"' );
        header ( 'Cache-Control: max-age=0' );
        $objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
        $objWriter->save ( 'php://output' );
    }
}
class DAYWISEVEHICLESUMMARY_Output_PDF {
    public $pdf;
    public static $txtDirection;
    public static $revDirection;
    public static $direction;
    private function initializePDF() {
        global $MYLANGUAGE;
        $left = self::$txtDirection;
        $right = self::$revDirection;
        
        $this->pdf = new mPDF ( "utf-8", "LETTER" );
        
        $this->pdf->SetCreator ( "Find'n'Secure" );
        $this->pdf->SetAuthor ( 'EMBARC' );
        $this->pdf->SetTitle ( 'Day Wise Vehicle Summary' );
        $this->pdf->SetSubject ( 'Day Wise Vehicle Summary' );
        $this->pdf->SetKeywords ( "Trip, Report, Findnsecure" );
        
        // set default header data
        $header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . 'Day Wise Vehicle Summary' . '</td><td align="' . $right . '"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
        $this->pdf->SetHTMLHeader ( $header, "E" );
        $this->pdf->SetHTMLHeader ( $header, "O" );
        $this->pdf->SetTopMargin ( 30 );
        
        // $this->pdf->SetDirectionality("rtl");
        $this->pdf->SetAutoFont ( AUTOFONT_ALL );
        $this->pdf->SetDirectionality ( self::$direction );
    }
    public function printPDF($arrDis) {
        global $GDATABASE, $MYLANGUAGE, $languageMatrix;
        
        if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
            self::$direction = $direction = "ltr";
        } else {
            self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
        }
        
        switch ($direction) {
            case "ltr" :
                self::$txtDirection = "left";
                self::$revDirection = "right";
                break;
            case "rtl" :
                self::$txtDirection = "right";
                self::$revDirection = "left";
                break;
        }
        
        $left = self::$txtDirection;
        $right = self::$revDirection;
        
        ob_start ();
        
        $rDatabase = new reportingQueries();
        
        $this->initializePDF ();
        
        $summary = array ();
        
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
        
        $aCount = count ( $arrDis [0] ['result'] );
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();
        
        //$header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . 'Day Wise Vehicle Summary' . '</td><td align="' . $right . '"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
        
        print '<table width="100%" class="topBottom10pxPadding" style="font-size:22px; font-weight:bold; background-color:#FFF !important;"><tr><td>Day Wise Vehicle Summary</td><td align="' . $right . '"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';
        
        print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1" style="background-color:#FFF !important;">
        <tr>
            <td style="font-weight:bold" width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
            <td><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
            
            <td style="font-weight:bold" width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
            <td><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
        </tr>
        
        <tr>
            <td style="font-weight:bold" ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
            <td><div class="tableHeading">' . $sdate . '</div></td>
            <td  style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
            <td><div class="tableHeading">' . $edate . '</div></td>
        </tr>
        </table>';
        
        $tCount = count ( $arrDis );

        
        for($i = 0; $i < $tCount; $i ++) {
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
            
            $VEHICLEID = $arrDis [$i] ['tinfo'] [0]['vehicleid'];
            $VEHICLEGROUP = $arrDis [$i] ['tinfo'] [0]['type'];
            $REGISTRATIONNO = $arrDis [$i] ['tinfo'] [0]['licensePlate'];

            print '<br><table width="100%" class ="topBottom10pxPadding">
            <tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
            </tr>';
            
            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            }
            print "</table>";
            
            $ecount = count ( $arrDis [$i] ['result'] );
            
            $data = $arrDis [$i] ['result'];
            $initialized = false;

            print '<div style="overflow:scroll;">';
            print '<table width="100%" cellspacing="3" cellpadding="3" bordercolor="#cccccc" border="1" frame="vsides" rules="rows"  class="subHeading" style="margin-top:0px;margin-bottom:0px; border: 1px dotted #aaaaaa; font-size:11px;background-color:#F2F2F2">';
                    print ' <tr >
                            <td  style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">SLNO</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">REGISTRATION NO</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">VEHICLE ID</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">VEHICLE GROUP</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">'.$MYLANGUAGE->getString('DATE' ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">START LOCATION</td>


                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">NO OF STOP</td>
                            <td style="font-weight:bold;text-transform: uppercase;" width="220px">STOP DURATION<br/>(HH.MM)</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">NO OF IDLE</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="120px">'.$MYLANGUAGE->getString('IDLE_DUR').'</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">IDLE PERCENTAGE (%)</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="100px">'.$MYLANGUAGE->getString('MAX_SPEED' ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="100px">'.$MYLANGUAGE->getString('AVG_SPEED' ) . '</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">NO OF OVER<br/>SPEED</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">TRAVEL TIME<br/>(HH.MM)</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">N/W LOSS OR <br/>STOP DURATION<br/>(HH.MM)</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">ENGINE HRS<br/>(HH.MM)</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">DISTANCE TRAVELLED</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">END LOCATION</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">DRIVER NAME</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">START PACKET TIME</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">END PACKET TIME</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">FIRST RUNNING<br/>RECORD</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">LAST RUNNING<br/>RECORD</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">IDLE<br/>VIOLATION COUNT</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">STOPPAGE<br/>VIOLATION COUNT</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">OWNER NAME</td>
                           
                    </tr>';


                                                                                          
             $sno=0;       
            
            for($j = 0; $j < $ecount - 1; $j ++) {
                
                $tripsCount = count ( $data [$j]->trips );

                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    $is_one_line_print = true;
                    $report_max_speed_array = array();
                    $report_avg_speed_array = array();
                    $no_of_stop = 0;
                    $no_of_ideal = 0;
                    $no_of_stop_violatio = 0;
                    $no_of_ideal_violatio = 0;

                    for($k = 0; $k < $tripsCount; $k ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$j]->trips [$k];
                            $initialized = true;
                            continue;
                        }
                        
                        if ($data [$j]->trips [$k]->status == STATUS_MOVING) {

                            $IdealTime_Limit = $_GET['IDTV'];
                            $stopTime_Limit = $_GET['SOTV'];
                            
                            $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                            $sdate = $fdate->getFormattedString ();
                            $splace = $oldRecord->place ['location'];
                            $start_odometer = $oldRecord->odometer;
                            
                            $fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            $edate = $fdate->getFormattedString ();
                            $eplace = $data [$j]->trips [$k]->place ['location'];
                            $end_odometer = $data [$j]->trips [$k]->odometer;
                            
                            $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            
                            $user = $_SESSION ['username'];
                            $rec = $GDATABASE->getUserRecord ( $user );
                            $password = $rec [0] ['password'];
                            
                            $hashData = $password . $oldRecord->date . $oldRecord->time . $data [$j]->trips [$k]->date . $data [$j]->trips [$k]->time . $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                            $hash = hash ( "sha256", $hashData );
                            
                            $dstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                            $idlestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                            $drivingstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration, $MYLANGUAGE );

                            $stoppagestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->stoppagetime, $MYLANGUAGE );


                            if($data [$j]->trips [$k]->stoppagetime > 0)$no_of_stop++;
                            if($data [$j]->trips [$k]->stoppagetime > $stopTime_Limit)$no_of_stop_violatio++;

                            if($data [$j]->trips [$k]->idletime > 0)$no_of_ideal++;
                            if($data [$j]->trips [$k]->idletime > $IdealTime_Limit)$no_of_ideal_violatio++;

                           
                            
                            $driver = $data [$j]->trips [$k]->driver;
                            if ($driver == false)
                                $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                            
                            $ttemp = array ();
                            if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
                                for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
                                    if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
                                        $n = new emptyClass ();
                                        $n->index = $tp;
                                        $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$j]->trips [$k]->maxTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "°F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$j]->trips [$k]->minTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "°F";
                                        array_push ( $ttemp, $n );
                                    }
                                }
                            }
                            
                            $backgroundColor = "none";
                            
                            $net_duration += ($data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime);
                            $net_idling_duration += $data [$j]->trips [$k]->idletime;
                            $net_stoppage_duration += $data [$j]->trips [$k]->stoppagetime;
                            
                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString . "<br/>";
                            }
                           
                            $net_distance += $data [$j]->trips [$k]->distance;
                            $net_private += $data [$j]->trips [$k]->pdistance;

                            if($is_one_line_print) {

                                $is_one_line_print = false;
                                $report_splace = $splace;
                                $report_sdate = $sdate;

                                $report_start_odometer = sprintf ( "%0.2f ", $start_odometer ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" );

                                $report_accel = $hCounts['accel'];

                            } else {

                                $report_eplace = $eplace;
                                $report_edate  = $edate;

                                $report_end_odometer = sprintf ( "%0.2f ", $end_odometer ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" );
                                $report_deaccel = $hCounts['deaccel'];
                            }
                            
                            $report_max_speed_array[] = $data [$j]->trips [$k]->maxSpeed;
                            $report_avg_speed_array[] = $data [$j]->trips [$k]->avgSpeed;

                        }
                        $oldRecord = $data [$j]->trips [$k];
                    }

                    $report_avg_speed = 0;
                    $report_avg_speed_array = array_filter($report_avg_speed_array);
                    $report_avg_speed = array_sum($report_avg_speed_array)/count($report_avg_speed_array);

                    $per_of_ideal = 0;
                    $per_of_ideal = ceil((($no_of_ideal * 100) / $tripsCount));


                    $firstIgnition =  0;
                    $lastIgnition = 0;

                    if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                        $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                        $sdate = $fdate->getFormattedDateString ();

                        $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                        $edate = $fdate->getFormattedDateString ();

                        $resultData = &$arrDis [$i] ['result'] [$j];

                        $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                        $firstIgnition = $fdate->getFormattedTimeString();

                        $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                        $lastIgnition = $fdate->getFormattedTimeString ();
                    }

                    if($report_splace!='') {

                        $sno=$sno + 1;

                        if($no_of_ideal_violatio < 15)$no_of_ideal_violatio=0;
                        if($no_of_stop_violatio < 9)$no_of_stop_violatio=0;

                        print '
                        <tr>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$sno.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$REGISTRATIONNO.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$VEHICLEID.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$VEHICLEGROUP.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . date('d/m/Y',strtotime($report_sdate)) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . $report_splace . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$no_of_stop.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ).'</td>

                            <td style="border: 1px solid #fff;padding: 8px;">'.$no_of_ideal.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$per_of_ideal.'(%)</td>

                            <td style="border: 1px solid #fff;padding: 8px;">' . sprintf ( "%0.1f ", max($report_max_speed_array) ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . sprintf ( "%0.1f ", $report_avg_speed ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . '</td>

                            <td style="border: 1px solid #fff;padding: 8px;">0</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ).'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . sprintf ( "%0.2f ", $net_distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>

                            <td style="border: 1px solid #fff;padding: 8px;">' . $report_eplace . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . $driver . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . $report_sdate . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . $report_edate . '</td>

                            <td style="border: 1px solid #fff;padding: 8px;">'.$firstIgnition.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$lastIgnition.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$no_of_ideal_violatio.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$no_of_stop_violatio.'</td>

                            <td style="border: 1px solid #fff;padding: 8px;"></td>
                        </tr>
                        ';

                    }
                }
            } // for J
            print '</table></div>';
            print "</table>";
        } // for I
        
        $contents = ob_get_contents ();
        ob_end_clean ();
        $this->pdf->WriteHTML ( $contents );
        $this->pdf->Output ();
    }
}
class DAYWISEVEHICLESUMMARY_Output_HTML {
    public static $txtDirection;
    public static $revDirection;
    public static $direction;
    public static function printHeader() {
        global $MYLANGUAGE, $languageMatrix;
        
        if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
            self::$direction = $direction = "ltr";
        } else {
            self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
        }
        
        switch ($direction) {
            case "ltr" :
                self::$txtDirection = "left";
                self::$revDirection = "right";
                break;
            case "rtl" :
                self::$txtDirection = "right";
                self::$revDirection = "left";
                break;
        }
        
        print '
                <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
                <html xmlns="http://www.w3.org/1999/xhtml">
                <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
                <title>' . 'Day Wise Vehicle Summary' . '</title>
                <style>' . file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:' . $direction . ';} </style>
                </head>
                <body class="mainbody" style="background-color:#999; background-image:none">
                <div id="reportframe" style="width:auto">
                <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
              ';
    }
    public static function printHTML($arrDis) {
        ob_start ();
        
        $summary = array ();
        
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        global $GDATABASE, $MYLANGUAGE;
        $rDatabase = new reportingQueries();
        
        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
        
        DAYWISEVEHICLESUMMARY_Output_HTML::printHeader ();
        $left = self::$txtDirection;
        $right = self::$revDirection;
        
        $aCount = count ( $arrDis [0] ['result'] );
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();
        
        print '<table width="100%" class="topBottom10pxPadding" style="font-size:22px; font-weight:bold; background-color:#FFF !important;"><tr><td>Day Wise Vehicle Summary</td><td align="' . $right . '"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';
        
        print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1" style="background-color:#FFF !important;">
        <tr>
            <td style="font-weight:bold" width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
            <td><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
            
            <td style="font-weight:bold" width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
            <td><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
        </tr>
        
        <tr>
            <td style="font-weight:bold" ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
            <td><div class="tableHeading">' . $sdate . '</div></td>
            <td  style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
            <td><div class="tableHeading">' . $edate . '</div></td>
        </tr>
        </table>';
        
        $tCount = count ( $arrDis );

        
        for($i = 0; $i < $tCount; $i ++) {
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
            
            $VEHICLEID = $arrDis [$i] ['tinfo'] [0]['vehicleid'];
            $VEHICLEGROUP = $arrDis [$i] ['tinfo'] [0]['type'];
            $REGISTRATIONNO = $arrDis [$i] ['tinfo'] [0]['licensePlate'];

            print '<br><table width="100%" class ="topBottom10pxPadding">
            <tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
            </tr>';
            
            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            }
            print "</table>";
            
            $ecount = count ( $arrDis [$i] ['result'] );
            
            $data = $arrDis [$i] ['result'];
            $initialized = false;

            print '<div style="overflow:scroll;">';
            print '<table width="100%" cellspacing="3" cellpadding="3" bordercolor="#cccccc" border="1" frame="vsides" rules="rows"  class="subHeading" style="margin-top:0px;margin-bottom:0px; border: 1px dotted #aaaaaa; font-size:11px;background-color:#F2F2F2">';
                    print ' <tr >
                            <td  style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">SLNO</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">REGISTRATION NO</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">VEHICLE ID</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">VEHICLE GROUP</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">'.$MYLANGUAGE->getString('DATE' ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">START LOCATION</td>


                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">NO OF STOP</td>
                            <td style="font-weight:bold;text-transform: uppercase;" width="220px">STOP DURATION<br/>(HH.MM)</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">NO OF IDLE</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="120px">'.$MYLANGUAGE->getString('IDLE_DUR').'</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">IDLE PERCENTAGE (%)</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="100px">'.$MYLANGUAGE->getString('MAX_SPEED' ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="100px">'.$MYLANGUAGE->getString('AVG_SPEED' ) . '</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">NO OF OVER<br/>SPEED</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">TRAVEL TIME<br/>(HH.MM)</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">N/W LOSS OR <br/>STOP DURATION<br/>(HH.MM)</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">ENGINE HRS<br/>(HH.MM)</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">DISTANCE TRAVELLED</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">END LOCATION</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">DRIVER NAME</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">START PACKET TIME</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">END PACKET TIME</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">FIRST RUNNING<br/>RECORD</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">LAST RUNNING<br/>RECORD</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">IDLE<br/>VIOLATION COUNT</td>
                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">STOPPAGE<br/>VIOLATION COUNT</td>

                            <td style="border: 1px solid #fff;padding: 8px;font-weight:bold;text-transform: uppercase;" width="220px">OWNER NAME</td>
                           
                    </tr>';


                                                                                          
             $sno=0;       
            
            for($j = 0; $j < $ecount - 1; $j ++) {
                
                $tripsCount = count ( $data [$j]->trips );

                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    $is_one_line_print = true;
                    $report_max_speed_array = array();
                    $report_avg_speed_array = array();
                    $no_of_stop = 0;
                    $no_of_ideal = 0;
                    $no_of_stop_violatio = 0;
                    $no_of_ideal_violatio = 0;

                    for($k = 0; $k < $tripsCount; $k ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$j]->trips [$k];
                            $initialized = true;
                            continue;
                        }
                        
                        if ($data [$j]->trips [$k]->status == STATUS_MOVING) {

                            $IdealTime_Limit = $_GET['IDTV'];
                            $stopTime_Limit = $_GET['SOTV'];
                            
                            $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                            $sdate = $fdate->getFormattedString ();
                            $splace = $oldRecord->place ['location'];
                            $start_odometer = $oldRecord->odometer;
                            
                            $fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            $edate = $fdate->getFormattedString ();
                            $eplace = $data [$j]->trips [$k]->place ['location'];
                            $end_odometer = $data [$j]->trips [$k]->odometer;
                            
                            $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            
                            $user = $_SESSION ['username'];
                            $rec = $GDATABASE->getUserRecord ( $user );
                            $password = $rec [0] ['password'];
                            
                            $hashData = $password . $oldRecord->date . $oldRecord->time . $data [$j]->trips [$k]->date . $data [$j]->trips [$k]->time . $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                            $hash = hash ( "sha256", $hashData );
                            
                            $dstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                            $idlestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                            $drivingstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration, $MYLANGUAGE );

                            $stoppagestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->stoppagetime, $MYLANGUAGE );


                            if($data [$j]->trips [$k]->stoppagetime > 0)$no_of_stop++;
                            if($data [$j]->trips [$k]->stoppagetime > $stopTime_Limit)$no_of_stop_violatio++;

                            if($data [$j]->trips [$k]->idletime > 0)$no_of_ideal++;
                            if($data [$j]->trips [$k]->idletime > $IdealTime_Limit)$no_of_ideal_violatio++;

                           
                            
                            $driver = $data [$j]->trips [$k]->driver;
                            if ($driver == false)
                                $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                            
                            $ttemp = array ();
                            if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
                                for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
                                    if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
                                        $n = new emptyClass ();
                                        $n->index = $tp;
                                        $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$j]->trips [$k]->maxTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "°F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$j]->trips [$k]->minTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "°F";
                                        array_push ( $ttemp, $n );
                                    }
                                }
                            }
                            
                            $backgroundColor = "none";
                            
                            $net_duration += ($data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime);
                            $net_idling_duration += $data [$j]->trips [$k]->idletime;
                            $net_stoppage_duration += $data [$j]->trips [$k]->stoppagetime;
                            
                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString . "<br/>";
                            }
                           
                            $net_distance += $data [$j]->trips [$k]->distance;
                            $net_private += $data [$j]->trips [$k]->pdistance;

                            if($is_one_line_print) {

                                $is_one_line_print = false;
                                $report_splace = $splace;
                                $report_sdate = $sdate;

                                $report_start_odometer = sprintf ( "%0.2f ", $start_odometer ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" );

                                $report_accel = $hCounts['accel'];

                            } else {

                                $report_eplace = $eplace;
                                $report_edate  = $edate;

                                $report_end_odometer = sprintf ( "%0.2f ", $end_odometer ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" );
                                $report_deaccel = $hCounts['deaccel'];
                            }
                            
                            $report_max_speed_array[] = $data [$j]->trips [$k]->maxSpeed;
                            $report_avg_speed_array[] = $data [$j]->trips [$k]->avgSpeed;

                        }
                        $oldRecord = $data [$j]->trips [$k];
                    }

                    $report_avg_speed = 0;
                    $report_avg_speed_array = array_filter($report_avg_speed_array);
                    $report_avg_speed = array_sum($report_avg_speed_array)/count($report_avg_speed_array);

                    $per_of_ideal = 0;
                    $per_of_ideal = ceil((($no_of_ideal * 100) / $tripsCount));


                    $firstIgnition =  0;
                    $lastIgnition = 0;

                    if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                        $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                        $sdate = $fdate->getFormattedDateString ();

                        $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                        $edate = $fdate->getFormattedDateString ();

                        $resultData = &$arrDis [$i] ['result'] [$j];

                        $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                        $firstIgnition = $fdate->getFormattedTimeString();

                        $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                        $lastIgnition = $fdate->getFormattedTimeString ();
                    }

                    if($report_splace!='') {

                        $sno=$sno + 1;

                        if($no_of_ideal_violatio < 15)$no_of_ideal_violatio=0;
                        if($no_of_stop_violatio < 9)$no_of_stop_violatio=0;

                        print '
                        <tr>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$sno.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$REGISTRATIONNO.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$VEHICLEID.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$VEHICLEGROUP.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . date('d/m/Y',strtotime($report_sdate)) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . $report_splace . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$no_of_stop.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ).'</td>

                            <td style="border: 1px solid #fff;padding: 8px;">'.$no_of_ideal.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$per_of_ideal.'(%)</td>

                            <td style="border: 1px solid #fff;padding: 8px;">' . sprintf ( "%0.1f ", max($report_max_speed_array) ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . sprintf ( "%0.1f ", $report_avg_speed ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . '</td>

                            <td style="border: 1px solid #fff;padding: 8px;">0</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ).'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . sprintf ( "%0.2f ", $net_distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>

                            <td style="border: 1px solid #fff;padding: 8px;">' . $report_eplace . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . $driver . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . $report_sdate . '</td>
                            <td style="border: 1px solid #fff;padding: 8px;">' . $report_edate . '</td>

                            <td style="border: 1px solid #fff;padding: 8px;">'.$firstIgnition.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$lastIgnition.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$no_of_ideal_violatio.'</td>
                            <td style="border: 1px solid #fff;padding: 8px;">'.$no_of_stop_violatio.'</td>

                            <td style="border: 1px solid #fff;padding: 8px;"></td>
                        </tr>
                        ';

                    }
                }
            } // for J
            print '</table></div>';
            print "</table>";
        } // for I
        
        DAYWISEVEHICLESUMMARY_Output_HTML::printFooter ();
        
        $contents = ob_get_contents ();
        ob_end_clean ();
        
        print $contents;
    }
    public static function printFooter() {
        print '
        <br/>
        <div style="width:100%; border:1px black solid; background-color:#404040; height:10px" />
        </div>
        </body></html>';
    }
}
class DAYWISEVEHICLESUMMARY_FNSv3_Report {
    private $mConverter;
    private $rDatabase;
    private $dateComputer;
    private function getStatus($data) {
        if ($data ['latitude'] == NULL)
            return STATUS_NOGPS;
        if ($data ['speed'] > 0 && strpos ( $data ['IO'], "j" ) !== false)
            $currentStatus = STATUS_MOVING;
        else if (strpos ( $data ['IO'], "j" ) !== false)
            $currentStatus = STATUS_IDLE;
        else
            $currentStatus = STATUS_STOPPED;
        
        return $currentStatus;
    }
    private function computeTrips($tid) {
        global $GDATABASE;
        
        if (isset ( $_GET ['SOTV'] ) && $_GET ['SOTV'] > 0)
            $TRIPS_STOP_BREAKING_TIME = $_GET ['SOTV'];
        else
            $TRIPS_STOP_BREAKING_TIME = TRIPS_STOP_BREAKING_TIME;
        
        if (isset ( $_GET ['IDTV'] ) && $_GET ['IDTV'] > 0)
            $TRIPS_IDLE_BREAKING_TIME = $_GET ['IDTV'];
        else
            $TRIPS_IDLE_BREAKING_TIME = TRIPS_IDLE_BREAKING_TIME;
        
        $trips = array ();
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        // Starting state of this automata will be TRIP_START
        $currentState = TRIP_START;
        
        $data = true;
        $distance = 0;
        $pdistance = 0;
        
        $tprofiles = $GDATABASE->getTrackerTemperatureProfiles ( $tid );
        $card = $GDATABASE->getTrackerCard ( $tid );
        
        $computeTemperature = false;
        $tpr = array ();
        
        for($v = 0; $v < count ( $tprofiles ); $v ++) {
            if ($tprofiles [$v] !== false) {
                $computeTemperature = true;
            }
        }
        
        $exit = false;
        $oldData = false;
        // $Odometer = new FNSOdometer($tid, $_SESSION['timezone']);
        
        while ( $exit == false ) {
            $data = $this->rDatabase->reports_nextLocation ();
            // print "<br/>\r\n".$data['date'].",".$data['time'].",".$data['latitude'].",".$data['longitude'].",".$data['speed'].",".$data['IO'];
            switch ($currentState) {
                
                case TRIP_START :
                    
                    if ($data == false) {
                        $exit = true;
                        break;
                    }
                    
                    // Skip the NO GPS State in the beginning of the data block
                    $checkState = $this->getStatus ( $data );
                    if ($checkState == STATUS_NOGPS)
                        break;
                        
                        // move the state into its determined state
                    $currentState = $checkState;
                    
                    $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                    $stateTransTime = $fdate->dateTime->getTimestamp ();
                    
                    $lastLatitude = $data ['latitude'];
                    $lastLongitude = $data ['longitude'];
                    $maxSpeed = $data ['speed'];
                    
                    $maxTemp = array ();
                    $minTemp = array ();
                    
                    if ($computeTemperature == true) {
                        for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
                            $minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
                        }
                    }
                    
                    $n = new tripRObject ();
                    $n->status = TRIP_START;
                    $n->distance = $distance;
                    $n->maxSpeed = $maxSpeed;
                    $n->latitude = $data ['latitude'];
                    $n->longitude = $data ['longitude'];
                    $n->duration = 0;
                    $n->date = $data ['date'];
                    $n->time = $data ['time'];
                    $n->maxTemp = $maxTemp;
                    $n->minTemp = $minTemp;
                    array_push ( $trips, $n );
                    break;
                
                case STATUS_MOVING :
                    if ($data != false) {
                        $newState = $this->getStatus ( $data );
                    }
                    
                    if ($newState != STATUS_MOVING || $data == false) {
                        
                        if ($data == false) {
                            $exit = true;
                            $data = $oldData;
                        }
                        
                        if ($newState == STATUS_NOGPS) {
                            $data = $oldData;
                        }
                        
                        $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                        
                        // if last state was movement only - means last state
                        // was skipped due to trip time
                        // in this case add to the previous packet otherwise
                        // emit new packet
                        $lastTripIndex = count ( $trips ) - 1;
                        if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == STATUS_MOVING) {
                            $trips [$lastTripIndex]->date = $data ['date'];
                            $trips [$lastTripIndex]->time = $data ['time'];
                            $trips [$lastTripIndex]->latitude = $data ['latitude'];
                            $trips [$lastTripIndex]->longitude = $data ['longitude'];
                            $trips [$lastTripIndex]->distance = $distance;
                            $trips [$lastTripIndex]->pdistance = $pdistance;
                            $trips [$lastTripIndex]->maxSpeed = $maxSpeed;
                            $trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
                        } else {
                            $n = new tripRObject ();
                            $n->status = $currentState;
                            $n->distance = $distance;
                            $n->pdistance = $pdistance;
                            $n->maxSpeed = $maxSpeed;
                            $n->latitude = $data ['latitude'];
                            $n->longitude = $data ['longitude'];
                            $n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
                            $n->date = $data ['date'];
                            $n->time = $data ['time'];
                            $n->maxTemp = $maxTemp;
                            $n->minTemp = $minTemp;
                            array_push ( $trips, $n );
                            
                            $maxTemp = array ();
                            $minTemp = array ();
                        }
                        
                        $currentState = $newState;
                        // Set State transition time
                        $stateTransTime = $fdate->dateTime->getTimestamp ();
                    }
                    
                    $dis = reportUtils::getDistance ( $data ['latitude'], $data ['longitude'], $lastLatitude, $lastLongitude );
                    $distance += $dis;
                    if ($data ['private'] == 1)
                        $pdistance += $dis;
                    
                    if ($computeTemperature == true) {
                        for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
                            
                            $ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
                            
                            if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
                                $maxTemp [$tp] = $ctemp;
                            else
                                $maxTemp [$tp] = $ctemp;
                            
                            if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
                                $minTemp [$tp] = $ctemp;
                            else
                                $minTemp [$tp] = $ctemp;
                        }
                    }
                    
                    if ($data ['speed'] > $maxSpeed)
                        $maxSpeed = $data ['speed'];
                    
                    $lastLatitude = $data ['latitude'];
                    $lastLongitude = $data ['longitude'];
                    
                    break;
                
                case STATUS_NOGPS :
                    if ($data != false) {
                        $newState = $this->getStatus ( $data );
                    } else {
                        $exit = true;
                        $data = $oldData;
                    }
                    
                    if ($newState != $currentState || $data == false) {
                        
                        $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                        $cTime = $fdate->dateTime->getTimestamp ();
                        
                        $n = new tripRObject ();
                        $n->status = $currentState;
                        $n->latitude = $lastLatitude;
                        $n->longitude = $lastLongitude;
                        $n->duration = $cTime - $stateTransTime;
                        $n->date = $data ['date'];
                        $n->time = $data ['time'];
                        array_push ( $trips, $n );
                        $stateTransTime = $cTime;
                        
                        $currentState = $newState;
                    }
                    break;
                
                case STATUS_STOPPED :
                // Both STOPPED and IDLE follow the same logic and correspondingly emits out correct records
                
                case STATUS_IDLE :
                    if ($data != false) {
                        $newState = $this->getStatus ( $data );
                        
                        $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                        $cTime = $fdate->dateTime->getTimestamp ();
                        
                        if ($computeTemperature == true) {
                            for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
                                
                                $ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
                                
                                if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
                                    $maxTemp [$tp] = $ctemp;
                                else
                                    $maxTemp [$tp] = $ctemp;
                                
                                if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
                                    $minTemp [$tp] = $ctemp;
                                else
                                    $minTemp [$tp] = $ctemp;
                            }
                        }
                        
                        // If the time difference is greater then trips breaking
                        // time then emit out
                        if ($newState == STATUS_NOGPS) {
                            $emitOut = true;
                            $data = $oldData;
                        } else if ($currentState == STATUS_STOPPED) {
                            
                            if (($cTime - $stateTransTime) > ($TRIPS_STOP_BREAKING_TIME * 60))
                                $emitOut = true;
                            else
                                $emitOut = false;
                        } else {
                            if (($cTime - $stateTransTime) > ($TRIPS_IDLE_BREAKING_TIME * 60))
                                $emitOut = true;
                            else
                                $emitOut = false;
                        }
                    }
                    
                    if ($newState != $currentState || $data == false) {
                        // Emit Packet and Set new state
                        if ($emitOut || $data == false) {
                            
                            if ($data == false) {
                                $exit = true;
                                $data = $oldData;
                                if ($emitOut == false)
                                    break;
                            }
                            
                            $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                            $lastTripIndex = count ( $trips ) - 1;
                            if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == $currentState) {
                                $trips [$lastTripIndex]->date = $data ['date'];
                                $trips [$lastTripIndex]->time = $data ['time'];
                                $trips [$lastTripIndex]->latitude = $data ['latitude'];
                                $trips [$lastTripIndex]->longitude = $data ['longitude'];
                                $trips [$lastTripIndex]->distance = 0;
                                $trips [$lastTripIndex]->pdistance = 0;
                                $trips [$lastTripIndex]->maxSpeed = 0;
                                $trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
                            } else {
                                $n = new tripRObject ();
                                $n->status = $currentState;
                                $n->latitude = $lastLatitude; // $data['latitude'];
                                $n->longitude = $lastLongitude; // $data['longitude'];
                                $n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
                                $n->date = $data ['date'];
                                $n->time = $data ['time'];
                                array_push ( $trips, $n );
                            }
                            
                            $stateTransTime = $fdate->dateTime->getTimestamp ();
                            $distance = 0;
                            $pdistance = 0;
                            $lastLatitude = $data ['latitude'];
                            $lastLongitude = $data ['longitude'];
                            
                            $maxSpeed = $data ['speed'];
                            
                            if ($computeTemperature == true) {
                                $minTemp = array ();
                                $maxTemp = array ();
                                
                                for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
                                    $minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
                                }
                            }
                        }
                        $currentState = $newState;
                    }
                    break;
            }
            $oldData = $data;
        }
        return $trips;
    }
    private function computeParameters($tid, $dateArray, $days, $trackerInfo) {
        global $GDATABASE;
        $geo = new GEOCODER ();
        
        $this->rDatabase->reports_getLocationsData ( $tid, $dateArray );
        
        $tripsArray = $this->computeTrips ( $tid );
        
        $daysCount = count ( $days );
        
        $sdate = new FNSDateTime ( $_SESSION ['timezone'] );
        $edate = new FNSDateTime ( $_SESSION ['timezone'] );
        $pdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        $tripsCount = count ( $tripsArray );
        $ba = 0;
        $newTrips = array ();
        // Post Processing
        $darray = $tripsArray;
        
        $Odometer = new FNSOdometer ( $tid, $_SESSION ['timezone'] );
        
        if ($tripsCount > 0) {
            $cLoop = true;
            
            for($i = 0; $i < $tripsCount; $i ++) {
                $pdate->setUTCDate ( $tripsArray [$i]->date, $tripsArray [$i]->time );
                
                $tripsArray [$i]->odometer = $Odometer->getValue ( $tripsArray [$i]->date, $tripsArray [$i]->time );
                $tripsArray [$i]->driver = $this->rDatabase->getDriverName ( $tid, $tripsArray [$i]->date, $tripsArray [$i]->time );
            }
            
            $cstate = $darray [$ba]->status;
            $n = $darray [$ba];
            $n->pdistance = $this->mConverter->convert ( $n->pdistance * 0.621371, 'D' );
            $n->distance = $this->mConverter->convert ( $n->distance * 0.621371, 'D' );
            $n->odometer = $this->mConverter->convert ( ($n->odometer / 1000.0) * 0.621371, 'D' );
            
            array_push ( $newTrips, $n );
        } else
            $cLoop = false;

        
        $ignition = $this->rDatabase->detectIgnition ( $tid );
        
        if (isset ( $_GET ['debug'] ) && $_GET ['debug'] == 1)
            print_r ( $tripsArray );


        while ( $cLoop ) {
            // DFA for summing up consecutive idle and moving journeys into single record
            if (isset ( $darray [$ba] ))
                $nstate = $darray [$ba]->status;
            else
                $nstate = $cstate;
            
            if ($ignition == false) {
                if ($nstate == STATUS_IDLE) {
                    $nstate = STATUS_STOPPED;
                    $darray [$ba]->status = STATUS_STOPPED;
                }
            }
            
            switch ($cstate) {
                case TRIP_START :
                    $cstate = $nstate;
                    $n = $darray [$ba];
                    $ba++;
                    break;
                
                case STATUS_STOPPED :
                    if ($ba >= $tripsCount)
                        $cLoop = false;
                    
                    if ($nstate != STATUS_STOPPED) {
                        $n->odometer = $this->mConverter->convert ( ($n->odometer / 1000.0) * 0.621371, 'D' );
                        array_push ( $newTrips, $n );
                        
                        $n = $darray [$ba];
                        if ($n->status == STATUS_IDLE) {
                            $n->idletime = $n->duration;
                            $n->duration = 0;
                        } else {
                            $n->stoppagetime = $n->duration;
                            $n->duration = 0;
                        }
                        $cstate = $nstate;
                        
                        // Collecting batch geocoding requests
                    }
                    $ba ++;
                    break;
                
                case STATUS_MOVING :
                case STATUS_IDLE :
                    if ($ba >= $tripsCount)
                        $cLoop = false;
                    $cstate = $nstate;
                    if ($nstate == STATUS_STOPPED || $cLoop == false) {
                        $n->status = STATUS_MOVING;
                        $n->pdistance = $this->mConverter->convert ( $n->pdistance * 0.621371, 'D' );
                        $n->distance = $this->mConverter->convert ( $n->distance * 0.621371, 'D' );
                        $n->odometer = $this->mConverter->convert ( ($n->odometer / 1000.0) * 0.621371, 'D' );
                        $n->maxSpeed = $this->mConverter->convert ( $n->maxSpeed, 'S' );
                        $n->avgSpeed = $this->mConverter->convert ( ($n->distance * 0.621371) / (($n->idletime + $n->duration) / 3600), 'S' );
                        
                        array_push ( $newTrips, $n );
                        $n = $darray [$ba];
                    } else {
                        $n->odometer = $darray [$ba]->odometer;
                        
                        if ($cstate == STATUS_MOVING) {
                            $n->duration += $darray [$ba]->duration;
                            $n->distance += $darray [$ba]->distance;
                            $n->pdistance += $darray [$ba]->pdistance;
                        } else
                            $n->idletime += $darray [$ba]->duration;
                        
                        if ($darray [$ba]->maxSpeed > $n->maxSpeed)
                            $n->maxSpeed = $darray [$ba]->maxSpeed;
                        
                        $n->date = $darray [$ba]->date;
                        $n->time = $darray [$ba]->time;
                        
                        if (isset ( $darray [$ba]->maxTemp ) && $darray [$ba]->maxTemp != false) {
                            foreach ( $darray [$ba]->maxTemp as $k => $v ) {
                                if ($v > $n->maxTemp [$k])
                                    $n->maxTemp [$k] = $v;
                                if ($v < $n->minTemp [$k])
                                    $n->minTemp [$k] = $v;
                            }
                        }
                    }
                    $ba ++;
                    break;
            }
        }

        if (isset ( $_GET ['debug'] ) && $_GET ['debug'] == 1)
            print_r ( $newTrips );

        $tripsArray = $newTrips;
        $tripsCount = count ( $newTrips );
        $y = 0;
        
        for($x = 0; $x < $daysCount - 1; $x ++) {
            $sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
            $edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
            
            $darray = array ();
            
            for(; $y < $tripsCount; $y ++) {
                $pdate->setUTCDate ( $tripsArray [$y]->date, $tripsArray [$y]->time );
                
                if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
                    
                    array_push ( $darray, $tripsArray [$y] );
                } else
                    break;
            } // for dcount
            
            $dc = count ( $darray );
            
            $batch = array ();
            
            for($ba = 0; $ba < $dc; $ba ++) {
                
                $n = $darray [$ba];
                
                $o = new emptyClass ();
                $o->lat = $n->latitude;
                $o->lng = $n->longitude;
                array_push ( $batch, $o );
            }

            //if (isset($_GET['doGeocode']) && $_GET['doGeocode'] == 1)
            {
                for($ba = 0; $ba < count ( $batch ); $ba ++) {
                    $darray [$ba]->place = $geo->search ( $batch [$ba]->lat, $batch [$ba]->lng, true );
                }
            }

            if ($dc > 0) {
                $days [$x]->trips = $darray;
            }
        } // for daysCount

        /******
        *******Start Code to get ignittion records
        */
        $lastData = $this->rDatabase->reports_nextLocation ();
        $data = $this->rDatabase->reports_nextLocation ();
        // $nextData = $this->rDatabase->reports_nextLocation ();
        
        for($x = 0; $x < $daysCount - 1; $x ++) {
            $sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
            $edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
            
            $days [$x]->distance = 0;

            while ( 1 ) {
                $pdate->setUTCDate ( $data ['date'], $data ['time'] );

                $data['Converted Time'] = $pdate->getFormattedString();
                

                if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
                    // Speed computations
                    if (isset ( $data ['IO'] ) && strpos ( $data ['IO'], 'j' ) !== false && $data ['speed'] > 0 ) {
                        // ignition is on
                        $npdate->setUTCDate ( $lastData ['date'], $lastData ['time'] );
                        
                        $difference = $pdate->dateTime->getTimestamp () - $npdate->dateTime->getTimestamp ();
                        if ($difference <= IGNITION_DIFF_THRESHOLD_TIME) {
                            $days [$x]->mDuration += $difference;
                            $days [$x]->distance += reportUtils::getDistance($data ['latitude'], $data ['longitude'], $lastData ['latitude'], $lastData ['longitude']);
                        }
                        if (!isset($days[$x]->firstIgnition['latitude'])) {             //For latitude and longitude of first ignition, useful in which j packet is not received
                            $days[$x]->firstIgnition['latitude'] = $lastData ['latitude'];
                            $days[$x]->firstIgnition['longitude'] = $lastData ['longitude'];
                        }
                    }
                    
                    if ($data ['speed'] > $days [$x]->maxSpeed)
                        $days [$x]->maxSpeed = $data ['speed'];
                    
                    $lastData = $data;
                    $data = $this->rDatabase->reports_nextLocation ();
                    if ($data == false)
                        break;
                } else
                    break; // if
                
            } // While

            if ($days [$x]->distance != 0) {
                $distance = $days [$x]->distance * 0.621371;
                
                $days [$x]->distance = $this->mConverter->convert ( $distance, "D" );
                $days [$x]->maxSpeed = $this->mConverter->convert ( $days [$x]->maxSpeed, "S" );
                
                if ($days [$x]->mDuration != 0)
                    $days [$x]->avgSpeed = $this->mConverter->convert ( $distance / ($days [$x]->mDuration / 3600), "S" );
                else
                    $days [$x]->avgSpeed = 0;
                
                if ($days [$x]->avgSpeed >= $days [$x]->maxSpeed) {
                    $days [$x]->maxSpeed = ceil ( $days [$x]->avgSpeed );
                }
                
                $days [$x]->latitude = $data ['latitude'];
                $days [$x]->longitude = $data ['longitude'];
            }
            $days[$x]->lastIgnition['latitude'] = $lastData ['latitude'];   //For latitude and longitude of last ignition, useful in which j packet is not received
            $days[$x]->lastIgnition['longitude'] = $lastData ['longitude'];
            
        } // for daysCount
        
        
        for($x = 0; $x < $daysCount - 1; $x ++) {
            $sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
            $edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
            $ign_result = $this->rDatabase->reports_getEventsData($tid,array('sdate' => $days[$x]->date, 'stime' => $days[$x]->time, 'edate' => $days[$x+1]->date, 'etime'=>$days[$x+1]->time),array(EVENT_START_ENGINE), true);

            if ($days[$x]->distance != 0 && $ign_result != false) {
                $days[$x]->firstIgnition = $ign_result[0];
                $days[$x]->lastIgnition = $ign_result[count($ign_result)-1];
            }
            $loc = $geo -> search($days[$x]->firstIgnition['latitude'],$days[$x]->firstIgnition['longitude'],true);
            $days[$x]->firstIgnition['location'] = $loc['location'];
            $loc = $geo -> search($days[$x]->lastIgnition['latitude'],$days[$x]->lastIgnition['longitude'],true);
            $days[$x]->lastIgnition['location'] = $loc['location'];
        } // for daysCount
        /*End Code to get ignittion record*/
        
        return $days;
    }
    private function getTrackersList() {
        global $GDATABASE;
        $trackers = $GDATABASE->getTrackersList ( "trackerid" );
        $a = array ();
        $tcount = count ( $trackers );
        for($i = 0; $i < $tcount; $i ++) {
            array_push ( $a, $trackers [$i] ['trackerid'] );
        }
        return $a;
    }
    private function getReportData() {
        global $GDATABASE;
        $arrdate = reportUtils::getUTCReportTime ( $_GET );
        
        if ($_GET ['ftype'] == "E") {
            $trackers = $this->getTrackersList ();
        } else {
            $trackers = explode ( ",", $_GET ['trackers'] );
        }
        
        $tcount = count ( $trackers );
        
        $display_array = array ();
        
        for($i = 0; $i < $tcount; $i ++) {
            
            $days = reportUtils::getDays ( $arrdate, $_SESSION ['timezone'] );
            $arr = array ();
            
            $arr ['tinfo'] = $GDATABASE->getTrackerCard ( $trackers [$i] );
            $arr ['details'] = $GDATABASE->rp_getTrackersDetails ( $trackers [$i] );
            
            $result = $this->computeParameters ( $trackers [$i], $arrdate, $days, $arr ['tinfo'] );
            $arr ['result'] = $result;
            
            array_push ( $display_array, $arr );
        }
        
        switch ($_GET ['format']) {
            case "HTML" :
                DAYWISEVEHICLESUMMARY_Output_HTML::printHTML ( $display_array );
                break;
            case "PDF" :
                $pdf = new DAYWISEVEHICLESUMMARY_Output_PDF ();
                $pdf->printPDF ( $display_array );
                break;
            case "XLSX" :
                DAYWISEVEHICLESUMMARY_Output_XLSX::printXLSX ( $display_array );
                break;
        }
    }
    public function execute() {
        global $MYLANGUAGE;
        $MYLANGUAGE = new FNSLanguage ();
        
        $this->mConverter = new metricConverter ();
        $this->mConverter->setMetrics ( $_GET ['metric'] );
        $this->rDatabase = new reportingQueries ();
        $this->dateComputer = new FNSDateTime ( $_SESSION ['timezone'] );
        
        $this->getReportData ();
    }
}

?>
