<?php

/**
 * @version: 5.1
 */

require_once (REPORTS_FOLDER . "/reportUtils.php");
require_once (DATABASE_FOLDER . "/reportingQueries.php");
require_once (GEOCODER_FOLDER . "/geo.php");
require_once (mPDF_FOLDER . "/mpdf.php");
require_once (GRAPH_LIB_FOLDER . '/src/jpgraph.php');
require_once (GRAPH_LIB_FOLDER . '/src/jpgraph_line.php');
require_once (GRAPH_LIB_FOLDER . '/src/jpgraph_pie.php');
require_once (GRAPH_LIB_FOLDER . '/src/jpgraph_pie3d.php');
require_once (PHPExcelPath . '/Classes/PHPExcel.php');

class DRIVERSCORE_Output_XLSX {
	public static function printXLSX($arrDis) {
		header("content-type:text/html");
	$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		$today = $fdate->dateTime->getTimestamp ();
		
		global $GDATABASE, $MYLANGUAGE;
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		switch ($_GET ['rmethod']) {
			case "daily" :
				$method = $MYLANGUAGE->getString ( "DAILY" );
				break;
			case "weekly" :
				$method = $MYLANGUAGE->getString ( "WEEKLY" );
				break;
			case "monthly" :
				$method = $MYLANGUAGE->getString ( "MONTHLY" );
				break;
		}
		
		$objPHPExcel = new PHPExcel();
		$sheetProperties = $objPHPExcel->getProperties();
		$sheetProperties->setCreator("Find'n'Secure");
		$sheetProperties->setTitle($MYLANGUAGE->getString ( 'DRIVERSCORE' ) . " (" . $method . ')');
		$sheetProperties->setDescription($MYLANGUAGE->getString('DRIVERSCORE_INFO'));
		
		$myWorkSheet = new PHPExcel_Worksheet($objPHPExcel, 'Report');
		$workSheet2 = new PHPExcel_Worksheet ( $objPHPExcel, 'Data' );
		$objPHPExcel->addSheet($myWorkSheet, 0);
		$objPHPExcel->addSheet ( $workSheet2, 1 );
		$objPHPExcel->setActiveSheetIndex(0);
		
		//set font-family and size
		$objPHPExcel->getDefaultStyle()->getFont()->setName('Arial');
		$objPHPExcel->getDefaultStyle()->getFont()->setSize(10);
		
		//set default column widths
		for($i='A'; $i<='K'; $i++) {
			$myWorkSheet->getColumnDimension($i)->setAutoSize(true);
		}
		
		//set margins
		$myWorkSheet->getPageMargins()->setRight(0.125);
		$myWorkSheet->getPageMargins()->setLeft(0.125);
		
		//set page orientation
		$myWorkSheet->getPageSetup()->setPaperSize(PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4);
		$myWorkSheet->getPageSetup()->setFitToWidth(1);
		$myWorkSheet->getPageSetup()->setFitToHeight(0);
		
		//set rtl
		//$myWorkSheet->setRightToLeft(true);
		
		$row = 2;
		$s2row = 1;
		
		//report heading
		$myWorkSheet->SetCellValue("A$row",$MYLANGUAGE->getString ( 'DRIVERSCORE' ) . " (" . $method . ')');
		$myWorkSheet->mergeCells ( "A$row:C" . ($row + 4) );
		$headingStyle = array(
				'font' => array(
						'bold' => true,
						'size' => 16
				),
				'alignment' => array(
						'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
						'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP
				)
		);
		$myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
		$myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );
		
		
		//company logo
		$logo = new PHPExcel_Worksheet_Drawing();
		$logo->setPath(REP_IMAGES_FOLDER.'/reports/fnslogo.png');
		$logo->setWorksheet($myWorkSheet);
		$logo->setCoordinates('D'.$row);
		$myWorkSheet->mergeCells ( "D$row:F" . ($row + 4) );
		$logo->setOffsetX ( 50 );
		
		$row = 9;
		
		//company details
		$myWorkSheet->SetCellValue('A'.$row, $MYLANGUAGE->getString('COMPANY_NAME'));
		$myWorkSheet->SetCellValue('B'.$row, $answer[0]['company']);
		$myWorkSheet->SetCellValue('F'.$row, $MYLANGUAGE->getString('USERNAME'));
		$myWorkSheet->SetCellValue('G'.$row, $answer[0]['username']);
		$myWorkSheet->mergeCells('B'.$row.':E'.$row);
		$myWorkSheet->mergeCells('G'.$row.':K'.$row);
		
		$row++;
		
		$myWorkSheet->SetCellValue('A'.$row, $MYLANGUAGE->getString('START_DATE'));
		$myWorkSheet->SetCellValue('B'.$row, $sdate);
		$myWorkSheet->SetCellValue('F'.$row, $MYLANGUAGE->getString('END_DATE'));
		$myWorkSheet->SetCellValue('G'.$row, $edate);
		$myWorkSheet->mergeCells('B'.$row.':E'.$row);
		$myWorkSheet->mergeCells('G'.$row.':K'.$row);
		
		$row += 2;
		
		$detailsStyle = array(
				'borders' => array(
						'inside' => array(
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array('argb' => 'FFFFFFFF')
						)
				),
					
				'fill' => array(
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array('argb' => 'FFDDDDDD')
				)
		);
		
		$rowHeadStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 9
				),
		
				'borders' => array (
						'bottom' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FF000000'
								)
						),
						'top' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FF000000'
								)
						)
				),
		
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FFDDDDDD'
						)
				)
		);
		
		
		$tCount = count ( $arrDis );
		
		for($i = 0; $i < $tCount; $i ++) {
		
			$myWorkSheet->SetCellValue('A'.$row, $MYLANGUAGE->getString ( 'DRIVER_NAME' ));
			$myWorkSheet->SetCellValue('B'.$row, $arrDis [$i] ['details'] ['name']);
			$myWorkSheet->SetCellValue('F'.$row, $MYLANGUAGE->getString ( 'REF_NO' ));
			$myWorkSheet->SetCellValue('G'.$row, $arrDis [$i] ['details'] ['referenceNo']);
			$myWorkSheet->mergeCells('B'.$row.':E'.$row);
			$myWorkSheet->mergeCells('G'.$row.':K'.$row);
			$myWorkSheet->getStyle("A$row:K$row")->applyFromArray($detailsStyle);
			$myWorkSheet->getStyle('A'.$row)->getFont()->setBold(true);
			$myWorkSheet->getStyle('F'.$row)->getFont()->setBold(true);
				
			$row++;
				
			$fdate->setUTCDate ( $arrDis [$i] ['details'] ['licvalid'], $arrDis [$i] ['details'] ['tlic'] );
			$licvalid = $fdate->getFormattedDateString ();
				
			$exdate = $fdate->dateTime->getTimestamp ();
				
			if ($exdate <= $today)
				$expired = $MYLANGUAGE->getString ( "EXPIRED" );
			else
				$expired = '';
		
			$myWorkSheet->SetCellValue('A'.$row, $MYLANGUAGE->getString ( 'TAG_ID' ));
			$myWorkSheet->SetCellValue('B'.$row, $arrDis [$i] ['details'] ['tagID']);
			$myWorkSheet->SetCellValue('F'.$row, $MYLANGUAGE->getString ( 'LICENSE_VALID' ));
			$myWorkSheet->SetCellValue('G'.$row, $licvalid);
			$myWorkSheet->SetCellValue('H'.$row, "($expired)");
			$myWorkSheet->mergeCells('B'.$row.':E'.$row);
			$myWorkSheet->mergeCells('H'.$row.':K'.$row);
			$myWorkSheet->getStyle("A$row:K$row")->applyFromArray($detailsStyle);
			$myWorkSheet->getStyle('A'.$row)->getFont()->setBold(true);
			$myWorkSheet->getStyle('F'.$row)->getFont()->setBold(true);
			$myWorkSheet->getStyle('H'.$row)->getFont()->setBold(true)->getColor()->setARGB("FFFF0000");
			$myWorkSheet->getStyle('H'.$row)->getFont()->setItalic(true);
			
			$row++;
				
			$rs = new DriverReport ();
			$rs->available = false;
				
			$myWorkSheet->SetCellValue('A'.$row, $MYLANGUAGE->getString ( 'DBG_HACC' ));
			$myWorkSheet->SetCellValue('B'.$row, $MYLANGUAGE->getString ( 'DBG_HBRK' ));
			$myWorkSheet->SetCellValue('C'.$row, $MYLANGUAGE->getString ( 'DBG_HCOR' ));
			$myWorkSheet->SetCellValue('D'.$row, $MYLANGUAGE->getString ( 'OVERSPEED_TXT' ));
			$myWorkSheet->SetCellValue('E'.$row, $MYLANGUAGE->getString ( 'IDLE_COUNT' ));
			$myWorkSheet->SetCellValue('F'.$row, $MYLANGUAGE->getString ( 'IDLE_DUR' ));
			$myWorkSheet->SetCellValue('G'.$row, $MYLANGUAGE->getString ( 'TRIPS' ));
			$myWorkSheet->SetCellValue('H'.$row, $MYLANGUAGE->getString ( 'DRI_DUR' ));
			$myWorkSheet->SetCellValue('I'.$row, $MYLANGUAGE->getString ( 'WORK_DUR' ));
			$myWorkSheet->SetCellValue('J'.$row, $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')');
			$myWorkSheet->SetCellValue('K'.$row, $MYLANGUAGE->getString ( 'SCORE' ));
				
			$row++;
				
			$ecount = count ( $arrDis [$i] ['result'] );
			
			$dataStartRow = $s2row;
				
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
		
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
		
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
		
				$summary = & $arrDis [$i] ['result'] [$j]->summary;
				$breakup = & $arrDis [$i] ['result'] [$j]->breakup;
		
				if ($summary->available == true) {
					$rs->available = $summary->available;
						
					$mDuration = reportUtils::getDurationTextShort ( $summary->movementDuration, $MYLANGUAGE );
					$iDuration = reportUtils::getDurationTextShort ( $summary->idlingDuration, $MYLANGUAGE );
					$tDuration = reportUtils::getDurationTextShort ( $summary->movementDuration + $summary->idlingDuration, $MYLANGUAGE );
						
					$myWorkSheet->SetCellValue('A'.$row, $MYLANGUAGE->getString('PERIOD')." : ".$sdate." - ".$edate);
					$myWorkSheet->mergeCells("A$row:K$row");
					$myWorkSheet->getStyle('A'.$row.':K'.$row)->applyFromArray($rowHeadStyle);
						
					$row++;
						
					$rs->harshAcceleration += $summary->harshAcceleration;
					$rs->harshBraking += $summary->harshBraking;
					$rs->harshCornering += $summary->harshCornering;
					$rs->idlingCount += $summary->idlingCount;
					$rs->movementDuration += $summary->movementDuration;
					$rs->idlingDuration += $summary->idlingDuration;
					$rs->movementCount += $summary->movementCount;
					$rs->overspeeding += $summary->overspeeding;
					$rs->distance += $summary->distance;
						
					$myWorkSheet->SetCellValue('A'.$row, $summary->harshAcceleration);
					$myWorkSheet->SetCellValue('B'.$row, $summary->harshBraking);
					$myWorkSheet->SetCellValue('C'.$row, $summary->harshCornering);
					$myWorkSheet->SetCellValue('D'.$row, $summary->overspeeding);
					$myWorkSheet->SetCellValue('E'.$row, $summary->idlingCount);
					$myWorkSheet->SetCellValue('F'.$row, $iDuration);
					$myWorkSheet->SetCellValue('G'.$row, $summary->movingCount);
					$myWorkSheet->SetCellValue('H'.$row, $mDuration);
					$myWorkSheet->SetCellValue('I'.$row, $tDuration);
					$myWorkSheet->SetCellValue('J'.$row, sprintf ( "%0.2f", $summary->distance ));
					$myWorkSheet->SetCellValue('K'.$row, sprintf ( "%0.2f", $summary->score ));
						
					$row++;
					
					$workSheet2->SetCellValue('A'.$s2row, '');
					$workSheet2->SetCellValue('B'.$s2row, sprintf ( "%0.2f", $summary->score ));
					$s2row++;
						
					//<td style="text-align:center"><img src="data:image/png;base64,' . $summary->graph . '"></img></td>
				}
			} // for J
				
			if ($rs->available) {
				$score = DRIVERSCORE_FNSv3_Report::getScore ( $rs );
/* 				$graph = base64_encode ( graphClass::drawSmallPie ( array (
						$score,
						10 - $score
				) ) );
 */		
				$mDuration = reportUtils::getDurationTextShort ( $rs->movementDuration, $MYLANGUAGE );
				$iDuration = reportUtils::getDurationTextShort ( $rs->idlingDuration, $MYLANGUAGE );
				$tDuration = reportUtils::getDurationTextShort ( $rs->movementDuration + $rs->idlingDuration, $MYLANGUAGE );
		
				$myWorkSheet->SetCellValue('A'.$row, $MYLANGUAGE->getString ( 'TOTAL' ));
				$myWorkSheet->mergeCells('A'.$row.':K'.$row);
				$myWorkSheet->getStyle("A$row:K$row")->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setARGB('FFe01212');
				$myWorkSheet->getStyle("A$row:K$row")->getFont()->getColor()->setARGB('ffffffff');
		
				$row++;
		
				$myWorkSheet->SetCellValue('A'.$row, $rs->harshAcceleration);
				$myWorkSheet->SetCellValue('B'.$row, $rs->harshBraking);
				$myWorkSheet->SetCellValue('C'.$row, $rs->harshCornering);
				$myWorkSheet->SetCellValue('D'.$row, $rs->overspeeding);
				$myWorkSheet->SetCellValue('E'.$row, $rs->idlingCount);
				$myWorkSheet->SetCellValue('F'.$row, $iDuration);
				$myWorkSheet->SetCellValue('G'.$row, $rs->movingCount);
				$myWorkSheet->SetCellValue('H'.$row, $mDuration);
				$myWorkSheet->SetCellValue('I'.$row, $tDuration);
				$myWorkSheet->SetCellValue('J'.$row, sprintf ( "%0.2f", $rs->distance ));
				$myWorkSheet->SetCellValue('K'.$row, sprintf ( "%0.2f", $score ));
					
				$row++;
		
				//<td style="text-align:center"><img src="data:image/png;base64,' . $graph . '"></img></td>
		
				$row++;
				
				$s2row--;
				
				$dataseriesLabels = array (
							new PHPExcel_Chart_DataSeriesValues ( 'String', 'Score', null, 1 )
					);
					
					$xAxisTickValues = array (
							new PHPExcel_Chart_DataSeriesValues ( 'String', 'Data!$A' . $dataStartRow . ':$A$' . $s2row, null, $ecount-1 ) 
					);
					
					$dataSeriesValues = array (
							new PHPExcel_Chart_DataSeriesValues ( 'Number', 'Data!$B' . $dataStartRow . ':$B$' . $s2row, null, $ecount-1 )
					);
					
					$series = new PHPExcel_Chart_DataSeries ( PHPExcel_Chart_DataSeries::TYPE_LINECHART, 					// plotType
											PHPExcel_Chart_DataSeries::GROUPING_STANDARD, 					// plotGrouping
											range ( 0, count ( $dataSeriesValues ) - 1 ), 					// plotOrder
											$dataseriesLabels, 					// plotLabel
											$xAxisTickValues, 					// plotCategory
											$dataSeriesValues, true, PHPExcel_Chart_DataSeries::STYLE_LINEMARKER );
											
					$plotarea = new PHPExcel_Chart_PlotArea ( null, array (
						$series 
					) );
					
					
					$title = new PHPExcel_Chart_Title ( $MYLANGUAGE->getString('DPGRAPH') );
					//$xAxisLabel = new PHPExcel_Chart_Title ( $MYLANGUAGE->getString('TIME') );
					$yAxisLabel = new PHPExcel_Chart_Title ( $MYLANGUAGE->getString('SCORE') );
					
					$chart = new PHPExcel_Chart ( 'fuel1Chart', 					// name
												$title, 					// title
												null, 					// legend
												$plotarea, 					// plotArea
												true, 					// plotVisibleOnly
												0, 					// displayBlanksAs
												null, 					// xAxisLabel
												$yAxisLabel ); // yAxisLabel
												
					$chart->setTopLeftPosition ( 'A' . $row );
					$chart->setBottomRightPosition ( 'K' . ($row + 20) );
					
					$objPHPExcel->setActiveSheetIndex ( 0 );
					// Add the chart to the worksheet
					$myWorkSheet->addChart ( $chart );
					
					$row+=22;
		
			}
		} // for I
		
		// redirect output to browser
		header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
		header ( 'Content-Disposition: attachment;filename="driverScore.xlsx"' );
		header ( 'Cache-Control: max-age=0' );
		$objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
		$objWriter->setIncludeCharts ( true );
		$objWriter->save ( 'php://output' );
	}
}
class DriverScoreGraphClass {
	public static function drawSmallPie($data) {
		$graph = new PieGraph ( 32, 32 );
		
		$pplot = new PiePlot3D ( $data );
		$graph->Add ( $pplot );
		$pplot->SetSliceColors ( array (
				"green",
				"red" 
		) );
		// Display the graph
		// define("__IMG_HANDLER","");
		ob_start ();
		$graph->Stroke ();
		$contents = ob_get_contents ();
		ob_end_clean ();
		
		return $contents;
	}
	public static function draw($data) {
		global $MYLANGUAGE;
		
		$graph = new Graph ( 800, 300 );
		$graph->SetScale ( "intint", 0, 10 );
		
		$graph->title->Set ( $MYLANGUAGE->getString ( 'DPGRAPH' ) );
		$graph->xaxis->title->Set ( $MYLANGUAGE->getString ( 'TIME' ) );
		
		$graph->title->SetFont ( FF_ARIAL, FS_BOLD, 10 );
		$graph->title->SetAlign ( "left" );
		$graph->xaxis->SetFont ( FF_ARIAL, FS_BOLD, 1 );
		
		$graph->xaxis->HideLabels ( true );
		$pplot = new LinePlot ( $data );
		$graph->Add ( $pplot );
		$pplot->SetColor ( "orange" );
		// Display the graph
		// define("__IMG_HANDLER","");
		ob_start ();
		$graph->Stroke ();
		$contents = ob_get_contents ();
		ob_end_clean ();
		
		return $contents;
	}
}
class DRIVERSCORE_Output_PDF {
	public $pdf;

	public static $txtDirection;
	public static $revDirection;
	public static $direction;
	
	
	private function initializePDF() {
		global $MYLANGUAGE;
		
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$this->pdf = new mPDF ( "utf-8", "LETTER" );
		
		$this->pdf->SetCreator ( "Find'n'Secure" );
		$this->pdf->SetAuthor ( 'EMBARC' );
		$this->pdf->SetTitle ( $MYLANGUAGE->getString ( 'DRIVERSCORE' ) );
		$this->pdf->SetSubject ( $MYLANGUAGE->getString ( 'DRIVERSCORE' ) );
		$this->pdf->SetKeywords ( "Driver Scoring, Report, Findnsecure" );
		
		// set default header data
		$header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . $MYLANGUAGE->getString ( 'DRIVERSCORE' ) . '</td><td align="'.$right.'"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
		$this->pdf->SetHTMLHeader ( $header, "E" );
		$this->pdf->SetHTMLHeader ( $header, "O" );
		$this->pdf->SetTopMargin ( 30 );
		
		// $this->pdf->SetDirectionality("rtl");
		$this->pdf->SetAutoFont ( AUTOFONT_ALL );
		$this->pdf->SetDirectionality(self::$direction);
	}
	public function printPDF($arrDis) {
		
		global $GDATABASE, $MYLANGUAGE, $languageMatrix;
		
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
		
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}
		
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		ob_start ();
		$tmpfiles = array();
		
		$summary = array ();
		
		$reportSummary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		$today = $fdate->dateTime->getTimestamp ();
		$this->initializePDF();
		
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		switch ($_GET ['rmethod']) {
			case "daily" :
				$method = $MYLANGUAGE->getString ( "DAILY" );
				break;
			case "weekly" :
				$method = $MYLANGUAGE->getString ( "WEEKLY" );
				break;
			case "monthly" :
				$method = $MYLANGUAGE->getString ( "MONTHLY" );
				break;
		}
		
		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
		
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>

		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';
		
		$tCount = count ( $arrDis );
		
		for($i = 0; $i < $tCount; $i ++) {
			print '<br><table width="100%" class = "topBottom10pxPadding">
			<tr style="background-color:#EFEFEF">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'DRIVER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'REF_NO' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] ['referenceNo'] . '</td>
			</tr>';
			
			$fdate->setUTCDate ( $arrDis [$i] ['details'] ['licvalid'], $arrDis [$i] ['details'] ['tlic'] );
			$licvalid = $fdate->getFormattedDateString ();
			
			$exdate = $fdate->dateTime->getTimestamp ();
			
			if ($exdate <= $today)
				$expired = $MYLANGUAGE->getString ( "EXPIRED" );
			else
				$expired = '';
			
			print '<tr style="background-color:#EFEFEF">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TAG_ID' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] ['tagID'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'LICENSE_VALID' ) . ':</td><td class="subHeading">' . $licvalid . " <span style='color:red;font-weight:bold'>($expired)</span>" . '</td>
			</tr>';
			
			print "</table>";
			
			$rs = new DriverReport ();
			$rs->available = false;
			
			print '<table width="100%" cellSpacing=2 cellpadding="2" rules="rows" style="font-size:11px;font-family:Arial" >
			<tr align="'.$left.'">
			<th width="80px">' . $MYLANGUAGE->getString ( 'DBG_HACC' ) . '</th>
			<th width="70px">' . $MYLANGUAGE->getString ( 'DBG_HBRK' ) . '</th>
			<th width="80px">' . $MYLANGUAGE->getString ( 'DBG_HCOR' ) . '</th>
			<th width="80px">' . $MYLANGUAGE->getString ( 'OVERSPEED_TXT' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'IDLE_COUNT' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'IDLE_DUR' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'TRIPS' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'DRI_DUR' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'WORK_DUR' ) . '</th>					
			<th align="center" width="70px">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
			<th >' . $MYLANGUAGE->getString ( 'SCORE' ) . '</th>
			</tr>';
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
				
				$summary = & $arrDis [$i] ['result'] [$j]->summary;
				$breakup = & $arrDis [$i] ['result'] [$j]->breakup;
				
				if ($summary->available == true) {
					$rs->available = $summary->available;
					
					$mDuration = reportUtils::getDurationTextShort ( $summary->movementDuration, $MYLANGUAGE );
					$iDuration = reportUtils::getDurationTextShort ( $summary->idlingDuration, $MYLANGUAGE );
					$tDuration = reportUtils::getDurationTextShort ( $summary->movementDuration + $summary->idlingDuration, $MYLANGUAGE );
					
					print '<tr style="background-color:#EEEEEE;height:20px; padding-top:10px;"><td colspan="12" style="font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate . '</td></tr>';
					
					$rs->harshAcceleration += $summary->harshAcceleration;
					$rs->harshBraking += $summary->harshBraking;
					$rs->harshCornering += $summary->harshCornering;
					$rs->idlingCount += $summary->idlingCount;
					$rs->movementDuration += $summary->movementDuration;
					$rs->idlingDuration += $summary->idlingDuration;
					$rs->movementCount += $summary->movementCount;
					$rs->overspeeding += $summary->overspeeding;
					$rs->distance += $summary->distance;
					
					$tmpfname = tempnam("/tmp", "FNS");
					array_push($tmpfiles, $tmpfname);
					$handle = fopen($tmpfname, "w+");
					fwrite($handle, base64_decode($summary->graph));
					fclose($handle);
						
					print '<tr align="'.$left.'" style="font-weight:normal; font-size:12px;">
					
						<td style="text-align:center">' . $summary->harshAcceleration . '</td>
						<td style="text-align:center">' . $summary->harshBraking . '</td>
						<td style="text-align:center">' . $summary->harshCornering . '</td>
						<td style="text-align:center">' . $summary->overspeeding . '</td>
						<td style="text-align:center">' . $summary->idlingCount . '</td>
						<td style="text-align:center">' . $iDuration . '</td>
						<td style="text-align:center">' . $summary->movingCount . '</td>
						<td style="text-align:center">' . $mDuration . '</td>
						<td style="text-align:center">' . $tDuration . '</td>
						<td style="text-align:center">' . sprintf ( "%0.2f", $summary->distance ) . '</td>
						<td style="text-align:center;font-weight:bold;">' . sprintf ( "%0.2f", $summary->score ) . '</td>
						<td style="text-align:center"><img src="'.$tmpfname.'"></img></td>
						</tr>';
				}
			} // for J
			
			if ($rs->available) {
				$score = DRIVERSCORE_FNSv3_Report::getScore ( $rs );
				$graph = DriverScoreGraphClass::drawSmallPie ( array (
						$score,
						10 - $score 
				) );
				
				$mDuration = reportUtils::getDurationTextShort ( $rs->movementDuration, $MYLANGUAGE );
				$iDuration = reportUtils::getDurationTextShort ( $rs->idlingDuration, $MYLANGUAGE );
				$tDuration = reportUtils::getDurationTextShort ( $rs->movementDuration + $rs->idlingDuration, $MYLANGUAGE );
				print '<tr style="background-color:red;height:20px; padding-top:10px;"><td colspan="12" style="color:white;font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'TOTAL' ) . '</td></tr>';
				
				$tmpfname = tempnam("/tmp", "FNS");
				array_push($tmpfiles, $tmpfname);
				$handle = fopen($tmpfname, "w+");
				fwrite($handle, $graph);
				fclose($handle);
				
				
				print '<tr align="'.$left.'" style="font-weight:normal; font-weight:bold; font-size:14px;">
				<td style="text-align:center">' . $rs->harshAcceleration . '</td>
						<td style="text-align:center">' . $rs->harshBraking . '</td>
						<td style="text-align:center">' . $rs->harshCornering . '</td>
						<td style="text-align:center">' . $rs->overspeeding . '</td>
						<td style="text-align:center">' . $rs->idlingCount . '</td>
						<td style="text-align:center">' . $iDuration . '</td>
						<td style="text-align:center">' . $rs->movingCount . '</td>
						<td style="text-align:center">' . $mDuration . '</td>
						<td style="text-align:center">' . $tDuration . '</td>
						<td style="text-align:center">' . sprintf ( "%0.2f", $rs->distance ) . '</td>
						<td style="text-align:center">' . sprintf ( "%0.2f", $score ) . '</td>
						<td style="text-align:center"><img src="'.$tmpfname.'"></img></td>								
						</tr>';
			}
			
			print "</table>";
			
			if (isset ( $arrDis [$i] ['graph'] ))
			{
				$tmpfname = tempnam("/tmp", "FNS");
				array_push($tmpfiles, $tmpfname);
				$handle = fopen($tmpfname, "w+");
				fwrite($handle, base64_decode($arrDis [$i] ['graph']));
				fclose($handle);
				print '<br/><img src="' . $tmpfname . '"></img>';
			}
				
		} // for I
		
		$contents = ob_get_contents ();
		ob_end_clean ();
		header('Content-type: text/html');
		//print $contents; die;
		$this->pdf->WriteHTML ( $contents );
		$this->pdf->Output ();
		foreach($tmpfiles as $k => $j)
		{
			unlink($j);
		}
		
	}
}
class DRIVERSCORE_Output_HTML {
	public static $txtDirection;
	public static $revDirection;
	public static $direction;

	
	public static function printHeader() {
		global $MYLANGUAGE, $languageMatrix;
		
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
		
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}

		print '
				<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>' . $MYLANGUAGE->getString ( 'DRIVERSCORE' ) . '</title>
				<style>'. file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:'.$direction.';} </style>
				</head>
				<body class="mainbody" style="background-color:#999; background-image:none">
			    <div id="reportframe">
			    <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
			  ';
	}
		public static function printHTML($arrDis) {
		ob_start ();
		
		$summary = array ();
		
		$reportSummary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		$today = $fdate->dateTime->getTimestamp ();
		
		global $GDATABASE, $MYLANGUAGE;
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		DRIVERSCORE_Output_HTML::printHeader ();
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		switch ($_GET ['rmethod']) {
			case "daily" :
				$method = $MYLANGUAGE->getString ( "DAILY" );
				break;
			case "weekly" :
				$method = $MYLANGUAGE->getString ( "WEEKLY" );
				break;
			case "monthly" :
				$method = $MYLANGUAGE->getString ( "MONTHLY" );
				break;
		}
		
		print '<table width="100%" class="topBottom10pxPadding"><tr><td>' . $MYLANGUAGE->getString ( 'DRIVERSCORE' ) . " (" . $method . ')</td><td align="'.$right.'"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';
		
		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
		
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>

		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';
		
		$tCount = count ( $arrDis );
		
		for($i = 0; $i < $tCount; $i ++) {
			print '<br><table width="100%" class = "topBottom10pxPadding">
			<tr style="background-color:#EFEFEF">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'DRIVER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'REF_NO' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] ['referenceNo'] . '</td>
			</tr>';
			
			$fdate->setUTCDate ( $arrDis [$i] ['details'] ['licvalid'], $arrDis [$i] ['details'] ['tlic'] );
			$licvalid = $fdate->getFormattedDateString ();
			
			$exdate = $fdate->dateTime->getTimestamp ();
			
			if ($exdate <= $today)
				$expired = $MYLANGUAGE->getString ( "EXPIRED" );
			else
				$expired = '';
			
			print '<tr style="background-color:#EFEFEF">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TAG_ID' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] ['tagID'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'LICENSE_VALID' ) . ':</td><td class="subHeading">' . $licvalid . " <span style='color:red;font-weight:bold'>($expired)</span>" . '</td>
			</tr>';
			
			print "</table>";
			
			$rs = new DriverReport ();
			$rs->available = false;
			
			print '<table width="100%" cellSpacing=2 cellpadding="2" border=1 frame="hsides" bordercolor="#999999" rules="rows" style="font-size:11px;font-family:Arial" >
			<tr align="'.$left.'">
			<th width="80px">' . $MYLANGUAGE->getString ( 'DBG_HACC' ) . '</th>
			<th width="70px">' . $MYLANGUAGE->getString ( 'DBG_HBRK' ) . '</th>
			<th width="80px">' . $MYLANGUAGE->getString ( 'DBG_HCOR' ) . '</th>
			<th width="80px">' . $MYLANGUAGE->getString ( 'OVERSPEED_TXT' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'IDLE_COUNT' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'IDLE_DUR' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'TRIPS' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'DRI_DUR' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'WORK_DUR' ) . '</th>					
			<th align="center" width="70px">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
			<th >' . $MYLANGUAGE->getString ( 'SCORE' ) . '</th>
			</tr>';
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
				
				$summary = & $arrDis [$i] ['result'] [$j]->summary;
				$breakup = & $arrDis [$i] ['result'] [$j]->breakup;
				
				if ($summary->available == true) {
					$rs->available = $summary->available;
					
					$mDuration = reportUtils::getDurationTextShort ( $summary->movementDuration, $MYLANGUAGE );
					$iDuration = reportUtils::getDurationTextShort ( $summary->idlingDuration, $MYLANGUAGE );
					$tDuration = reportUtils::getDurationTextShort ( $summary->movementDuration + $summary->idlingDuration, $MYLANGUAGE );
					
					print '<tr style="background-color:#EEEEEE;height:20px; padding-top:10px;"><td colspan="12" style="font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate . '</td></tr>';
					
					$rs->harshAcceleration += $summary->harshAcceleration;
					$rs->harshBraking += $summary->harshBraking;
					$rs->harshCornering += $summary->harshCornering;
					$rs->idlingCount += $summary->idlingCount;
					$rs->movementDuration += $summary->movementDuration;
					$rs->idlingDuration += $summary->idlingDuration;
					$rs->movementCount += $summary->movementCount;
					$rs->overspeeding += $summary->overspeeding;
					$rs->distance += $summary->distance;
					
					print '<tr align="'.$left.'" style="font-weight:normal; font-size:12px;">
					
						<td style="text-align:center">' . $summary->harshAcceleration . '</td>
						<td style="text-align:center">' . $summary->harshBraking . '</td>
						<td style="text-align:center">' . $summary->harshCornering . '</td>
						<td style="text-align:center">' . $summary->overspeeding . '</td>
						<td style="text-align:center">' . $summary->idlingCount . '</td>
						<td style="text-align:center">' . $iDuration . '</td>
						<td style="text-align:center">' . $summary->movingCount . '</td>
						<td style="text-align:center">' . $mDuration . '</td>
						<td style="text-align:center">' . $tDuration . '</td>
						<td style="text-align:center">' . sprintf ( "%0.2f", $summary->distance ) . '</td>
						<td style="text-align:center;font-weight:bold;">' . sprintf ( "%0.2f", $summary->score ) . '</td>
						<td style="text-align:center"><img src="data:image/png;base64,' . $summary->graph . '"></img></td>
						</tr>';
				}
			} // for J
			
			if ($rs->available) {
				$score = DRIVERSCORE_FNSv3_Report::getScore ( $rs );
				$graph = base64_encode ( DriverScoreGraphClass::drawSmallPie ( array (
						$score,
						10 - $score 
				) ) );
				
				$mDuration = reportUtils::getDurationTextShort ( $rs->movementDuration, $MYLANGUAGE );
				$iDuration = reportUtils::getDurationTextShort ( $rs->idlingDuration, $MYLANGUAGE );
				$tDuration = reportUtils::getDurationTextShort ( $rs->movementDuration + $rs->idlingDuration, $MYLANGUAGE );
				print '<tr style="background-color:red;height:20px; padding-top:10px;"><td colspan="12" style="color:white;font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'TOTAL' ) . '</td></tr>';
				
				print '<tr align="'.$left.'" style="font-weight:normal; font-weight:bold; font-size:14px;">
				<td style="text-align:center">' . $rs->harshAcceleration . '</td>
						<td style="text-align:center">' . $rs->harshBraking . '</td>
						<td style="text-align:center">' . $rs->harshCornering . '</td>
						<td style="text-align:center">' . $rs->overspeeding . '</td>
						<td style="text-align:center">' . $rs->idlingCount . '</td>
						<td style="text-align:center">' . $iDuration . '</td>
						<td style="text-align:center">' . $rs->movingCount . '</td>
						<td style="text-align:center">' . $mDuration . '</td>
						<td style="text-align:center">' . $tDuration . '</td>
						<td style="text-align:center">' . sprintf ( "%0.2f", $rs->distance ) . '</td>
						<td style="text-align:center">' . sprintf ( "%0.2f", $score ) . '</td>
						<td style="text-align:center"><img src="data:image/png;base64,' . $graph . '"></img></td>
						</tr>';
			}
			print "</table>";
			
			if (isset ( $arrDis [$i] ['graph'] ))
				print '<img src="data:image/png;base64,' . $arrDis [$i] ['graph'] . '"></img>';
				
		} // for I
		
		DRIVERSCORE_Output_HTML::printFooter ();
		
		$contents = ob_get_contents ();
		ob_end_clean ();
		header ( "Content-type: text/html" );
		print $contents;
	}
	public static function printFooter() {
		print '
		<br/>
		<div style="width:100%; border:1px black solid; background-color:#404040; height:10px" />
		</div></div>
		</body></html>';
	}
}
class DRIVERSCORE_FNSv3_Report {
	private $mConverter;
	private $rDatabase;
	private $trips;
	private $driversDistance;
	private $dperformance;

	public static function getScore($summary) {
		if ($summary->distance == 0)
			$distance = 1;
		else
			$distance = $summary->distance;
		
		if ($summary->movementDuration == 0)
			$mduration = 1;
		else
			$mduration = $summary->movementDuration;
		
		$hapkm = $summary->harshAcceleration / $distance;
		$hbpkm = $summary->harshBraking / $distance;
		$hcpkm = $summary->harshCornering / $distance;
		$idlpkm = $summary->idlingCount / $distance;
		$ovspkm = $summary->overspeeding / $distance;
		
		$hovsw = 1.5;
		$haw = 1.5;
		$hbw = 1.5;
		$hcw = 1.5;
		$idlw = 1;
		$idltw = 3;
		
		$hovspc = ($ovspkm * $hovsw) / 10;
		$hapc = ($hapkm * $haw) / 10;
		$hbpc = ($hbpkm * $hbw) / 10;
		$hcpc = ($hcpkm * $hcw) / 10;
		$idlpc = ($idlpkm * $idlw) / 10;
		$idltpc = (($summary->idlingDuration / $mduration) * $idltw) / 10;
		
		if ($hapc > $haw)
			$hapc = $haw;
		if ($hbpc > $hbw)
			$hbpc = $hbw;
		if ($hcpc > $hcw)
			$hcpc = $hcw;
		if ($idlpc > $idlw)
			$idlpc = $idlw;
		if ($idltpc > $idltw)
			$idltpc = $idltw;
		if ($hovspc > $hovsw)
			$hovspc = $hovsw;
		
		$iqs = 10 - ($hapc + $hbpc + $hcpc + $idlpc + $idltpc + $hovspc);
		return $iqs;
	}
	
	private function getStatus($speed, $io) {
		if ($speed > 0 && strpos ( $io, "j" ) !== false)
			$currentStatus = STATUS_MOVING;
		else if (strpos ( $io, "j" ) !== false)
			$currentStatus = STATUS_IDLE;
		else
			$currentStatus = STATUS_STOPPED;
		
		return $currentStatus;
	}
	
private function computeTrips($tid) {
		global $GDATABASE;
		
		$trips = array ();
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		// Starting state of this automata will be TRIP_START
		$currentState = TRIP_START;
		
		$data = true;
		$distance = 0;
		
		$tprofiles = $GDATABASE->getTrackerTemperatureProfiles ( $tid );
		$card = $GDATABASE->getTrackerCard ( $tid );
		
		$computeTemperature = false;
		$tpr = array ();
		
		for($v = 0; $v < count ( $tprofiles ); $v ++) {
			if ($tprofiles [$v] !== false) {
				$computeTemperature = true;
			}
		}
		
		$exit = false;
		$oldData = false;
		
		while ( $exit == false ) {
			$data = $this->rDatabase->reports_nextLocation ();
			 //print "<br/>\r\n".$data['date'].",".$data['time'].",".$data['latitude'].",".$data['longitude'].",".$data['speed'].",".$data['IO'];
			switch ($currentState) {
				
				case TRIP_START :
					
					if ($data == false) {
						$exit = true;
						break;
					}
					// move the state into its determined state
					$currentState = $this->getStatus ( $data ['speed'], $data ['IO'] );
					
					$fdate->setUTCDate ( $data ['date'], $data ['time'] );
					$stateTransTime = $fdate->dateTime->getTimestamp ();
					
					$lastLatitude = $data ['latitude'];
					$lastLongitude = $data ['longitude'];
					$maxSpeed = $data ['speed'];
					
					$maxTemp = array ();
					$minTemp = array ();
					
					if ($computeTemperature == true) {
						for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
							$minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
						}
					}
					
					$n = new tripRObject ();
					$n->status = TRIP_START;
					$n->distance = $distance;
					$n->maxSpeed = $maxSpeed;
					$n->latitude = $data ['latitude'];
					$n->longitude = $data ['longitude'];
					$n->duration = 0;
					$n->date = $data ['date'];
					$n->time = $data ['time'];
					$n->maxTemp = $maxTemp;
					$n->minTemp = $minTemp;
					$n->odometer = $GDATABASE->getOdometer($tid, $n->date, $n->time);
					$n->driver = $this->rDatabase->getDriverObject ( $tid, $n->date, $n->time );
					array_push($trips,$n);
					break;
				
				case STATUS_MOVING :
					if ($data != false) {
						$newState = $this->getStatus ( $data ['speed'], $data ['IO'] );
					}
					
					if ($newState != STATUS_MOVING || $data == false) {
						if ($data == false) {
							$exit = true;
							$data = $oldData;
						}
						
						$fdate->setUTCDate ( $data ['date'], $data ['time'] );
						
						// if last state was movement only - means last state
						// was skipped due to trip time
						// in this case add to the previous packet otherwise
						// emit new packet
						$lastTripIndex = count ( $trips ) - 1;
						if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == STATUS_MOVING) {
							$trips [$lastTripIndex]->date = $data ['date'];
							$trips [$lastTripIndex]->time = $data ['time'];
							$trips [$lastTripIndex]->latitude = $data ['latitude'];
							$trips [$lastTripIndex]->longitude = $data ['longitude'];
							$trips [$lastTripIndex]->odometer = $GDATABASE->getOdometer($tid, $n->date, $n->time);
							$trips [$lastTripIndex]->distance = $distance;
							$trips [$lastTripIndex]->maxSpeed = $maxSpeed;
							$trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
						} else {
							$n = new tripRObject ();
							$n->status = $currentState;
							$n->distance = $distance;
							$n->maxSpeed = $maxSpeed;
							$n->latitude = $data ['latitude'];
							$n->longitude = $data ['longitude'];
							$n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
							$n->date = $data ['date'];
							$n->time = $data ['time'];
							$n->odometer = $GDATABASE->getOdometer($tid, $n->date, $n->time);
							$n->maxTemp = $maxTemp;
							$n->minTemp = $minTemp;
							$n->driver = $this->rDatabase->getDriverObject ( $tid, $n->date, $n->time );
							array_push ( $trips, $n );
							
							$maxTemp = array ();
							$minTemp = array ();
						}
						
						$currentState = $newState;
						// Set State transition time
						$stateTransTime = $fdate->dateTime->getTimestamp ();
					}
					
					$distance += reportUtils::getDistance ( $data ['latitude'], $data ['longitude'], $lastLatitude, $lastLongitude );
					
					if ($computeTemperature == true) {
						for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
							
							$ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
							
							if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
								$maxTemp [$tp] = $ctemp;
							else
								$maxTemp [$tp] = $ctemp;
							
							if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
								$minTemp [$tp] = $ctemp;
							else
								$minTemp [$tp] = $ctemp;
						}
					}
					
					if ($data ['speed'] > $maxSpeed)
						$maxSpeed = $data ['speed'];
					
					$lastLatitude = $data ['latitude'];
					$lastLongitude = $data ['longitude'];
					
					break;
				
				case STATUS_STOPPED :
				// Both STOPPED and IDLE follow the same logic and correspondingly emits out correct records
				
				case STATUS_IDLE :
					if ($data != false) {
						$newState = $this->getStatus ( $data ['speed'], $data ['IO'] );
						
						$fdate->setUTCDate ( $data ['date'], $data ['time'] );
						$cTime = $fdate->dateTime->getTimestamp ();
						
						if ($computeTemperature == true) {
							for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
								
								$ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
								
								if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
									$maxTemp [$tp] = $ctemp;
								else
									$maxTemp [$tp] = $ctemp;
								
								if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
									$minTemp [$tp] = $ctemp;
								else
									$minTemp [$tp] = $ctemp;
							}
						}
						
						// If the time difference is greater then trips breaking
						// time then emit out
						if (($cTime - $stateTransTime) > (TRIPS_BREAKING_TIME * 60))
							$emitOut = true;
						else
							$emitOut = false;
					}
					
					if ($newState != $currentState || $data == false) {
						// Emit Packet and Set new state
						if ($emitOut || $data == false) {

							if ($data == false) {
								$exit = true;
								$data = $oldData;
							}
							
							$fdate->setUTCDate ( $data ['date'], $data ['time'] );
							$lastTripIndex = count ( $trips ) - 1;
							if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == $currentState) {
								$trips [$lastTripIndex]->date = $data ['date'];
								$trips [$lastTripIndex]->time = $data ['time'];
								$trips [$lastTripIndex]->latitude = $data ['latitude'];
								$trips [$lastTripIndex]->longitude = $data ['longitude'];
								$trips [$lastTripIndex]->odometer = $GDATABASE->getOdometer($tid, $n->date, $n->time);
								$trips [$lastTripIndex]->distance = 0;
								$trips [$lastTripIndex]->maxSpeed = 0;
								$trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
							} else {	
								$n = new tripRObject ();
								$n->status = $currentState;
								$n->latitude = $lastLatitude; // $data['latitude'];
								$n->longitude = $lastLongitude; // $data['longitude'];
								$n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
								$n->date = $data ['date'];
								$n->time = $data ['time'];
								$n->odometer = $GDATABASE->getOdometer($tid, $n->date, $n->time);
								$n->driver = $this->rDatabase->getDriverObject ( $tid, $n->date, $n->time );
								array_push ( $trips, $n );
							}
							
							$stateTransTime = $fdate->dateTime->getTimestamp ();
							$distance = 0;
							$lastLatitude = $data ['latitude'];
							$lastLongitude = $data ['longitude'];
							$maxSpeed = $data ['speed'];
							
							if ($computeTemperature == true) {
								$minTemp = array ();
								$maxTemp = array ();
								
								for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
									$minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
								}
							}
						}
						$currentState = $newState;
					}
					
					break;
			}
			$oldData = $data;
		}
		//print_r($trips);
		//die;
		
		return $trips;
	}
		
	private function getDistance($tid, $dateArray) {
		$this->rDatabase->reports_getLocationsData ( $tid, $dateArray );
		$pLocation = $this->rDatabase->reports_nextLocation ();
		$distance = 0;
		
		while ( 1 ) {
			$cLocation = $this->rDatabase->reports_nextLocation ();
			if ($cLocation == false)
				break;
			
			$distance += reportUtils::getDistance ( $pLocation ['latitude'], $pLocation ['longitude'], $cLocation ['latitude'], $cLocation ['longitude'] );
			$pLocation = $cLocation;
		}
		return $distance;
	}
	private function getTrips($tid, $dateArray) {
		if (isset ( $this->trips [$tid] ))
			return $this->trips [$tid];
		
		$this->rDatabase->reports_getLocationsData ( $tid, $dateArray );
		$this->trips [$tid] = $this->computeTrips ( $tid );
		
		return $this->trips [$tid];
	}
	private function computeParameters($did, $dateArray, $trackers, $days) {
		global $GDATABASE;
		$reportArray = array ();
		
		if ($trackers == false)
			return $reportArray;
		
		$sdate = new FNSDateTime ( $_SESSION ['timezone'] );
		$edate = new FNSDateTime ( $_SESSION ['timezone'] );
		$pdate = new FNSDateTime ( $_SESSION ['timezone'] );
		$xdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		$daysCount = count ( $days );

		if($_SERVER['REMOTE_ADDR'] == '103.86.137.22'){
			//echo '<pre>'.print_r($trackers);echo '</pre>';	//die('chala');
		}

		for($i = 0; $i < count ( $trackers ); $i ++) {

				$trips = $this->getTrips ( $trackers [$i] ['trackerid'], $dateArray );
			
				for($x = 0; $x < $daysCount - 1; $x ++) {

					$s = new DriverReport ();
					$s->trackerid = $trackers [$i] ['trackerid'];
					$s->trackerName = $trackers [$i] ['name'];
					
					$sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
					$edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
					
					if (isset ( $days [$x]->summary ) == false) {
						$days [$x]->summary = new DriverReport ();
						$days [$x]->breakup = array ();
					}
					
					if (isset ( $this->dperformance [$trackers [$i] ['trackerid']] ) == false) {
						$this->dperformance [$trackers [$i] ['trackerid']] = $this->rDatabase->getDriverScoring ( $trackers [$i] ['trackerid'], $dateArray );
					}
					
					$n = $this->dperformance [$trackers [$i] ['trackerid']] [$did];
					
					$clearTrips = $trips;

					
					foreach ( $trips as $y => $v ) {
						if ($trips [$y]->driver->tag == $did) {
							$pdate->setUTCDate ( $trips [$y]->date, $trips [$y]->time );
							if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
								if ($trips [$y]->status == STATUS_MOVING) {
									// array_push($days[$x]->moving,$trips[$y]);
									$s->distance += $trips [$y]->distance;
									$s->movementDuration += $trips [$y]->duration;
									$s->movingCount ++;
								} else if ($trips [$y]->status == STATUS_IDLE) {
									// array_push($days[$x]->idling,$trips[$y]);
									$s->idlingCount ++;
									$s->idlingDuration += $trips [$y]->duration;
								}
								unset ( $clearTrips [$y] );
							} else
								break;
						}
					}
					


					$trips = $clearTrips;
					
					$ha = $n->ha;
					
					foreach ( $n->ha as $y => $v ) {
						$pdate->setUTCDate ( $n->ha [$y] ['date'], $n->ha [$y] ['time'] );
						if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
							// array_push($days[$x]->ha,$n->ha[$y]);
							$s->harshAcceleration ++;
							unset ( $ha [$y] );
						} else
							break;
					}
					
					$n->ha = $ha;
					
					$hb = $n->hb;
					
					foreach ( $n->hb as $y => $v ) {
						$pdate->setUTCDate ( $n->hb [$y] ['date'], $n->hb [$y] ['time'] );
						if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
							// array_push($days[$x]->hb,$n->hb[$y]);
							$s->harshBraking ++;
							unset ( $hb [$y] );
						} else
							break;
					}
					
					$n->hb = $hb;
					
					$hc = $n->hc;
					
					foreach ( $n->hc as $y => $v ) {
						$pdate->setUTCDate ( $n->hc [$y] ['date'], $n->hc [$y] ['time'] );
						if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
							// array_push($days[$x]->hc,$n->hc[$y]);
							$s->harshCornering ++;
							unset ( $hc [$y] );
						} else
							break;
					}
					
					$n->hc = $hc;
					
					$ovs = $n->ovs;
					
					foreach ( $n->ovs as $y => $v ) {
						$pdate->setUTCDate ( $n->ovs [$y] ['date'], $n->ovs [$y] ['time'] );
						if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
							$s->overspeeding ++;
							unset ( $ovs [$y] );
						} else
							break;
					}
					
					$n->ovs = $ovs;


					
					if ($s->distance > 0 || $s->harshAcceleration > 0 || $s->harshBraking > 0 || $s->idlingCount > 0 || $s->harshCornering > 0 || $s->overspeeding > 0 || $s->movingCount > 0) {
						$days [$x]->summary->available = true;
						
						$s->distance = $this->mConverter->convert($s->distance,'D');
						
						$days [$x]->summary->distance += $s->distance;
						$days [$x]->summary->harshAcceleration += $s->harshAcceleration;
						$days [$x]->summary->harshBraking += $s->harshBraking;
						$days [$x]->summary->harshCornering += $s->harshCornering;
						$days [$x]->summary->movementDuration += $s->movementDuration;
						$days [$x]->summary->idlingDuration += $s->idlingDuration;
						$days [$x]->summary->idlingCount += $s->idlingCount;
						$days [$x]->summary->movingCount += $s->movingCount;
						$days [$x]->summary->overspeeding += $s->overspeeding;
						array_push ( $days [$x]->breakup, $s );
					}
					
				}



		}

		//if($_SERVER['REMOTE_ADDR'] == '103.86.137.22'){die('Fns maintenance running !');}

		
		
		$lineArray = array ();
		
		for($x = 0; $x < $daysCount - 1; $x ++) {
			if ($days [$x]->summary->available == true) {
				$days [$x]->summary->score = DRIVERSCORE_FNSv3_Report::getScore ( $days [$x]->summary );
				$days [$x]->summary->graph = base64_encode ( DriverScoreGraphClass::drawSmallPie ( array (
						$days [$x]->summary->score,
						10 - $days [$x]->summary->score 
				) ) );
				
				array_push ( $lineArray, $days [$x]->summary->score );
			}
		}
		
		$result = array ();
		$result ['days'] = $days;
		
		if (count ( $lineArray ))
			$result ['graph'] = base64_encode ( DriverScoreGraphClass::draw ( $lineArray ) );
		
		return $result;
	}
	private function getDriversList() {
		global $GDATABASE;
		$drivers = $GDATABASE->getDriversList ( "tagID" );
		$a = array ();
		$dcount = count ( $drivers );
		for($i = 0; $i < $dcount; $i ++) {
			array_push ( $a, $drivers [$i] ['tagID'] );
		}
		return $a;
	}
	private function getReportData() {
		global $GDATABASE;
		
		

		$arrdate = reportUtils::getUTCReportTime ( $_GET );
		
		if ($_GET ['ftype'] == "E") {
			$drivers = $this->getDriversList ();
		} else {
			$drivers = explode ( ",", $_POST ['drivers'] );
		}
		
		$dcount = count ( $drivers );
		$display_array = array ();
		$selected_trackers_arr = array();
		$selected_trackers_ids =  '';
		
		foreach ($_REQUEST as $key => $value) {
			
			if (strpos($key, 'selected_trackers_fns_') !== false) {
			    $selected_trackers_arr[] = $value;
			}
		}
		
		$selected_trackers_ids = implode(',', $selected_trackers_arr);

		if (isset ( $_GET ['rmethod'] ) == false)
			$_GET ['rmethod'] = "daily";
		
		for($i = 0; $i < $dcount; $i ++) {
			$arr = array ();
			$arr ['details'] = $GDATABASE->getDriverCard ( $drivers [$i] );
			

			if ($arr ['details'] ['map'] == 'E')
				$trackers = $GDATABASE->getTrackersList ( "trackerid, name", $selected_trackers_ids );
			else
				$trackers = $GDATABASE->driverTrackersList ( $drivers [$i] );

			$days = reportUtils::getDays ( $arrdate, $_SESSION ['timezone'], $_GET ['rmethod'] );

			$result = $this->computeParameters ( $drivers [$i], $arrdate, $trackers, $days );
			
			$arr ['result'] = $result ['days'];
			if (isset ( $result ['graph'] ))
				$arr ['graph'] = $result ['graph'];
			
			array_push ( $display_array, $arr );
		}
		
		switch ($_GET ['format']) {
			case "HTML" :
				DRIVERSCORE_Output_HTML::printHTML ( $display_array );
				break;
			case "PDF" :
				$pdf = new DRIVERSCORE_Output_PDF ();
				$pdf->printPDF ( $display_array );
				break;
			case "XLSX" :
				DRIVERSCORE_Output_XLSX::printXLSX ( $display_array );
				break;
		}
	}
	
	public function execute() {
		global $MYLANGUAGE;
		$MYLANGUAGE = new FNSLanguage ();
		
		$this->mConverter = new metricConverter ();
		$this->mConverter->setMetrics ( $_GET ['metric'] );
		$this->rDatabase = new reportingQueries ();
		$this->trips = array ();
		$this->driversDistance = array ();
		$this->dperformance = array ();
				
		$this->getReportData ();
		
		unset($this->rDatabase);
		
	}
}
?>