<?php

/**
 * @version: 5.1
 */

require_once (REPORTS_FOLDER . "/reportUtils.php");
require_once (DATABASE_FOLDER . "/reportingQueries.php");
require_once (GEOCODER_FOLDER . "/geo.php");
require_once (PHPExcelPath . '/Classes/PHPExcel.php');
require_once (mPDF_FOLDER . "/mpdf.php");

class EVENTS_Output_XLSX {
	public static function printXLSX($arrDis) {
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		global $GDATABASE, $MYLANGUAGE;
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		$objPHPExcel = new PHPExcel ();
		$sheetProperties = $objPHPExcel->getProperties ();
		$sheetProperties->setCreator ( "Find'n'Secure" );
		$sheetProperties->setTitle ( $MYLANGUAGE->getString ( 'REVENTS' ) );
		$sheetProperties->setDescription ( $MYLANGUAGE->getString ( 'EV_INFO' ) );
		
		$myWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, $MYLANGUAGE->getString ( 'REVENTS' ) );
		$objPHPExcel->addSheet ( $myWorkSheet, 0 );
		$objPHPExcel->setActiveSheetIndex ( 0 );
		
		// set font-family and size
		$objPHPExcel->getDefaultStyle ()->getFont ()->setName ( 'Arial' );
		$objPHPExcel->getDefaultStyle ()->getFont ()->setSize ( 10 );
		
		// set default column widths
		for($i = 'A'; $i <= 'F'; $i ++) {
			$myWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
		}
		
		// set margins
		$myWorkSheet->getPageMargins ()->setRight ( 0.125 );
		$myWorkSheet->getPageMargins ()->setLeft ( 0.125 );
		
		// set page orientation
		$myWorkSheet->getPageSetup ()->setPaperSize ( PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4 );
		$myWorkSheet->getPageSetup ()->setFitToWidth ( 1 );
		$myWorkSheet->getPageSetup ()->setFitToHeight ( 0 );
		
		$row = 2;
		
		// report heading
		$myWorkSheet->SetCellValue ( "A$row", $MYLANGUAGE->getString ( 'REVENTS' ) );
		$myWorkSheet->mergeCells ( "A$row:C" . ($row + 4) );
		$headingStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 16 
				),
				'alignment' => array (
						'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
						'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP 
				) 
		);
		$myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
		$myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );
		
		// company logo
		$logo = new PHPExcel_Worksheet_Drawing ();
		$logo->setPath ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' );
		$logo->setWorksheet ( $myWorkSheet );
		$logo->setCoordinates ( 'D' . $row );
		$myWorkSheet->mergeCells ( "D$row:F" . ($row + 4) );
		$logo->setOffsetX ( 115 );
		
		$row = 9;
		
		// company details
		$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'COMPANY_NAME' ) );
		$myWorkSheet->SetCellValue ( 'B' . $row, $answer [0] ['company'] );
		$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'USERNAME' ) );
		$myWorkSheet->SetCellValue ( 'E' . $row, $answer [0] ['username'] );
		$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
		$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
		
		$row ++;
		
		$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
		$myWorkSheet->SetCellValue ( 'B' . $row, $sdate );
		$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
		$myWorkSheet->SetCellValue ( 'E' . $row, $edate );
		$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
		$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
		
		$row += 2;
		
		$tCount = count ( $arrDis );
		
		$detailsStyle = array (
				'borders' => array (
						'inside' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FFFFFFFF' 
								) 
						) 
				),
				
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FFDDDDDD' 
						) 
				) 
		);
		
		$rowHeadStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 9 
				),
				
				'borders' => array (
						'bottom' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FF000000' 
								) 
						) 
				) 
		);
		
		$periodStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 9 
				),
				
				'borders' => array (
						'bottom' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FF000000' 
								) 
						),
						'top' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FF000000' 
								) 
						) 
				),
				
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FFDDDDDD' 
						) 
				) 
		);
		
		for($i = 0; $i < $tCount; $i ++) {
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
			
			$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TRACKER_NAME' ) );
			$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['tinfo'] [0] ['name'] );
			$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'APPLICATION' ) );
			$myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( $apptype ) );
			$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
			$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
			$myWorkSheet->getStyle ( "A$row:F$row" )->applyFromArray ( $detailsStyle );
			$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
			
			$row ++;
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LICENSEPLATE' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['licensePlate'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'VTYPE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['vtype'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REFNO' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['arefno'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
			}
			$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
			$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
			$myWorkSheet->getStyle ( "A$row:F$row" )->applyFromArray ( $detailsStyle );
			$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
			
			$row += 3;
			
			$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TIME' ) );
			$myWorkSheet->SetCellValue ( 'B' . $row, $MYLANGUAGE->getString ( 'EVENT' ) );
			$myWorkSheet->SetCellValue ( 'C' . $row, $MYLANGUAGE->getString ( 'PLACE' ) );
			$myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( 'LATITUDE' ) );
			$myWorkSheet->SetCellValue ( 'F' . $row, $MYLANGUAGE->getString ( 'LONGITUDE' ) );
			$myWorkSheet->SetCellValue ( 'G' . $row, 'TAG ID' );
			$myWorkSheet->mergeCells ( 'C' . $row . ':D' . $row );
			$myWorkSheet->getStyle ( 'A' . $row . ':F' . $row )->applyFromArray ( $rowHeadStyle );
			$myWorkSheet->getStyle ( "D$row:F$row" )->getAlignment ()->setHorizontal ( PHPExcel_Style_Alignment::HORIZONTAL_RIGHT );
			
			$row += 2;
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
				
				$entCount = count ( $arrDis [$i] ['result'] [$j]->events );
				
				if ($entCount != 0) {
					$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate );
					$myWorkSheet->mergeCells ( "A$row:F$row" );
					$myWorkSheet->getStyle ( 'A' . $row . ':F' . $row )->applyFromArray ( $periodStyle );
					$row ++;
					
					for($k = 0; $k < $entCount; $k ++) {
						// if( $arrDis [$i] ['result'] [$j]->events [$k]->rfiddesc."" == "0" ){

						// }else{
							$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->events [$k]->date, $arrDis [$i] ['result'] [$j]->events [$k]->time );
							
							$date = $fdate->getDateStruct ();
							
							$myWorkSheet->SetCellValue ( 'A' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $date->year, $date->month, $date->day, $date->hour, $date->min, $date->sec ) );
							$myWorkSheet->getStyle ( 'A' . $row )->getNumberFormat ()->setFormatCode ( 'hh:mm:ss' );
							$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['result'] [$j]->events [$k]->name );
							$myWorkSheet->SetCellValue ( 'C' . $row, $arrDis [$i] ['result'] [$j]->events [$k]->place ['location'] );
							$myWorkSheet->mergeCells ( "C$row:D$row" );
							$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['result'] [$j]->events [$k]->latitude );
							$myWorkSheet->SetCellValue ( 'F' . $row, $arrDis [$i] ['result'] [$j]->events [$k]->longitude );
							$myWorkSheet->SetCellValue ( 'G' . $row, $arrDis [$i] ['result'] [$j]->events [$k]->rfiddesc );
							$row ++;
						//}
					}
				}
			} // for J
			$row ++;
		} // for I
		  
		// redirect output to browser
		header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
		header ( 'Content-Disposition: attachment;filename="events.xlsx"' );
		header ( 'Cache-Control: max-age=0' );
		$objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
		$objWriter->save ( 'php://output' );
	}
}

class EVENTS_Output_PDF {
	public $pdf;

	public static $txtDirection;
	public static $revDirection;
	public static $direction;
	private function initializePDF() {
		global $MYLANGUAGE;
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$this->pdf = new mPDF ( "utf-8", "LETTER" );
		
		$this->pdf->SetCreator ( "Find'n'Secure" );
		$this->pdf->SetAuthor ( 'EMBARC' );
		$this->pdf->SetTitle ( $MYLANGUAGE->getString ( 'EVENTS' ) );
		$this->pdf->SetSubject ( $MYLANGUAGE->getString ( 'EVENTS' ) );
		$this->pdf->SetKeywords ( "Events, Report, Findnsecure" );
		
		// set default header data
		$header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . $MYLANGUAGE->getString ( 'EVENTS' ) . '</td><td align="'.$right.'"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
		$this->pdf->SetHTMLHeader ( $header, "E" );
		$this->pdf->SetHTMLHeader ( $header, "O" );
		$this->pdf->SetTopMargin ( 30 );
		
		// $this->pdf->SetDirectionality("rtl");
		$this->pdf->SetAutoFont ( AUTOFONT_ALL );
		$this->pdf->SetDirectionality(self::$direction);
	}
	public function printPDF($arrDis) {
		global $GDATABASE, $MYLANGUAGE, $languageMatrix;
		
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
		
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}
		
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$this->initializePDF ();
		
		ob_start ();
		
		print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<style>' . file_get_contents ( CSS_FOLDER . '/reports_pdf.css' ) . '</style>
				</head>
				<body class="mainbody">
			  ';
		
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
			
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>
		
		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';
		
		$tCount = count ( $arrDis );
		
		for($i = 0; $i < $tCount; $i ++) {
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
			
			print '<br><table width="100%" class ="topBottom10pxPadding">
			<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
			</tr>';
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			}
			print "</table>";
			
			print '<table width="100%" cellSpacing=2 cellpadding="2" style="font-size:11px;" >
			<tr align="'.$left.'">
			<th align="'.$left.'" width="100px">' . $MYLANGUAGE->getString ( 'TIME' ) . '</th>
			<th align="'.$left.'" width="100px">' . $MYLANGUAGE->getString ( 'EVENT' ) . '</th>
			<th align="'.$left.'" width="400px">' . $MYLANGUAGE->getString ( 'PLACE' ) . '</th>
			<th align="'.$left.'">' . $MYLANGUAGE->getString ( 'LATITUDE' ) . '</th>
			<th align="'.$left.'">' . $MYLANGUAGE->getString ( 'LONGITUDE' ) . '</th>
			</tr>';
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
				
				$entCount = count ( $arrDis [$i] ['result'] [$j]->events );
				
				if ($entCount != 0) {
					
					print '<tr style="background-color:#BBBBBB;height:20px; padding-top:10px;"><td colspan="5" style="font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate . '</td></tr>';
					
					for($k = 0; $k < $entCount; $k ++) {
						$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->events [$k]->date, $arrDis [$i] ['result'] [$j]->events [$k]->time );
						
						print '<tr align="'.$left.'" style="font-weight:normal;background-color:' . $backgroundColor . ';">
						
						<td>' . $fdate->getFormattedTimeString () . '</td>
						<td >' . $arrDis [$i] ['result'] [$j]->events [$k]->name . '</td>
						<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->events [$k]->place ['location'] . '</td>
						<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->events [$k]->latitude . '</td>
						<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->events [$k]->longitude . '</td>
											
						</tr>';
					}
				}
			} // for J
			print "</table>";
			
			print '<br><div class="dashes"> </div><br/>';
		} // for I
		
		$contents = ob_get_contents ();
		ob_end_clean ();
		$this->pdf->WriteHTML ( $contents );
		$this->pdf->Output ();
	}
}
class EVENTS_Output_HTML {
	public static $txtDirection;
	public static $revDirection;
	public static $direction;

	
	public static function printHeader() {
		global $MYLANGUAGE, $languageMatrix;
		
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
		
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}

		print '
				<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>' . $MYLANGUAGE->getString ( 'EVENTS' ) . '</title>
				<style>'. file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:'.$direction.';} </style>
				</head>
				<body class="mainbody" style="background-color:#999; background-image:none">
			    <div id="reportframe">
			    <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
			  ';
	}
		public static function printHTML($arrDis) {
		ob_start ();
		
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		global $GDATABASE, $MYLANGUAGE;
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		EVENTS_Output_HTML::printHeader ();
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		print '<table width="100%" class="topBottom10pxPadding"><tr><td>' . $MYLANGUAGE->getString ( 'EVENTS' ) . '</td><td align="'.$right.'"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';
		
		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
			
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>
		
		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';
		
		$tCount = count ( $arrDis );
		
		for($i = 0; $i < $tCount; $i ++) {
			
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
			
			print '<br><table width="100%" class ="topBottom10pxPadding">
			<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
			</tr>';
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			}
			print "</table>";
			
			print '<table width="100%" cellSpacing=2 cellpadding="2" border=1 frame="hsides" bordercolor="#999999" rules="rows" style="font-size:11px;font-family:Arial" >
			<tr align="'.$left.'">
			<th >' . $MYLANGUAGE->getString ( 'TIME' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'EVENT' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'PLACE' ) . '</th>
			<th align="'.$left.'">' . $MYLANGUAGE->getString ( 'LATITUDE' ) . '</th>
			<th align="'.$left.'">' . $MYLANGUAGE->getString ( 'LONGITUDE' ) . '</th>
			<th align="'.$left.'">' . 'TAG ID' . '</th>
						</tr>';
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
				
				$entCount = count ( $arrDis [$i] ['result'] [$j]->events );
				
				if ($entCount != 0) {
					
					print '<tr><td colspan="5">&nbsp;</td></tr><tr style="background-color:#BBBBBB;height:20px; padding-top:10px;"><td colspan="5" style="font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate . '</td></tr>';
					
					for($k = 0; $k < $entCount; $k ++) {
						// if( $arrDis [$i] ['result'] [$j]->events [$k]->rfiddesc."" == "0" ){

						// }else{
							$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->events [$k]->date, $arrDis [$i] ['result'] [$j]->events [$k]->time );
							
							print '<tr align="'.$left.'" style="font-weight:normal;background-color:' . $backgroundColor . ';">
							
							<td>' . $fdate->getFormattedTimeString () . '</td>
							<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->events [$k]->name . '</td>
							<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->events [$k]->place ['location'] . '</td>
							<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->events [$k]->latitude . '</td>
							<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->events [$k]->longitude . '</td>
							<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->events [$k]->rfiddesc . '</td>					
							</tr>';
						//}
					}
				}
			} // for J
			print "</table>";
			
			print '<br><div class="dashes"> </div><br/>';
		} // for I
		
		EVENTS_Output_HTML::printFooter ();
		
		$contents = ob_get_contents ();
		ob_end_clean ();
		print $contents;
	}
	public static function printFooter() {
		print '
		<br/>
		<div style="width:100%; border:1px black solid; background-color:#404040; height:10px" />
		</div></div>
		</body></html>';
	}
}

class EVENTS_FNSv3_Report {
	private $mConverter;
	private $rDatabase;
	
	private function computeParameters($tid, $dateArray, $days) {
		global $TRACKING_EVENTS, $MYLANGUAGE, $GDATABASE;
		
		if (isset($_GET ['events'])){
			if(is_array(($_GET ['events']))){
				$eventsParam = $_GET ['events'];
			}else{
				$eventsParam = explode(",",$_GET ['events']);
			}
		}else{
			$eventsParam = null;
		}
		
		$this->rDatabase->reports_getEventsData ( $tid, $dateArray, $eventsParam );
		$daysCount = count ( $days );
		
		$sdate = new FNSDateTime ( $_SESSION ['timezone'] );
		$edate = new FNSDateTime ( $_SESSION ['timezone'] );
		$pdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		$data = $this->rDatabase->reports_nextEvent ();
		
		$geo = new GEOCODER ();
		
		for($x = 0; $x < $daysCount - 1; $x ++) {
			$sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
			$edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
			
			$days [$x]->distance = 0;
			
			$events = array ();
			
			while ( 1 ) {
			
				$pdate->setUTCDate ( $data ['date'], $data ['time'] );
				
				if ($data == false)
					break;
				
				if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
					$n = new overspeedRObject ();
					
					// $n->name = $MYLANGUAGE->getString ( $TRACKING_EVENTS->getEventName ( $data ['event'] ) );

					if ($data['description']-> bin) {
					$n->name = $MYLANGUAGE->getString ( $TRACKING_EVENTS->getEventName ( $data ['event'] ) );	
					} else {
						$n->name = $MYLANGUAGE->getString ( $TRACKING_EVENTS->getEventName ( 215 ) );
					}
					
					//if ($data ['event'] == EVENT_RFID_SWEEP || $data ['event'] == EVENT_ENTER_GEOFENCE || $data ['event'] == EVENT_LEAVE_GEOFENCE || $data ['event'] == EVENT_DEVICE_RESPONSE || 

						if($data ['event'] == EVENT_TAG_IN || $data ['event'] == EVENT_TAG_OUT) {
						//$n->name .= ':' . $data ['description'];
						$n->name .= ':' . $data ['description']->bin;
					}
					
					$n->place = $geo->search ( $data ['latitude'], $data ['longitude'], false );
					$n->date = $data ['date'];
					$n->time = $data ['time'];
					$n->latitude = $data ['latitude'];
					$n->longitude = $data ['longitude'];
					$n->speed = $this->mConverter->convert ( $data ['speed'] );
					$n->rfiddesc = $data ['description']->bin;

					array_push ( $events, $n );
					
					$data = $this->rDatabase->reports_nextEvent ();
				} else
					break; // if
			} // for dcount
			
			$days [$x]->events = $events;
		} // for daysCount
		
		return $days;
	}
	private function getTrackersList() {
		global $GDATABASE;
		$trackers = $GDATABASE->getTrackersList ( "trackerid" );
		$a = array ();
		$tcount = count ( $trackers );
		for($i = 0; $i < $tcount; $i ++) {
			array_push ( $a, $trackers [$i] ['trackerid'] );
		}
		return $a;
	}
	private function getReportData() {
		global $GDATABASE;
		$arrdate = reportUtils::getUTCReportTime ( $_GET );
		
		if ($_GET ['ftype'] == "E") {
			$trackers = $this->getTrackersList ();
		} else {
			$trackers = explode ( ",", $_GET ['trackers'] );
		}
		
		$tcount = count ( $trackers );
		
		$display_array = array ();
		
		for($i = 0; $i < $tcount; $i ++) {
			$days = reportUtils::getDays ( $arrdate, $_SESSION ['timezone'] );
			$result = $this->computeParameters ( $trackers [$i], $arrdate, $days );
			
			$arr = array ();
			
			$arr ['tinfo'] = $GDATABASE->getTrackerCard ( $trackers [$i] );
			$arr ['details'] = $GDATABASE->rp_getTrackersDetails ( $trackers [$i] );
			$arr ['result'] = $result;
			
			array_push ( $display_array, $arr );
		}
		
		switch ($_GET ['format']) {
			case "HTML" :
				EVENTS_Output_HTML::printHTML ( $display_array );
				break;
			case "PDF" :
				$pdf = new EVENTS_Output_PDF ();
				$pdf->printPDF ( $display_array );
				break;
			case "XLSX" :
				$xlsx = new EVENTS_Output_XLSX ();
				$xlsx->printXLSX ( $display_array );
				break;
				
		}
	}
	public function execute() {
		global $MYLANGUAGE;
		set_time_limit ( 0 );
		$MYLANGUAGE = new FNSLanguage ();
		
		$this->mConverter = new metricConverter ();
		$this->mConverter->setMetrics ( $_GET ['metric'] );
		$this->rDatabase = new reportingQueries ();
		
		$this->getReportData ();
	}
}
?>
