<?php
/**
 * Created by PhpStorm.
 * Date: 2/18/2016
 * Time: 8:28 PM
 */
require_once (REPORTS_FOLDER . "/reportUtils.php");
require_once (DATABASE_FOLDER . "/reportingQueries.php");
require_once (PHPExcelPath . '/Classes/PHPExcel.php');
require_once (mPDF_FOLDER . "/mpdf.php");

class FATIGUE_Output_XLSX {
    public static function printXLSX($arrDis) {

        $summary = array ();
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );

        global $GDATABASE, $MYLANGUAGE;

        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );

        $aCount = count ( $arrDis [0] ['result'] );

        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();

        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();

        $objPHPExcel = new PHPExcel ();
        $sheetProperties = $objPHPExcel->getProperties ();
        $sheetProperties->setCreator ( "Find'n'Secure" );
        $sheetProperties->setTitle ( $MYLANGUAGE->getString ( 'FATIGUE' ) );
        $sheetProperties->setDescription ( $MYLANGUAGE->getString ( 'CON_INFO' ) );

        $myWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, 'Report' );
        $objPHPExcel->addSheet ( $myWorkSheet, 0 );

        $summaryWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, 'Summary' );
        $objPHPExcel->addSheet ( $summaryWorkSheet, 1 );

        $objPHPExcel->setActiveSheetIndex ( 0 );

        // set font-family and size
        $objPHPExcel->getDefaultStyle ()->getFont ()->setName ( 'Arial' );
        $objPHPExcel->getDefaultStyle ()->getFont ()->setSize ( 10 );

        // set default column widths
        for($i = 'A'; $i <= 'F'; $i ++) {
            $myWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
            $summaryWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
        }

        // set margins
        $myWorkSheet->getPageMargins ()->setRight ( 0.125 );
        $myWorkSheet->getPageMargins ()->setLeft ( 0.125 );

        // set page orientation
        $myWorkSheet->getPageSetup ()->setPaperSize ( PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4 );
        $myWorkSheet->getPageSetup ()->setFitToWidth ( 1 );
        $myWorkSheet->getPageSetup ()->setFitToHeight ( 0 );

        $row = 2;

        // report heading
        $myWorkSheet->SetCellValue ( "A$row", $MYLANGUAGE->getString ( 'FATIGUE' ) );
        $myWorkSheet->mergeCells ( "A$row:C" . ($row + 4) );
        $headingStyle = array (
            'font' => array (
                'bold' => true,
                'size' => 16
            ),
            'alignment' => array (
                'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP
            )
        );
        $myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
        $myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );

        // company logo
        $logo = new PHPExcel_Worksheet_Drawing ();
        $logo->setPath ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' );
        $logo->setWorksheet ( $myWorkSheet );
        $logo->setCoordinates ( 'D' . $row );
        $myWorkSheet->mergeCells ( "D$row:F" . ($row + 4) );
        $logo->setOffsetX ( 115 );

        $row = 9;

        // company details
        $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'COMPANY_NAME' ) );
        $myWorkSheet->SetCellValue ( 'B' . $row, $answer [0] ['company'] );
        $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'USERNAME' ) );
        $myWorkSheet->SetCellValue ( 'E' . $row, $answer [0] ['username'] );
        $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
        $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );

        $row ++;

        $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
        $myWorkSheet->SetCellValue ( 'B' . $row, $sdate );
        $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
        $myWorkSheet->SetCellValue ( 'E' . $row, $edate );
        $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
        $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );

        $row += 2;

        // report details
        $detailsStyle = array (
            'borders' => array (
                'inside' => array (
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array (
                        'argb' => 'FFFFFFFF'
                    )
                )
            ),

            'fill' => array (
                'type' => PHPExcel_Style_Fill::FILL_SOLID,
                'startcolor' => array (
                    'argb' => 'FFDDDDDD'
                )
            )
        );

        $tCount = count ( $arrDis );

        for($i = 0; $i < $tCount; $i ++) {
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

            $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TRACKER_NAME' ) );
            $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['tinfo'] [0] ['name'] );
            $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'APPLICATION' ) );
            $myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( $apptype ) );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            $myWorkSheet->getStyle ( "A$row:H$row" )->applyFromArray ( $detailsStyle );
            $myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
            $myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );

            $row ++;

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LICENSEPLATE' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['licensePlate'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'VTYPE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['vtype'] );
            }

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
            }

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REFNO' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['arefno'] );
            }

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
            }

            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            $myWorkSheet->getStyle ( "A$row:H$row" )->applyFromArray ( $detailsStyle );
            $myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
            $myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );

            $row += 3;

            $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'DATE' ) );
            $myWorkSheet->SetCellValue ( 'B' . $row, $MYLANGUAGE->getString ( 'DAY' ) );
            $myWorkSheet->SetCellValue ( 'C' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
            $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
            //$myWorkSheet->SetCellValue ( 'E' . $row, 'Last Ignition Location' );
            //$myWorkSheet->SetCellValue ( 'F' . $row, $MYLANGUAGE->getString ( 'SDURATION' ) );
            $myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( 'FATIGUE' ) .' '.$MYLANGUAGE->getString ( 'MDURATION' ) );
            //$myWorkSheet->SetCellValue ( 'H' . $row, $MYLANGUAGE->getString ( 'AVG_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ")" );
            //$myWorkSheet->SetCellValue ( 'I' . $row, $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ")" );
            $myWorkSheet->SetCellValue ( 'F' . $row, $MYLANGUAGE->getString ( 'FATIGUE' ) .' '.$MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ")" );
            $rowHeadStyle = array (
                'font' => array (
                    'bold' => true,
                    'size' => 9
                ),

                'borders' => array (
                    'bottom' => array (
                        'style' => PHPExcel_Style_Border::BORDER_THIN,
                        'color' => array (
                            'argb' => 'FF000000'
                        )
                    )
                )
            );
            $myWorkSheet->getStyle ( 'A' . $row . ':H' . $row )->applyFromArray ( $rowHeadStyle );
            $myWorkSheet->getStyle ( "D$row:F$row" )->getAlignment ()->setHorizontal ( PHPExcel_Style_Alignment::HORIZONTAL_RIGHT );

            $row ++;

            $ecount = count ( $arrDis [$i] ['result'] );

            $netDistance = 0;
            $netDuration = 0;
            $fmaxSpeed = 0;
            $totalStop = 0;
            $totalMove = 0;

            for($j = 0; $j < $ecount - 1; $j ++) {
                if ($j % 2 == 1)
                    $backgroundColor = "#FaFaFa";
                else
                    $backgroundColor = "#F2F2F2";

                if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getDateStruct ();

                    $myWorkSheet->SetCellValue ( 'A' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $sdate->year, $sdate->month, $sdate->day, $sdate->hour, $sdate->min, $sdate->sec ) );
                    $myWorkSheet->getStyle ( 'A' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy' );


                    $resultData = &$arrDis [$i] ['result'] [$j];

                    $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                    $firstIgnition = $fdate->getDateStruct();


                    $stime = $resultData->stime;
                    $etime = $resultData->etime;
                    $day = $resultData->day;


                    $myWorkSheet->SetCellValue ( 'B' . $row, $MYLANGUAGE->getString ( $day ));

                    //$myWorkSheet->SetCellValue ( 'C' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $firstIgnition->year, $firstIgnition->month, $firstIgnition->day, $firstIgnition->hour, $firstIgnition->min, $firstIgnition->sec ) );
                    //$myWorkSheet->getStyle ( 'C' . $row )->getNumberFormat ()->setFormatCode ( 'hh:mm:ss' );

                    $myWorkSheet->SetCellValue ( 'C' . $row, $stime);

                    //$myWorkSheet->SetCellValue ( 'C' . $row, $resultData->firstIgnition['location']);


                    $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                    $lastIgnition = $fdate->getDateStruct();

                    //$myWorkSheet->SetCellValue ( 'D' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $lastIgnition->year, $lastIgnition->month, $lastIgnition->day, $lastIgnition->hour, $lastIgnition->min, $lastIgnition->sec ) );
                    //$myWorkSheet->getStyle ( 'D' . $row )->getNumberFormat ()->setFormatCode ( 'hh:mm:ss' );
                    //$myWorkSheet->SetCellValue ( 'E' . $row, $resultData->lastIgnition['location']);
                    $myWorkSheet->SetCellValue ( 'D' . $row, $etime);


                    $moveDuration = reportUtils::getDurationTextMedium($resultData->mDuration, $MYLANGUAGE);
                    $stopDuration = reportUtils::getDurationTextMedium(86400 - $resultData->mDuration, $MYLANGUAGE);

                    $totalMove += $resultData->mDuration;
                    $totalStop += (86400 - $resultData->mDuration);

                    $netDuration += $arrDis [$i] ['result'] [$j]->mDuration;

                    if ($arrDis [$i] ['result'] [$j]->maxSpeed > $fmaxSpeed)
                        $fmaxSpeed = $arrDis [$i] ['result'] [$j]->maxSpeed;

                    //$myWorkSheet->SetCellValue ( 'F' . $row, $stopDuration);
                    $myWorkSheet->SetCellValue ( 'E' . $row, $moveDuration);
                    //$myWorkSheet->SetCellValue ( 'E' . $row, sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->avgSpeed ) );
                    //$myWorkSheet->SetCellValue ( 'I' . $row, sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->maxSpeed ) );
                    $myWorkSheet->SetCellValue ( 'F' . $row, sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->distance ) );
                    $myWorkSheet->getStyle ( "A$row:J$row" )->getFill ()->getStartColor ()->setARGB ( 'FF' . $backgroundColor );

                    $netDistance += $arrDis [$i] ['result'] [$j]->distance;
                    $row ++;
                }
            } // for J

            $row ++;

            // row1 footer
            //$myWorkSheet->SetCellValue ( 'D' . $row, reportUtils::getDurationTextMedium($totalStop, $MYLANGUAGE) );
            $myWorkSheet->SetCellValue ( 'E' . $row, reportUtils::getDurationTextMedium($totalMove, $MYLANGUAGE) );
            $myWorkSheet->SetCellValue ( 'F' . $row, $netDistance );
            $myWorkSheet->getStyle ( 'A' . $row . ':H' . $row )->getFont ()->setBold ( true );

            $row += 3;

            $cs = new csSummaryObject ();
            $cs->name = $arrDis [$i] ['tinfo'] [0] ['name'];
            $cs->distance = $netDistance;
            $cs->duration = $netDuration;
            $cs->maxSpeed = $fmaxSpeed;

            array_push ( $summary, $cs );
        } // for I

        $sCount = count ( $summary );

        $row ++;

        $s2row = 1;

        // report Header
        $summaryWorkSheet->SetCellValue ( 'A' . $s2row, $MYLANGUAGE->getString ( 'RSUMM' ) );
        $summaryWorkSheet->getStyle ( 'A' . $s2row )->getFont ()->setBold ( true );
        $s2row += 2;

        $summaryWorkSheet->SetCellValue ( 'A' . $s2row, $MYLANGUAGE->getString ( 'NAME' ) );
        $summaryWorkSheet->mergeCells ( 'A' . $s2row . ':B' . $s2row );
        $summaryWorkSheet->SetCellValue ( 'C' . $s2row, $MYLANGUAGE->getString ( 'MDURATION' ) );
        $summaryWorkSheet->mergeCells ( 'C' . $s2row . ':D' . $s2row );
        //$summaryWorkSheet->SetCellValue ( 'E' . $s2row, $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ")" );
        $summaryWorkSheet->SetCellValue ( 'E' . $s2row, $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ")" );
        //$summaryWorkSheet->getStyle ( 'A' . $s2row . ':F' . $s2row )->applyFromArray ( $rowHeadStyle );
        $summaryWorkSheet->getStyle ( 'A' . $s2row . ':E' . $s2row )->applyFromArray ( $rowHeadStyle );
        //$summaryWorkSheet->getStyle ( "D$s2row:F$s2row" )->getAlignment ()->setHorizontal ( PHPExcel_Style_Alignment::HORIZONTAL_RIGHT );
        $summaryWorkSheet->getStyle ( "D$s2row:E$s2row" )->getAlignment ()->setHorizontal ( PHPExcel_Style_Alignment::HORIZONTAL_RIGHT );
        $s2row ++;

        // report summary
        for($i = 0; $i < $sCount; $i ++) {
            $summaryWorkSheet->SetCellValue ( 'A' . $s2row, $summary [$i]->name );
            $summaryWorkSheet->mergeCells ( 'A' . $s2row . ':B' . $s2row );
            $summaryWorkSheet->SetCellValue ( 'C' . $s2row, reportUtils::getDurationText ( $summary [$i]->duration, $MYLANGUAGE ) );
            $summaryWorkSheet->mergeCells ( 'C' . $s2row . ':D' . $s2row );
            //$summaryWorkSheet->SetCellValue ( 'E' . $s2row, floor ( $summary [$i]->maxSpeed ) );
            $summaryWorkSheet->SetCellValue ( 'E' . $s2row, sprintf ( "%0.2f", $summary [$i]->distance ) );
            //$summaryWorkSheet->getStyle ( 'A' . $s2row . ':F' . $s2row )->getBorders ()->getBottom ()->setBorderStyle ( PHPExcel_Style_Border::BORDER_THIN );
            $summaryWorkSheet->getStyle ( 'A' . $s2row . ':E' . $s2row )->applyFromArray ( $rowHeadStyle );
            //$summaryWorkSheet->getStyle ( 'A' . $s2row . ':F' . $s2row )->getBorders ()->getTop ()->setBorderStyle ( PHPExcel_Style_Border::BORDER_THIN );
            $summaryWorkSheet->getStyle ( 'A' . $s2row . ':E' . $s2row )->getBorders ()->getTop ()->setBorderStyle ( PHPExcel_Style_Border::BORDER_THIN );
            $s2row ++;
        }////////////////////////////////
        // redirect output to browser
        header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
        header ( 'Content-Disposition: attachment;filename="fatigue_report.xlsx"' );
        header ( 'Cache-Control: max-age=0' );
        $objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
        ob_end_clean();
        $objWriter->save ( 'php://output' );
    }
}
class FATIGUE_Output_PDF {
    public $pdf;
    public static $txtDirection;
    public static $revDirection;
    public static $direction;
    private function initializePDF() {
        global $MYLANGUAGE;

        $this->pdf = new mPDF ( "utf-8", "LETTER" );

        $this->pdf->SetCreator ( "Find'n'Secure" );
        $this->pdf->SetAuthor ( 'EMBARC' );
        $this->pdf->SetTitle ( $MYLANGUAGE->getString ( 'FATIGUE' ) );
        $this->pdf->SetSubject ( $MYLANGUAGE->getString ( 'FATIGUE' ) );
        $this->pdf->SetKeywords ( "FATIGUE, Report, Findnsecure" );

        // set default header data
        $header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . $MYLANGUAGE->getString ( 'FATIGUE' ) . '</td><td align="' . self::$revDirection . '"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
        $this->pdf->SetHTMLHeader ( $header, "E" );
        $this->pdf->SetHTMLHeader ( $header, "O" );
        $this->pdf->SetTopMargin ( 30 );

        // $this->pdf->SetDirectionality("rtl");
        $this->pdf->SetAutoFont ( AUTOFONT_ALL );
        $this->pdf->SetDirectionality ( self::$direction );
    }
    public function printPDF($arrDis) {
        global $GDATABASE, $MYLANGUAGE, $languageMatrix;

        if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
            self::$direction = $direction = "ltr";
        } else {
            self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
        }

        switch ($direction) {
            case "ltr" :
                self::$txtDirection = "left";
                self::$revDirection = "right";
                break;
            case "rtl" :
                self::$txtDirection = "right";
                self::$revDirection = "left";
                break;
        }

        $left = self::$txtDirection;
        $right = self::$revDirection;

        ob_start ();
        print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
                <html xmlns="http://www.w3.org/1999/xhtml">
                <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
                <style>' . file_get_contents ( CSS_FOLDER . '/reports_pdf.css' ) . '*{direction:' . $direction . ';} </style>
                </head>
                <body class="mainbody">
              ';

        $summary = array ();

        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );

        $this->initializePDF ();

        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
        $aCount = count ( $arrDis [0] ['result'] );

        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();

        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();

        print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
        <tr>
            <td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>

            <td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
        </tr>

        <tr>
            <td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
            <td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
        </tr>
        </table>';

        $tCount = count ( $arrDis );

        for($i = 0; $i < $tCount; $i ++) {

            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

            print '<br><table width="100%" class ="topBottom10pxPadding">
            <tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
            </tr>';

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            }

            print "</table>";

            print '<table width="100%" cellspacing=0 cellpadding=5 style="font-size:11px;font-family:Arial;border:1px solid black" >
            <tr align="' . $left . '">
            <th style="width:100px">' . $MYLANGUAGE->getString ( 'DATE' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'DAY' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'DUTY_START' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'DUTY_END' ) . '</th>'.
            //<th>' . 'Last Ignition Location' . '</th>
            //<th>' . $MYLANGUAGE->getString ( 'SDURATION' ) . '</th>
            '<th>' . $MYLANGUAGE->getString ( 'FATIGUE' ) .' '.$MYLANGUAGE->getString ( 'MDURATION' ) . '</th>'.
            //<th align="center">' . $MYLANGUAGE->getString ( 'AVG_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            //<th align="center">' . $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            '<th align="' . $right . '">' . $MYLANGUAGE->getString ( 'FATIGUE' ) .' '.$MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
            </tr>';

            $ecount = count ( $arrDis [$i] ['result'] );

            $netDistance = 0;
            $netDuration = 0;
            $fmaxSpeed = 0;
            $totalStop = 0;
            $totalMove = 0;

            for($j = 0; $j < $ecount - 1; $j ++) {
                if ($j % 2 == 1)
                    $backgroundColor = "#FaFaFa";
                else
                    $backgroundColor = "#F2F2F2";

                if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedDateString ();

                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                    $edate = $fdate->getFormattedDateString ();

                    $resultData = &$arrDis [$i] ['result'] [$j];

                    $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                    $firstIgnition = $fdate->getFormattedTimeString();
                    $firstIgnitionLocation = $resultData->firstIgnition['location'];

                    $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                    $lastIgnition = $fdate->getFormattedTimeString ();
                    $lastIgnitionLocation = $resultData->lastIgnition['location'];
                    $stime = $resultData->stime;
                    $etime = $resultData->etime;
                    $day = $resultData->day;

                    //$hours = floor ( $arrDis [$i] ['result'] [$j]->mDuration / 3600 );
                    //$mins = floor ( ($arrDis [$i] ['result'] [$j]->mDuration - $hours * 3600) / 60 );
                    //$seconds = ($arrDis [$i] ['result'] [$j]->mDuration - $hours * 3600 - $mins * 60);

                    $moveDuration = reportUtils::getDurationTextMedium($resultData->mDuration, $MYLANGUAGE);
                    $stopDuration = reportUtils::getDurationTextMedium(86400 - $resultData->mDuration, $MYLANGUAGE);

                    $totalMove += $resultData->mDuration;
                    $totalStop += (86400 - $resultData->mDuration);

                    $netDuration += $arrDis [$i] ['result'] [$j]->mDuration;
                    if ($arrDis [$i] ['result'] [$j]->maxSpeed > $fmaxSpeed)
                        $fmaxSpeed = $arrDis [$i] ['result'] [$j]->maxSpeed;

                    print '<tr align="' . $left . '" style="font-weight:normal;font-size:11px;background-color:' . $backgroundColor . ';">
                    <td>' . $sdate . '</td>
                    <td>' . $MYLANGUAGE->getString ( $day ) . '</td>
                    <td>' . $stime . '</td>
                    <td>' . $etime . '</td>'.
                    //<td>' . $lastIgnitionLocation . '</td>
                    //<td>' . $stopDuration . '</td>
                    '<td>' . $moveDuration .'</td>'.
                    //<td align="center">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->avgSpeed ) . '</td>
                    //<td align="center">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->maxSpeed ) . '</td>
                    '<td align="' . $right . '">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->distance ) . '</td>
                    </tr>';
                    $netDistance += $arrDis [$i] ['result'] [$j]->distance;
                }
            } // for J

            print "<tr align = 'left' style='font-size:11px; font-weight:bold'> <td colspan='3'>&nbsp;</td><td>";
            print /*reportUtils::getDurationTextMedium($totalStop, $MYLANGUAGE).*/"&nbsp; </td><td>".reportUtils::getDurationTextMedium($totalMove, $MYLANGUAGE);
            //print "<td colspan='2'>&nbsp;</td>";
            print "<td align='right'>".sprintf("%0.2f", $netDistance)."</td></tr>";
            print "</table>";


            $cs = new csSummaryObject ();
            $cs->name = $arrDis [$i] ['tinfo'] [0] ['name'];
            $cs->distance = $netDistance;
            $cs->duration = $netDuration;
            $cs->maxSpeed = $fmaxSpeed;

            array_push ( $summary, $cs );
        } // for I

        $sCount = count ( $summary );

        print '<br/><br/>
            <div style="font-family:Arial; font-size:18px; font-weight:bold;">' . $MYLANGUAGE->getString ( 'RSUMM' ) . '</div><br/>

            <table class="topHeader" border=0 width="100%" cellpadding="0" cellspacing="3" style="font-size:13px; padding-top:5px; padding-bottom:5px;">
        ';

        for($i = 0; $i < $sCount; $i ++) {
            print '<tr>
                <td>' . $summary [$i]->name . '&nbsp;</td>'.
                //<td>' . reportUtils::getDurationText ( $summary [$i]->duration, $MYLANGUAGE ) . '</td>
                //<td align="right">' . floor ( $summary [$i]->maxSpeed ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ' </td>
                '<td style="font-weight:bold" align="' . $right . '">' . sprintf ( "%0.2f", $summary [$i]->distance ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
            </tr>';
        }

        print '</table>
            ';

        $contents = ob_get_contents ();
        ob_end_clean ();

        $this->pdf->WriteHTML ( $contents );
        $this->pdf->Output ();
    }
}
class FATIGUE_Output_HTML {
    public static $txtDirection;
    public static $revDirection;
    public static $direction;
    public static function printHeader() {
        global $MYLANGUAGE, $languageMatrix;

        if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
            self::$direction = $direction = "ltr";
        } else {
            self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
        }

        switch ($direction) {
            case "ltr" :
                self::$txtDirection = "left";
                self::$revDirection = "right";
                break;
            case "rtl" :
                self::$txtDirection = "right";
                self::$revDirection = "left";
                break;
        }

        print '
                <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
                <html xmlns="http://www.w3.org/1999/xhtml">
                <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
                <title>' . $MYLANGUAGE->getString ( 'FATIGUE' ) . '</title>
                <style>' . file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:' . $direction . ';} table tr td { min-width:90px;padding:5px;} </style>
                </head>
                <body class="mainbody" style="background-color:#999; background-image:none">
                <div id="reportframe" style="width:1020px">
                <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
              ';
    }


    public static function printHTML($arrDis) {
        ob_start ();

        $summary = array ();

        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );

        global $GDATABASE, $MYLANGUAGE;

        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );

        FATIGUE_Output_HTML::printHeader ();
        $left = self::$txtDirection;
        $right = self::$revDirection;

        $aCount = count ( $arrDis [0] ['result'] );

        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();

        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();

        print '<table width="100%" class="topBottom10pxPadding"><tr><td>' . $MYLANGUAGE->getString ( 'FATIGUE' ) . '</td><td align="' . $right . '"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';

        print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
        <tr>
            <td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>

            <td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
        </tr>

        <tr>
            <td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
            <td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
        </tr>
        </table>';

        $tCount = count ( $arrDis );

        for($i = 0; $i < $tCount; $i ++) {

            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

            print '<br><table width="100%" class ="topBottom10pxPadding">
            <tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
            </tr>';

            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
            </tr>';
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                print '<tr style="background-color:#DDDDDD">
            <td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
            <td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            }

            print "</table>";

            print '<table width="100%" cellSpacing=5 border=1 frame="hsides" rules="rows" style="font-size:13px;font-family:Arial" >
            <tr align="' . $left . '">
            <th>' . $MYLANGUAGE->getString ( 'DATE' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'DAY' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'DUTY_START' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'DUTY_END' ) .'</th>'
            //<th>' . $MYLANGUAGE->getString ( 'LAST_IGNITION' ) . '</th>
            //<th>' . 'Last Ignition Location' .'</th>'
            //<th>' . $MYLANGUAGE->getString ( 'SDURATION' ) . '</th>
            .'<th>' . $MYLANGUAGE->getString ( 'FATIGUE' ) .' '.$MYLANGUAGE->getString ( 'MDURATION' ) . '</th>'.
            '<th>Off Schedule Movement Duration</th><th>Off Schedule Driving Distance</th><th>Off Schedule Driving Time</th>'.
            '<th align="center"> Total Driving Duration</th>'.
            //<th align="center">' . $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            // '<th align="' . $right . '">' . $MYLANGUAGE->getString ( 'FATIGUE' ).' '.$MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
            '</tr>';

            /*print "</table>";

            print '<table width="100%" cellSpacing=5 border=1 frame="hsides" rules="rows" style="font-size:13px;font-family:Arial" >
            <tr align="' . $left . '">
            <th>' . $MYLANGUAGE->getString ( 'DATE' ) . '</th>
            <th>' . $MYLANGUAGE->getString ( 'MDURATION' ) . '</th>
            <th align="center">' . $MYLANGUAGE->getString ( 'AVG_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            <th align="center">' . $MYLANGUAGE->getString ( 'LMAX_SPEED' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ')</th>
            <th align="' . $right . '">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . " (" . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . ')</th>
            </tr>';*/

            $ecount = count ( $arrDis [$i] ['result'] );

            $netDistance = 0;
            $netDuration = 0;
            $fmaxSpeed = 0;
            $totalStop = 0;
            $totalMove = 0;

            for($j = 0; $j < $ecount - 1; $j ++) {
                if ($j % 2 == 1)
                    $backgroundColor = "#FaFaFa";
                else
                    $backgroundColor = "#F2F2F2";

                if ($arrDis [$i] ['result'] [$j]->distance != 0) {
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedDateString ();

                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                    $edate = $fdate->getFormattedDateString ();


                    $resultData = &$arrDis [$i] ['result'] [$j];

                    $fdate->setUTCDate ( $resultData->firstIgnition['date'], $resultData->firstIgnition['time'] );
                    $firstIgnition = $fdate->getFormattedTimeString();
                    $firstIgnitionLocation = $resultData->firstIgnition['location'];

                    $fdate->setUTCDate ( $resultData->lastIgnition['date'], $resultData->lastIgnition['time'] );
                    $lastIgnition = $fdate->getFormattedTimeString ();
                    $lastIgnitionLocation = $resultData->lastIgnition['location'];
                    $stime = $resultData->stime;
                    $etime = $resultData->etime;
                    $day = $resultData->day;

                    $hours = floor ( $arrDis [$i] ['result'] [$j]->mDuration / 3600 );

                    //$mins = floor ( ($arrDis [$i] ['result'] [$j]->mDuration - $hours * 3600) / 60 );
                    //$seconds = ($arrDis [$i] ['result'] [$j]->mDuration - $hours * 3600 - $mins * 60);

                    $moveDuration = reportUtils::getDurationTextMedium($resultData->mDuration, $MYLANGUAGE);
                    $stopDuration = reportUtils::getDurationTextMedium(86400 - $resultData->mDuration, $MYLANGUAGE);

                    $totalMove += $resultData->mDuration;
                    $totalStop += (86400 - $resultData->mDuration);

                    $netDuration += $arrDis [$i] ['result'] [$j]->mDuration;
                    if($resultData->fDuration > 0)
                        $fMove = reportUtils::getDurationTextMedium($resultData->fDuration, $MYLANGUAGE);
                    else
                        $fMove = "-";
                    if($resultData->startTime != null)
                        $fTime = $resultData->startTime . " to ".$resultData->endTime;
                    else
                        $fTime = "-";

                    if($resultData->fDistance >0)
                        $fDistance = $resultData->fDistance;
                    else
                        $fDistance = '-';
                    if($hours >= 4)
                        $fatigueDuration = $moveDuration;
                    else
                        $fatigueDuration = "-";

                    if ($arrDis [$i] ['result'] [$j]->maxSpeed > $fmaxSpeed)
                        $fmaxSpeed = $arrDis [$i] ['result'] [$j]->maxSpeed;

                    print '<tr align="' . $left . '" style="font-weight:normal;font-size:11px;background-color:' . $backgroundColor . ';">
                    <td>' . $sdate . '</td>
                    <td>' . $MYLANGUAGE->getString ( $day ) . '</td>
                    <td>' . $stime . '</td>
                    <td>' . $etime . '</td>'.
                    //<td>' . $lastIgnitionLocation . '</td>'.
                    //<td>' . $stopDuration . '</td>
                    '<td>'. $fatigueDuration .'</td>'.
                    '<td>'. $fMove .'</td>'.
                    
                    '<td>'. sprintf ( "%0.2f", $fDistance ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) .'</td>'.
                    '<td>'. $fTime .'</td>'.
                    '<td>' . $moveDuration .'</td>'.
                    //<td align="center">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->avgSpeed ) . '</td>
                    //<td align="center">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->maxSpeed ) . '</td>
                    // '<td align="' . $right . '">' . sprintf ( "%0.2f", $arrDis [$i] ['result'] [$j]->distance ) . '</td>
                    '</tr>';
                    $netDistance += $arrDis [$i] ['result'] [$j]->distance;
                }
            } // for J

            //print "<tr align = 'left' style='font-size:11px; font-weight:bold'> <td colspan='5'>&nbsp;</td><td>";
            // print "<tr align = 'left' style='font-size:11px; font-weight:bold'> <td colspan='3'>&nbsp;</td><td>";
            // print /*reportUtils::getDurationTextMedium($totalStop, $MYLANGUAGE).*/"&nbsp </td><td>". reportUtils::getDurationTextMedium($totalMove, $MYLANGUAGE);
            //print "<td colspan=''>&nbsp;</td>";
            // print "<td align='right'>".sprintf("%0.2f", $netDistance)."</td></tr>";
            print "</table>";

            $cs = new csSummaryObject ();
            $cs->name = $arrDis [$i] ['tinfo'] [0] ['name'];
            $cs->distance = $netDistance;
            $cs->duration = $netDuration;
            $cs->maxSpeed = $fmaxSpeed;

            array_push ( $summary, $cs );
        } // for I

        $sCount = count ( $summary );

        print '<br/><br/>
            <div style="font-family:Arial; font-size:18px; font-weight:bold;">' . $MYLANGUAGE->getString ( 'RSUMM' ) . '</div><br/>

            <table class="topHeader" border=1 frame="hsides" rules="rows" width="100%" cellpadding="0" cellspacing="0" style="font-size:15px; padding-top:5px; padding-bottom:5px;">
        ';

        for($i = 0; $i < $sCount; $i ++) {
            print '<tr>
                <td>' . $summary [$i]->name . '&nbsp;</td>
                <td>' . reportUtils::getDurationText ( $summary [$i]->duration, $MYLANGUAGE ) . '</td>'.
                //<td align="right">' . floor ( $summary [$i]->maxSpeed ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . ' </td>
                '<td style="font-weight:bold" align="' . $right . '">' . sprintf ( "%0.2f", $summary [$i]->distance ) . ' ' . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
            </tr>';
        }

        print '</table>
            ';

        FATIGUE_Output_HTML::printFooter ();

        $contents = ob_get_contents ();
        ob_end_clean ();
        print $contents;
    }
    public static function printFooter() {
        print '
        <br/>
        <div style="width:100%; border:1px black solid; background-color:#404040; height:10px"> </div>
        </div></div>
        </body></html>';
    }
}

class FATIGUE_FNSv3_Report {
    private $mConverter;
    private $rDatabase;

    private function getTrackerSchedule ($tid, $day) {
        $trackerSchedule = $this->rDatabase->getTrackerWorkingSchedule($tid);

        $trackerSchedule = json_decode($trackerSchedule['workSchedule'], true);

        if (!$trackerSchedule)
            return false;

        $fdate = new FNSDateTime($trackerSchedule['tz']);

        $fdate->setUTCDate($day->date, $day->time);

        $weekDay = $fdate->dateTime->format('N');

        $daySchedule = $trackerSchedule[$weekDay];

        $tzDate = $fdate->dateTime->format('Y-m-d');

        if ($daySchedule['duty'] == 1) {

            $fdate->setDate($tzDate, $daySchedule['sTime']);

            $stimestamp = $fdate->dateTime->getTimestamp();

            $stime = $fdate->getFormattedTimeString();

            //$day = $fdate->dateTime->format('l');
            $day = $fdate->dateTime->format('D');

            $fdate->setDate($tzDate, $daySchedule['eTime']);

            $etimestamp = $fdate->dateTime->getTimestamp();

            $etime = $fdate->getFormattedTimeString();

            //$workSchedule = array('stimestamp' => $stimestamp, 'etimestamp' => $etimestamp);
        } elseif (($daySchedule['duty'] == 0)) {
            $fdate->setDate($tzDate, 0);
            //$stimestamp = $fdate->dateTime->getTimestamp();
            $etimestamp = $fdate->dateTime->getTimestamp();


            $fdate->setDate($tzDate, 86400);

            //$etimestamp = $fdate->dateTime->getTimestamp();
            $stimestamp = $fdate->dateTime->getTimestamp();

            //$day = $fdate->dateTime->format('l');
            $day = $fdate->dateTime->format('D');

            //$stimestamp = $fdate->dateTime->getTimestamp();

            //$etimestamp = $day->timestamp;


            $stime = '-';
            $etime = '-';
        }

        //$workSchedule = array('stimestamp' => $stimestamp, 'etimestamp' => $etimestamp);
        $workSchedule = array('stimestamp' => $stimestamp, 'etimestamp' => $etimestamp, 'stime' => $stime, 'etime' => $etime, 'day' => $day);

        return $workSchedule;
    }

    private function computeParameters($tid, $dateArray, $days) {
        $geo = new GEOCODER();
        $this->rDatabase->reports_getLocationsData ( $tid, $dateArray );
        $daysCount = count ( $days );

        $sdate = new FNSDateTime ( $_SESSION ['timezone'] );
        $edate = new FNSDateTime ( $_SESSION ['timezone'] );
        $pdate = new FNSDateTime ( $_SESSION ['timezone'] );
        $npdate = new FNSDateTime ( $_SESSION ['timezone'] );

        $lastData = $this->rDatabase->reports_nextLocation ();
        $data = $this->rDatabase->reports_nextLocation ();

        for($x = 0; $x < $daysCount - 1; $x ++) {
            $sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
            $edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );

            $days [$x]->distance = 0;

            $trackerSchedule = $this->getTrackerSchedule($tid, $days[$x]);

            if (!$trackerSchedule)
                return false;

            $days [$x]->stime = $trackerSchedule['stime'];
            $days [$x]->etime = $trackerSchedule['etime'];
            $days [$x]->day = strtoupper($trackerSchedule['day']);

            $days [$x]->fDistance = 0;
            $days [$x]->fDuration = 0;

            $days [$x]->startTime = null;
            $days [$x]->endTime = null;

            while ( 1 ) {
                $pdate->setUTCDate ( $data ['date'], $data ['time'] );

//*************
                $data['Converted Time'] = $pdate->getFormattedString();
//*************



                if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {

                    if (($data['timestamp'] >= $days[$x]->timestamp && $data['timestamp'] < $trackerSchedule['stimestamp']) || ($data['timestamp'] >= $trackerSchedule['etimestamp'] && $data['timestamp'] < $days[$x + 1]->timestamp)) {
                        if (isset ( $data ['IO'] ) && strpos ( $data ['IO'], 'j' ) !== false && $data ['speed'] > 0 ) {
                            if($days [$x]->startTime == null)
                                $days [$x]->startTime = date('H:i:s', $data['timestamp']);
                            // ignition is on
                            $npdate->setUTCDate ( $lastData ['date'], $lastData ['time'] );

                            $difference = $pdate->dateTime->getTimestamp () - $npdate->dateTime->getTimestamp ();
                            if ($difference <= IGNITION_DIFF_THRESHOLD_TIME) {
                                // $days [$x]->mDuration += $difference;
                                // $days [$x]->distance += reportUtils::getDistance($data ['latitude'], $data ['longitude'], $lastData ['latitude'], $lastData ['longitude']);
                                $days [$x]->fDuration += $difference;
                                $days [$x]->fDistance += reportUtils::getDistance($data ['latitude'], $data ['longitude'], $lastData ['latitude'], $lastData ['longitude']);
                            }
                            if (!isset($days[$x]->firstIgnition['latitude'])) {             //For latitude and longitude of first ignition, useful in which j packet is not received
                                $days[$x]->firstIgnition['latitude'] = $lastData ['latitude'];
                                $days[$x]->firstIgnition['longitude'] = $lastData ['longitude'];
                            }
                            
                        }

                        if ($data ['speed'] > $days [$x]->maxSpeed)
                            $days [$x]->maxSpeed = $data ['speed'];

                        $days[$x]->driver =$this->rDatabase-> getDriverName($tid);

                    }

                    // Speed computations
                    if (isset ( $data ['IO'] ) && strpos ( $data ['IO'], 'j' ) !== false && $data ['speed'] > 0 ) {
                        if (isset($trackerSchedule['stimestamp']) && ($data['timestamp'] >= $days[$x]->timestamp && $data['timestamp'] >= $trackerSchedule['stimestamp']) && ($data['timestamp'] < $trackerSchedule['etimestamp'] && $data['timestamp'] < $days[$x + 1]->timestamp)) {
                        if($days [$x]->startTime != null && $days [$x]->endTime == null)
                                $days [$x]->endTime = date('H:i:s', $data['timestamp']);
                        }
                        // ignition is on
                        $npdate->setUTCDate ( $lastData ['date'], $lastData ['time'] );

                        $difference = $pdate->dateTime->getTimestamp () - $npdate->dateTime->getTimestamp ();
                        if ($difference <= IGNITION_DIFF_THRESHOLD_TIME) {
                            $days [$x]->mDuration += $difference;
                            $days [$x]->distance += reportUtils::getDistance($data ['latitude'], $data ['longitude'], $lastData ['latitude'], $lastData ['longitude']);
                        }
                        if (!isset($days[$x]->firstIgnition['latitude'])) {             //For latitude and longitude of first ignition, useful in which j packet is not received
                            $days[$x]->firstIgnition['latitude'] = $lastData ['latitude'];
                            $days[$x]->firstIgnition['longitude'] = $lastData ['longitude'];
                        }
                    }

                    if ($data ['speed'] > $days [$x]->maxSpeed)
                        $days [$x]->maxSpeed = $data ['speed'];

                    $lastData = $data;
                    $data = $this->rDatabase->reports_nextLocation ();
                    if ($data == false)
                        break;
                } else
                    break; // if

            } // While

            if($days [$x]->startTime != null && $days [$x]->endTime == null)
                $days [$x]->endTime = date('H:i:s', $data['timestamp']);

            if ($days [$x]->distance != 0) {
                $distance = $days [$x]->distance * 0.621371;

                $days [$x]->distance = $this->mConverter->convert ( $distance, "D" );
                $days [$x]->maxSpeed = $this->mConverter->convert ( $days [$x]->maxSpeed, "S" );

                if ($days [$x]->mDuration != 0)
                    $days [$x]->avgSpeed = $this->mConverter->convert ( $distance / ($days [$x]->mDuration / 3600), "S" );
                else
                    $days [$x]->avgSpeed = 0;

                if ($days [$x]->avgSpeed >= $days [$x]->maxSpeed) {
                    $days [$x]->maxSpeed = ceil ( $days [$x]->avgSpeed );
                }



                $days [$x]->latitude = $data ['latitude'];
                $days [$x]->longitude = $data ['longitude'];
            }
            if($days[$x]->fDistance != 0){
                $fDistance = $days[$x]->fDistance * 0.621371;
                $days[$x]->fDistance = $this->mConverter->convert ($fDistance , "D");
            }
            $days[$x]->lastIgnition['latitude'] = $lastData ['latitude'];   //For latitude and longitude of last ignition, useful in which j packet is not received
            $days[$x]->lastIgnition['longitude'] = $lastData ['longitude'];

        } // for daysCount


        for($x = 0; $x < $daysCount - 1; $x ++) {
            $sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
            $edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
            $ign_result = $this->rDatabase->reports_getEventsData($tid,array('sdate' => $days[$x]->date, 'stime' => $days[$x]->time, 'edate' => $days[$x+1]->date, 'etime'=>$days[$x+1]->time),array(EVENT_START_ENGINE), true);

            if ($days[$x]->distance != 0 && $ign_result != false) {
                $days[$x]->firstIgnition = $ign_result[0];
                $days[$x]->lastIgnition = $ign_result[count($ign_result)-1];
            }
            //$loc = $geo -> search($days[$x]->firstIgnition['latitude'],$days[$x]->firstIgnition['longitude'],true);
            //$days[$x]->firstIgnition['location'] = $loc['location'];
            //$loc = $geo -> search($days[$x]->lastIgnition['latitude'],$days[$x]->lastIgnition['longitude'],true);
            //$days[$x]->lastIgnition['location'] = $loc['location'];
        } // for daysCount


        return $days;
    }
    private function getTrackersList() {
        global $GDATABASE;
        $trackers = $GDATABASE->getTrackersList ( "trackerid" );
        $a = array ();
        $tcount = count ( $trackers );
        for($i = 0; $i < $tcount; $i ++) {
            array_push ( $a, $trackers [$i] ['trackerid'] );
        }
        return $a;
    }
    private function getReportData() {
        global $GDATABASE;
        $arrdate = reportUtils::getUTCReportTime ( $_GET );

        if ($_GET ['ftype'] == "E") {
            $trackers = $this->getTrackersList ();
        } else {
            $trackers = explode ( ",", $_GET ['trackers'] );
        }

        $tcount = count ( $trackers );

        $display_array = array ();

        for($i = 0; $i < $tcount; $i ++) {
            $days = reportUtils::getDays ( $arrdate, 'UTC' );

            $result = $this->computeParameters ( $trackers [$i], $arrdate, $days );

            $arr = array ();

            $arr ['tinfo'] = $GDATABASE->getTrackerCard ( $trackers [$i] );
            $arr ['details'] = $GDATABASE->rp_getTrackersDetails ( $trackers [$i] );
            $arr ['result'] = $result;

            array_push ( $display_array, $arr );
        }

        switch ($_GET ['format']) {
            case 'HTML' :
                FATIGUE_Output_HTML::printHTML ( $display_array );
                break;
            case "PDF" :
                $pdf = new FATIGUE_Output_PDF ();
                $pdf->printPDF ( $display_array );
                break;
            case "XLSX" :
                FATIGUE_Output_XLSX::printXLSX ( $display_array );
                break;
        }
    }
    public function execute() {
        global $MYLANGUAGE;
        $MYLANGUAGE = new FNSLanguage ();

        $this->mConverter = new metricConverter ();
        $this->mConverter->setMetrics ( $_GET ['metric'] );
        $this->rDatabase = new reportingQueries ();

        $this->getReportData ();
    }
}
?>