<?php

/**
 * @version: 5.1
 */

require_once (REPORTS_FOLDER . "/reportUtils.php");
require_once (DATABASE_FOLDER . "/reportingQueries.php");
require_once (GEOCODER_FOLDER . "/geo.php");
require_once (mPDF_FOLDER . "/mpdf.php");
require_once (PHPExcelPath . '/Classes/PHPExcel.php');


class GEOFENCE_Output_XLSX {
	public static function printXLSX($arrDis) {
		ob_start ();
		
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		global $GDATABASE, $MYLANGUAGE;
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		$objPHPExcel = new PHPExcel ();
		$sheetProperties = $objPHPExcel->getProperties ();
		$sheetProperties->setCreator ( "Find'n'Secure" );
		$sheetProperties->setTitle ( $MYLANGUAGE->getString ( 'GEOFENCE' ) );
		$sheetProperties->setDescription ( $MYLANGUAGE->getString ( 'GEO_INFO' ) );
		
		$myWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, $MYLANGUAGE->getString ( 'GEOFENCE' ) );
		$objPHPExcel->addSheet ( $myWorkSheet, 0 );
		$objPHPExcel->setActiveSheetIndex ( 0 );
		
		// set font-family and size
		$objPHPExcel->getDefaultStyle ()->getFont ()->setName ( 'Arial' );
		$objPHPExcel->getDefaultStyle ()->getFont ()->setSize ( 10 );
		
		// set default column widths
		for($i = 'A'; $i <= 'F'; $i ++) {
			$myWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
		}
		
		// set margins
		$myWorkSheet->getPageMargins ()->setRight ( 0.125 );
		$myWorkSheet->getPageMargins ()->setLeft ( 0.125 );
		
		// set page orientation
		$myWorkSheet->getPageSetup ()->setPaperSize ( PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4 );
		$myWorkSheet->getPageSetup ()->setFitToWidth ( 1 );
		$myWorkSheet->getPageSetup ()->setFitToHeight ( 0 );
		
		$row = 2;
		
		// report heading
		$myWorkSheet->SetCellValue ( "A$row", $MYLANGUAGE->getString ( 'GEOFENCE' ) );
		$myWorkSheet->mergeCells ( "A$row:C" . ($row + 4) );
		$headingStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 16 
				),
				'alignment' => array (
						'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
						'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP 
				) 
		);
		$myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
		$myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );
		
		// company logo
		$logo = new PHPExcel_Worksheet_Drawing ();
		$logo->setPath ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' );
		$logo->setWorksheet ( $myWorkSheet );
		$logo->setCoordinates ( 'D' . $row );
		$myWorkSheet->mergeCells ( "D$row:F" . ($row + 4) );
		$logo->setOffsetX ( 115 );
		
		$row = 9;
		
		// company details
		$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'COMPANY_NAME' ) );
		$myWorkSheet->SetCellValue ( 'B' . $row, $answer [0] ['company'] );
		$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'USERNAME' ) );
		$myWorkSheet->SetCellValue ( 'E' . $row, $answer [0] ['username'] );
		$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
		$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
		
		$row ++;
		
		$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
		$myWorkSheet->SetCellValue ( 'B' . $row, $sdate );
		$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
		$myWorkSheet->SetCellValue ( 'E' . $row, $edate );
		$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
		$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
		
		$row += 2;
		
		// report details
		$detailsStyle = array (
				'borders' => array (
						'inside' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FFFFFFFF' 
								) 
						) 
				),
				
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FFDDDDDD' 
						) 
				) 
		);
		
		$tCount = count ( $arrDis );
		$geofence_name_selected = strtolower(str_replace(' ', '', $_GET ['geofenceNameSelTag']));
		
		for($i = 0; $i < $tCount; $i ++) {
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
			
			$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TRACKER_NAME' ) );
			$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['tinfo'] [0] ['name'] );
			$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'APPLICATION' ) );
			$myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( $apptype ) );
			$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
			$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
			$myWorkSheet->getStyle ( "A$row:F$row" )->applyFromArray ( $detailsStyle );
			$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
			
			$row ++;
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LICENSEPLATE' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['licensePlate'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'VTYPE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['vtype'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REFNO' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['arefno'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
			}
			$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
			$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
			$myWorkSheet->getStyle ( "A$row:F$row" )->applyFromArray ( $detailsStyle );
			$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
			
			$row += 3;
			
			// row1 header
			$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TIME' ) );
			$myWorkSheet->SetCellValue ( 'B' . $row, $MYLANGUAGE->getString ( 'RGEO' ) );
			$myWorkSheet->SetCellValue ( 'C' . $row, $MYLANGUAGE->getString ( 'PLACE' ) );
			$myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( 'LATITUDE' ) );
			$myWorkSheet->SetCellValue ( 'F' . $row, $MYLANGUAGE->getString ( 'LONGITUDE' ) );
			$myWorkSheet->mergeCells ( 'C' . $row . ':D' . $row );
			$rowHeadStyle = array (
					'font' => array (
							'bold' => true,
							'size' => 9 
					),
					
					'borders' => array (
							'bottom' => array (
									'style' => PHPExcel_Style_Border::BORDER_THIN,
									'color' => array (
											'argb' => 'FF000000' 
									) 
							) 
					) 
			);
			$myWorkSheet->getStyle ( 'A' . $row . ':F' . $row )->applyFromArray ( $rowHeadStyle );
			$myWorkSheet->getStyle ( "D$row:F$row" )->getAlignment ()->setHorizontal ( PHPExcel_Style_Alignment::HORIZONTAL_RIGHT );
			
			$row += 2;
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
				
				$entCount = count ( $arrDis [$i] ['result'] [$j]->enterGeo );

				$entCountEntry = $entCount;
				$enterGeoPoiintsArr = array();
				$leaveGeoCount = count ( $arrDis [$i] ['result'] [$j]->leaveGeo );
				
				$printHeader = false;
				
				$rowHead1Style = array (
						'font' => array (
								'bold' => true,
								'size' => 9 
						),
						
						'borders' => array (
								'bottom' => array (
										'style' => PHPExcel_Style_Border::BORDER_THIN,
										'color' => array (
												'argb' => 'FF000000' 
										) 
								),
								'top' => array (
										'style' => PHPExcel_Style_Border::BORDER_THIN,
										'color' => array (
												'argb' => 'FF000000' 
										) 
								) 
						),
						
						'fill' => array (
								'type' => PHPExcel_Style_Fill::FILL_SOLID,
								'startcolor' => array (
										'argb' => 'FFDDDDDD' 
								) 
						) 
				);
				
				if ($entCount != 0) {
					
					// row1 inner header 1
					$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate );
					$myWorkSheet->mergeCells ( "A$row:F$row" );
					$myWorkSheet->getStyle ( 'A' . $row . ':F' . $row )->applyFromArray ( $rowHead1Style );
					
					$row +=2;
					
					// row1 inner header 2
					$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'GEO_ENTRY' ) );
					$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
					$myWorkSheet->mergeCells ( "A$row:F$row" );
					
					$row ++;
					
					for($k = 0; $k < $entCount; $k ++) {

						$egp_name = strtolower(str_replace(' ', '', $arrDis [$i] ['result'] [$j]->enterGeo [$k]->name));
						$egp_timestamp = $arrDis [$i] ['result'] [$j]->enterGeo [$k]->timestamp;

						$rep_flag = false;

						if($geofence_name_selected == $egp_name) {
							$rep_flag = true;							
						} else if($geofence_name_selected == 'all') {
							$rep_flag = true;
						}

						if($rep_flag) {

							$enterGeoPoiintsArr[$k] = array('timestamp'=>$egp_timestamp, 'name'=>$egp_name);

							$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->enterGeo [$k]->date, $arrDis [$i] ['result'] [$j]->enterGeo [$k]->time );
							$sdate = $fdate->getDateStruct ();
							
							$myWorkSheet->SetCellValue ( 'A' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel($sdate->year,$sdate->month,$sdate->day,$sdate->hour,$sdate->min,$sdate->sec));
							$myWorkSheet->getStyle ( 'A' . $row )->getNumberFormat ()->setFormatCode ( 'hh:mm:ss' );
							$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['result'] [$j]->enterGeo [$k]->name );
							$myWorkSheet->SetCellValue ( 'C' . $row, $arrDis [$i] ['result'] [$j]->enterGeo [$k]->place ['location'] );
							$myWorkSheet->mergeCells ( "C$row:D$row" );
							$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['result'] [$j]->enterGeo [$k]->latitude );
							$myWorkSheet->SetCellValue ( 'F' . $row, $arrDis [$i] ['result'] [$j]->enterGeo [$k]->longitude );
							$myWorkSheet->getStyle ( "A$row:F$row" )->getFill ()->getStartColor ()->setARGB ( 'FF' . $backgroundColor );
							
							$row ++;
						}
					}
				} else {
					$printHeader = true;
				}

				$timestamp_displayed = array();
				
				if($entCountEntry) {

					$entCount = count ( $arrDis [$i] ['result'] [$j]->leaveGeo );
					if ($entCount != 0) {
						if ($printHeader == true) {
							// row1 inner header 1
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate );
							$myWorkSheet->mergeCells ( "A$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row . ':F' . $row )->applyFromArray ( $rowHead1Style );
						}
						$row ++;
							
						$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'GEO_EXIT' ) );
						$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
						$myWorkSheet->mergeCells ( "A$row:F$row" );
						
						$row ++;
						
						for($k = 0; $k < $entCount; $k ++) {

							$egp_name = strtolower(str_replace(' ', '', $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->name));
							$egp_timestamp = $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->timestamp;

							$rep_flag = false;

							if($geofence_name_selected == $egp_name) {
								$rep_flag = true;							
							} else if($geofence_name_selected == 'all') {
								$rep_flag = true;
							}
						
							if($rep_flag) {

								foreach ($enterGeoPoiintsArr as $ky => $valu_arr) {

									if($valu_arr['name'] == $egp_name && $valu_arr['timestamp'] < $egp_timestamp) {

										if (!in_array($egp_timestamp, $timestamp_displayed)) {

										    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->date, $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->time );
											$sdate = $fdate->getDateStruct ();
											
											$myWorkSheet->SetCellValue ( 'A' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel($sdate->year,$sdate->month,$sdate->day,$sdate->hour,$sdate->min,$sdate->sec));
											$myWorkSheet->getStyle ( 'A' . $row )->getNumberFormat ()->setFormatCode ( 'hh:mm:ss' );
											$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->name );
											$myWorkSheet->SetCellValue ( 'C' . $row, $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->place ['location'] );
											$myWorkSheet->mergeCells ( "C$row:D$row" );
											$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->latitude );
											$myWorkSheet->SetCellValue ( 'F' . $row, $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->longitude );
											$myWorkSheet->getStyle ( "A$row:F$row" )->getFill ()->getStartColor ()->setARGB ( 'FF' . $backgroundColor );
										}

										$timestamp_displayed[] = $egp_timestamp;
										$row ++;
									}
								}
							}	
							
						}
						$row++;
					}
					
				}

				
			} // for J
		} // for I
		
		$contents = ob_get_contents ();
		ob_end_clean ();
		
		// redirect output to browser
		header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
		header ( 'Content-Disposition: attachment;filename="geofence.xlsx"' );
		header ( 'Cache-Control: max-age=0' );
		$objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
		$objWriter->save ( 'php://output' );
	}
}
class GEOFENCE_Output_PDF {
	public $pdf;

	public static $txtDirection;
	public static $revDirection;
	public static $direction;
	private function initializePDF() {
		global $MYLANGUAGE;
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$this->pdf = new mPDF ( "utf-8", "LETTER" );
		
		$this->pdf->SetCreator ( "Find'n'Secure" );
		$this->pdf->SetAuthor ( 'EMBARC' );
		$this->pdf->SetTitle ( $MYLANGUAGE->getString ( 'GEOFENCE' ) );
		$this->pdf->SetSubject ( $MYLANGUAGE->getString ( 'GEOFENCE' ) );
		$this->pdf->SetKeywords ( "Geofence, Report, Findnsecure" );
		
		// set default header data
		$header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . $MYLANGUAGE->getString ( 'GEOFENCE' ) . '</td><td align="'.$right.'"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
		$this->pdf->SetHTMLHeader ( $header, "E" );
		$this->pdf->SetHTMLHeader ( $header, "O" );
		$this->pdf->SetTopMargin ( 30 );
		
		// $this->pdf->SetDirectionality("rtl");
		$this->pdf->SetAutoFont ( AUTOFONT_ALL );
		$this->pdf->SetDirectionality(self::$direction);
	}

	public function printPDF($arrDis) {
		global $GDATABASE, $MYLANGUAGE, $languageMatrix;
		
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
		
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}
		
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		ob_start ();
		
		print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<style>' . file_get_contents ( CSS_FOLDER . '/reports_pdf.css' ) . '</style>
				</head>
				<body class="mainbody">
			  ';
		
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		$this->initializePDF ();
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
			
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>
		
		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';
		
		$tCount = count ( $arrDis );
		$geofence_name_selected = strtolower(str_replace(' ', '', $_GET ['geofenceNameSelTag']));

		for($i = 0; $i < $tCount; $i ++) {
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
			
			print '<br><table width="100%" class ="topBottom10pxPadding" >
			<tr style="background-color:#dddddd">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
			</tr>';
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
			</tr>';
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
			</tr>';
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			}
			
			print "</table>";
			
			print '<table width="100%" cellSpacing=2 cellpadding="2" frame="hsides" bordercolor="#999999" rules="rows" style="font-size:11px;" >
			<tr align="'.$left.'">
			<th>' . $MYLANGUAGE->getString ( 'TIME' ) . '</th>
			<th>' . $MYLANGUAGE->getString ( 'RGEO' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'PLACE' ) . '</th>
			<th align="center">' . $MYLANGUAGE->getString ( 'LATITUDE' ) . '</th>
			<th align="center">' . $MYLANGUAGE->getString ( 'LONGITUDE' ) . '</th>
						</tr>';
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
				
				$entCount = count ( $arrDis [$i] ['result'] [$j]->enterGeo );

				$entCountEntry = $entCount;
				$enterGeoPoiintsArr = array();
				$leaveGeoCount = count ( $arrDis [$i] ['result'] [$j]->leaveGeo );
				
				$printHeader = false;
				
				if ($entCount != 0) {
					
					print '<tr><td colspan="5">&nbsp;</td></tr><tr style="background-color:#BBBBBB;height:20px; padding-top:10px;"><td colspan="5" style="font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate . '</td></tr>';
					
					print '<tr><td colspan="5"><div style="font-weight:bold; font-size:13px">' . $MYLANGUAGE->getString ( 'GEO_ENTRY' ) . '</div></td></tr>';
					
					for($k = 0; $k < $entCount; $k ++) {

						$egp_name = strtolower(str_replace(' ', '', $arrDis [$i] ['result'] [$j]->enterGeo [$k]->name));

						$rep_flag = false;

						if($geofence_name_selected == $egp_name) {
							$rep_flag = true;							
						} else if($geofence_name_selected == 'all') {
							$rep_flag = true;
						}

						if($rep_flag) {

							$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->enterGeo [$k]->date, $arrDis [$i] ['result'] [$j]->enterGeo [$k]->time );
							print '<tr align="'.$left.'" style="font-weight:normal;background-color:' . $backgroundColor . ';">
							
							<td>' . $fdate->getFormattedTimeString () . '</td>
							<td>' . $arrDis [$i] ['result'] [$j]->enterGeo [$k]->name . '</td>
							<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->enterGeo [$k]->place ['location'] . '</td>
							<td align="center">' . $arrDis [$i] ['result'] [$j]->enterGeo [$k]->latitude . '</td>
							<td align="center">' . $arrDis [$i] ['result'] [$j]->enterGeo [$k]->longitude . '</td>
												
							</tr>';

							$egp_name = strtolower(str_replace(' ', '', $arrDis [$i] ['result'] [$j]->enterGeo [$k]->name));
							$egp_timestamp = $arrDis [$i] ['result'] [$j]->enterGeo [$k]->timestamp;

							$enterGeoPoiintsArr[$k] = array('timestamp'=>$egp_timestamp, 'name'=>$egp_name);
						}

					}
				} else {
					$printHeader = true;
				}

				$timestamp_displayed = array();
				
				if($entCountEntry) {

					$entCount = count ( $arrDis [$i] ['result'] [$j]->leaveGeo );
					if ($entCount != 0) {
						
						if ($printHeader == true)
							print '<tr><td>&nbsp;</td></tr><tr style="background-color:#BBBBBB;height:20px; padding-top:10px;"><td colspan="5" style="font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate . '</td></tr>';
						
						print '<tr><td colspan="5"><div style="font-weight:bold; font-size:13px">' . $MYLANGUAGE->getString ( 'GEO_EXIT' ) . '</div></td></tr>';
						
						for($k = 0; $k < $entCount; $k ++) {
							
							$egp_name = strtolower(str_replace(' ', '', $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->name));
							$egp_timestamp = $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->timestamp;

							$rep_flag = false;

							if($geofence_name_selected == $egp_name) {
								$rep_flag = true;							
							} else if($geofence_name_selected == 'all') {
								$rep_flag = true;
							}
						
							if($rep_flag) {

								foreach ($enterGeoPoiintsArr as $ky => $valu_arr) {

									if($valu_arr['name'] == $egp_name && $valu_arr['timestamp'] < $egp_timestamp) {

										if (!in_array($egp_timestamp, $timestamp_displayed)) {

										    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->date, $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->time );
											print '<tr align="'.$left.'" style="font-weight:normal;background-color:' . $backgroundColor . ';">
											
											<td>' . $fdate->getFormattedTimeString () . '</td>
											<td>' . $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->name . '</td>
											<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->place ['location'] . '</td>
											<td align="center">' . $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->latitude . '</td>
											<td align="center">' . $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->longitude . '</td>								
											</tr>';
										}

										$timestamp_displayed[] = $egp_timestamp;

									}
								}

							}
						}
					}

				}

				
			} // for J
			print "</table>";
			print '<br><div class="dashes"> </div><br/>';
		} // for I
		
		print '</body></html>';
		
		$contents = ob_get_contents ();
		ob_end_clean ();
		
		$this->pdf->WriteHTML ( $contents );
		$this->pdf->Output ();
	}
}

class GEOFENCE_Output_HTML {
	public static $txtDirection;
	public static $revDirection;
	public static $direction;

	
	public static function printHeader() {
		global $MYLANGUAGE, $languageMatrix;
		
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
		
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}

		print '
				<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>' . $MYLANGUAGE->getString ( 'GEOFENCE' ) . '</title>
				<style>'. file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:'.$direction.';} </style>
				</head>
				<body class="mainbody" style="background-color:#999; background-image:none">
			    <div id="reportframe">
			    <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
			  ';
	}
		public static function printHTML($arrDis) {
		ob_start ();
		
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		global $GDATABASE, $MYLANGUAGE;
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		GEOFENCE_Output_HTML::printHeader ();
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		print '<table width="100%" class="topBottom10pxPadding"><tr><td>' . $MYLANGUAGE->getString ( 'GEOFENCE' ) . '</td><td align="'.$right.'"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';
		
		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
			
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>
		
		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';
		
		$tCount = count ( $arrDis );
		$geofence_name_selected = strtolower(str_replace(' ', '', $_GET ['geofenceNameSelTag']));
		
		for($i = 0; $i < $tCount; $i ++) {
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
			
			print '<br><table width="100%" class ="topBottom10pxPadding">
			<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
			</tr>';
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			}
			print "</table>";
						
			print '<table width="100%" cellSpacing=2 cellpadding="2" border=1 frame="hsides" bordercolor="#999999" rules="rows" style="font-size:11px;font-family:Arial" >
			<tr align="'.$left.'">
			<th>' . $MYLANGUAGE->getString ( 'TIME' ) . '</th>
			<th>' . $MYLANGUAGE->getString ( 'RGEO' ) . '</th>
			<th >' . $MYLANGUAGE->getString ( 'PLACE' ) . '</th>
			<th align="center">' . $MYLANGUAGE->getString ( 'LATITUDE' ) . '</th>
			<th align="center">' . $MYLANGUAGE->getString ( 'LONGITUDE' ) . '</th>
						</tr>';
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				if ($j % 2 == 1)
					$backgroundColor = "#FaFaFa";
				else
					$backgroundColor = "#F2F2F2";
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
				$sdate = $fdate->getFormattedString ();
				
				$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
				$edate = $fdate->getFormattedString ();
				
				$entCount = count ( $arrDis [$i] ['result'] [$j]->enterGeo );

				/*if($_SERVER['REMOTE_ADDR'] == '103.93.136.51') {
					echo '<pre>';print_r($arrDis [$i] ['result'] [$j]->enterGeo);echo '</pre>';die();
				}*/

				$entCountEntry = $entCount;
				$enterGeoPoiintsArr = array();
				$leaveGeoCount = count ( $arrDis [$i] ['result'] [$j]->leaveGeo );
				
				$printHeader = false;
				
				if ($entCount != 0 ) {
					
					print '<tr><td colspan="5">&nbsp;</td></tr><tr style="background-color:#BBBBBB;height:20px; padding-top:10px;"><td colspan="5" style="font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate . '</td></tr>';
					
					print '<tr><td colspan="5"><div style="font-family:Arial; font-weight:bold; font-size:13px">' . $MYLANGUAGE->getString ( 'GEO_ENTRY' ) . '</div></td></tr>';

					//echo $geofence_name_selected;
					
					for($k = 0; $k < $entCount; $k ++) {

						$egp_name = strtolower(str_replace(' ', '', $arrDis [$i] ['result'] [$j]->enterGeo [$k]->name));

						$rep_flag = false;

						if($geofence_name_selected == $egp_name) {
							$rep_flag = true;							
						} else if($geofence_name_selected == 'all') {
							$rep_flag = true;
						}

						if($rep_flag) {
							$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->enterGeo [$k]->date, $arrDis [$i] ['result'] [$j]->enterGeo [$k]->time );
							print '<tr align="'.$left.'" style="font-weight:normal;background-color:' . $backgroundColor . ';">
							
							<td>' . $fdate->getFormattedTimeString () . '</td>
							<td>' . $arrDis [$i] ['result'] [$j]->enterGeo [$k]->name . '</td>
							<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->enterGeo [$k]->place ['location'] . '</td>
							<td align="center">' . $arrDis [$i] ['result'] [$j]->enterGeo [$k]->latitude . '</td>
							<td align="center">' . $arrDis [$i] ['result'] [$j]->enterGeo [$k]->longitude . '</td>
												
							</tr>';

							$egp_name = strtolower(str_replace(' ', '', $arrDis [$i] ['result'] [$j]->enterGeo [$k]->name));
							$egp_timestamp = $arrDis [$i] ['result'] [$j]->enterGeo [$k]->timestamp;

							$enterGeoPoiintsArr[$k] = array('timestamp'=>$egp_timestamp, 'name'=>$egp_name);
						}

					}
					
				} else {
					$printHeader = true;
				}

				/*if($_SERVER['REMOTE_ADDR'] == '103.93.136.51' && count($enterGeoPoiintsArr) > 0) {
					echo '<pre>';print_r($enterGeoPoiintsArr);echo '</pre>';
					echo '<pre>';print_r($arrDis [$i] ['result'] [$j]->leaveGeo);echo '</pre>';
				}*/

				$timestamp_displayed = array();

				if($entCountEntry) {

					$entCount = count ( $arrDis [$i] ['result'] [$j]->leaveGeo );
					if ($entCount != 0) {
						
						if ($printHeader == true)
							print '<tr><td>&nbsp;</td></tr><tr style="background-color:#BBBBBB;height:20px; padding-top:10px;"><td colspan="5" style="font-family:Arial; font-weight:bold; font-size:12px">' . $MYLANGUAGE->getString ( 'PERIOD' ) . ': ' . $sdate . " - " . $edate . '</td></tr>';
						
						print '<tr><td colspan="5"><div style="font-family:Arial; font-weight:bold; font-size:13px">' . $MYLANGUAGE->getString ( 'GEO_EXIT' ) . '</div></td></tr>';
						

						for($k = 0; $k < $entCount; $k ++) {

							$egp_name = strtolower(str_replace(' ', '', $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->name));
							$egp_timestamp = $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->timestamp;

							$rep_flag = false;

							if($geofence_name_selected == $egp_name) {
								$rep_flag = true;							
							} else if($geofence_name_selected == 'all') {
								$rep_flag = true;
							}
						
							if($rep_flag) {
								
								foreach ($enterGeoPoiintsArr as $ky => $valu_arr) {

									if($valu_arr['name'] == $egp_name && $valu_arr['timestamp'] < $egp_timestamp) {

										if (!in_array($egp_timestamp, $timestamp_displayed)) {

										    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->date, $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->time );
											print '<tr align="'.$left.'" style="font-weight:normal;background-color:' . $backgroundColor . ';">
											
											<td>' . $fdate->getFormattedTimeString () . '</td>
											<td>' . $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->name . '</td>
											<td align="'.$left.'">' . $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->place ['location'] . '</td>
											<td align="center">' . $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->latitude . '</td>
											<td align="center">' . $arrDis [$i] ['result'] [$j]->leaveGeo [$k]->longitude . '</td>
																
											</tr>';
										}

										$timestamp_displayed[] = $egp_timestamp;

									}
								}
							}
						}
					}

				}
				
				
			} // for J
			print "</table>";
			
			print '<br><div class="dashes"> </div><br/>';
		} // for I
		
		GEOFENCE_Output_HTML::printFooter ();
		
		$contents = ob_get_contents ();
		ob_end_clean ();
		print $contents;
	}
	public static function printFooter() {
		print '
		<br/>
		<div style="width:100%; border:1px black solid; background-color:#404040; height:10px" />
		</div></div>
		</body></html>';
	}
}
class GEOFENCE_FNSv3_Report {
	private $mConverter;
	private $rDatabase;
	private function computeParameters($tid, $dateArray, $days) {
		$this->rDatabase->reports_getEventsData ( $tid, $dateArray, array (
				EVENT_ENTER_GEOFENCE,
				EVENT_LEAVE_GEOFENCE 
		) );
		$daysCount = count ( $days );
		
		$sdate = new FNSDateTime ( $_SESSION ['timezone'] );
		$edate = new FNSDateTime ( $_SESSION ['timezone'] );
		$pdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		$data = $this->rDatabase->reports_nextEvent ();
		
		$geo = new GEOCODER ();
		
		for($x = 0; $x < $daysCount - 1; $x ++) {
			$sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
			$edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
			
			$days [$x]->distance = 0;
			
			$enterGeo = array ();
			$leaveGeo = array ();
			
			while ( 1 ) {
				$pdate->setUTCDate ( $data ['date'], $data ['time'] );
				
				if ($data == false)
					break;
				
				if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
					$n = new geofenceRObject ();
					//$n->name = $data ['description'];
					$n->name = $data ['description']->bin;
					$n->place = $geo->search ( $data ['latitude'], $data ['longitude'], false );
					$n->date = $data ['date'];
					$n->time = $data ['time'];
					$n->latitude = $data ['latitude'];
					$n->longitude = $data ['longitude'];
					$n->timestamp = $data ['timestamp'];
					
					if ($data ['event'] == EVENT_ENTER_GEOFENCE) {
						array_push ( $enterGeo, $n );
					} else {
						array_push ( $leaveGeo, $n );
					}
					
					$data = $this->rDatabase->reports_nextEvent ();
				} else
					break; // if
			} // for dcount
			
			$days [$x]->enterGeo = $enterGeo;
			$days [$x]->leaveGeo = $leaveGeo;
		} // for daysCount
		
		return $days;
	}
	private function getTrackersList() {
		global $GDATABASE;
		$trackers = $GDATABASE->getTrackersList ( "trackerid" );
		$a = array ();
		$tcount = count ( $trackers );
		for($i = 0; $i < $tcount; $i ++) {
			array_push ( $a, $trackers [$i] ['trackerid'] );
		}
		return $a;
	}
	private function getReportData() {
		global $GDATABASE;
		$arrdate = reportUtils::getUTCReportTime ( $_GET );
		
		if ($_GET ['ftype'] == "E") {
			$trackers = $this->getTrackersList ();
		} else {
			$trackers = explode ( ",", $_GET ['trackers'] );
		}
		
		$tcount = count ( $trackers );
		
		$display_array = array ();
		
		for($i = 0; $i < $tcount; $i ++) {
			$days = reportUtils::getDays ( $arrdate, $_SESSION ['timezone'] );
			$result = $this->computeParameters ( $trackers [$i], $arrdate, $days );
			
			$arr = array ();
			
			$arr ['tinfo'] = $GDATABASE->getTrackerCard ( $trackers [$i] );
			$arr ['details'] = $GDATABASE->rp_getTrackersDetails ( $trackers [$i] );
			$arr ['result'] = $result;
			
			array_push ( $display_array, $arr );
		}
		
		switch ($_GET ['format']) {
			case "HTML" :
				GEOFENCE_Output_HTML::printHTML ( $display_array );
				break;
			case "PDF" :
				$pdf = new GEOFENCE_Output_PDF ();
				$pdf->printPDF ( $display_array );
				break;
			case "XLSX" :
				$xlsx = new GEOFENCE_Output_XLSX ();
				$xlsx->printXLSX ( $display_array );
				break;
		}
	}
	public function execute() {
		global $MYLANGUAGE;
		$MYLANGUAGE = new FNSLanguage ();
		
		$this->mConverter = new metricConverter ();
		$this->mConverter->setMetrics ( $_GET ['metric'] );
		$this->rDatabase = new reportingQueries ();
		
		$this->getReportData ();
	}
}
?>
