<?php

/**
 * @version: 5.1
 */

require_once (REPORTS_FOLDER . "/reportUtils.php");
require_once (DATABASE_FOLDER . "/reportingQueries.php");
require_once (GEOCODER_FOLDER . '/geo.php');
require_once (PHPExcelPath . '/Classes/PHPExcel.php');
require_once (mPDF_FOLDER . "/mpdf.php");

class TRIP_Output_XLSX {
	public static function printXLSX($arrDis) {
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		global $GDATABASE, $MYLANGUAGE;
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		$objPHPExcel = new PHPExcel ();
		$sheetProperties = $objPHPExcel->getProperties ();
		$sheetProperties->setCreator ( "Find'n'Secure" );
		$sheetProperties->setTitle ( $MYLANGUAGE->getString ( 'TRIP' ) );
		$sheetProperties->setDescription ( $MYLANGUAGE->getString ( 'TRIP_INFO' ) );
		
		$myWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, $MYLANGUAGE->getString ( 'TRIP' ) );
		$objPHPExcel->addSheet ( $myWorkSheet, 0 );
		$objPHPExcel->setActiveSheetIndex ( 0 );
		
		// set font-family and size
		$objPHPExcel->getDefaultStyle ()->getFont ()->setName ( 'Arial' );
		$objPHPExcel->getDefaultStyle ()->getFont ()->setSize ( 9 );
		
		// set default column widths
		for($i = 'A'; $i <= 'F'; $i ++) {
			$myWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
		}
		
		// set margins
		$myWorkSheet->getPageMargins ()->setRight ( 0.125 );
		$myWorkSheet->getPageMargins ()->setLeft ( 0.125 );
		
		// set page orientation
		$myWorkSheet->getPageSetup ()->setPaperSize ( PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4 );
		$myWorkSheet->getPageSetup ()->setFitToWidth ( 1 );
		$myWorkSheet->getPageSetup ()->setFitToHeight ( 0 );
		
		$row = 2;
		
		// report heading
		$myWorkSheet->SetCellValue ( "A$row", $MYLANGUAGE->getString ( 'TRIP' ) );
		$myWorkSheet->mergeCells ( "A$row:C" . ($row + 4) );
		$headingStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 16 
				),
				'alignment' => array (
						'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
						'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP 
				) 
		);
		$myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
		$myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );
		
		// company logo
		$logo = new PHPExcel_Worksheet_Drawing ();
		$logo->setPath ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' );
		$logo->setWorksheet ( $myWorkSheet );
		$logo->setCoordinates ( 'D' . $row );
		$myWorkSheet->mergeCells ( "D$row:F" . ($row + 4) );
		$logo->setOffsetX ( 115 );
		
		$row = 9;
		
		// company details
		$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'COMPANY_NAME' ) );
		$myWorkSheet->SetCellValue ( 'B' . $row, $answer [0] ['company'] );
		$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'USERNAME' ) );
		$myWorkSheet->SetCellValue ( 'E' . $row, $answer [0] ['username'] );
		$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
		$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
		
		$row ++;
		
		$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
		$myWorkSheet->SetCellValue ( 'B' . $row, $sdate );
		$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
		$myWorkSheet->SetCellValue ( 'E' . $row, $edate );
		$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
		$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
		
		$row += 2;
		
		// report details
		$detailsStyle = array (
				'borders' => array (
						'inside' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FFFFFFFF' 
								) 
						) 
				),
				
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FFDDDDDD' 
						) 
				) 
		);
		
		$rowHeadStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 9 
				),
				
				'borders' => array (
						'bottom' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FF000000' 
								) 
						),
						'top' => array (
								'style' => PHPExcel_Style_Border::BORDER_THIN,
								'color' => array (
										'argb' => 'FF000000' 
								) 
						) 
				),
				
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FFDDDDDD' 
						) 
				) 
		);
		
		$rowGreenStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 9,
						'color' => array (
								argb => 'FFFFFFFF' 
						) 
				),
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FF1e8000' 
						) 
				) 
		);
		
		$rowRedStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 9,
						'color' => array (
								argb => 'FFFFFFFF' 
						) 
				),
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FFFF0000' 
						) 
				) 
		);
		
		$rowYellowStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 9,
						'color' => array (
								argb => 'FFFFFFFF'
						)
				),
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FFE2BA00'
						)
				)
		
		);

		$rowPurpleStyle = array (
				'font' => array (
						'bold' => true,
						'size' => 9,
						'color' => array (
								argb => 'FFFFFFFF'
						)
				),
				'fill' => array (
						'type' => PHPExcel_Style_Fill::FILL_SOLID,
						'startcolor' => array (
								'argb' => 'FF9127f3'
						)
				)
		);
		
		
		
		
		$tCount = count ( $arrDis );
		
		for($i = 0; $i < $tCount; $i ++) {
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
			
			$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TRACKER_NAME' ) );
			$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['tinfo'] [0] ['name'] );
			$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'APPLICATION' ) );
			$myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( $apptype ) );
			$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
			$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
			$myWorkSheet->getStyle ( "A$row:F$row" )->applyFromArray ( $detailsStyle );
			$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
			
			$row ++;
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LICENSEPLATE' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['licensePlate'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'VTYPE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['vtype'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REFNO' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['arefno'] );
			}
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
				$myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
				$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
				$myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
			}
			$myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
			$myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
			$myWorkSheet->getStyle ( "A$row:F$row" )->applyFromArray ( $detailsStyle );
			$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
			$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
			
			$row += 3;
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			$data = $arrDis [$i] ['result'];
			$initialized = false;
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				
				$tripsCount = count ( $data [$j]->trips );
				
				if ($tripsCount > 0) {
					
					$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
					$sdate = $fdate->getFormattedString ();
					
					$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
					$edate = $fdate->getFormattedString ();
					$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate );
					$myWorkSheet->mergeCells ( "A$row:F$row" );
					$myWorkSheet->getStyle ( 'A' . $row . ':F' . $row )->applyFromArray ( $rowHeadStyle );
					$row += 2;
					
					for($k = 0; $k < $tripsCount; $k ++) {
						if ($initialized == false) {
							$oldRecord = $data [$j]->trips [$k];
							$initialized = true;
							continue;
						}
						
						$fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
						$sdate = $fdate->getDateStruct ();
						$splace = $oldRecord->place ['location'];
						
						$fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
						$edate = $fdate->getDateStruct ();
						$eplace = $data [$j]->trips [$k]->place ['location'];
						
						$dstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration, $MYLANGUAGE );
						$driver = $data [$j]->trips [$k]->driver;
						if ($driver == false)
							$driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
						
						$ttemp = array ();
						if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
							for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
								if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
									$n = new emptyClass ();
									$n->index = $tp;
									$n->dString = $MYLANGUAGE->getString ( 'MAX' ) . " " . $data [$j]->trips [$k]->maxTemp [$tp] . "°C / " . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "°F | " . $MYLANGUAGE->getString ( 'MIN' ) . " " . $data [$j]->trips [$k]->minTemp [$tp] . "°C / " . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "°F";
									array_push ( $ttemp, $n );
								}
							}
						}
						
						if ($data [$j]->trips [$k]->status == STATUS_MOVING) {
							$backgroundColor = "white";
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'MOVING' ) );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->applyFromArray ( $rowGreenStyle );
							
							$row ++;
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_FROM' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $splace );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REACHED' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $eplace );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_AT' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $sdate->year, $sdate->month, $sdate->day, $sdate->hour, $sdate->min, $sdate->sec ) );
							$myWorkSheet->getStyle ( 'B' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'REACH_TIME' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $edate->year, $edate->month, $edate->day, $edate->hour, $edate->min, $edate->sec ) );
							$myWorkSheet->getStyle ( 'E' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'DURATION' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $dstring );
							$myWorkSheet->mergeCells ( "B$row:C$row" );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'DRIVER' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, $driver );
							$myWorkSheet->mergeCells ( "E$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							
							$row ++;
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_ODO' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, sprintf("%0.2f", $data [$j]->trips [$k]->startOdo));
							$myWorkSheet->mergeCells ( "B$row:C$row" );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_ODO' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, sprintf("%0.2f", $data [$j]->trips [$k]->endOdo) );
							$myWorkSheet->mergeCells ( "E$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
								
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'DISTANCE' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, sprintf ( "%0.2f ", $data [$j]->trips [$k]->distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) );
							$myWorkSheet->mergeCells ( "B$row:C$row" );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MAX_SPEED' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, sprintf ( "%0.1f ", $data [$j]->trips [$k]->maxSpeed ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) );
							$myWorkSheet->mergeCells ( "E$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							
							for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
								if (($tp % 2) == 0) {
									$row ++;
									$column = 0;
								}
								$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
								$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
								$myWorkSheet->mergeCells ( "E$row:F$row" );
								$myWorkSheet->mergeCells ( "B$row:C$row" );
								$myWorkSheet->setCellValueByColumnAndRow ( $column, $row, $MYLANGUAGE->getString ( 'TEMPERATURE' ) . ' ' . ($ttemp [$tp]->index + 1) );
								$myWorkSheet->setCellValueByColumnAndRow ( ($column + 1), $row, $ttemp [$tp]->dString );
								$column += 3;
							}
							
							$row += 2;
						} else if ($data [$j]->trips [$k]->status == STATUS_STOPPED){
							#e2ba00
							$backgroundColor = "white";
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'STOPPED' ) );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->applyFromArray ( $rowRedStyle );
							$row ++;
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'STOP_OVER' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $eplace );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'FTIME' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $sdate->year, $sdate->month, $sdate->day, $sdate->hour, $sdate->min, $sdate->sec ) );
							$myWorkSheet->getStyle ( 'B' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'TTIME' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $edate->year, $edate->month, $edate->day, $edate->hour, $edate->min, $edate->sec ) );
							$myWorkSheet->getStyle ( 'E' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'DURATION' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $dstring );
							$myWorkSheet->mergeCells ( "B$row:C$row" );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'DRIVER' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, $driver );
							$myWorkSheet->mergeCells ( "E$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							
							$row += 2;
							
						} else if ($data [$j]->trips [$k]->status == STATUS_IDLE){
							
							$backgroundColor = "white";
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'IDLING' ) );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->applyFromArray ( $rowYellowStyle );
							$row ++;
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'STOP_OVER' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $eplace );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'FTIME' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $sdate->year, $sdate->month, $sdate->day, $sdate->hour, $sdate->min, $sdate->sec ) );
							$myWorkSheet->getStyle ( 'B' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'TTIME' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $edate->year, $edate->month, $edate->day, $edate->hour, $edate->min, $edate->sec ) );
							$myWorkSheet->getStyle ( 'E' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'DURATION' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $dstring );
							$myWorkSheet->mergeCells ( "B$row:C$row" );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'DRIVER' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, $driver );
							$myWorkSheet->mergeCells ( "E$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							
							$row += 2;
						
						} else if ($data [$j]->trips [$k]->status == STATUS_NOGPS){
							
							$backgroundColor = "white";
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'GPS_INVALID' ) );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->applyFromArray ( $rowPurpleStyle );
							$row ++;
							
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LOCATION' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $eplace );
							$myWorkSheet->mergeCells ( "B$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'FTIME' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $sdate->year, $sdate->month, $sdate->day, $sdate->hour, $sdate->min, $sdate->sec ) );
							$myWorkSheet->getStyle ( 'B' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'TTIME' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $edate->year, $edate->month, $edate->day, $edate->hour, $edate->min, $edate->sec ) );
							$myWorkSheet->getStyle ( 'E' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							$row ++;
							$myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'DURATION' ) );
							$myWorkSheet->SetCellValue ( 'B' . $row, $dstring );
							$myWorkSheet->mergeCells ( "B$row:C$row" );
							$myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'DRIVER' ) );
							$myWorkSheet->SetCellValue ( 'E' . $row, $driver );
							$myWorkSheet->mergeCells ( "E$row:F$row" );
							$myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
							$myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
							
							$row += 2;
						}						
						
						$oldRecord = $data [$j]->trips [$k];
					}
				}
			} // for J
		} // for I
		  // redirect output to browser
		header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
		header ( 'Content-Disposition: attachment;filename="trip.xlsx"' );
		header ( 'Cache-Control: max-age=0' );
		$objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
		$objWriter->save ( 'php://output' );
	}
}
class TRIP_Output_PDF {
	public $pdf;	
	public static $txtDirection;
	public static $revDirection;
	public static $direction;
	private function initializePDF() {
		global $MYLANGUAGE;
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$this->pdf = new mPDF ( "utf-8", "LETTER" );
		
		$this->pdf->SetCreator ( "Find'n'Secure" );
		$this->pdf->SetAuthor ( 'EMBARC' );
		$this->pdf->SetTitle ( $MYLANGUAGE->getString ( 'TRIP' ) );
		$this->pdf->SetSubject ( $MYLANGUAGE->getString ( 'TRIP' ) );
		$this->pdf->SetKeywords ( "Trip, Report, Findnsecure" );
		
		// set default header data
		$header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . $MYLANGUAGE->getString ( 'TRIP' ) . '</td><td align="'.$right.'"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
		$this->pdf->SetHTMLHeader ( $header, "E" );
		$this->pdf->SetHTMLHeader ( $header, "O" );
		$this->pdf->SetTopMargin ( 30 );
		
		// $this->pdf->SetDirectionality("rtl");
		$this->pdf->SetAutoFont ( AUTOFONT_ALL );
		$this->pdf->SetDirectionality(self::$direction);
	}
	public function printPDF($arrDis) {
		
		global $GDATABASE, $MYLANGUAGE, $languageMatrix;
		
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
		
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}
		
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$this->initializePDF ();
		ob_start ();
		
		print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<style>' . file_get_contents ( CSS_FOLDER . '/reports_pdf.css' ) . '</style>
				</head>
				<body class="mainbody">
			  ';
		
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
			
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>
		
		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';
		
		$tCount = count ( $arrDis );

		$totalMovingCount = [];
		$totalMovingDuration = [];
		$tidArr = [];
		
		for($i = 0; $i < $tCount; $i ++) {
			
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );

			array_push($tidArr,$arrDis [$i] ['tinfo'] [0] ['name']);
			array_push($totalMovingCount,0);
			array_push($totalMovingDuration,0);
			
			print '<br><table width="100%" class ="topBottom10pxPadding">
			<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
			</tr>';
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			}
			print "</table>";
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			$data = $arrDis [$i] ['result'];
			$initialized = false;
			
			for($j = 0; $j < $ecount - 1; $j ++) {
				
				$tripsCount = count ( $data [$j]->trips );
				
				if ($tripsCount > 0) {
					
					$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
					$sdate = $fdate->getFormattedString ();
					
					$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
					$edate = $fdate->getFormattedString ();
					print '<div class="subHeading" style="padding-left:3px; padding-top:3px; padding-bottom:3px; margin-top:5px; margin-bottom:5px; background-color:#444444;font-weight:bold; width:100%;color:white; " >' . $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate . "</div>";
					
					for($k = 0; $k < $tripsCount; $k ++) {
						if ($initialized == false) {
							$oldRecord = $data [$j]->trips [$k];
							$initialized = true;
							continue;
						}
						
						$fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
						$sdate = $fdate->getFormattedString ();
						$splace = $oldRecord->place ['location'];
						
						$fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
						$edate = $fdate->getFormattedString ();
						$eplace = $data [$j]->trips [$k]->place ['location'];
						
						$dstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration, $MYLANGUAGE );
						$dur = $data [$j]->trips [$k]->duration;

						$driver = $data [$j]->trips [$k]->driver;
						if ($driver == false)
							$driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
						
						$ttemp = array ();
						if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
							for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
								if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
									$n = new emptyClass ();
									$n->index = $tp;
									$n->dString = $MYLANGUAGE->getString ( 'MAX' ) . " " . $data [$j]->trips [$k]->maxTemp [$tp] . "°C / " . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "°F | " . $MYLANGUAGE->getString ( 'MIN' ) . " " . $data [$j]->trips [$k]->minTemp [$tp] . "°C / " . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "°F";
									array_push ( $ttemp, $n );
								}
							}
						}
						
						print '<table width="100%" cellspacing="0" cellpadding="3"  class="subHeading" style="margin-top:10px;margin-bottom:10px; border: 1px dotted #aaaaaa; font-size:11px;background-color:#F2F2F2">';
						
						if ($data [$j]->trips [$k]->status == STATUS_MOVING) {
							$backgroundColor = "white";
							
							$totalMovingCount[$i] = $totalMovingCount[$i]+1;
							$totalMovingDuration[$i] = $totalMovingDuration[$i]+$dur;


							print '
									
	 						<tr > <td style="background-color:#1e8000;font-weight:bold; font-size:13px; font-variant:small-caps;color:white;">' . $MYLANGUAGE->getString ( 'MOVING' ) . '</td></tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold">' . $MYLANGUAGE->getString ( 'START_FROM' ) . ':</td><td>' . $splace . '</td>
	 						<td style="font-weight:bold">' . $MYLANGUAGE->getString ( 'REACHED' ) . ':</td><td>' . $eplace . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'START_AT' ) . ':</td><td width="320">' . $sdate . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'REACH_TIME' ) . ':</td><td width="320">' . $edate . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DURATION' ) . ':</td><td width="320">' . $dstring . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DRIVER' ) . ':</td><td width="320">' . $driver . '</td>
	 						</tr>
	 								
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'START_ODO' ) . ':</td><td width="320">' . sprintf("%0.2f", $data [$j]->trips [$k]->startOdo) . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'END_ODO' ) . ':</td><td width="320">' . sprintf("%0.2f",$data [$j]->trips [$k]->endOdo) . '</td>
	 						</tr>
	 								
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . ':</td><td width="320">' . sprintf ( "%0.2f ", $data [$j]->trips [$k]->distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'MAX_SPEED' ) . ':</td><td width="320">' . sprintf ( "%0.1f ", $data [$j]->trips [$k]->maxSpeed ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . '</td>
	 						</tr>';
							
							$toutput = false;
							for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
								if (($tp % 2) == 0) {
									if ($tp != 0)
										print '</tr>';
									print '<tr style="background-color:' . $backgroundColor . '">';
									$toutput = true;
								}
								print '<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'TEMPERATURE' ) . ' ' . ($ttemp [$tp]->index + 1) . ':</td><td width="320">' . $ttemp [$tp]->dString . '</td>';
							}
							
							if ($toutput)
								print '</tr>';
						} else if ($data [$j]->trips [$k]->status == STATUS_STOPPED){
							$backgroundColor = "white";
							print '
	 						
	 						<tr> <td style="background-color:red;font-weight:bold; font-size:13px; font-variant:small-caps;color:white;">' . $MYLANGUAGE->getString ( 'STOPPED' ) . '</td></tr>
	 						
	 						<tr style="background-color:' . $backgroundColor . '">
	 						
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'STOP_OVER' ) . ':</td><td width="320" colspan="3">' . $eplace . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'FTIME' ) . ':</td><td width="320">' . $sdate . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'TTIME' ) . ':</td><td width="320"> ' . $edate . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DURATION' ) . ':</td><td width="320">' . $dstring . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DRIVER' ) . ':</td><td width="320">' . $driver . '</td>
	 						</tr>
	 						';
						}else if ($data [$j]->trips [$k]->status == STATUS_IDLE)
						{
							$backgroundColor = "white";
							print '<tr> <td style="background-color:#e2ba00;font-weight:bold; font-size:13px; font-variant:small-caps;color:white;">' . $MYLANGUAGE->getString ( 'IDLING' ) . '</td></tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'STOP_OVER' ) . ':</td><td width="320" colspan="3">' . $eplace . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'FTIME' ) . ':</td><td width="320">' . $sdate . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'TTIME' ) . ':</td><td width="320"> ' . $edate . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DURATION' ) . ':</td><td width="320">' . $dstring . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DRIVER' ) . ':</td><td width="320">' . $driver . '</td>
	 						</tr>
	 						';
						} else if ($data [$j]->trips [$k]->status == STATUS_NOGPS) {
							$backgroundColor = "white";
							print '
	 						<tr > <td style="background-color:purple;color:white;font-weight:bold; font-size:13px; font-variant:small-caps">' . $MYLANGUAGE->getString ( 'INVALID_GPS' ) . '</td></tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'LOC' ) . ':</td><td width="320" colspan="3">' . $eplace . '</td>
	 						</tr>
	 								
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'FTIME' ) . ':</td><td width="320">' . $sdate . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'TTIME' ) . ':</td><td width="320"> ' . $edate . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DURATION' ) . ':</td><td width="320">' . $dstring . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DRIVER' ) . ':</td><td width="320">' . $driver . '</td>
	 						</tr>
	 						';
						}
													print '</table>';
						
						$oldRecord = $data [$j]->trips [$k];
					}
				}
			} // for J
			print "</table>";
		} // for I
		

		print "<br/>";

        print '<table width="100%" cellspacing="3" cellpadding="3" bordercolor="#cccccc" border="1" frame="vsides" rules="rows"  class="subHeading" style="margin-top:10px;margin-bottom:10px; border: 1px dotted #aaaaaa; font-size:11px;background-color:#F2F2F2">';
        $tempcount1 = 0;
        foreach ($tidArr as $t1) {
            print '<tr style="background-color:peru;color:white;font-weight:bold; font-size:13px;"> <td >'.$tidArr[$tempcount1].'</td><td>&nbsp;</td></tr>';

            //foreach ($t->dates as $k=>$v){
            print "<tr><td>"."Move Count "."</td>"."<td>".$totalMovingCount[$tempcount1]."</td></tr>";
            print "<tr><td>"."Total Moving Time "."</td>"."<td>".reportUtils::getDurationText ( $totalMovingDuration[$tempcount1], $MYLANGUAGE )."</td></tr>";
            //}
            print '<tr style="background-color:white;color:white;font-weight:bold; font-size:13px;"> <td >&nbsp;</td><td>&nbsp;</td></tr>';
            $tempcount1++;
        }

        print "</table>";


		$contents = ob_get_contents ();
		ob_end_clean ();
		$this->pdf->WriteHTML ( $contents );
		$this->pdf->Output ();
	}
}
class TRIP_Output_HTML {
	public static $txtDirection;
	public static $revDirection;
	public static $direction;

	
	public static function printHeader() {
		global $MYLANGUAGE, $languageMatrix;
		
		if (isset($languageMatrix[$_SESSION['language']]) == false) {
			self::$direction = $direction = "ltr";
		}
		else {
			self::$direction = $direction = $languageMatrix[$_SESSION['language']]->direction;
		}
		
		switch($direction)
		{
			case "ltr":
				self::$txtDirection = "left";
				self::$revDirection = "right";
				break;
			case "rtl":
				self::$txtDirection = "right";
				self::$revDirection = "left";
				break;
		}

		print '
				<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>' . $MYLANGUAGE->getString ( 'TRIP' ) . '</title>
				<style>'. file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:'.$direction.';} </style>
				</head>
				<body class="mainbody" style="background-color:#999; background-image:none">
			    <div id="reportframe">
			    <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
			  ';
	}
		public static function printHTML($arrDis) {
		ob_start ();
		
		$summary = array ();
		
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		global $GDATABASE, $MYLANGUAGE;
		
		$answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
		
		TRIP_Output_HTML::printHeader ();
		$left = self::$txtDirection;
		$right = self::$revDirection;
		
		$aCount = count ( $arrDis [0] ['result'] );
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
		$sdate = $fdate->getFormattedString ();
		
		$fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
		$edate = $fdate->getFormattedString ();
		
		print '<table width="100%" class="topBottom10pxPadding"><tr><td>' . $MYLANGUAGE->getString ( 'TRIP' ) . '</td><td align="'.$right.'"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';
		
		print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
		<tr>
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
			
			<td width="120px"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
			<td style="font-weight:bold"><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
		</tr>
		
		<tr>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $sdate . '</div></td>
			<td ><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
			<td style="font-weight:bold"><div class="tableHeading">' . $edate . '</div></td>
		</tr>
		</table>';
		
		$tCount = count ( $arrDis );

		$totalMovingCount = [];
		$totalMovingDuration = [];
		$tidArr = [];
		
		for($i = 0; $i < $tCount; $i ++) {
			
			$apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
			
			array_push($tidArr,$arrDis [$i] ['tinfo'] [0] ['name']);
			array_push($totalMovingCount,0);
			array_push($totalMovingDuration,0);


			// $tidArr[i] = $arrDis [$i] ['tinfo'] [0] ['name'];
			// $totalMovingCount[i] = 0;
			// $totalMovingDuration[i] = 0;

			print '<br><table width="100%" class ="topBottom10pxPadding">
			<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'APPLICATION' ) . ':</td><td class="subHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
			</tr>';
			
			if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
			</tr>';
			} else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
				print '<tr style="background-color:#DDDDDD">
			<td class="subHeading" style="font-weight:bold" width="100px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td><td class="subHeading" width="250px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
			<td class="subHeading" style="font-weight:bold" width="130px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td><td class="subHeading">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
			</tr>';
			}
			
			print "</table>";
			
			$ecount = count ( $arrDis [$i] ['result'] );
			
			$data = $arrDis [$i] ['result'];
			$initialized = false;
			


			for($j = 0; $j < $ecount - 1; $j ++) {
				
				$tripsCount = count ( $data [$j]->trips );
				
				if ($tripsCount > 0) {
					
					$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
					$sdate = $fdate->getFormattedString ();
					
					$fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
					$edate = $fdate->getFormattedString ();
					print '<div class="subHeading" style="padding-left:3px; padding-top:3px; padding-bottom:3px; margin-top:5px; margin-bottom:5px; background-color:#444444;font-weight:bold; width:100%;color:white; " >' . $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate . "</div>";
					
					for($k = 0; $k < $tripsCount; $k ++) {
						if ($initialized == false) {
							$oldRecord = $data [$j]->trips [$k];
							$initialized = true;
							continue;
						}
						
						$fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
						$sdate = $fdate->getFormattedString ();
						$splace = $oldRecord->place ['location'];
						
						$fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
						$edate = $fdate->getFormattedString ();
						$eplace = $data [$j]->trips [$k]->place ['location'];
						
						if ($data [$j]->trips [$k]->duration > 0 ) $dur = $data [$j]->trips [$k]->duration;
						else $dur = 1;
						
						$dstring = reportUtils::getDurationText ( $dur, $MYLANGUAGE );
						$driver = $data [$j]->trips [$k]->driver;
						if ($driver == false)
							$driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
						
						$ttemp = array ();
						
						if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
							for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
								if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
									$n = new emptyClass ();
									$n->index = $tp;
									$n->dString = $MYLANGUAGE->getString ( 'MAX' ) . " " . $data [$j]->trips [$k]->maxTemp [$tp] . "°C / " . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "°F | " . $MYLANGUAGE->getString ( 'MIN' ) . " " . $data [$j]->trips [$k]->minTemp [$tp] . "°C / " . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "°F";
									array_push ( $ttemp, $n );
								}
							}
						}
						
						print '<table width="100%" cellspacing="3" cellpadding="3" bordercolor="#cccccc" border="1" frame="vsides" rules="rows"  class="subHeading" style="margin-top:10px;margin-bottom:10px; border: 1px dotted #aaaaaa; font-size:11px;background-color:#F2F2F2">';
						
						if ($data [$j]->trips [$k]->status == STATUS_MOVING) {
							$backgroundColor = "white";
							

							$totalMovingCount[$i] = $totalMovingCount[$i]+1;
							$totalMovingDuration[$i] = $totalMovingDuration[$i]+$dur;

							print '
	 						<tr style="background-color:#1e8000;color:white; font-weight:bold; font-size:13px; font-variant:small-caps;"> <td>' . $MYLANGUAGE->getString ( 'MOVING' ) . '</td></tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold">' . $MYLANGUAGE->getString ( 'START_FROM' ) . ':</td><td>' . $splace . '</td>
	 						<td style="font-weight:bold">' . $MYLANGUAGE->getString ( 'REACHED' ) . ':</td><td>' . $eplace . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'START_AT' ) . ':</td><td width="320">' . $sdate . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'REACH_TIME' ) . ':</td><td width="320">' . $edate . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DURATION' ) . ':</td><td width="320">' . $dstring . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DRIVER' ) . ':</td><td width="320">' . $driver . '</td>
	 						</tr>

	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'START_ODO' ) . ':</td><td width="320">' . sprintf("%0.2f", $data [$j]->trips [$k]->startOdo) . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'END_ODO' ) . ':</td><td width="320">' . sprintf("%0.2f",$data [$j]->trips [$k]->endOdo) . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . ':</td><td width="320">' . sprintf ( "%0.2f ", $data [$j]->trips [$k]->distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'MAX_SPEED' ) . ':</td><td width="320">' . sprintf ( "%0.1f ", $data [$j]->trips [$k]->maxSpeed ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . '</td>
	 						</tr>';
							
							$toutput = false;
							for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
								if (($tp % 2) == 0) {
									if ($tp != 0)
										print '</tr>';
									print '<tr style="background-color:' . $backgroundColor . '">';
									$toutput = true;
								}
								print '<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'TEMPERATURE' ) . ' ' . ($ttemp [$tp]->index + 1) . ':</td><td width="320">' . $ttemp [$tp]->dString . '</td>';
							}
							
							if ($toutput)
								print '</tr>';
						} else if ($data [$j]->trips [$k]->status == STATUS_STOPPED) {
							$backgroundColor = "white";
							print '
	 						
	 						<tr style="background-color:red;color:white;font-weight:bold; font-size:13px; font-variant:small-caps"> <td >' . $MYLANGUAGE->getString ( 'STOPPED' ) . '</td></tr>
	 						
	 						<tr style="background-color:' . $backgroundColor . '">
	 						
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'STOP_OVER' ) . ':</td><td width="320" colspan="3">' . $eplace . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'FTIME' ) . ':</td><td width="320">' . $sdate . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'TTIME' ) . ':</td><td width="320"> ' . $edate . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DURATION' ) . ':</td><td width="320">' . $dstring . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DRIVER' ) . ':</td><td width="320">' . $driver . '</td>
	 						</tr>
	 						';
						} else if ($data [$j]->trips [$k]->status == STATUS_IDLE) {
							$backgroundColor = "white";
							print '
	 						
	 						<tr style="background-color:#e2ba00;color:white;font-weight:bold; font-size:13px; font-variant:small-caps"> <td >' . $MYLANGUAGE->getString ( 'IDLING' ) . '</td></tr>
	 						
	 						<tr style="background-color:' . $backgroundColor . '">
	 						
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'STOP_OVER' ) . ':</td><td width="320" colspan="3">' . $eplace . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'FTIME' ) . ':</td><td width="320">' . $sdate . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'TTIME' ) . ':</td><td width="320"> ' . $edate . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DURATION' ) . ':</td><td width="320">' . $dstring . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DRIVER' ) . ':</td><td width="320">' . $driver . '</td>
	 						</tr>
	 						';
						} else if ($data [$j]->trips [$k]->status == STATUS_NOGPS) {
							$backgroundColor = "white";
							print '
	 						
	 						<tr style="background-color:purple;color:white;font-weight:bold; font-size:13px; font-variant:small-caps"> <td >' . $MYLANGUAGE->getString ( 'GPS_INVALID' ) . '</td></tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'LOCATION' ) . ':</td><td width="320" colspan="3">' . $eplace . '</td>
	 						</tr>
	 								
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'FTIME' ) . ':</td><td width="320">' . $sdate . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'TTIME' ) . ':</td><td width="320"> ' . $edate . '</td>
	 						</tr>
	 						<tr style="background-color:' . $backgroundColor . '">
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DURATION' ) . ':</td><td width="320">' . $dstring . '</td>
	 						<td style="font-weight:bold" width="100">' . $MYLANGUAGE->getString ( 'DRIVER' ) . ':</td><td width="320">' . $driver . '</td>
	 						</tr>
	 						';
						}
													
						print '</table>';
						
						$oldRecord = $data [$j]->trips [$k];
					}
				}
			} // for J
			print "</table>";
		} // for I
		


		print "<br/>";

        print '<table width="100%" cellspacing="3" cellpadding="3" bordercolor="#cccccc" border="1" frame="vsides" rules="rows"  class="subHeading" style="margin-top:10px;margin-bottom:10px; border: 1px dotted #aaaaaa; font-size:11px;background-color:#F2F2F2">';
        $tempcount1 = 0;
        foreach ($tidArr as $t1) {
            print '<tr style="background-color:peru;color:white;font-weight:bold; font-size:13px;"> <td >'.$tidArr[$tempcount1].'</td><td>&nbsp;</td></tr>';

            //foreach ($t->dates as $k=>$v){
            print "<tr><td>"."Move Count "."</td>"."<td>".$totalMovingCount[$tempcount1]."</td></tr>";
            print "<tr><td>"."Total Moving Time "."</td>"."<td>".reportUtils::getDurationText ( $totalMovingDuration[$tempcount1], $MYLANGUAGE )."</td></tr>";
            //}
            print '<tr style="background-color:white;color:white;font-weight:bold; font-size:13px;"> <td >&nbsp;</td><td>&nbsp;</td></tr>';
            $tempcount1++;
        }

        print "</table>";



		TRIP_Output_HTML::printFooter ();
		
		$contents = ob_get_contents ();
		ob_end_clean ();
		
		print $contents;
	}
	public static function printFooter() {
		print '
		<br/>
		<div style="width:100%; border:1px black solid; background-color:#404040; height:10px" />
		</div>
		</body></html>';
	}
}


class TRIP_FNSv3_Report {
	private $mConverter;
	private $rDatabase;

	
	private function getStatus($data) {
		if ($data['latitude'] == NULL) return STATUS_NOGPS;
		
		if ($data['speed'] > 0 && strpos ( $data['IO'], "j" ) !== false)
			$currentStatus = STATUS_MOVING;
		else if (strpos ( $data['IO'], "j" ) !== false)
			$currentStatus = STATUS_IDLE;
		else
			$currentStatus = STATUS_STOPPED;
		
		return $currentStatus;
	}
	
	private function computeTrips($tid) {
		global $GDATABASE;
		
		if (isset($_GET['SOTV']) && $_GET['SOTV'] > 0) $TRIPS_STOP_BREAKING_TIME = $_GET['SOTV'];
		else $TRIPS_STOP_BREAKING_TIME = TRIPS_STOP_BREAKING_TIME; 

		if (isset($_GET['IDTV']) && $_GET['IDTV'] > 0) $TRIPS_IDLE_BREAKING_TIME = $_GET['IDTV'];
		else $TRIPS_IDLE_BREAKING_TIME = TRIPS_IDLE_BREAKING_TIME;
		
		$trips = array ();
		$fdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		// Starting state of this automata will be TRIP_START
		$currentState = TRIP_START;
		
		$data = true;
		$distance = 0;
		
		$tprofiles = $GDATABASE->getTrackerTemperatureProfiles ( $tid );
		$card = $GDATABASE->getTrackerCard ( $tid );
		
		$computeTemperature = false;
		$tpr = array ();
		
		for($v = 0; $v < count ( $tprofiles ); $v ++) {
			if ($tprofiles [$v] !== false) {
				$computeTemperature = true;
			}
		}
		
		$exit = false;
		$oldData = false;
		
		while ( $exit == false ) {
			$data = $this->rDatabase->reports_nextLocation ();
			
			//print "<br/>\r\n".$data['pdatetime']."\t|\t".$data['date']."\t|\t".$data['time']."\t|\t".$data['latitude'].",".$data['longitude']."\t|\t".$data['speed']."\t|\t".$data['IO'];
			
			switch ($currentState) {
				
				case TRIP_START :
					
					if ($data == false) {
						$exit = true;
						break;
					}
					
					//Skip the NO GPS State in the beginning of the data block
					$checkState = $this->getStatus ( $data );
					if ($checkState == STATUS_NOGPS) break;
					
					// move the state into its determined state
					$currentState = $checkState; 
					
					$fdate->setUTCDate ( $data ['date'], $data ['time'] );
					$stateTransTime = $fdate->dateTime->getTimestamp ();
					
					$lastLatitude = $data ['latitude'];
					$lastLongitude = $data ['longitude'];
					$maxSpeed = $data ['speed'];
					
					$maxTemp = array ();
					$minTemp = array ();
					
					if ($computeTemperature == true) {
						for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
							$minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
						}
					}
					
					$n = new tripRObject ();
					$n->status = TRIP_START;
					$n->distance = $distance;
					$n->maxSpeed = $maxSpeed;
					$n->latitude = $data ['latitude'];
					$n->longitude = $data ['longitude'];
					$n->duration = 0;
					$n->date = $data ['date'];
					$n->time = $data ['time'];
					$n->maxTemp = $maxTemp;
					$n->minTemp = $minTemp;
					array_push($trips,$n);
					break;
				
				case STATUS_MOVING :
					if ($data != false) {
						$newState = $this->getStatus ( $data );
					}
					
					if ($newState != STATUS_MOVING || $data == false) {
						
						if ($data == false) {
							$exit = true;
							$data = $oldData;
						}
						
						if ($newState == STATUS_NOGPS) {
							$data = $oldData;
						}
						
						$fdate->setUTCDate ( $data ['date'], $data ['time'] );

                        // $distance += reportUtils::getDistance ( $data ['latitude'], $data ['longitude'], $lastLatitude, $lastLongitude );

                        // if ($data ['speed'] > $maxSpeed)
                        //     $maxSpeed = $data ['speed'];
						
						// if last state was movement only - means last state
						// was skipped due to trip time
						// in this case add to the previous packet otherwise
						// emit new packet
						$lastTripIndex = count ( $trips ) - 1;
						if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == STATUS_MOVING) {
							$trips [$lastTripIndex]->date = $data ['date'];
							$trips [$lastTripIndex]->time = $data ['time'];
							$trips [$lastTripIndex]->latitude = $data ['latitude'];
							$trips [$lastTripIndex]->longitude = $data ['longitude'];
							$trips [$lastTripIndex]->distance = $distance;
							$trips [$lastTripIndex]->maxSpeed = $maxSpeed;
							$trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
						} else {
							$n = new tripRObject ();
							$n->status = $currentState;
							$n->distance = $distance;
							$n->maxSpeed = $maxSpeed;
							$n->latitude = $data ['latitude'];
							$n->longitude = $data ['longitude'];
							$n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
							$n->date = $data ['date'];
							$n->time = $data ['time'];
							$n->maxTemp = $maxTemp;
							$n->minTemp = $minTemp;
							array_push ( $trips, $n );
							
							$maxTemp = array ();
							$minTemp = array ();
						}
						
						$currentState = $newState;
						// Set State transition time
						$stateTransTime = $fdate->dateTime->getTimestamp ();
					}
					
					$distance += reportUtils::getDistance ( $data ['latitude'], $data ['longitude'], $lastLatitude, $lastLongitude );
					
					if ($computeTemperature == true) {
						for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
							
							$ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
							
							if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
								$maxTemp [$tp] = $ctemp;
							else
								$maxTemp [$tp] = $ctemp;
							
							if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
								$minTemp [$tp] = $ctemp;
							else
								$minTemp [$tp] = $ctemp;
						}
					}
					
					if ($data ['speed'] > $maxSpeed)
						$maxSpeed = $data ['speed'];
					
					$lastLatitude = $data ['latitude'];
					$lastLongitude = $data ['longitude'];
					
					break;
				
				case STATUS_NOGPS:
					if ($data != false) {
						$newState = $this->getStatus ( $data );
					}else {
						$exit = true;
						$data = $oldData;
					}
					
					if ($newState != $currentState || $data == false) {
						
						$fdate->setUTCDate ( $data ['date'], $data ['time'] );
						$cTime = $fdate->dateTime->getTimestamp ();
						
						$n = new tripRObject ();
						$n->status = $currentState;
						$n->latitude = $lastLatitude;
						$n->longitude = $lastLongitude;
						$n->duration = $cTime - $stateTransTime;
						$n->date = $data['date'];
						$n->time = $data['time'];
						array_push ( $trips, $n );
						$stateTransTime = $cTime;

						$currentState = $newState;
					}
					break;
					
				case STATUS_STOPPED :
				// Both STOPPED and IDLE follow the same logic and correspondingly emits out correct records
				
				case STATUS_IDLE :
					if ($data != false) {
						$newState = $this->getStatus ( $data );
						
						$fdate->setUTCDate ( $data ['date'], $data ['time'] );
						$cTime = $fdate->dateTime->getTimestamp ();
						
						if ($computeTemperature == true) {
							for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
								
								$ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
								
								if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
									$maxTemp [$tp] = $ctemp;
								else
									$maxTemp [$tp] = $ctemp;
								
								if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
									$minTemp [$tp] = $ctemp;
								else
									$minTemp [$tp] = $ctemp;
							}
						}
						
						// If the time difference is greater then trips breaking
						// time then emit out
						if ($newState == STATUS_NOGPS){
							$emitOut = true;
							$data = $oldData;
						}else if ($currentState == STATUS_STOPPED) {
							
							if (($cTime - $stateTransTime) > ($TRIPS_STOP_BREAKING_TIME * 60))
								$emitOut = true;
							else
								$emitOut = false;
							
						} else {
							if (($cTime - $stateTransTime) > ($TRIPS_IDLE_BREAKING_TIME * 60))
								$emitOut = true;
							else
								$emitOut = false;
						}
						
					}
					
					if ($newState != $currentState || $data == false) {
						// Emit Packet and Set new state
						if ($emitOut || $data == false) {

							if ($data == false) {
								$exit = true;
								$data = $oldData;
								if ($emitOut == false) break;
							}
							
							$fdate->setUTCDate ( $data ['date'], $data ['time'] );
							$lastTripIndex = count ( $trips ) - 1;
							if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == $currentState) {
								$trips [$lastTripIndex]->date = $data ['date'];
								$trips [$lastTripIndex]->time = $data ['time'];
								$trips [$lastTripIndex]->latitude = $data ['latitude'];
								$trips [$lastTripIndex]->longitude = $data ['longitude'];
								$trips [$lastTripIndex]->distance = 0;
								$trips [$lastTripIndex]->maxSpeed = 0;
								$trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
							} else {	
								$n = new tripRObject ();
								$n->status = $currentState;
								$n->latitude = $lastLatitude; // $data['latitude'];
								$n->longitude = $lastLongitude; // $data['longitude'];
								$n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
								$n->date = $data ['date'];
								$n->time = $data ['time'];
								array_push ( $trips, $n );
							}
							
							$stateTransTime = $fdate->dateTime->getTimestamp ();
							$distance = 0;
							if ($emitOut == true) {
                                //$distance = 0;
                            }

							$lastLatitude = $data ['latitude'];
							$lastLongitude = $data ['longitude'];

							$maxSpeed = $data ['speed'];
							
							
							if ($computeTemperature == true) {
								$minTemp = array ();
								$maxTemp = array ();
								
								for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
									$minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
								}
							}
						}
						$currentState = $newState;
					}
					break;
			}       //switch
			$oldData = $data;
		}		//while

		return $trips;
	}
		
	private function computeParameters($tid, $dateArray, $days) {
		$geo = new GEOCODER ();
		$ignition = $this->rDatabase->detectIgnition ( $tid );
		
		if (isset($_GET['NGPS_C']) && $_GET['NGPS_C'] == 1 )
		{
			$this->rDatabase->reports_getLocationDataWithInvalidGPS( $tid, $dateArray);
		}else {
			$this->rDatabase->reports_getLocationsData ( $tid, $dateArray);
		}

		$tripsArray = $this->computeTrips ( $tid );

		$daysCount = count ( $days );
		
		$sdate = new FNSDateTime ( $_SESSION ['timezone'] );
		$edate = new FNSDateTime ( $_SESSION ['timezone'] );
		$pdate = new FNSDateTime ( $_SESSION ['timezone'] );
		
		$tripsCount = count ( $tripsArray );
		$y = 0;
		
		$Odometer = new FNSOdometer($tid, $_SESSION['timezone']);
		
		for($x = 0; $x < $daysCount - 1; $x ++) {
			$sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
			$edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
			
			$darray = array ();
			
			for(; $y < $tripsCount; $y++) {
				$pdate->setUTCDate ( $tripsArray [$y]->date, $tripsArray [$y]->time );

				if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
					if ($ignition == false) {
						if ($tripsArray [$y]->status == STATUS_IDLE)
							$tripsArray [$y]->status = STATUS_STOPPED;
					}
					
					$tripsArray[$y]->odometer = $Odometer->getValue($tripsArray[$y]->date, $tripsArray[$y]->time);
						
					if ($y > 0) {
						$tripsArray[$y]->startOdo = $this->mConverter->convert ( ($tripsArray[$y-1]->odometer / 1000.0) * 0.621371 ,'D');
						$tripsArray[$y]->endOdo = $this->mConverter->convert ( ($tripsArray[$y]->odometer / 1000.0) * 0.621371 ,'D');
						$tripsArray [$y]->driver = $this->rDatabase->getDriverName ( $tid, $tripsArray [$y]->date, $tripsArray [$y]->time );
					}
					
					$tripsArray [$y]->distance = $this->mConverter->convert ( $tripsArray [$y]->distance * 0.621371,'D' );
					$tripsArray [$y]->maxSpeed = $this->mConverter->convert ( $tripsArray [$y]->maxSpeed ,'S');
					
					if (isset($_GET['doGeocode']) && $_GET['doGeocode'] == 1)
						$tripsArray [$y]->place = $geo->search ( $tripsArray [$y]->latitude, $tripsArray [$y]->longitude, true );
					else 
						$tripsArray [$y]->place = array('location'=>$tripsArray[$y]->latitude." | ".$tripsArray[$y]->longitude);
					array_push ( $darray, $tripsArray [$y] );
				} else{
					break;
				}
			} // for dcount
			
			$dc = count ( $darray );
			if ($dc > 0) {
				$days [$x]->trips = $darray;
			}
		} // for daysCount
		if (isset($_GET['debug']) && $_GET['debug'] == 1) print_r($tripsArray);
		
        //print_r($tripsArray);
		return $days;
	}
	private function getTrackersList() {
		global $GDATABASE;
		$trackers = $GDATABASE->getTrackersList ( "trackerid" );
		$a = array ();
		$tcount = count ( $trackers );
		for($i = 0; $i < $tcount; $i ++) {
			array_push ( $a, $trackers [$i] ['trackerid'] );
		}
		return $a;
	}
	private function getReportData() {
		global $GDATABASE;
		$arrdate = reportUtils::getUTCReportTime ( $_GET );
		
		if ($_GET ['ftype'] == "E") {
			$trackers = $this->getTrackersList ();
		} else if ($_GET ['ftype'] == "S") {
			$trackers = explode ( ",", $_GET ['trackers'] );
		}
		
		$tcount = count ( $trackers );
		
		$display_array = array ();
		
		for($i = 0; $i < $tcount; $i ++) {
			$days = reportUtils::getDays ( $arrdate, $_SESSION ['timezone'] );
			$result = $this->computeParameters ( $trackers [$i], $arrdate, $days );
			
			$arr = array ();
			
			$arr ['tinfo'] = $GDATABASE->getTrackerCard ( $trackers [$i] );
			$arr ['details'] = $GDATABASE->rp_getTrackersDetails ( $trackers [$i] );
			$arr ['result'] = $result;
			
			array_push ( $display_array, $arr );
		}
		//print_r($display_array);
		switch ($_GET ['format']) {
			case "HTML" :
				TRIP_Output_HTML::printHTML ( $display_array );
				break;
			case "PDF" :
				$pdf = new TRIP_Output_PDF ();
				$pdf->printPDF ( $display_array );
				break;
			case "XLSX" :
				TRIP_Output_XLSX::printXLSX ( $display_array );
				break;
		}
	}
	public function execute() {
		global $MYLANGUAGE;
		$MYLANGUAGE = new FNSLanguage ();
		
		$this->mConverter = new metricConverter ();
		$this->mConverter->setMetrics ( $_GET ['metric'] );
		$this->rDatabase = new reportingQueries ();
		
		$this->getReportData ();
	}
}
?>

