<?php

// ini_set('display_errors', 1);
// ini_set('display_startup_errors', 1);
// error_reporting(E_ALL);

/**
 * @version: 5.1
 */

require_once (REPORTS_FOLDER . "/reportUtils.php");
require_once (DATABASE_FOLDER . "/reportingQueries.php");
require_once (GEOCODER_FOLDER . '/geo.php');
require_once (mPDF_FOLDER . "/mpdf.php");
require_once (PHPExcelPath . '/Classes/PHPExcel.php');
class VEHICLEACTIVITYREPORT_Output_XLSX {
    public static function printXLSX($arrDis) {
        
        $rDatabase = new reportingQueries();
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        global $GDATABASE, $MYLANGUAGE;
        
        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
        
        $aCount = count ( $arrDis [0] ['result'] );
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();
        
        $objPHPExcel = new PHPExcel ();
        $sheetProperties = $objPHPExcel->getProperties ();
        $sheetProperties->setCreator ( "Find'n'Secure" );
        $sheetProperties->setTitle ('Vehicle Activity Report');
        $sheetProperties->setDescription ('Vehicle Activity Report');
        
        $myWorkSheet = new PHPExcel_Worksheet ( $objPHPExcel, 'Report' );
        $objPHPExcel->addSheet ( $myWorkSheet, 0 );
        $objPHPExcel->setActiveSheetIndex ( 0 );
        
        // set font-family and size
        $objPHPExcel->getDefaultStyle ()->getFont ()->setName ( 'Arial' );
        $objPHPExcel->getDefaultStyle ()->getFont ()->setSize ( 10 );
        
        // set default column widths
        for($i = 'A'; $i <= 'T'; $i ++) {
            $myWorkSheet->getColumnDimension ( $i )->setAutoSize ( true );
        }
        
        // set margins
        $myWorkSheet->getPageMargins ()->setRight ( 0.125 );
        $myWorkSheet->getPageMargins ()->setLeft ( 0.125 );
        
        // set page orientation
        $myWorkSheet->getPageSetup ()->setPaperSize ( PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4 );
        $myWorkSheet->getPageSetup ()->setFitToWidth ( 1 );
        $myWorkSheet->getPageSetup ()->setFitToHeight ( 0 );
        
        // set rtl
        // $myWorkSheet->setRightToLeft(true);
        
        $row = 2;
        
        // report heading
        $myWorkSheet->SetCellValue ( "A$row", 'Vehicle Activity Report' );
        $myWorkSheet->mergeCells ( "A$row:C" . ($row + 4) );
        $headingStyle = array (
                'font' => array (
                        'bold' => true,
                        'size' => 16 
                ),
                'alignment' => array (
                        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                        'vertical' => PHPExcel_Style_Alignment::VERTICAL_TOP 
                ) 
        );
        $myWorkSheet->getStyle ( "A$row" )->applyFromArray ( $headingStyle );
        $myWorkSheet->getStyle ( "A$row" )->getAlignment ()->setWrapText ( true );
        
        // company logo
        $logo = new PHPExcel_Worksheet_Drawing ();
        $logo->setPath ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' );
        $logo->setWorksheet ( $myWorkSheet );
        $logo->setCoordinates ( 'D' . $row );
        $myWorkSheet->mergeCells ( "D$row:F" . ($row + 4) );
        $logo->setOffsetX ( 50 );
        
        $row = 9;
        
        // company details
        $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'COMPANY_NAME' ) );
        $myWorkSheet->SetCellValue ( 'B' . $row, $answer [0] ['company'] );
        $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'USERNAME' ) );
        $myWorkSheet->SetCellValue ( 'E' . $row, $answer [0] ['username'] );
        $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
        $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
        
        $row ++;
        
        $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'START_DATE' ) );
        $myWorkSheet->SetCellValue ( 'B' . $row, $sdate );
        $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'END_DATE' ) );
        $myWorkSheet->SetCellValue ( 'E' . $row, $edate );
        $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
        $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
        
        $row += 2;
        
        $detailsStyle = array (
                'borders' => array (
                        'inside' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FFFFFFFF' 
                                ) 
                        ) 
                ),
                
                'fill' => array (
                        'type' => PHPExcel_Style_Fill::FILL_SOLID,
                        'startcolor' => array (
                                'argb' => 'FFDDDDDD' 
                        ) 
                ) 
        );
        
        $rowHeadStyle = array (
                'font' => array (
                        'bold' => true,
                        'size' => 9 
                ),
                
                'borders' => array (
                        'bottom' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FF000000' 
                                ) 
                        ),
                        'top' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FF000000' 
                                ) 
                        ) 
                ),
                
                'fill' => array (
                        'type' => PHPExcel_Style_Fill::FILL_SOLID,
                        'startcolor' => array (
                                'argb' => 'FFDDDDDD' 
                        ) 
                ) 
        );
        
        $subHeadStyle = array (
                'font' => array (
                        'bold' => true,
                        'size' => 9 
                ),
                
                'borders' => array (
                        'bottom' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FFcccccc' 
                                ) 
                        ),
                        'top' => array (
                                'style' => PHPExcel_Style_Border::BORDER_THIN,
                                'color' => array (
                                        'argb' => 'FFcccccc' 
                                ) 
                        ) 
                ),
                
                'fill' => array (
                        'type' => PHPExcel_Style_Fill::FILL_SOLID,
                        'startcolor' => array (
                                'argb' => 'FFF2F2F2' 
                        ) 
                ) 
        );
        
        $tCount = count ( $arrDis );
        
        for($i = 0; $i < $tCount; $i ++) {
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
            
            $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'TRACKER_NAME' ) );
            $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['tinfo'] [0] ['name'] );
            $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'APPLICATION' ) );
            $myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( $apptype ) );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':T' . $row );
            $myWorkSheet->getStyle ( "A$row:T$row" )->applyFromArray ( $detailsStyle );
            $myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
            $myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
            
            $row ++;
            
            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'LICENSEPLATE' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['licensePlate'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'VTYPE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['vtype'] );
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'REFNO' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['arefno'] );
            } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PNAME' ) );
                $myWorkSheet->SetCellValue ( 'B' . $row, $arrDis [$i] ['details'] [0] ['pname'] );
                $myWorkSheet->SetCellValue ( 'D' . $row, $MYLANGUAGE->getString ( 'MOBILE' ) );
                $myWorkSheet->SetCellValue ( 'E' . $row, $arrDis [$i] ['details'] [0] ['pmobile'] );
            }
            
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':T' . $row );
            $myWorkSheet->getStyle ( "A$row:F$row" )->applyFromArray ( $detailsStyle );
            $myWorkSheet->getStyle ( 'A' . $row )->getFont ()->setBold ( true );
            $myWorkSheet->getStyle ( 'D' . $row )->getFont ()->setBold ( true );
            
            $row += 3;
            
            $ecount = count ( $arrDis [$i] ['result'] );
            
            $data = $arrDis [$i] ['result'];
            $initialized = false;


            /*Summaery for header*/


            $top_row_index = 0;
            $totel_no_stop = 0;
            $totel_no_idle= 0;

            $avg_speed_array = array();
            $avg_stop_speed_array = array();

            for($x = 0; $x < $ecount - 1; $x ++) {
                
                $tripsCount = count ( $data [$x]->trips );
                
                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$x]->date, $arrDis [$i] ['result'] [$x]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$x + 1]->date, $arrDis [$i] ['result'] [$x + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    //print '<div class="subHeading" style="padding-left:3px; padding-top:3px; padding-bottom:3px; margin-top:5px; margin-bottom:5px; background-color:#444444;font-weight:bold; width:100%;color:white; " >' . $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate . "</div>";
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_stoppage_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    
                    
                    
                    for($y = 0; $y < $tripsCount; $y ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$x]->trips [$y];
                            $initialized = true;
                            continue;
                        }
                        
                        if ($data [$x]->trips [$y]->status == STATUS_MOVING) {
                            
                            $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                            $sdate = $fdate->getFormattedString ();
                            $splace = $oldRecord->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $oldRecord->latitude . "," . $oldRecord->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $start_odometer = $oldRecord->odometer;
                            
                            $fdate->setUTCDate ( $data [$x]->trips [$y]->date, $data [$x]->trips [$y]->time );
                            $edate = $fdate->getFormattedString ();
                            $eplace = $data [$x]->trips [$y]->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $data [$x]->trips [$y]->latitude . "," . $data [$x]->trips [$y]->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $end_odometer = $data [$x]->trips [$y]->odometer;
                            
                            $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$x]->trips [$y]->date, $data [$x]->trips [$y]->time );
                            
                            $user = $_SESSION ['username'];
                            $rec = $GDATABASE->getUserRecord ( $user );
                            $password = $rec [0] ['password'];
                            
                            $hashData = $password . $oldRecord->date . $oldRecord->time . $data [$x]->trips [$y]->date . $data [$x]->trips [$y]->time . $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                            $hash = hash ( "sha256", $hashData );
                            
                            $dstring = reportUtils::getDurationText ( $data [$x]->trips [$y]->duration + $data [$x]->trips [$y]->idletime, $MYLANGUAGE );
                            $idlestring = reportUtils::getDurationText ( $data [$x]->trips [$y]->idletime, $MYLANGUAGE );

                            $stoppagestring = reportUtils::getDurationText ( $data [$x]->trips [$y]->stoppagetime, $MYLANGUAGE );

                            $drivingstring = reportUtils::getDurationText ( $data [$x]->trips [$y]->duration, $MYLANGUAGE );
                            
                            $driver = $data [$x]->trips [$y]->driver;
                            if ($driver == false)
                                $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                            
                            $ttemp = array ();
                            if ($data [$x]->trips [$y]->maxTemp != false && count ( $data [$x]->trips [$y]->maxTemp ) > 0) {
                                for($tp = 0; $tp < count ( $data [$x]->trips [$y]->maxTemp ); $tp ++) {
                                    if ($data [$x]->trips [$y]->maxTemp [$tp] !== null) {
                                        $n = new emptyClass ();
                                        $n->index = $tp;
                                        $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$x]->trips [$y]->maxTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$x]->trips [$y]->maxTemp [$tp] * 1.8 + 32 ) . "°F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$x]->trips [$y]->minTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$x]->trips [$y]->minTemp [$tp] * 1.8 + 32 ) . "°F";
                                        array_push ( $ttemp, $n );
                                    }
                                }
                            }
                            
                            $backgroundColor = "none";
                            
                            $net_duration += ($data [$x]->trips [$y]->duration + $data [$x]->trips [$y]->idletime);
                            $net_idling_duration += $data [$x]->trips [$y]->idletime;

                            $net_stoppage_duration += $data [$x]->trips [$y]->stoppagetime;

                            if($data [$x]->trips [$y]->avgSpeed > 0) {
                                $category = 'RUNNING';

                                $avg_speed_array[] = $data [$x]->trips [$y]->avgSpeed;
                                $avg_stop_speed_array[] = $data [$x]->trips [$y]->avgSpeed;

                            } elseif($data [$x]->trips [$y]->idletime != 0) {
                                $category = 'IDLE';
                                $totel_no_idle ++;
                            } elseif($data [$x]->trips [$y]->stoppagetime != 0) {
                                $category = 'STOP';
                                $totel_no_stop ++;
                                $avg_stop_speed_array[] = $data [$x]->trips [$y]->avgSpeed;
                            } else {
                                $category = 'NA';
                            }
                            
                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString . "<br/>";
                            }
                            
                            $net_distance += $data [$x]->trips [$y]->distance;
                            $net_private += $data [$x]->trips [$y]->pdistance;
                        }
                        $oldRecord = $data [$x]->trips [$y];
                    }
                }
            } // for X


            $average_excluding_stop = $average_including_stop = 0;
            $avg_speed_array = array_filter($avg_speed_array);
            $average_excluding_stop = array_sum($avg_speed_array)/count($avg_speed_array);

            $avg_stop_speed_array = array_filter($avg_stop_speed_array);
            $average_including_stop = array_sum($avg_stop_speed_array)/count($avg_stop_speed_array);


            // company details
            $myWorkSheet->SetCellValue ( 'A' . $row, 'Duration Selected' );
            $myWorkSheet->SetCellValue ( 'B' . $row, reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) );
            $myWorkSheet->SetCellValue ( 'D' . $row, 'Total Stop Duration' );
            $myWorkSheet->SetCellValue ( 'E' . $row, reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ) );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            
            $row ++;

            $myWorkSheet->SetCellValue ( 'A' . $row, 'Total Number Of Stop' );
            $myWorkSheet->SetCellValue ( 'B' . $row, $totel_no_stop );
            $myWorkSheet->SetCellValue ( 'D' . $row, 'Total Idle Duration' );
            $myWorkSheet->SetCellValue ( 'E' . $row, reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            
            $row ++;

            $myWorkSheet->SetCellValue ( 'A' . $row, 'Total Number Of Idle' );
            $myWorkSheet->SetCellValue ( 'B' . $row, $totel_no_idle );
            $myWorkSheet->SetCellValue ( 'D' . $row, 'Average Speed (excluding stops)' );
            $myWorkSheet->SetCellValue ( 'E' . $row, sprintf ( "%0.2f ", $average_excluding_stop ) );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            
            $row ++;

            $myWorkSheet->SetCellValue ( 'A' . $row, 'Average Speed (including stops)' );
            $myWorkSheet->SetCellValue ( 'B' . $row, sprintf ( "%0.2f ", $average_including_stop ) );
            $myWorkSheet->SetCellValue ( 'D' . $row, 'Number Of Overspeed' );
            $myWorkSheet->SetCellValue ( 'E' . $row, 0 );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            
            $row ++;

            $myWorkSheet->SetCellValue ( 'A' . $row, 'Distance Travelled with Overspeed' );
            $myWorkSheet->SetCellValue ( 'B' . $row, sprintf ( "%0.2f ", $average_including_stop ) );
            $myWorkSheet->SetCellValue ( 'D' . $row, 'Travel Time' );
            $myWorkSheet->SetCellValue ( 'E' . $row, reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) );
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            
            $row ++;

            $myWorkSheet->SetCellValue ( 'A' . $row, 'Max Speed' );
            $myWorkSheet->SetCellValue ( 'B' . $row, sprintf ( "%0.2f ", (max($avg_speed_array)) ).' kms/hr' );
            $myWorkSheet->SetCellValue ( 'D' . $row, 'Engine Hours' );
            $myWorkSheet->SetCellValue ( 'E' . $row, reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ));
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            
            $row ++;

            $myWorkSheet->SetCellValue ( 'A' . $row, 'Total Distance Travelled' );
            $myWorkSheet->SetCellValue ( 'B' . $row, sprintf ( "%0.2f ", $net_distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) );
            $myWorkSheet->SetCellValue ( 'D' . $row, 'N/W Los' );
            $myWorkSheet->SetCellValue ( 'E' . $row, '');
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            
            $row ++;

            $myWorkSheet->SetCellValue ( 'A' . $row, 'Fuel Consumed' );
            $myWorkSheet->SetCellValue ( 'B' . $row, '');
            $myWorkSheet->SetCellValue ( 'D' . $row, '' );
            $myWorkSheet->SetCellValue ( 'E' . $row, '');
            $myWorkSheet->mergeCells ( 'B' . $row . ':C' . $row );
            $myWorkSheet->mergeCells ( 'E' . $row . ':F' . $row );
            
            $row ++;


            /*Summaery for header*/


            $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'DATE' ) . ' '.$MYLANGUAGE->getString ( 'TIME' ) );
            $myWorkSheet->SetCellValue ( 'B' . $row, $MYLANGUAGE->getString ( 'LOCATION' ) );
            $myWorkSheet->SetCellValue ( 'C' . $row, $MYLANGUAGE->getString ( 'SPEED' ) );
            $myWorkSheet->SetCellValue ( 'D' . $row, 'Stoppage Time (Hrs.Mins)' );
            $myWorkSheet->SetCellValue ( 'E' . $row, $MYLANGUAGE->getString ( 'IDLE_DUR' ) );
            $myWorkSheet->SetCellValue ( 'F' . $row, $MYLANGUAGE->getString ( 'DURATION' ) );
            $myWorkSheet->SetCellValue ( 'G' . $row, $MYLANGUAGE->getString ( 'DISTANCE' ) );
            $myWorkSheet->SetCellValue ( 'H' . $row, 'Category' );
            $myWorkSheet->SetCellValue ( 'I' . $row, 'Cumulative Odometer' );

            $myWorkSheet->getStyle ( 'A' . $row . ':I' . $row )->applyFromArray ( $subHeadStyle );
            
            $row ++;

            
            for($j = 0; $j < $ecount - 1; $j ++) {
                
                $tripsCount = count ( $data [$j]->trips );
                
                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    
                    // $myWorkSheet->SetCellValue ( 'A' . $row, $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate );
                    // $myWorkSheet->mergeCells ( "A$row:T$row" );
                    // $myWorkSheet->getStyle ( 'A' . $row . ':T' . $row )->applyFromArray ( $rowHeadStyle );
                    //$row += 2;
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    
                    
                    for($k = 0; $k < $tripsCount; $k ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$j]->trips [$k];
                            $initialized = true;
                            continue;
                        }
                        
                        $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                        $sdate = $fdate->getDateStruct ();
                        $splace = $oldRecord->place ['location'];
                        $start_odometer = $oldRecord->odometer;
                        
                        $fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                        $edate = $fdate->getDateStruct ();
                        $eplace = $data [$j]->trips [$k]->place ['location'];
                        $end_odometer = $data [$j]->trips [$k]->odometer;
                        
                        $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                        
                        $dstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                        $idlestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                        $stoppagestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->stoppagetime, $MYLANGUAGE );
                        $drivingstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration, $MYLANGUAGE );

                        $category = 'NA';
                        if($data [$j]->trips [$k]->avgSpeed > 0) {
                            $category = 'RUNNING';
                        } elseif($data [$j]->trips [$k]->idletime != 0) {
                            $category = 'IDLE';
                        } elseif($data [$j]->trips [$k]->stoppagetime != 0) {
                            $category = 'STOP';
                        } else {
                            $category = 'NA';
                        }
                        
                        $driver = $data [$j]->trips [$k]->driver;
                        if ($driver == false)
                            $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                        
                        $ttemp = array ();
                        if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
                            for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
                                if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
                                    $n = new emptyClass ();
                                    $n->index = $tp;
                                    $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$j]->trips [$k]->maxTemp [$tp] . "�C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "�F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$j]->trips [$k]->minTemp [$tp] . "�C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "�F";
                                    array_push ( $ttemp, $n );
                                }
                            }
                        }
                        
                        if ($data [$j]->trips [$k]->status == STATUS_MOVING) {
                            $backgroundColor = "none";
                            
                            $net_duration += $data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime;
                            $net_idling_duration += $data [$j]->trips [$k]->idletime;

                            $net_stoppage_duration += $data [$x]->trips [$y]->stoppagetime;

                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString;
                            }
                            
                            // sdate
                            $myWorkSheet->SetCellValue ( 'A' . $row, PHPExcel_Shared_Date::FormattedPHPToExcel ( $sdate->year, $sdate->month, $sdate->day, $sdate->hour, $sdate->min, $sdate->sec ) );
                            $myWorkSheet->getStyle ( 'A' . $row )->getNumberFormat ()->setFormatCode ( 'dd mmm yyyy hh:mm:ss' );

                            $myWorkSheet->SetCellValue ( 'B' . $row, $eplace );
                            $myWorkSheet->SetCellValue ( 'C' . $row, sprintf ( "%0.1f ", $data [$j]->trips [$k]->avgSpeed ) );
                            $myWorkSheet->SetCellValue ( 'D' . $row, $stoppagestring );
                            $myWorkSheet->SetCellValue ( 'E' . $row, $idlestring );
                            $myWorkSheet->SetCellValue ( 'F' . $row, $dstring );
                            $myWorkSheet->SetCellValue ( 'G' . $row, sprintf ( "%0.2f ", $data [$j]->trips [$k]->distance ) );

                            // origin
                            $myWorkSheet->SetCellValue ( 'H' . $row, $category );
                            $myWorkSheet->SetCellValue ( 'I' . $row, sprintf ( "%0.2f ", $end_odometer ) );
                            
                            
                            
                            $row ++;
                            
                            $net_distance += $data [$j]->trips [$k]->distance;
                            $net_private += $data [$j]->trips [$k]->pdistance;
                        }
                        $oldRecord = $data [$j]->trips [$k];
                    }
                    
                    // origin
                    
                    // $myWorkSheet->SetCellValue ( 'G' . $row, reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) );
                    // $myWorkSheet->SetCellValue ( 'H' . $row, reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) );
                    // $myWorkSheet->SetCellValue ( 'I' . $row, reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) );
                    // $myWorkSheet->SetCellValue ( 'K' . $row, sprintf ( "%0.2f ", $net_distance ) );
                    // $myWorkSheet->SetCellValue ( 'L' . $row, sprintf ( "%0.2f ", $net_private ) );
                    // $myWorkSheet->SetCellValue ( 'M' . $row, sprintf ( "%0.2f ", $net_distance - $net_private ) );
                    // $myWorkSheet->getStyle ( "A$row:T$row" )->getFont ()->setBold ( true );
                    // $myWorkSheet->getStyle ( "A$row:T$row" )->getFont ()->getColor ()->setARGB ( 'ff017fff' );
                    
                    $row ++;
                }
            } // for J
            $row ++;
        } // for I
          
        // redirect output to browser
        header ( 'Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' );
        header ( 'Content-Disposition: attachment;filename="VehicleActivityReport.xlsx"' );
        header ( 'Cache-Control: max-age=0' );
        $objWriter = PHPExcel_IOFactory::createWriter ( $objPHPExcel, 'Excel2007' );
        $objWriter->save ( 'php://output' );
    }
}
class VEHICLEACTIVITYREPORT_Output_PDF {
    public $pdf;
    public static $txtDirection;
    public static $revDirection;
    public static $direction;
    private function initializePDF() {
        global $MYLANGUAGE;
        $left = self::$txtDirection;
        $right = self::$revDirection;
        
        $this->pdf = new mPDF ( "utf-8", "LETTER" );
        
        $this->pdf->SetCreator ( "Find'n'Secure" );
        $this->pdf->SetAuthor ( 'EMBARC' );
        $this->pdf->SetTitle ( 'Vehicle Activity Report' );
        $this->pdf->SetSubject ( 'Vehicle Activity Report' );
        $this->pdf->SetKeywords ( "Trip, Report, Findnsecure" );
        
        // set default header data
        $header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . 'Vehicle Activity Report' . '</td><td align="' . $right . '"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
        $this->pdf->SetHTMLHeader ( $header, "E" );
        $this->pdf->SetHTMLHeader ( $header, "O" );
        $this->pdf->SetTopMargin ( 30 );
        
        // $this->pdf->SetDirectionality("rtl");
        $this->pdf->SetAutoFont ( AUTOFONT_ALL );
        $this->pdf->SetDirectionality ( self::$direction );
    }
    public function printPDF($arrDis) {
        global $GDATABASE, $MYLANGUAGE, $languageMatrix;
        
        if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
            self::$direction = $direction = "ltr";
        } else {
            self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
        }
        
        switch ($direction) {
            case "ltr" :
                self::$txtDirection = "left";
                self::$revDirection = "right";
                break;
            case "rtl" :
                self::$txtDirection = "right";
                self::$revDirection = "left";
                break;
        }
        
        $left = self::$txtDirection;
        $right = self::$revDirection;
        
        ob_start ();
        
        $rDatabase = new reportingQueries();
        
        $this->initializePDF ();
        
        $summary = array ();
        
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
        
        $aCount = count ( $arrDis [0] ['result'] );
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();
        
        $header = '<table width="100%" class="topBottom10pxPadding"><tr><td style="font-size:20px; font-weight:bold">' . 'Vehicle Activity Report' . '</td><td align="' . $right . '"><img src="' . REP_IMAGES_FOLDER . '/reports/fnslogo.png' . '"/></td></tr></table>';
        
        print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">
        <tr>
            <td width="120px" style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td>
            <td><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
        
            <td width="120px" style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td>
            <td><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
        </tr>
        
        <tr>
            <td style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'START_DATE' ) . '</div></td>
            <td><div class="tableHeading">' . $sdate . '</div></td>
            <td style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'END_DATE' ) . '</div></td>
            <td><div class="tableHeading">' . $edate . '</div></td>
        </tr>
        </table>';
        
        $tCount = count ( $arrDis );
        
        for($i = 0; $i < $tCount; $i ++) {
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
            
            print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1">';
            
            print '<tr style="background-color:#DDDDDD">
                <td width="200px">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . '</td>
                <td width="200px">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</td>
                <td width="200px">'.$MYLANGUAGE->getString ( 'APPLICATION' ).'</td>
                <td width="200px">' . $MYLANGUAGE->getString ( $apptype ) . '</td>
            </tr>';
            
            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                print '<tr>
                    <td style="font-weight:bold" width="200px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td>
                    <td width="200px">' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
                    <td style="font-weight:bold" width="200px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td>
                    <td width="200px">' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
                    </tr>';
                    } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                        print '<tr>
                    <td style="font-weight:bold" width="200px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td>
                    <td width="200px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
                    <td style="font-weight:bold" width="200px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td>
                    <td width="200px">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
                    </tr>';
                    } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                        print '<tr>
                    <td style="font-weight:bold" width="200px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td>
                    <td width="200px">' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
                    </tr>';
                    } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                        print '<tr>
                    <td style="font-weight:bold" width="200px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td>
                    <td width="200px">' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
                    <td style="font-weight:bold" width="200px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td>
                    <td width="200px">' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            }

            print '<tr><td colspan="4">&nbsp;</td></tr>';
            //print "</table>";
            
            $ecount = count ( $arrDis [$i] ['result'] );
            
            $data = $arrDis [$i] ['result'];
            $initialized = false;


            /*Summaery for header*/


            $top_row_index = 0;
            $totel_no_stop = 0;
            $totel_no_idle= 0;

            $avg_speed_array = array();
            $avg_stop_speed_array = array();

            for($x = 0; $x < $ecount - 1; $x ++) {
                
                $tripsCount = count ( $data [$x]->trips );
                
                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$x]->date, $arrDis [$i] ['result'] [$x]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$x + 1]->date, $arrDis [$i] ['result'] [$x + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    //print '<div class="subHeading" style="padding-left:3px; padding-top:3px; padding-bottom:3px; margin-top:5px; margin-bottom:5px; background-color:#444444;font-weight:bold; width:100%;color:white; " >' . $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate . "</div>";
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_stoppage_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    
                    
                    
                    for($y = 0; $y < $tripsCount; $y ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$x]->trips [$y];
                            $initialized = true;
                            continue;
                        }
                        
                        if ($data [$x]->trips [$y]->status == STATUS_MOVING) {
                            
                            $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                            $sdate = $fdate->getFormattedString ();
                            $splace = $oldRecord->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $oldRecord->latitude . "," . $oldRecord->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $start_odometer = $oldRecord->odometer;
                            
                            $fdate->setUTCDate ( $data [$x]->trips [$y]->date, $data [$x]->trips [$y]->time );
                            $edate = $fdate->getFormattedString ();
                            $eplace = $data [$x]->trips [$y]->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $data [$x]->trips [$y]->latitude . "," . $data [$x]->trips [$y]->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $end_odometer = $data [$x]->trips [$y]->odometer;
                            
                            $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$x]->trips [$y]->date, $data [$x]->trips [$y]->time );
                            
                            $user = $_SESSION ['username'];
                            $rec = $GDATABASE->getUserRecord ( $user );
                            $password = $rec [0] ['password'];
                            
                            $hashData = $password . $oldRecord->date . $oldRecord->time . $data [$x]->trips [$y]->date . $data [$x]->trips [$y]->time . $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                            $hash = hash ( "sha256", $hashData );
                            
                            $dstring = reportUtils::getDurationText ( $data [$x]->trips [$y]->duration + $data [$x]->trips [$y]->idletime, $MYLANGUAGE );
                            $idlestring = reportUtils::getDurationText ( $data [$x]->trips [$y]->idletime, $MYLANGUAGE );

                            $stoppagestring = reportUtils::getDurationText ( $data [$x]->trips [$y]->stoppagetime, $MYLANGUAGE );

                            $drivingstring = reportUtils::getDurationText ( $data [$x]->trips [$y]->duration, $MYLANGUAGE );
                            
                            $driver = $data [$x]->trips [$y]->driver;
                            if ($driver == false)
                                $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                            
                            $ttemp = array ();
                            if ($data [$x]->trips [$y]->maxTemp != false && count ( $data [$x]->trips [$y]->maxTemp ) > 0) {
                                for($tp = 0; $tp < count ( $data [$x]->trips [$y]->maxTemp ); $tp ++) {
                                    if ($data [$x]->trips [$y]->maxTemp [$tp] !== null) {
                                        $n = new emptyClass ();
                                        $n->index = $tp;
                                        $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$x]->trips [$y]->maxTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$x]->trips [$y]->maxTemp [$tp] * 1.8 + 32 ) . "°F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$x]->trips [$y]->minTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$x]->trips [$y]->minTemp [$tp] * 1.8 + 32 ) . "°F";
                                        array_push ( $ttemp, $n );
                                    }
                                }
                            }
                            
                            $backgroundColor = "none";
                            
                            $net_duration += ($data [$x]->trips [$y]->duration + $data [$x]->trips [$y]->idletime);
                            $net_idling_duration += $data [$x]->trips [$y]->idletime;

                            $net_stoppage_duration += $data [$x]->trips [$y]->stoppagetime;

                            if($data [$x]->trips [$y]->avgSpeed > 0) {
                                $category = 'RUNNING';

                                $avg_speed_array[] = $data [$x]->trips [$y]->avgSpeed;
                                $avg_stop_speed_array[] = $data [$x]->trips [$y]->avgSpeed;

                            } elseif($data [$x]->trips [$y]->idletime != 0) {
                                $category = 'IDLE';
                                $totel_no_idle ++;
                            } elseif($data [$x]->trips [$y]->stoppagetime != 0) {
                                $category = 'STOP';
                                $totel_no_stop ++;
                                $avg_stop_speed_array[] = $data [$x]->trips [$y]->avgSpeed;
                            } else {
                                $category = 'NA';
                            }
                            
                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString . "<br/>";
                            }
                            
                            $net_distance += $data [$x]->trips [$y]->distance;
                            $net_private += $data [$x]->trips [$y]->pdistance;
                        }
                        $oldRecord = $data [$x]->trips [$y];
                    }
                }
            } // for X


            $average_excluding_stop = $average_including_stop = 0;
            $avg_speed_array = array_filter($avg_speed_array);
            $average_excluding_stop = array_sum($avg_speed_array)/count($avg_speed_array);

            $avg_stop_speed_array = array_filter($avg_stop_speed_array);
            $average_including_stop = array_sum($avg_stop_speed_array)/count($avg_stop_speed_array);


            print '
                    <tr style="background-color:#DDDDDD">
                        <td width="200px">Duration Selected</td>
                        <td width="200px">' . reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) . '</td>
                        <td width="200px">Total Stop Duration</td>
                        <td width="200px">'.reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ).'</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td width="200px">Total Number Of Stop</td>
                        <td width="200px">'.$totel_no_stop.'</td>
                        <td width="200px">Total Idle Duration</td>
                        <td width="200px">' . reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) . '</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td width="200px">Total Number Of Idle</td>
                        <td width="200px">'.$totel_no_idle.'</td>
                        <td width="200px">Average Speed (excluding stops)</td>
                        <td width="200px">'.sprintf ( "%0.2f ", $average_excluding_stop ).' kms/hr</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td width="200px">Average Speed (including stops) </td>
                        <td width="200px">'.sprintf ( "%0.2f ", $average_including_stop ).' kms/hr</td>
                        <td width="200px">Number Of Overspeed</td>
                        <td width="200px">0</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td width="200px">Distance Travelled with Overspeed</td>
                        <td width="200px">0.0</td>
                        <td width="200px">Travel Time</td>
                        <td width="200px">' . reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) . '</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td width="200px">Max Speed</td>
                        <td width="200px">'.sprintf ( "%0.2f ", (max($avg_speed_array)) ).' kms/hr</td>
                        <td width="200px">Engine Hours</td>
                        <td width="200px">' . reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) . '</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">    
                        <td width="200px">Total Distance Travelled</td>
                        <td width="200px">' . sprintf ( "%0.2f ", $net_distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                        <td width="200px">N/W Los</td>
                        <td width="200px">&nbsp;</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td width="400px">Fuel Consumed</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                    </tr>
                    <tr style="background-color:#DDDDDD"><td colspan="4">&nbsp;</td></tr>
                </table>
            ';


            /*Summaery for header*/


            print '<table width="100%" cellspacing="3" cellpadding="3" bordercolor="#cccccc" border="1" frame="vsides" rules="rows"  class="subHeading" style="margin-top:0px;margin-bottom:0px; border: 1px dotted #aaaaaa; font-size:11px;background-color:#F2F2F2">';
                    print ' <tr style="background-color: #FFF;">
                            <td style="font-weight:bold" width="3%">S.No.</td>
                            <td style="font-weight:bold" width="10%">' . $MYLANGUAGE->getString ( 'DATE' ) . ' '.$MYLANGUAGE->getString ( 'TIME' ).'</td>
                            <td style="font-weight:bold" width="25%">' . $MYLANGUAGE->getString ( 'LOCATION' ) . '</td>
                            <td style="font-weight:bold" width="10%">' . $MYLANGUAGE->getString ( 'SPEED' ) . '</td>
                            <td style="font-weight:bold" width="11%">Stoppage Time (Hrs.Mins)</td>
                            <td style="font-weight:bold" width="11%">' . $MYLANGUAGE->getString ( 'IDLE_DUR' ) . '</td>
                            <td style="font-weight:bold" width="10%">' . $MYLANGUAGE->getString ( 'DURATION' ) . '</td>
                            <td style="font-weight:bold" width="10%">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . '</td>
                            <td style="font-weight:bold" width="10%">Category</td>
                            <td style="font-weight:bold" width="10%">Cumulative Odometer</td>
                    </tr>';
            
            $row_index = 0;

            for($j = 0; $j < $ecount - 1; $j ++) {
                
                $tripsCount = count ( $data [$j]->trips );
                
                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    //print '<div class="subHeading" style="padding-left:3px; padding-top:3px; padding-bottom:3px; margin-top:5px; margin-bottom:5px; background-color:#444444;font-weight:bold; width:100%;color:white; " >' . $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate . "</div>";
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    
                    
                    for($k = 0; $k < $tripsCount; $k ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$j]->trips [$k];
                            $initialized = true;
                            continue;
                        }
                        
                        if ($data [$j]->trips [$k]->status == STATUS_MOVING) {
                            
                            $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                            $sdate = $fdate->getFormattedString ();
                            $splace = $oldRecord->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $oldRecord->latitude . "," . $oldRecord->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $start_odometer = $oldRecord->odometer;
                            
                            $fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            $edate = $fdate->getFormattedString ();
                            $eplace = $data [$j]->trips [$k]->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $data [$j]->trips [$k]->latitude . "," . $data [$j]->trips [$k]->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $end_odometer = $data [$j]->trips [$k]->odometer;
                            
                            $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            
                            $user = $_SESSION ['username'];
                            $rec = $GDATABASE->getUserRecord ( $user );
                            $password = $rec [0] ['password'];
                            
                            $hashData = $password . $oldRecord->date . $oldRecord->time . $data [$j]->trips [$k]->date . $data [$j]->trips [$k]->time . $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                            $hash = hash ( "sha256", $hashData );
                            
                            $dstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                            $idlestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->idletime, $MYLANGUAGE );

                            $stoppagestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->stoppagetime, $MYLANGUAGE );

                            $drivingstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration, $MYLANGUAGE );
                            
                            $driver = $data [$j]->trips [$k]->driver;
                            if ($driver == false)
                                $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                            
                            $ttemp = array ();
                            if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
                                for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
                                    if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
                                        $n = new emptyClass ();
                                        $n->index = $tp;
                                        $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$j]->trips [$k]->maxTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "°F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$j]->trips [$k]->minTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "°F";
                                        array_push ( $ttemp, $n );
                                    }
                                }
                            }
                            
                            $backgroundColor = "none";
                            
                            $net_duration += ($data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime);
                            $net_idling_duration += $data [$j]->trips [$k]->idletime;

                            if($data [$j]->trips [$k]->avgSpeed > 0) {
                                $category = 'RUNNING';
                            } elseif($data [$j]->trips [$k]->idletime != 0) {
                                $category = 'IDLE';
                            } elseif($data [$j]->trips [$k]->stoppagetime != 0) {
                                $category = 'STOP';
                            } else {
                                $category = 'NA';
                            }
                            
                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString . "<br/>";
                            }
                            
                            print '
                            <tr style="background-color:' . $backgroundColor . '">
                            <td>'.++$row_index.'</td>
                            <td >' . $sdate . '</td>
                            <td>' . $eplace . '</td>
                            <td >' . sprintf ( "%0.1f ", $data [$j]->trips [$k]->avgSpeed ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . '</td>
                            <td >' . reportUtils::getDurationText ( $data [$j]->trips [$k]->stoppagetime, $MYLANGUAGE ) . '</td>
                            <td >' . $idlestring . '</td>
                            <td >' . $dstring . '</td>
                            <td >' . sprintf ( "%0.2f ", $data [$j]->trips [$k]->distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                            <td >'.$category.'</td>
                            <td >' . sprintf ( "%0.2f ", $end_odometer ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>

                            
                            </tr>
                            ';
                            $net_distance += $data [$j]->trips [$k]->distance;
                            $net_private += $data [$j]->trips [$k]->pdistance;
                        }
                        $oldRecord = $data [$j]->trips [$k];
                    }
                    /*print '
                        <tr style="background-color:' . $backgroundColor . ';font-weight:bold;color:#017fff">
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td >' . reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) . '</td>
                        <td >' . reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) . '</td>
                        <td >' . reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) . '</td>
                        <td>&nbsp;</td>
                        <td >' . sprintf ( "%0.2f ", $net_distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                        <td >' . sprintf ( "%0.2f ", $net_private ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                        <td >' . sprintf ( "%0.2f ", $net_distance - $net_private ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        </tr>
                    ';*/
                    
                    
                }
            } // for J
            print '</table>';
            print "</table>";
        } // for I
        
        $contents = ob_get_contents ();
        ob_end_clean ();
        $this->pdf->WriteHTML ( $contents );
        $this->pdf->Output ();
    }
}
class VEHICLEACTIVITYREPORT_Output_HTML {
    public static $txtDirection;
    public static $revDirection;
    public static $direction;
    public static function printHeader() {
        global $MYLANGUAGE, $languageMatrix;
        
        if (isset ( $languageMatrix [$_SESSION ['language']] ) == false) {
            self::$direction = $direction = "ltr";
        } else {
            self::$direction = $direction = $languageMatrix [$_SESSION ['language']]->direction;
        }
        
        switch ($direction) {
            case "ltr" :
                self::$txtDirection = "left";
                self::$revDirection = "right";
                break;
            case "rtl" :
                self::$txtDirection = "right";
                self::$revDirection = "left";
                break;
        }
        
        print '
                <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
                <html xmlns="http://www.w3.org/1999/xhtml">
                <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
                <title>Vehicle Activity Report</title>
                <style>' . file_get_contents ( CSS_FOLDER . '/reports.css' ) . '*{direction:' . $direction . ';} </style>
                </head>
                <body class="mainbody" style="background-color:#999; background-image:none">
                <div id="reportframe" style="width:auto">
                <div style="padding-top:10px; padding-left:10px; padding-bottom:10px; padding-right:10px">
              ';
    }
    public static function printHTML($arrDis) {
        ob_start ();
        
        $summary = array ();
        
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        global $GDATABASE, $MYLANGUAGE;
        $rDatabase = new reportingQueries();
        
        $answer = $GDATABASE->getAccountCard ( $_SESSION ['username'] );
        
        VEHICLEACTIVITYREPORT_Output_HTML::printHeader ();
        $left = self::$txtDirection;
        $right = self::$revDirection;
        
        $aCount = count ( $arrDis [0] ['result'] );
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [0]->date, $arrDis [0] ['result'] [0]->time );
        $sdate = $fdate->getFormattedString ();
        
        $fdate->setUTCDate ( $arrDis [0] ['result'] [$aCount - 1]->date, $arrDis [0] ['result'] [$aCount - 1]->time );
        $edate = $fdate->getFormattedString ();
        
        print '<table width="100%" class="topBottom10pxPadding" style="font-size:22px; font-weight:bold; background-color:#FFF !important;"><tr><td>Vehicle Activity Report</td><td align="' . $right . '"><img src="data:image/png;base64,' . base64_encode ( file_get_contents ( REP_IMAGES_FOLDER . '/reports/fnslogo.png' ) ) . '"/></td></tr></table>';
        
        print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1" style="background-color:#FFF !important;">
        <tr>
            <td width="400px" style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'COMPANY_NAME' ) . '</div></td> 
            <td><div class="tableHeading">' . $answer [0] ['company'] . '</div></td>
            
            <td  width="400px" style="font-weight:bold"><div class="tableHeading">From Date</div></td>
            <td><div class="tableHeading">' . $sdate . '</div></td>
        </tr>
        
        <tr>
            <td width="400px" style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'USERNAME' ) . '</div></td> 
            <td><div class="tableHeading">' . $answer [0] ['username'] . '</div></td>
            <td  width="400px" style="font-weight:bold"><div class="tableHeading">To Date</div></td>
            <td><div class="tableHeading">' . $edate . '</div></td>
        </tr>
        <tr><td>&nbsp;</td></tr>
        </table>';
        
        $tCount = count ( $arrDis );
        
        for($i = 0; $i < $tCount; $i ++) {
            $apptype = reportUtils::getApplicationType ( $arrDis [$i] ['details'] [0] ['apptype'] );
            
            print '<table width="100%" class="topHeader" cellpadding="0" cellspacing="1" style="background-color:#FFF !important;">
            <tr>
                <td width="400px" style="font-weight:bold"><div class="tableHeading">' . $MYLANGUAGE->getString ( 'TRACKER_NAME' ) . '</div></td> 
                <td><div class="tableHeading" style="width: 136px;">' . $arrDis [$i] ['tinfo'] [0] ['name'] . '</div></td>
                
                <td  width="400px" style="font-weight:bold"><div class="tableHeading">'.$MYLANGUAGE->getString ( 'APPLICATION' ).'</div></td>
                <td><div class="tableHeading">' . $MYLANGUAGE->getString ( $apptype ) . '</div></td>
            </tr>';
            
            if ($arrDis [$i] ['details'] [0] ['apptype'] == "VT") {
                print '<tr>
                    <td style="font-weight:bold" width="400px">' . $MYLANGUAGE->getString ( 'LICENSEPLATE' ) . ':</td>
                    <td>' . $arrDis [$i] ['details'] [0] ['licensePlate'] . '</td>
                    <td style="font-weight:bold" width="400px"> ' . $MYLANGUAGE->getString ( 'VTYPE' ) . ':</td>
                    <td>' . $arrDis [$i] ['details'] [0] ['vtype'] . '</td>
                    </tr>';
                    } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "PT") {
                        print '<tr>
                    <td style="font-weight:bold" width="400px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td>
                    <td >' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
                    <td style="font-weight:bold" width="400px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td>
                    <td>' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
                    </tr>';
                    } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "AT") {
                        print '<tr>
                    <td style="font-weight:bold" width="400px">' . $MYLANGUAGE->getString ( 'REFNO' ) . ':</td>
                    <td >' . $arrDis [$i] ['details'] [0] ['arefno'] . '</td>
                    </tr>';
                    } else if ($arrDis [$i] ['details'] [0] ['apptype'] == "OT") {
                        print '<tr>
                    <td style="font-weight:bold" width="400px">' . $MYLANGUAGE->getString ( 'PNAME' ) . ':</td>
                    <td >' . $arrDis [$i] ['details'] [0] ['pname'] . '</td>
                    <td style="font-weight:bold" width="400px"> ' . $MYLANGUAGE->getString ( 'MOBILE' ) . ':</td>
                    <td>' . $arrDis [$i] ['details'] [0] ['pmobile'] . '</td>
            </tr>';
            }

            print '<tr><td colspan="4">&nbsp;</td></tr>';
            print "</table>";
            
            $ecount = count ( $arrDis [$i] ['result'] );
            
            $data = $arrDis [$i] ['result'];
            $initialized = false;


            /*Summaery for header*/


            $top_row_index = 0;
            $totel_no_stop = 0;
            $totel_no_idle= 0;

            $avg_speed_array = array();
            $avg_stop_speed_array = array();

            for($x = 0; $x < $ecount - 1; $x ++) {
                
                $tripsCount = count ( $data [$x]->trips );
                
                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$x]->date, $arrDis [$i] ['result'] [$x]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$x + 1]->date, $arrDis [$i] ['result'] [$x + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    //print '<div class="subHeading" style="padding-left:3px; padding-top:3px; padding-bottom:3px; margin-top:5px; margin-bottom:5px; background-color:#444444;font-weight:bold; width:100%;color:white; " >' . $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate . "</div>";
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_stoppage_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    
                    
                    
                    for($y = 0; $y < $tripsCount; $y ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$x]->trips [$y];
                            $initialized = true;
                            continue;
                        }
                        
                        if ($data [$x]->trips [$y]->status == STATUS_MOVING) {
                            
                            $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                            $sdate = $fdate->getFormattedString ();
                            $splace = $oldRecord->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $oldRecord->latitude . "," . $oldRecord->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $start_odometer = $oldRecord->odometer;
                            
                            $fdate->setUTCDate ( $data [$x]->trips [$y]->date, $data [$x]->trips [$y]->time );
                            $edate = $fdate->getFormattedString ();
                            $eplace = $data [$x]->trips [$y]->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $data [$x]->trips [$y]->latitude . "," . $data [$x]->trips [$y]->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $end_odometer = $data [$x]->trips [$y]->odometer;
                            
                            $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$x]->trips [$y]->date, $data [$x]->trips [$y]->time );
                            
                            $user = $_SESSION ['username'];
                            $rec = $GDATABASE->getUserRecord ( $user );
                            $password = $rec [0] ['password'];
                            
                            $hashData = $password . $oldRecord->date . $oldRecord->time . $data [$x]->trips [$y]->date . $data [$x]->trips [$y]->time . $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                            $hash = hash ( "sha256", $hashData );
                            
                            $dstring = reportUtils::getDurationText ( $data [$x]->trips [$y]->duration + $data [$x]->trips [$y]->idletime, $MYLANGUAGE );
                            $idlestring = reportUtils::getDurationText ( $data [$x]->trips [$y]->idletime, $MYLANGUAGE );

                            $stoppagestring = reportUtils::getDurationText ( $data [$x]->trips [$y]->stoppagetime, $MYLANGUAGE );

                            $drivingstring = reportUtils::getDurationText ( $data [$x]->trips [$y]->duration, $MYLANGUAGE );
                            
                            $driver = $data [$x]->trips [$y]->driver;
                            if ($driver == false)
                                $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                            
                            $ttemp = array ();
                            if ($data [$x]->trips [$y]->maxTemp != false && count ( $data [$x]->trips [$y]->maxTemp ) > 0) {
                                for($tp = 0; $tp < count ( $data [$x]->trips [$y]->maxTemp ); $tp ++) {
                                    if ($data [$x]->trips [$y]->maxTemp [$tp] !== null) {
                                        $n = new emptyClass ();
                                        $n->index = $tp;
                                        $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$x]->trips [$y]->maxTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$x]->trips [$y]->maxTemp [$tp] * 1.8 + 32 ) . "°F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$x]->trips [$y]->minTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$x]->trips [$y]->minTemp [$tp] * 1.8 + 32 ) . "°F";
                                        array_push ( $ttemp, $n );
                                    }
                                }
                            }
                            
                            $backgroundColor = "none";
                            
                            $net_duration += ($data [$x]->trips [$y]->duration + $data [$x]->trips [$y]->idletime);
                            $net_idling_duration += $data [$x]->trips [$y]->idletime;

                            $net_stoppage_duration += $data [$x]->trips [$y]->stoppagetime;

                            if($data [$x]->trips [$y]->avgSpeed > 0) {
                                $category = 'RUNNING';

                                $avg_speed_array[] = $data [$x]->trips [$y]->avgSpeed;
                                $avg_stop_speed_array[] = $data [$x]->trips [$y]->avgSpeed;

                            } elseif($data [$x]->trips [$y]->idletime != 0) {
                                $category = 'IDLE';
                                $totel_no_idle ++;
                            } elseif($data [$x]->trips [$y]->stoppagetime != 0) {
                                $category = 'STOP';
                                $totel_no_stop ++;
                                $avg_stop_speed_array[] = $data [$x]->trips [$y]->avgSpeed;
                            } else {
                                $category = 'NA';
                            }
                            
                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString . "<br/>";
                            }
                            
                            $net_distance += $data [$x]->trips [$y]->distance;
                            $net_private += $data [$x]->trips [$y]->pdistance;
                        }
                        $oldRecord = $data [$x]->trips [$y];
                    }
                }
            } // for X


            $average_excluding_stop = $average_including_stop = 0;
            $avg_speed_array = array_filter($avg_speed_array);
            $average_excluding_stop = array_sum($avg_speed_array)/count($avg_speed_array);

            $avg_stop_speed_array = array_filter($avg_stop_speed_array);
            $average_including_stop = array_sum($avg_stop_speed_array)/count($avg_stop_speed_array);


            print '
                <table width="100%" class ="topBottom10pxPadding">
                    <tr style="background-color:#DDDDDD">
                        <td class="subHeading" width="400px">Duration Selected</td>
                        <td>' . reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) . '</td>
                        <td class="subHeading" width="400px">Total Stop Duration</td>
                        <td>'.reportUtils::getDurationText ( $net_stoppage_duration, $MYLANGUAGE ).'</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td class="subHeading" width="400px">Total Number Of Stop</td>
                        <td>'.$totel_no_stop.'</td>
                        <td class="subHeading" width="400px">Total Idle Duration</td>
                        <td>' . reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) . '</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td class="subHeading" width="400px">Total Number Of Idle</td>
                        <td >'.$totel_no_idle.'</td>
                        <td class="subHeading" width="400px">Average Speed (excluding stops)</td>
                        <td>'.sprintf ( "%0.2f ", $average_excluding_stop ).' kms/hr</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td class="subHeading" width="400px">Average Speed (including stops) </td>
                        <td>'.sprintf ( "%0.2f ", $average_including_stop ).' kms/hr</td>
                        <td class="subHeading" width="400px">Number Of Overspeed</td>
                        <td>0</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td class="subHeading" width="400px">Distance Travelled with Overspeed</td>
                        <td>0.0</td>
                        <td class="subHeading" width="400px">Travel Time</td>
                        <td>' . reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) . '</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td class="subHeading" width="400px">Max Speed</td>
                        <td>'.sprintf ( "%0.2f ", (max($avg_speed_array)) ).' kms/hr</td>
                        <td class="subHeading" width="400px">Engine Hours</td>
                        <td>' . reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) . '</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">    
                        <td class="subHeading" width="400px">Total Distance Travelled</td>
                        <td>' . sprintf ( "%0.2f ", $net_distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                        <td class="subHeading" width="400px">N/W Los</td>
                        <td>&nbsp;</td>
                    </tr>
                    <tr style="background-color:#DDDDDD">
                        <td class="subHeading" width="400px">Fuel Consumed</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                    </tr>
                    <tr style="background-color:#DDDDDD"><td colspan="4">&nbsp;</td></tr>
                </table>
            ';


            /*Summaery for header*/


            print '<table width="100%" cellspacing="3" cellpadding="3" bordercolor="#cccccc" border="1" frame="vsides" rules="rows"  class="subHeading" style="margin-top:0px;margin-bottom:0px; border: 1px dotted #aaaaaa; font-size:11px;background-color:#F2F2F2">';
                    print ' <tr style="background-color: #FFF;">
                            <td style="font-weight:bold" width="3%">S.No.</td>
                            <td style="font-weight:bold" width="10%">' . $MYLANGUAGE->getString ( 'DATE' ) . ' '.$MYLANGUAGE->getString ( 'TIME' ).'</td>
                            <td style="font-weight:bold" width="25%">' . $MYLANGUAGE->getString ( 'LOCATION' ) . '</td>
                            <td style="font-weight:bold" width="10%">' . $MYLANGUAGE->getString ( 'SPEED' ) . '</td>
                            <td style="font-weight:bold" width="11%">Stoppage Time (Hrs.Mins)</td>
                            <td style="font-weight:bold" width="11%">' . $MYLANGUAGE->getString ( 'IDLE_DUR' ) . '</td>
                            <td style="font-weight:bold" width="10%">' . $MYLANGUAGE->getString ( 'DURATION' ) . '</td>
                            <td style="font-weight:bold" width="10%">' . $MYLANGUAGE->getString ( 'DISTANCE' ) . '</td>
                            <td style="font-weight:bold" width="10%">Category</td>
                            <td style="font-weight:bold" width="10%">Cumulative Odometer</td>
                    </tr>';
            
            $row_index = 0;

            for($j = 0; $j < $ecount - 1; $j ++) {
                
                $tripsCount = count ( $data [$j]->trips );
                
                if ($tripsCount > 0) {
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j]->date, $arrDis [$i] ['result'] [$j]->time );
                    $sdate = $fdate->getFormattedString ();
                    
                    $fdate->setUTCDate ( $arrDis [$i] ['result'] [$j + 1]->date, $arrDis [$i] ['result'] [$j + 1]->time );
                    $edate = $fdate->getFormattedString ();
                    //print '<div class="subHeading" style="padding-left:3px; padding-top:3px; padding-bottom:3px; margin-top:5px; margin-bottom:5px; background-color:#444444;font-weight:bold; width:100%;color:white; " >' . $MYLANGUAGE->getString ( 'PERIOD' ) . " : " . $sdate . " - " . $edate . "</div>";
                    
                    $net_duration = 0;
                    $net_idling_duration = 0;
                    $net_distance = 0;
                    $net_private = 0;
                    
                    
                    
                    for($k = 0; $k < $tripsCount; $k ++) {
                        if ($initialized == false) {
                            $oldRecord = $data [$j]->trips [$k];
                            $initialized = true;
                            continue;
                        }
                        
                        if ($data [$j]->trips [$k]->status == STATUS_MOVING) {
                            
                            $fdate->setUTCDate ( $oldRecord->date, $oldRecord->time );
                            $sdate = $fdate->getFormattedString ();
                            $splace = $oldRecord->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $oldRecord->latitude . "," . $oldRecord->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $start_odometer = $oldRecord->odometer;
                            
                            $fdate->setUTCDate ( $data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            $edate = $fdate->getFormattedString ();
                            $eplace = $data [$j]->trips [$k]->place ['location'] . "<a href='#' onclick=\"javascript:window.open('http://maps.google.com/?q=" . $data [$j]->trips [$k]->latitude . "," . $data [$j]->trips [$k]->longitude . "')\"> " . $MYLANGUAGE->getString ( 'SHOW_ON_MAP' ) . " </a>";
                            $end_odometer = $data [$j]->trips [$k]->odometer;
                            
                            $hCounts = $rDatabase->getHarshCounts($arrDis [$i] ['tinfo'] [0] ['trackerid'], $oldRecord->date, $oldRecord->time,$data [$j]->trips [$k]->date, $data [$j]->trips [$k]->time );
                            
                            $user = $_SESSION ['username'];
                            $rec = $GDATABASE->getUserRecord ( $user );
                            $password = $rec [0] ['password'];
                            
                            $hashData = $password . $oldRecord->date . $oldRecord->time . $data [$j]->trips [$k]->date . $data [$j]->trips [$k]->time . $arrDis [$i] ['tinfo'] [0] ['trackerid'];
                            $hash = hash ( "sha256", $hashData );
                            
                            $dstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime, $MYLANGUAGE );
                            $idlestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->idletime, $MYLANGUAGE );

                            $stoppagestring = reportUtils::getDurationText ( $data [$j]->trips [$k]->stoppagetime, $MYLANGUAGE );

                            $drivingstring = reportUtils::getDurationText ( $data [$j]->trips [$k]->duration, $MYLANGUAGE );
                            
                            $driver = $data [$j]->trips [$k]->driver;
                            if ($driver == false)
                                $driver = $MYLANGUAGE->getString ( 'UNKNOWN' );
                            
                            $ttemp = array ();
                            if ($data [$j]->trips [$k]->maxTemp != false && count ( $data [$j]->trips [$k]->maxTemp ) > 0) {
                                for($tp = 0; $tp < count ( $data [$j]->trips [$k]->maxTemp ); $tp ++) {
                                    if ($data [$j]->trips [$k]->maxTemp [$tp] !== null) {
                                        $n = new emptyClass ();
                                        $n->index = $tp;
                                        $n->dString = $MYLANGUAGE->getString ( 'MAX' ) . "&nbsp;" . $data [$j]->trips [$k]->maxTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->maxTemp [$tp] * 1.8 + 32 ) . "°F&nbsp;|&nbsp;" . $MYLANGUAGE->getString ( 'MIN' ) . "&nbsp;" . $data [$j]->trips [$k]->minTemp [$tp] . "°C&nbsp;/&nbsp;" . sprintf ( "%2.1f", $data [$j]->trips [$k]->minTemp [$tp] * 1.8 + 32 ) . "°F";
                                        array_push ( $ttemp, $n );
                                    }
                                }
                            }
                            
                            $backgroundColor = "none";
                            
                            $net_duration += ($data [$j]->trips [$k]->duration + $data [$j]->trips [$k]->idletime);
                            $net_idling_duration += $data [$j]->trips [$k]->idletime;

                            if($data [$j]->trips [$k]->avgSpeed > 0) {
                                $category = 'RUNNING';
                            } elseif($data [$j]->trips [$k]->idletime != 0) {
                                $category = 'IDLE';
                            } elseif($data [$j]->trips [$k]->stoppagetime != 0) {
                                $category = 'STOP';
                            } else {
                                $category = 'NA';
                            }
                            
                            $toutput = '';
                            for($tp = 0; $tp < count ( $ttemp ); $tp ++) {
                                $toutput .= ($ttemp [$tp]->index + 1) . '&nbsp;:&nbsp;' . $ttemp [$tp]->dString . "<br/>";
                            }
                            
                            print '
                            <tr style="background-color:' . $backgroundColor . '">
                            <td>'.++$row_index.'</td>
                            <td >' . $sdate . '</td>
                            <td>' . $eplace . '</td>
                            <td >' . sprintf ( "%0.1f ", $data [$j]->trips [$k]->avgSpeed ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_SU" ) . '</td>
                            <td >' . $stoppagestring . '</td>
                            <td >' . $idlestring . '</td>
                            <td >' . $dstring . '</td>
                            <td >' . sprintf ( "%0.2f ", $data [$j]->trips [$k]->distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                            <td >'.$category.'</td>
                            <td >' . sprintf ( "%0.2f ", $end_odometer ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>

                            
                            </tr>
                            ';
                            $net_distance += $data [$j]->trips [$k]->distance;
                            $net_private += $data [$j]->trips [$k]->pdistance;
                        }
                        $oldRecord = $data [$j]->trips [$k];
                    }
                    /*print '
                        <tr style="background-color:' . $backgroundColor . ';font-weight:bold;color:#017fff">
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td >' . reportUtils::getDurationText ( $net_duration, $MYLANGUAGE ) . '</td>
                        <td >' . reportUtils::getDurationText ( $net_duration - $net_idling_duration, $MYLANGUAGE ) . '</td>
                        <td >' . reportUtils::getDurationText ( $net_idling_duration, $MYLANGUAGE ) . '</td>
                        <td>&nbsp;</td>
                        <td >' . sprintf ( "%0.2f ", $net_distance ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                        <td >' . sprintf ( "%0.2f ", $net_private ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                        <td >' . sprintf ( "%0.2f ", $net_distance - $net_private ) . $MYLANGUAGE->getString ( $_GET ['metric'] . "_DU" ) . '</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        </tr>
                    ';*/
                    
                    
                }
            } // for J
            print '</table>';
            print "</table>";
        } // for I
        
        VEHICLEACTIVITYREPORT_Output_HTML::printFooter ();
        
        $contents = ob_get_contents ();
        ob_end_clean ();
        
        print $contents;
    }
    public static function printFooter() {
        print '
        <br/>
        <div style="width:100%; border:1px black solid; background-color:#404040; height:10px" />
        </div>
        </body></html>';
    }
}
class VEHICLEACTIVITYREPORT_FNSv3_Report {
    private $mConverter;
    private $rDatabase;
    private $dateComputer;
    private function getStatus($data) {
        if ($data ['latitude'] == NULL)
            return STATUS_NOGPS;
        if ($data ['speed'] > 0 && strpos ( $data ['IO'], "j" ) !== false)
            $currentStatus = STATUS_MOVING;
        else if (strpos ( $data ['IO'], "j" ) !== false)
            $currentStatus = STATUS_IDLE;
        else
            $currentStatus = STATUS_STOPPED;
        
        return $currentStatus;
    }
    private function computeTrips($tid) {
        global $GDATABASE;
        
        if (isset ( $_GET ['SOTV'] ) && $_GET ['SOTV'] > 0)
            $TRIPS_STOP_BREAKING_TIME = $_GET ['SOTV'];
        else
            $TRIPS_STOP_BREAKING_TIME = TRIPS_STOP_BREAKING_TIME;
        
        if (isset ( $_GET ['IDTV'] ) && $_GET ['IDTV'] > 0)
            $TRIPS_IDLE_BREAKING_TIME = $_GET ['IDTV'];
        else
            $TRIPS_IDLE_BREAKING_TIME = TRIPS_IDLE_BREAKING_TIME;
        
        $trips = array ();
        $fdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        // Starting state of this automata will be TRIP_START
        $currentState = TRIP_START;
        
        $data = true;
        $distance = 0;
        $pdistance = 0;
        
        $tprofiles = $GDATABASE->getTrackerTemperatureProfiles ( $tid );
        $card = $GDATABASE->getTrackerCard ( $tid );
        
        $computeTemperature = false;
        $tpr = array ();
        
        for($v = 0; $v < count ( $tprofiles ); $v ++) {
            if ($tprofiles [$v] !== false) {
                $computeTemperature = true;
            }
        }
        
        $exit = false;
        $oldData = false;
        // $Odometer = new FNSOdometer($tid, $_SESSION['timezone']);
        
        while ( $exit == false ) {
            $data = $this->rDatabase->reports_nextLocation ();
            // print "<br/>\r\n".$data['date'].",".$data['time'].",".$data['latitude'].",".$data['longitude'].",".$data['speed'].",".$data['IO'];
            switch ($currentState) {
                
                case TRIP_START :
                    
                    if ($data == false) {
                        $exit = true;
                        break;
                    }
                    
                    // Skip the NO GPS State in the beginning of the data block
                    $checkState = $this->getStatus ( $data );
                    if ($checkState == STATUS_NOGPS)
                        break;
                        
                        // move the state into its determined state
                    $currentState = $checkState;
                    
                    $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                    $stateTransTime = $fdate->dateTime->getTimestamp ();
                    
                    $lastLatitude = $data ['latitude'];
                    $lastLongitude = $data ['longitude'];
                    $maxSpeed = $data ['speed'];
                    
                    $maxTemp = array ();
                    $minTemp = array ();
                    
                    if ($computeTemperature == true) {
                        for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
                            $minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
                        }
                    }
                    
                    $n = new tripRObject ();
                    $n->status = TRIP_START;
                    $n->distance = $distance;
                    $n->maxSpeed = $maxSpeed;
                    $n->latitude = $data ['latitude'];
                    $n->longitude = $data ['longitude'];
                    $n->duration = 0;
                    $n->date = $data ['date'];
                    $n->time = $data ['time'];
                    $n->maxTemp = $maxTemp;
                    $n->minTemp = $minTemp;
                    array_push ( $trips, $n );
                    break;
                
                case STATUS_MOVING :
                    if ($data != false) {
                        $newState = $this->getStatus ( $data );
                    }
                    
                    if ($newState != STATUS_MOVING || $data == false) {
                        
                        if ($data == false) {
                            $exit = true;
                            $data = $oldData;
                        }
                        
                        if ($newState == STATUS_NOGPS) {
                            $data = $oldData;
                        }
                        
                        $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                        
                        // if last state was movement only - means last state
                        // was skipped due to trip time
                        // in this case add to the previous packet otherwise
                        // emit new packet
                        $lastTripIndex = count ( $trips ) - 1;
                        if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == STATUS_MOVING) {
                            $trips [$lastTripIndex]->date = $data ['date'];
                            $trips [$lastTripIndex]->time = $data ['time'];
                            $trips [$lastTripIndex]->latitude = $data ['latitude'];
                            $trips [$lastTripIndex]->longitude = $data ['longitude'];
                            $trips [$lastTripIndex]->distance = $distance;
                            $trips [$lastTripIndex]->pdistance = $pdistance;
                            $trips [$lastTripIndex]->maxSpeed = $maxSpeed;
                            $trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
                        } else {
                            $n = new tripRObject ();
                            $n->status = $currentState;
                            $n->distance = $distance;
                            $n->pdistance = $pdistance;
                            $n->maxSpeed = $maxSpeed;
                            $n->latitude = $data ['latitude'];
                            $n->longitude = $data ['longitude'];
                            $n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
                            $n->date = $data ['date'];
                            $n->time = $data ['time'];
                            $n->maxTemp = $maxTemp;
                            $n->minTemp = $minTemp;
                            array_push ( $trips, $n );
                            
                            $maxTemp = array ();
                            $minTemp = array ();
                        }
                        
                        $currentState = $newState;
                        // Set State transition time
                        $stateTransTime = $fdate->dateTime->getTimestamp ();
                    }
                    
                    $dis = reportUtils::getDistance ( $data ['latitude'], $data ['longitude'], $lastLatitude, $lastLongitude );
                    $distance += $dis;
                    if ($data ['private'] == 1)
                        $pdistance += $dis;
                    
                    if ($computeTemperature == true) {
                        for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
                            
                            $ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
                            
                            if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
                                $maxTemp [$tp] = $ctemp;
                            else
                                $maxTemp [$tp] = $ctemp;
                            
                            if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
                                $minTemp [$tp] = $ctemp;
                            else
                                $minTemp [$tp] = $ctemp;
                        }
                    }
                    
                    if ($data ['speed'] > $maxSpeed)
                        $maxSpeed = $data ['speed'];
                    
                    $lastLatitude = $data ['latitude'];
                    $lastLongitude = $data ['longitude'];
                    
                    break;
                
                case STATUS_NOGPS :
                    if ($data != false) {
                        $newState = $this->getStatus ( $data );
                    } else {
                        $exit = true;
                        $data = $oldData;
                    }
                    
                    if ($newState != $currentState || $data == false) {
                        
                        $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                        $cTime = $fdate->dateTime->getTimestamp ();
                        
                        $n = new tripRObject ();
                        $n->status = $currentState;
                        $n->latitude = $lastLatitude;
                        $n->longitude = $lastLongitude;
                        $n->duration = $cTime - $stateTransTime;
                        $n->date = $data ['date'];
                        $n->time = $data ['time'];
                        array_push ( $trips, $n );
                        $stateTransTime = $cTime;
                        
                        $currentState = $newState;
                    }
                    break;
                
                case STATUS_STOPPED :
                // Both STOPPED and IDLE follow the same logic and correspondingly emits out correct records
                
                case STATUS_IDLE :
                    if ($data != false) {
                        $newState = $this->getStatus ( $data );
                        
                        $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                        $cTime = $fdate->dateTime->getTimestamp ();
                        
                        if ($computeTemperature == true) {
                            for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
                                
                                $ctemp = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
                                
                                if (isset ( $maxTemp [$tp] ) && $ctemp > $maxTemp [$tp])
                                    $maxTemp [$tp] = $ctemp;
                                else
                                    $maxTemp [$tp] = $ctemp;
                                
                                if (isset ( $minTemp [$tp] ) && $ctemp < $minTemp [$tp])
                                    $minTemp [$tp] = $ctemp;
                                else
                                    $minTemp [$tp] = $ctemp;
                            }
                        }
                        
                        // If the time difference is greater then trips breaking
                        // time then emit out
                        if ($newState == STATUS_NOGPS) {
                            $emitOut = true;
                            $data = $oldData;
                        } else if ($currentState == STATUS_STOPPED) {
                            
                            if (($cTime - $stateTransTime) > ($TRIPS_STOP_BREAKING_TIME * 60))
                                $emitOut = true;
                            else
                                $emitOut = false;
                        } else {
                            if (($cTime - $stateTransTime) > ($TRIPS_IDLE_BREAKING_TIME * 60))
                                $emitOut = true;
                            else
                                $emitOut = false;
                        }
                    }
                    
                    if ($newState != $currentState || $data == false) {
                        // Emit Packet and Set new state
                        if ($emitOut || $data == false) {
                            
                            if ($data == false) {
                                $exit = true;
                                $data = $oldData;
                                if ($emitOut == false)
                                    break;
                            }
                            
                            $fdate->setUTCDate ( $data ['date'], $data ['time'] );
                            $lastTripIndex = count ( $trips ) - 1;
                            if ($lastTripIndex >= 0 && $trips [$lastTripIndex]->status == $currentState) {
                                $trips [$lastTripIndex]->date = $data ['date'];
                                $trips [$lastTripIndex]->time = $data ['time'];
                                $trips [$lastTripIndex]->latitude = $data ['latitude'];
                                $trips [$lastTripIndex]->longitude = $data ['longitude'];
                                $trips [$lastTripIndex]->distance = 0;
                                $trips [$lastTripIndex]->pdistance = 0;
                                $trips [$lastTripIndex]->maxSpeed = 0;
                                $trips [$lastTripIndex]->duration += $fdate->dateTime->getTimestamp () - $stateTransTime;
                            } else {
                                $n = new tripRObject ();
                                $n->status = $currentState;
                                $n->latitude = $lastLatitude; // $data['latitude'];
                                $n->longitude = $lastLongitude; // $data['longitude'];
                                $n->duration = $fdate->dateTime->getTimestamp () - $stateTransTime;
                                $n->date = $data ['date'];
                                $n->time = $data ['time'];
                                array_push ( $trips, $n );
                            }
                            
                            $stateTransTime = $fdate->dateTime->getTimestamp ();
                            $distance = 0;
                            $pdistance = 0;
                            $lastLatitude = $data ['latitude'];
                            $lastLongitude = $data ['longitude'];
                            
                            $maxSpeed = $data ['speed'];
                            
                            if ($computeTemperature == true) {
                                $minTemp = array ();
                                $maxTemp = array ();
                                
                                for($tp = 0; $tp < count ( $tprofiles ); $tp ++) {
                                    $minTemp [$tp] = $maxTemp [$tp] = $GDATABASE->getTemperatureFromProfile ( $tprofiles [$tp], $data ['temperature' . ($tp + 1)] );
                                }
                            }
                        }
                        $currentState = $newState;
                    }
                    break;
            }
            $oldData = $data;
        }
        return $trips;
    }
    private function computeParameters($tid, $dateArray, $days, $trackerInfo) {
        global $GDATABASE;
        $geo = new GEOCODER ();
        
        $this->rDatabase->reports_getLocationsData ( $tid, $dateArray );
        
        $tripsArray = $this->computeTrips ( $tid );
        
        $daysCount = count ( $days );
        
        $sdate = new FNSDateTime ( $_SESSION ['timezone'] );
        $edate = new FNSDateTime ( $_SESSION ['timezone'] );
        $pdate = new FNSDateTime ( $_SESSION ['timezone'] );
        
        $tripsCount = count ( $tripsArray );
        $ba = 0;
        $newTrips = array ();
        // Post Processing
        $darray = $tripsArray;
        
        $Odometer = new FNSOdometer ( $tid, $_SESSION ['timezone'] );
        
        if ($tripsCount > 0) {
            $cLoop = true;
            
            for($i = 0; $i < $tripsCount; $i ++) {
                $pdate->setUTCDate ( $tripsArray [$i]->date, $tripsArray [$i]->time );
                
                $tripsArray [$i]->odometer = $Odometer->getValue ( $tripsArray [$i]->date, $tripsArray [$i]->time );
                $tripsArray [$i]->driver = $this->rDatabase->getDriverName ( $tid, $tripsArray [$i]->date, $tripsArray [$i]->time );
            }
            
            $cstate = $darray [$ba]->status;
            $n = $darray [$ba];
            $n->pdistance = $this->mConverter->convert ( $n->pdistance * 0.621371, 'D' );
            $n->distance = $this->mConverter->convert ( $n->distance * 0.621371, 'D' );
            $n->odometer = $this->mConverter->convert ( ($n->odometer / 1000.0) * 0.621371, 'D' );
            
            array_push ( $newTrips, $n );
        } else
            $cLoop = false;

        
        $ignition = $this->rDatabase->detectIgnition ( $tid );
        
        if (isset ( $_GET ['debug'] ) && $_GET ['debug'] == 1)
            print_r ( $tripsArray );


        while ( $cLoop ) {
            // DFA for summing up consecutive idle and moving journeys into single record
            if (isset ( $darray [$ba] ))
                $nstate = $darray [$ba]->status;
            else
                $nstate = $cstate;
            
            if ($ignition == false) {
                if ($nstate == STATUS_IDLE) {
                    $nstate = STATUS_STOPPED;
                    $darray [$ba]->status = STATUS_STOPPED;
                }
            }
            
            switch ($cstate) {
                case TRIP_START :

                    $n->category = 'RUNNING';

                    $cstate = $nstate;
                    $n = $darray [$ba];
                    $ba++;
                    break;
                
                case STATUS_STOPPED :

                    $n->category = 'STOP';

                    if ($ba >= $tripsCount)
                        $cLoop = false;
                    
                    if ($nstate != STATUS_STOPPED) {
                        $n->odometer = $this->mConverter->convert ( ($n->odometer / 1000.0) * 0.621371, 'D' );
                        array_push ( $newTrips, $n );
                        
                        $n = $darray [$ba];
                        if ($n->status == STATUS_IDLE) {
                            $n->idletime = $n->duration;
                            $n->duration = 0;
                        } else {
                            $n->stoppagetime = $n->duration;
                            $n->duration = 0;
                        }
                        $cstate = $nstate;
                        
                        // Collecting batch geocoding requests
                    }
                    $ba ++;
                    break;
                
                case STATUS_MOVING :
                case STATUS_IDLE :

                    $n->category = 'IDLE';

                    if ($ba >= $tripsCount)
                        $cLoop = false;
                    $cstate = $nstate;
                    if ($nstate == STATUS_STOPPED || $cLoop == false) {
                        $n->status = STATUS_MOVING;
                        $n->pdistance = $this->mConverter->convert ( $n->pdistance * 0.621371, 'D' );
                        $n->distance = $this->mConverter->convert ( $n->distance * 0.621371, 'D' );
                        $n->odometer = $this->mConverter->convert ( ($n->odometer / 1000.0) * 0.621371, 'D' );
                        $n->maxSpeed = $this->mConverter->convert ( $n->maxSpeed, 'S' );
                        $n->avgSpeed = $this->mConverter->convert ( ($n->distance * 0.621371) / (($n->idletime + $n->duration) / 3600), 'S' );
                        
                        array_push ( $newTrips, $n );
                        $n = $darray [$ba];
                    } else {
                        $n->odometer = $darray [$ba]->odometer;
                        
                        if ($cstate == STATUS_MOVING) {
                            $n->duration += $darray [$ba]->duration;
                            $n->distance += $darray [$ba]->distance;
                            $n->pdistance += $darray [$ba]->pdistance;
                        } else
                            $n->idletime += $darray [$ba]->duration;
                        
                        if ($darray [$ba]->maxSpeed > $n->maxSpeed)
                            $n->maxSpeed = $darray [$ba]->maxSpeed;
                        
                        $n->date = $darray [$ba]->date;
                        $n->time = $darray [$ba]->time;
                        
                        if (isset ( $darray [$ba]->maxTemp ) && $darray [$ba]->maxTemp != false) {
                            foreach ( $darray [$ba]->maxTemp as $k => $v ) {
                                if ($v > $n->maxTemp [$k])
                                    $n->maxTemp [$k] = $v;
                                if ($v < $n->minTemp [$k])
                                    $n->minTemp [$k] = $v;
                            }
                        }
                    }
                    $ba ++;
                    break;
            }
        }

        if (isset ( $_GET ['debug'] ) && $_GET ['debug'] == 1)
            print_r ( $newTrips );

        $tripsArray = $newTrips;
        $tripsCount = count ( $newTrips );
        $y = 0;
        
        for($x = 0; $x < $daysCount - 1; $x ++) {
            $sdate->setUTCDate ( $days [$x]->date, $days [$x]->time );
            $edate->setUTCDate ( $days [$x + 1]->date, $days [$x + 1]->time );
            
            $darray = array ();
            
            for(; $y < $tripsCount; $y ++) {
                $pdate->setUTCDate ( $tripsArray [$y]->date, $tripsArray [$y]->time );
                
                if ($pdate->dateTime->getTimestamp () >= $sdate->dateTime->getTimestamp () && $pdate->dateTime->getTimestamp () < $edate->dateTime->getTimestamp ()) {
                    
                    array_push ( $darray, $tripsArray [$y] );
                } else
                    break;
            } // for dcount
            
            $dc = count ( $darray );
            
            $batch = array ();
            
            for($ba = 0; $ba < $dc; $ba ++) {
                
                $n = $darray [$ba];
                
                $o = new emptyClass ();
                $o->lat = $n->latitude;
                $o->lng = $n->longitude;
                array_push ( $batch, $o );
            }

            //if (isset($_GET['doGeocode']) && $_GET['doGeocode'] == 1)
            {
                for($ba = 0; $ba < count ( $batch ); $ba ++) {
                    $darray [$ba]->place = $geo->search ( $batch [$ba]->lat, $batch [$ba]->lng, true );
                }
            }

            if ($dc > 0) {
                $days [$x]->trips = $darray;
            }
        } // for daysCount
        
        return $days;
    }
    private function getTrackersList() {
        global $GDATABASE;
        $trackers = $GDATABASE->getTrackersList ( "trackerid" );
        $a = array ();
        $tcount = count ( $trackers );
        for($i = 0; $i < $tcount; $i ++) {
            array_push ( $a, $trackers [$i] ['trackerid'] );
        }
        return $a;
    }
    private function getReportData() {
        global $GDATABASE;
        $arrdate = reportUtils::getUTCReportTime ( $_GET );
        
        if ($_GET ['ftype'] == "E") {
            $trackers = $this->getTrackersList ();
        } else {
            $trackers = explode ( ",", $_GET ['trackers'] );
        }
        
        $tcount = count ( $trackers );
        
        $display_array = array ();
        
        for($i = 0; $i < $tcount; $i ++) {
            
            $days = reportUtils::getDays ( $arrdate, $_SESSION ['timezone'] );
            $arr = array ();
            
            $arr ['tinfo'] = $GDATABASE->getTrackerCard ( $trackers [$i] );
            $arr ['details'] = $GDATABASE->rp_getTrackersDetails ( $trackers [$i] );
            
            $result = $this->computeParameters ( $trackers [$i], $arrdate, $days, $arr ['tinfo'] );
            $arr ['result'] = $result;
            
            array_push ( $display_array, $arr );
        }
        
        switch ($_GET ['format']) {
            case "HTML" :
                VEHICLEACTIVITYREPORT_Output_HTML::printHTML ( $display_array );
                break;
            case "PDF" :
                $pdf = new VEHICLEACTIVITYREPORT_Output_PDF ();
                $pdf->printPDF ( $display_array );
                break;
            case "XLSX" :
                VEHICLEACTIVITYREPORT_Output_XLSX::printXLSX ( $display_array );
                break;
        }
    }
    public function execute() {
        global $MYLANGUAGE;
        $MYLANGUAGE = new FNSLanguage ();
        
        $this->mConverter = new metricConverter ();
        $this->mConverter->setMetrics ( $_GET ['metric'] );
        $this->rDatabase = new reportingQueries ();
        $this->dateComputer = new FNSDateTime ( $_SESSION ['timezone'] );
        
        $this->getReportData ();
    }
}

?>
